$NOFLOATCALLS
$STORAGE:2
      PROGRAM ADDORDEL
C***  PROGRAM ADD_OR_DELete_rows_or_columns
C***
C***  COMBINES FUNCTIONS OF ADROWS, DLROWS, ADCOLS, AND DLCOLS
C***  ADROWS - CONCATENATE TWO STATPAC FILES ROW-WISE.
C***  DLROWS - DELETE SELECTED SEQUENCES OF ROWS FROM A STATPAC FILE.
C***  ADCOLS - CONCATENATE TWO STATPAC FILES COLUMN-WISE.
C***  DLCOLS - DELETE SELECTED SEQUENCES OF COLUMNS FROM A
C***           STATPAC FILE.
C***
C***  ADROWS OPTION REQUIRES THE TWO STATPAC FILES TO HAVE THE
C***  SAME NUMBER OF COLUMNS.
C***  ADCOLS OPTION REQUIRES THE TWO STATPAC FILES TO HAVE THE
C***  SAME NUMBER OF ROWS.
C***
C***  LINKS REQUIRED: ADDRO, ASCIIZ, BYTMOV, CHRKNT, CKSAFE, CONCAT,
C***                  DELRC, DOSREN, FNDCUR, ODOMTR, PACK, UNPK, SOUND
C***  ADAPTED BY W.D. GRUNDY FROM PROGRAMS OF A.T. MIESCH
C***  JANUARY 22, 1985     REVISED MARCH 1985
C***
      CHARACTER*32 UNIT10,UNIT11,UNIT14
      CHARACTER*16 NAME
      CHARACTER*8 ID,IVID
      CHARACTER*1 IA,IB,ANS
      LOGICAL FLAG
      INTEGER*4 LOC
      COMMON X(200),Y(200),IVID(200),IA(200),IB(200),ISV(200),LOC(2),
     1ID,NAME,UNIT10,UNIT11,UNIT14,FLAG,N1(200),N2(200),IPACK(40)
      KI1=10
      KI2=14
      KO=11
   10 WRITE(*,'(/,'' DO YOU WANT TO:'',/,'' 1) APPEND THE ROWS OF '',
     1''ONE STATPAC FILE TO THOSE OF ANOTHER;'',/,'' 2) APPEND THE '',
     2''COLUMNS OF ONE STATPAC FILE TO THOSE OF ANOTHER;'',/,'' 3) '',
     3''DELETE ONE OR MORE SEQUENCES OF ROWS FROM A STATPAC FILE; OR'',
     4/,'' 4) DELETE ONE OR MORE SEQUENCES OF COLUMNS FROM A STATPAC'',
     5'' FILE?'',/,''    ANSWER 1, 2, 3, OR 4: '',\)')
      READ(*,'(A1)') ANS
      IANS=ICHAR(ANS)-48
      IF(IANS.LT.1.OR.IANS.GT.4) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' YOU MUST ANSWER 1, 2, 3, OR 4'
      GO TO 10
      ENDIF
      WRITE(*,'('' '')')
   20 IF(IANS.GE.3)
     1WRITE(*,'(A\)') ' ENTER NAME OF STATPAC INPUT FILE: '
      IF(IANS.LE.2)
     1WRITE(*,'(A\)') ' ENTER NAME OF FIRST STATPAC INPUT FILE: '
      READ(*,'(A32)') UNIT10
      CALL CKSAFE(UNIT10,2,FLAG)
      IF(FLAG) GO TO 20
      IF(IANS.LT.3) THEN
   30 WRITE(*,'(A\)') ' ENTER NAME OF SECOND STATPAC INPUT FILE: '
      READ(*,'(A32)') UNIT14
      IF(UNIT14.EQ.UNIT10) THEN
      CALL WARN
      WRITE(*,'(A)') ' YOU CANNOT USE THE SAME INPUT FILE TWICE'
      GO TO 30
      ENDIF
      CALL CKSAFE(UNIT14,2,FLAG)
      IF(FLAG) GO TO 30
      ENDIF
   40 WRITE(*,'(A\)') ' GIVE A NAME FOR THE STATPAC OUTPUT FILE: '
      READ(*,'(A32)') UNIT11
      IF(UNIT11.EQ.UNIT10.OR.UNIT11.EQ.UNIT14) THEN
      CALL WARN
      WRITE(*,'(A)') ' STATPAC INPUT FILE CANNOT BE USED FOR OUTPUT'
      GO TO 40
      ENDIF
      CALL CKSAFE(UNIT11,1,FLAG)
      IF(FLAG) GO TO 40
      WRITE(*,'(/,'' NOW OPENING THE DISK FILES'',/)')
      OPEN(KI1,FILE=UNIT10,STATUS='OLD',FORM='UNFORMATTED')
      IF(IANS.LT.3)
     1OPEN(KI2,FILE=UNIT14,STATUS='OLD',FORM='UNFORMATTED')
      OPEN(KO,FILE=UNIT11,STATUS='NEW',FORM='UNFORMATTED')
      IF(IANS.EQ.1) CALL ADDRO(KI1,KI2,KO,N,M)
      IF(FLAG) GO TO 60
      IF(IANS.EQ.2) CALL ADDCO(KI1,KI2,KO,N,M)
      IF(FLAG) GO TO 60
      IF(IANS.GT.2) THEN
      IANS2=IANS-2
      CALL DELRC(KI1,KO,N,M,IANS2)
      ENDIF
      WRITE(*,'('' THE STATPAC FILE HAS BEEN WRITTEN'',/,
     2'' THE FILE NAME IS '',A32,/,'' DATA SET ID='',A8,/,
     3'' N= '',I4,3X,'' M= '',I3)') UNIT11,ID,N,M
      DO 50 I=1,5
      CALL SOUND(1000,25)
   50 CONTINUE
   60 WRITE(*,'(/,'' DO YOU WANT TO RERUN THIS PROGRAM? Y/N: '',\)')
      READ(*,'(A1)') ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') THEN
      CLOSE(KI1)
      IF(IANS.LT.3) CLOSE(KI2)
      CLOSE(KO)
      GO TO 10
      ENDIF
      STOP 'NORMAL END OF PROGRAM'
      END
      SUBROUTINE ADDRO(KI1,KI2,KO,N,M)
      CHARACTER*32 UNIT10,UNIT11,UNIT14
      CHARACTER*16 NAME
      CHARACTER*8 ID,IVID
      CHARACTER*4 LIST(2)
      CHARACTER*1 IA,IB,ANS
      LOGICAL FLAG
      INTEGER*4 LOC
      COMMON X(200),Y(200),IVID(200),IA(200),IB(200),ISV(200),LOC(2),
     1ID,NAME,UNIT10,UNIT11,UNIT14,FLAG,N1(200),N2(200),IPACK(40)
      FLAG=.FALSE.
      READ(KI1) ID,NN1,M1,(IVID(I),I=1,M1)
      READ(KI2) ID,NN2,M2
      IF(M1.NE.M2) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' DIFFERENT NUMBER OF COLUMNS IN THE TWO FILES - '',
     1''CANNOT PROCESS.'')')
      FLAG=.TRUE.
      GO TO 30
      ENDIF
      N=NN1+NN2
      M=M1
      NPACK=(M+4)/5
      WRITE(KO) ID,N,M,(IVID(I),I=1,M)
      WRITE(*,'(''          .......READING FIRST INPUT FILE'')')
      CALL FNDCUR(IRRR,ICCC,0)
      DO 10 I=1,NN1
      IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
      READ(KI1) IROW,NAME,LOC,(X(K),K=1,M),(IPACK(K),K=1,NPACK)
      WRITE(KO) I,NAME,LOC,(X(K),K=1,M),(IPACK(K),K=1,NPACK)
   10 CONTINUE
      WRITE(*,'(''+'',I5,)') NN1
      WRITE(*,'(''+'',''          .......READING SECOND INPUT FILE'')')
      J=NN1+1
      DO 20 I=J,N
      IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
      READ(KI2) IROW,NAME,LOC,(X(K),K=1,M),(IPACK(K),K=1,NPACK)
      WRITE(KO) I,NAME,LOC,(X(K),K=1,M),(IPACK(K),K=1,NPACK)
   20 CONTINUE
      WRITE(*,'(''+'',I5)') N
   30 RETURN
      END
      SUBROUTINE ADDCO(KI1,KI2,KO,N,M)
      CHARACTER*32 UNIT10,UNIT11,UNIT14
      CHARACTER*16 NAME
      CHARACTER*8 ID,IVID
      CHARACTER*4 LIST(2)
      CHARACTER*1 IA,IB,ANS
      LOGICAL FLAG
      INTEGER*4 LOC
      COMMON X(200),Y(200),IVID(200),IA(200),IB(200),ISV(200),LOC(2),
     1ID,NAME,UNIT10,UNIT11,UNIT14,FLAG,N1(200),N2(200),IPACK(40)
      FLAG=.FALSE.
      READ(KI1)ID,NN1,M1
      READ(KI2)ID,NN2,M2
      IF(NN1.NE.NN2) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' DIFFERENT NUMBER OF ROWS IN THE TWO FILES - CAN'',
     1''NOT PROCESS.'')')
      FLAG=.TRUE.
      GO TO 30
      ENDIF
      M=M1+M2
      MPAK=(M+4)/5
      IF(M.GT.200) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' THE NUMBER OF COLUMNS IS GREATER THAN 200 - CAN'',
     1''NOT PROCESS.'')')
      FLAG=.TRUE.
      GO TO 30
      ENDIF
      REWIND KI1
      REWIND KI2
      N=NN1
      READ(KI1) ID,NN1,M1,(IVID(I),I=1,M1)
      MN=M1+1
      M1PAK=(M1+4)/5
      READ(KI2) ID,NN2,M2,(IVID(I),I=MN,M)
      M2PAK=(M2+4)/5
      WRITE(KO) ID,N,M,(IVID(I),I=1,M)
      WRITE(*,'(''          ......READING DATA'')')
      CALL FNDCUR(IRRR,ICCC,0)
      DO 20 I=1,NN1
      IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
      READ(KI2) IROW,NAME,LOC,(X(K),K=1,M2),(IPACK(K),K=1,M2PAK)
      CALL UNPK(IB,M2,IPACK)
      READ(KI1) IROW,NAME,LOC,(Y(K),K=1,M1),(IPACK(K),K=1,M1PAK)
      CALL UNPK(IA,M1,IPACK)
      K=0
      DO 10 J=MN,M
      K=K+1
      Y(J)=X(K)
      IA(J)=IB(K)
   10 CONTINUE
      CALL PACK(IA,M,IPACK,MPAK)
      WRITE(KO) I,NAME,LOC,(Y(K),K=1,M),(IPACK(K),K=1,MPAK)
   20 CONTINUE
      WRITE(*,'(''+'',I5)') NN1
   30 RETURN
      END
      SUBROUTINE DELRC(KI1,KO,N,M,JANS)
C***  COMBINES FUNCTIONS OF PROGRAMS DLROWS AND DLCOLS
C***  THIS SUBROUTINE IS CALLED BY PROGRAM ROCOLOPS.
C***  SUBROUTINES REQUIRED: CKSAFE,DLCOL,DLROW,JKGTLS,JKPTLS,SOUND
C***  JKGTLS AND JKPTLS ARE IN IOS.OBJ
      CHARACTER*32 UNIT10,UNIT11,UNIT14
      CHARACTER*16 NAME
      CHARACTER*8 ID,IVID
      CHARACTER*4 LIST(2)
      CHARACTER*1 IA,IB,ANS
      LOGICAL FLAG
      INTEGER*4 LOC
      COMMON X(200),Y(200),IVID(200),IA(200),IB(200),ISV(200),LOC(2),
     1ID,NAME,UNIT10,UNIT11,UNIT14,FLAG,N1(200),N2(200),IPACK(40)
      DATA LIST/'ROWS','COLS'/
      READ(KI1) ID,N,M,(IVID(I),I=1,M)
      WRITE(*,'('' '',//,5X,''STATPAC INPUT FILE ID IS:  '',A8,
     1/,5X,''NUMBER OF ROWS= '',I4,/,5X,''NUMBER OF COLUMNS= '',I3)')
     2ID,N,M
      MAXNS=MIN0(N,200)
      IF(JANS.EQ.2) THEN
      WRITE(*,'(5X,''COLUMN IDS ARE:'')')
      WRITE(*,'('' '')')
      WRITE(*,'(5(1X,I2,'')'',A8))')(I,IVID(I),I=1,M)
      MAXNS=MIN0(M,200)
      ENDIF
   10 WRITE(*,'(/,'' HOW MANY SEQUENCES OF '',A4,'' ARE TO BE '',
     1''DELETED? '',\)') LIST(JANS)
      READ(*,*,ERR=20) NS
      GO TO 30
   20 CALL SOUND(256,100)
      WRITE(*,'(A)') ' INTEGER VALUE WAS EXPECTED. REDO.'
      GO TO 10
   30 IF(NS.LT.1.OR.NS.GT.MAXNS) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' YOU MUST ENTER A NUMBER FROM 1 TO '',I3)') MAXNS
      GO TO 10
      ENDIF
      WRITE(*,'('' ENTER '',I3,'' PAIRS OF '',A4,'' NUMBERS'')')
     1NS,LIST(JANS)
      NN=N
      DO 80 I=1,NS
   40 WRITE(*,'('' ENTER PAIR NO. '',I3,'': '',\)') I
      READ(*,*,ERR=50) N1(I),N2(I)
      GO TO 60
   50 CALL SOUND(256,100)
      WRITE(*,'(A)') ' INTEGER VALUES WERE EXPECTED.  REDO.'
      GO TO 40
   60 IF(N1(I).LE.0.OR.N2(I).LE.0.OR.(JANS.EQ.1.AND.N2(I).GT.N).
     1OR.(JANS.EQ.2.AND.N2(I).GT.M)) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' VALUES OUTSIDE OF POSSIBLE RANGES.  REDO.'
      GO TO 40
      ENDIF
      IF(JANS.EQ.1.AND.I.NE.1.AND.N1(I).LE.N2(I-1)) THEN
      CALL SOUND(256,100)
      WRITE(*,70)
   70 FORMAT(' SEQUENCE ERROR - REDO FROM START.')
      GO TO 10
      ENDIF
      IF(I.EQ.1.AND.JANS.EQ.2) GO TO 80
      IF(JANS.EQ.2.AND.N1(I).LE.N2(I-1)) THEN
      CALL SOUND(256,100)
      WRITE(*,70)
      GO TO 10
      ENDIF
      IF(JANS.EQ.1.AND.N2(I).GT.N.OR.N1(I).GT.N2(I).OR.N1(I).LT.1)
     1THEN
      CALL SOUND(256,100)
      WRITE(*,70)
      GO TO 10
      ENDIF
      IF(JANS.EQ.1) NN=NN-(N2(I)-N1(I)+1)
   80 CONTINUE
      IF(JANS.EQ.1) CALL DLROW(KI1,KO,NN,N,M,NS)
      IF(JANS.EQ.2) CALL DLCOL(KI1,KO,N,M,NS)
      RETURN
      END
      SUBROUTINE DLROW(KI1,KO,NN,N,M,NS)
C***  THIS SUBROUTINE IS CALLED BY SUBROUTINE DELRC.
      CHARACTER*32 UNIT10,UNIT11,UNIT14
      CHARACTER*16 NAME
      CHARACTER*8 ID,IVID
      CHARACTER*4 LIST(2)
      CHARACTER*1 IA,IB,ANS
      LOGICAL FLAG
      INTEGER*4 LOC
      COMMON X(200),Y(200),IVID(200),IA(200),IB(200),ISV(200),LOC(2),
     1ID,NAME,UNIT10,UNIT11,UNIT14,FLAG,N1(200),N2(200),IPACK(40)
      FLAG=.FALSE.
      MPAK=(M+4)/5
      WRITE(KO) ID,NN,M,(IVID(I),I=1,M)
      ICT=0
      J=1
      WRITE(*,'(''          READING DATA'')')
      CALL FNDCUR(IRRR,ICCC,0)
      DO 30 I=1,N
      IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
      READ(KI1) IROW,NAME,LOC,(X(K),K=1,M),(IPACK(K),K=1,MPAK)
      IF(J.GT.NS) GO TO 10
      IF(IROW.GE.N1(J).AND.IROW.LE.N2(J)) GO TO 20
   10 ICT=ICT+1
      WRITE(KO) ICT,NAME,LOC,(X(K),K=1,M),(IPACK(K),K=1,MPAK)
      GO TO 30
   20 IF(I.EQ.N2(J)) J=J+1
   30 CONTINUE
      WRITE(*,'(''+'',I5)') N
      N=NN
   40 RETURN
      END
      SUBROUTINE DLCOL(KI1,KO,N,M,NS)
C***  THIS SUBROUTINE IS CALLED BY SUBROUTINE DELRC.
      CHARACTER*32 UNIT10,UNIT11,UNIT14
      CHARACTER*16 NAME
      CHARACTER*8 ID,IVID
      CHARACTER*4 LIST(2)
      CHARACTER*1 IA,IB,ANS
      LOGICAL FLAG
      INTEGER*4 LOC
      COMMON X(200),Y(200),IVID(200),IA(200),IB(200),ISV(200),LOC(2),
     1ID,NAME,UNIT10,UNIT11,UNIT14,FLAG,N1(200),N2(200),IPACK(40)
      FLAG=.FALSE.
      NSV=0
      J=1
      DO 30 I=1,M
      IF(J.GT.NS) GO TO 10
      IF(I.GE.N1(J).AND.I.LE.N2(J)) GO TO 20
   10 NSV=NSV+1
      ISV(NSV)=I
      GO TO 30
   20 IF(I.EQ.N2(J)) J=J+1
   30 CONTINUE
      NSVPAK=(NSV+4)/5
      MPAK=(M+4)/5
      DO 40 I=1,NSV
      J=ISV(I)
      IVID(I)=IVID(J)
   40 CONTINUE
      WRITE(KO) ID,N,NSV,(IVID(I),I=1,NSV)
      WRITE(*,'(''          READING DATA'')')
      CALL FNDCUR(IRRR,ICCC,0)
      DO 60 I=1,N
      IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
      READ(KI1) IROW,NAME,LOC,(X(K),K=1,M),(IPACK(K),K=1,MPAK)
      CALL UNPK(IA,M,IPACK)
      DO 50 J=1,NSV
      K=ISV(J)
      X(J)=X(K)
      IA(J)=IA(K)
   50 CONTINUE
      CALL PACK(IA,NSV,IPACK,NSVPAK)
      WRITE(KO) I,NAME,LOC,(X(K),K=1,NSV),(IPACK(K),K=1,NSVPAK)
   60 CONTINUE
      WRITE(*,'(''+'',I5)') N
      M=NSV
   70 RETURN
      END
