$NOFLOATCALLS
$STORAGE:2
      PROGRAM ANOV 1
C    * * * * * * * * ANALYSIS OF VARIANCE - USGS STATPAC * * * * * * *
C                        PROGRAM NUMBER D0038
C                        U S GEOLOGICAL SURVEY
C                  GEOLOGIC DIVISION, DENVER, COLORADO
C    * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C    THE METHOD USED IN THIS PROGRAM TAKEN FROM 'STATISTICAL THEORY IN
C    RESEARCH' BY ANDERSON AND BANCROFT,PP 327-330
C     ORIGINALLY PROGRAMMED BY R.N. EICHER, USGS, DENVER, COLORADO.
C     ADAPTED TO IBM PC FORTRAN BY A.T. MIESCH, USGS, GRAND JUNCTION,
C        COLORADO, JUNE, 1983
C***  MODIFIED BY W. D. GRUNDY     JUNE 1986
C***  LINKS REQUIRED: CKSAFE, SOUND
C    ------------------------------------------------------------------
      CHARACTER*32 UNIT15,UNIT17
      CHARACTER*8 NAME(2),IVID(60),ID
      CHARACTER*4 NAMES(10,2),NUM(10),ICOMP
      CHARACTER*2 INS,SGN(11)
      CHARACTER*1 IANS
      INTEGER*4 LOC(2)
      LOGICAL FLAG,IRITE
      DIMENSION Z(60),SXX(60),IC(60,10),S(60,10),T(60,10),IPACK(2),
     *XLEV(10),XLVL(10),KF(11),SS(11),V(60),S2(11),PCT(10),FRAT(11),
     *QCALC(11),TEMP(11),JA(10)
      COMMON/XXX/ A(60,10,10)
      DOUBLE PRECISION X,T,SXX,A,S,SS,TEMP,V,S2,Y
      DATA IPACK/2*0/
      DATA INS/'NS'/,ICOMP/'VCOM'/
      DATA NUM/'P 1 ','P 2 ','P 3 ','P 4 ','P 5 ','P 6 ','P 7 ','P 8 ',
     1'P 9 ','P 10'/
      KI=15
      KO=17
      KP=16
   10 WRITE(*,'(A\)') ' ENTER NAME OF STATPAC INPUT FILE: '
      READ(*,'(A)') UNIT15
      CALL CKSAFE(UNIT15,2,FLAG)
      IF(FLAG) GO TO 10
      WRITE(*,'('' '',''DO YOU WANT TO WRITE THE VARIANCE COMPONENTS'',
     1'' ON AN OUTPUT FILE?: '',\)')
      READ(*,'(A)') IANS
      IRITE=IANS.EQ.'Y'.OR.IANS.EQ.'y'
      IF(IRITE) THEN
   20 WRITE(*,'(A\)') ' GIVE A NAME FOR THE OUTPUT FILE: '
      READ(*,'(A)') UNIT17
      CALL CKSAFE(UNIT17,1,FLAG)
      IF(FLAG) GO TO 20
      DO 30 I=1,10
      NAMES(I,1)=ICOMP
   30 NAMES(I,2)=NUM(I)
      ENDIF
      OPEN(KI,FILE=UNIT15,STATUS='OLD',FORM='UNFORMATTED')
      IF(IRITE) OPEN(KO,FILE=UNIT17,STATUS='NEW',FORM=
     *'UNFORMATTED')
      OPEN(KP,FILE='LPT1',STATUS='NEW')
C***  CLEAR EPSON OF PREVIOUS MODES
      WRITE(KP,'('' '',2A1,\)') CHAR(27),'@'
C***  PRINT HEADER ON EPSON IN DOUBLE-WIDE LETTERS.
      WRITE(KP,'('' '',2A1,\)') CHAR(27),'G'
      WRITE(KP,'('' '',A1,9X,''ONE-WAY HIERARCHICAL'')') CHAR(14)
      WRITE(KP,'(/,'' '',A1,10X,''ANALYSIS OF VARIANCE'')') CHAR(14)
      WRITE(KP,'(/,'' '',A1,14X,''USGS STATPAC'')') CHAR(14)
      WRITE(KP,'('' '',2A1),\)') CHAR(27),'H'
C***  PUT EPSON PRINTER IN COMPRESSED MODE
      WRITE(KP,'('' '',A1,\)') CHAR(15)
      WRITE(KP,920)
      WRITE(KP,920)
      WRITE(KP,920)
   40 WRITE(*,'('' '',''HOW MANY LEVELS ARE IN THE HIERARCHICAL'',
     1'' DESIGN? '',/,'' (MIN=2  MAX=10): '',\)')
      READ(*,'(BN,I10)',ERR=40) NL
      IF(NL.LT.2.OR.NL.GT.10) GO TO 40
      NPACK=(NL+4)/5
      NLM1=NL-1
      NLP1=NL+1
   50 WRITE(*,'('' '',''AT WHAT PROBABILITY LEVEL DO YOU WANT THE'',
     1'' VARIANCE COMPONENTS TESTED?'',/,'' ENTER A VALUE FROM''
     2'' ZERO TO ONE: '',\)')
      READ(*,'(BN,F10.0)',ERR=50) PFQ
      IF(PFQ.LT.0.0.OR.PFQ.GT.1.0) GO TO 50
      IFLAG=1
      READ(KI) ID,N,M,(IVID(I),I=1,M)
      IF(M.GT.60) STOP 'PROGRAM IS LIMITED TO 60 VARIABLES'
C     -----------------------------------------------------------------
      DO 280 J=1,M
      SXX(J)=0.0
      DO 280 K=1,NL
      IC(J,K)=0
      S(J,K)=0.0
      T(J,K)=0.0
      DO 280 L=1,NL
  280 A(J,K,L)=0.0
      DO 285 J=1,10
  285 XLEV(J)=0.0
C     -----------------------------------------------------------------
C     READ LEVELS AND DATA FROM TAPE AND CALCULATE SUMS AND AVERAGE
C        FREQUENCIES FOR EACH LEVEL
C     -----------------------------------------------------------------
      MS=M
      M=M-NL
      READ(KI) IROW,NAME,LOC,(Z(MP),MP=1,MS)
      DO 290 I=1,NL
  290 XLEV(I)=Z(I)
      DO 295 I=1,M
  295 Z(I)=Z(I+NL)
      WRITE(*,'(A)') '       ...READING DATA'
      DO 430 I=1,N
      IF(MOD(I,10).EQ.0) WRITE(*,'(''+'',I5)') I
      DO 340 J=1,M
      T(J,NL)=T(J,NL)+Z(J)
      IC(J,NL)=IC(J,NL)+1
      SXX(J)=SXX(J)+Z(J)**2
  340 A(J,NL,NL)=A(J,NL,NL)+1.0
      IF (I.EQ.N) GO TO 360
      DO 350 L=1,NL
  350 XLVL(L)=XLEV(L)
      READ(KI) IROW,NAME,LOC,(Z(MP),MP=1,MS)
      DO 352 L=1,NL
  352 XLEV(L)=Z(L)
      DO 353 L=1,M
  353 Z(L)=Z(L+NL)
      GO TO 380
  360 DO 370 L=1,NL
      XLVL(L)=XLEV(L)
  370 XLEV(L)=999.9
  380 DO 420 L=1,NLM1
      IF (XLVL(L).EQ.XLEV(L)) GO TO 420
      DO 410 M1=L,NLM1
      MM=NLM1+L-M1
      NN=MM+1
      DO 410 J=1,M
      X=A(J,NN,NN)
      A(J,MM,MM)=A(J,MM,MM)+X
      A(J,NN,MM)=A(J,NN,MM)+X**2
      X=1.0/X
      KB=MM+2
      IF (KB.GT.NL) GO TO 400
      DO 390 K=KB,NL
      A(J,K,MM)=A(J,K,MM)+A(J,K,NN)
      A(J,NN,K)=A(J,NN,K)+X*A(J,K,NN)
  390 A(J,K,NN)=0.0
  400 CONTINUE
      T(J,MM)=T(J,MM)+T(J,NN)
      IC(J,MM)=IC(J,MM)+1
      S(J,NN)=S(J,NN)+X*T(J,NN)**2
      A(J,NN,NN)=0.0
      T(J,NN)=0.0
  410 CONTINUE
      GO TO 430
  420 CONTINUE
  430 CONTINUE
      WRITE(*,'(''+'',I5)') N
      IF(IRITE) WRITE (KO) ID,M,NL,(NAMES(I,1),NAMES(I,2),I=1,NL)
      NAME(2)=' '
      DO 630 J=1,M
      WRITE(KP,'('' '',A1,\)') CHAR(18)
      WRITE(KP,'('' '',2A1,\)') CHAR(27),'G'
      WRITE(KP,'('' '',A1,9X,''COLUMN NO'',I3,'':'',2X,A8)') CHAR(14),
     1J,IVID(J+NL)
      WRITE(KP,'('' '',2A1,\)') CHAR(27),'H'
      WRITE(KP,'('' '',A1,\)') CHAR(15)
      WRITE(KP,750) PFQ
C     -----------------------------------------------------------------
C     CALCULATE ANALYSIS OF VARIANCE
C     -----------------------------------------------------------------
      X=1.0/A(J,1,1)
      S(J,1)=X*T(J,1)**2
      KF(1)=IC(J,1)-1
      DO 460 L=1,NLM1
      MM=L+1
      KF(MM)=IC(J,MM)-IC(J,L)
      A(J,MM,MM)=A(J,1,1)
      A(J,1,MM)=X*A(J,MM,1)
      DO 450 NN=1,L
      IF (KF(NN).NE.0) GO TO 440
      A(J,MM,NN)=0.0
      GO TO 450
  440 A(J,MM,NN)=(A(J,NN+1,MM)-A(J,NN,MM))/KF(NN)
  450 CONTINUE
  460 SS(L)=S(J,MM)-S(J,L)
      SS(NL)=SXX(J)-S(J,NL)
      SS(NLP1)=SXX(J)-S(J,1)
      KF(NLP1)=IC(J,NL)-1
      DO 470 L=1,NL
  470 V(L)=SS(L)/KF(L)
C     -----------------------------------------------------------------
C     ESTIMATE VARIANCE COMPONENTS
C     -----------------------------------------------------------------
      S2(NL)=V(NL)
      X=V(NL)
      XPCT=0.0
      DO 510 LM=1,NLM1
      L=NLM1+1-LM
      IF (KF(L).NE.0) GO TO 480
      S2(L)=0
      GO TO 510
  480 Y=V(L)-X
      NB=L+2
      IF (NB.GT.NL) GO TO 500
      DO 490 NX=NB,NL
      NN=NB+NL-NX
  490 Y=Y-A(J,NN,L)*S2(NN-1)
  500 S2(L)=Y/A(J,L+1,L)
  510 CONTINUE
      XPCT=0.0
      DO 515 L=1,NL
C     PCT(L)=SNGL(S2(L))
      PCT(L)=S2(L)
      IF (PCT(L).LT.0.0) PCT(L)=0.0
  515 XPCT=XPCT+PCT(L)
C     -----------------------------------------------------------------
C     TESTS OF HYPOTHESIS BY CALCULATING F-RATIO AND COMPARING
C     THE PROBABILITY OF F-RATIO WITH THE PROBABILITY LEVEL SUPPLIED
C     ON INPUT
C     -----------------------------------------------------------------
      DO 520 L=1,NLM1
      CALL HTEST (V(L),V(L+1),KF(L),KF(L+1),PFQ,FRAT(L),QCALC(L),SGN(L),
     1 IFLAG)
      LM1=L-1
  520 WRITE (KP,760) L,LM1,SS(L),KF(L),V(L),L,IC(J,L),S2(L),FRAT(L),QCA
     1LC(L),SGN(L)
      L=NL
      LM1=L-1
      WRITE (KP,760) L,LM1,SS(L),KF(L),V(L),L,IC(J,L),S2(L)
      L=NLP1
      WRITE (KP,770) SS(L),KF(L),XPCT
      DO 525 I=1,NL
  525 PCT(I)=100.0*PCT(I)/XPCT
      JJ=J
      NAME(1)=IVID(J+NL)
      DO 528 I=1,NL
  528 Z(I)=S2(I)
      IF(IRITE) WRITE(KO)JJ,NAME,LOC,(Z(MP),MP=1,NL),
     1(IPACK(MP),MP=1,NPACK)
      WRITE (KP,950)
      WRITE (KP,960) (PCT(I),I=1,NL)
      WRITE (KP,780)
      DO 550 L=1,NL
      LP1=L+1
      IF (LP1.GT.NL) GO TO 540
      DO 530 NN=LP1,NL
      NNN=LP1+NL-NN
  530 TEMP(NN-LP1+1)=A(J,NNN,L)
      NTOT=NL-LP1+1
      WRITE (KP,790) (TEMP(NN),NN=1,NTOT)
      GO TO 550
  540 WRITE (KP,910)
  550 CONTINUE
C     -----------------------------------------------------------------
C     POOLED ANALYSIS OF VARIANCE
C     -----------------------------------------------------------------
      DO 570 L=1,NL
      DO 560 I=1,NL
  560 A(J,L,I)=0.0
  570 A(J,L,L)=L
      IF (NL.LE.2) GO TO 621
      WRITE (KP,800)
      DO 620 LL=2,NLM1
      L=NLM1+2-LL
      IF (SGN(L).NE.INS) GO TO 620
      MM=L+1
      SS(L)=SS(L)+SS(MM)
      KF(L)=KF(L)+KF(MM)
      V(L)=SS(L)/KF(L)
      DO 580 I=L,NL
  580 A(J,L,I)=A(J,L,I)+A(J,MM,I)
      LM1=L-1
      NN=LM1
      CALL HTEST (V(NN),V(NN+1),KF(NN),KF(NN+1),PFQ,FRAT(NN),QCALC(NN),
     1 SGN(NN),IFLAG)
      DO 590 I=1,NL
  590 JA(I)=A(J,NN,I)+0.0001
      WRITE (KP,810) (JA(I),I=1,NL)
      WRITE (KP,820) SS(NN),KF(NN),V(NN),FRAT(NN),QCALC(NN),SGN(NN)
      NN=L
      DO 600 I=1,NL
  600 JA(I)=A(J,NN,I)+.0001
      WRITE (KP,810) (JA(I),I=1,NL)
      WRITE (KP,820) SS(NN),KF(NN),V(NN)
      WRITE (KP,920)
  620 CONTINUE
  621 DO 622 L=1,3
  622 WRITE(KP,645)
  630 CONTINUE
  640 WRITE(KP,645)
  645 FORMAT('  ')
C***  PUT EPSON PRINTER BACK INTO NORMAL MODE
      WRITE(KP,'('' '',A1,\)') CHAR(18)
      STOP 'NORMAL END OF PROGRAM'
C     -----------------------------------------------------------------
  650 FORMAT (7A4,A2,2A4,I5,I3,10I1,2A4,13X,I3)
  660 FORMAT (26I3)
  710 FORMAT (I5,F10.0)
  750 FORMAT(///,45X,
     1'SIGNIFICANCE LEVEL  Q =',F6.4,//,13X,'ANALYSIS OF VARIANCE',23X,
     2'ESTIMATION OF VARIANCE COMPONENTS',11X,'TEST OF HYPOTHESIS',//,
     3 6X,'SOURCE',6X,'SUM OF   DEGREES OF    MEAN',14X,'LEVEL    UNIT',
     4 5X,'VARIANCE',11X,'F-RATIO',5X,'EST. Q    SIGNI-',/,1X,'BETWEEN W
     5ITHIN   SQUARES   FREEDOM     SQUARE',22X,'SIZE',5X,'COMPONENT',
     6 32X,'FICANCE',/)
  760 FORMAT(1X,I4,I8,2X,F12.5,I7,2X,F14.5,10X,I2,I10,3X,F12.5,7X,
     1 F12.5,1X,F10.3,4X,A2)
  770 FORMAT(8X,'TOTAL',2X,F12.5,I7,41X,F12.5/)
  780 FORMAT (/'0COEFFICIENTS OF VARIANCE COMPONENTS IN ESTIMATES OF THE
     1 MEAN SQUARE'//)
  790 FORMAT(' 1.0000',3X,9F12.4)
  800 FORMAT(29X,'ANALYSIS OF POOLED VARIANCE',//,7X,'LEVEL',15X,
     1'SUM OF   DEGREES OF',6X,'MEAN',9X,'F-RATIO',6X,'EST. Q   SIGNI-',
     2 /,26X,'SQUARES',5X,'FREEDOM',6X,'SQUARE',30X,'FICANCE',/)
  810 FORMAT(1X,9(I1,'+'),I2)
  820 FORMAT('+',23X,F11.4,I8,5X,F12.5,4X,F12.5,1X,F10.3,4X,A2)
  830 FORMAT (' SELECTED COLUMNS')
  840 FORMAT (10(4X,I4,5X))
  850 FORMAT (7X,'TITLE',23X,'INPUT ID',7X,'N',5X,'M',4X,'***** OPTIONS
     1*****',4X,'OUTPUT ID'/1X,7A4,A2,3X,'-',2A4,'-',2X,I5,3X,I3,3X,10I2
     2,3X,'-',2A4,'-'/)
  855 FORMAT (/7X,'** NOTE **   NO. OF ACTUAL COLUMNS  = M - 10',//)
  860 FORMAT (' NUMBER OF SELECTED COLUMNS   = ',I4/)
  870 FORMAT ('0SELECTED COLUMN IDENTIFIERS')
  880 FORMAT (/'0SELECTED ROW PAIRS')
  890 FORMAT (10(1X,I5,'-',I5,1X))
  900 FORMAT (10(2X,2A4,3X))
  910 FORMAT(' 1.0000',///)
  920 FORMAT(' ')
  930 FORMAT('1D0038 - ANALYSIS OF VARIANCE (08/27/79)',58X,'DATE',I4,
     1 '/',I2,'/',I2,/)
  940 FORMAT ('0THE NUMBER OF SELECTED COLUMNS EXCEEDS 99.')
  950 FORMAT(///' VARIANCE COMPONENTS AS PERCENTAGES OF THE ',
     1'TOTAL VARIANCE'/)
  960 FORMAT(10F7.2)
  970 FORMAT ('0THE NO. OF SELECTED COLUMNS (',I3,') EXCEEDS THE',
     1' MAXIMUM(70 COLUMNS) ALLOWED BY THIS PROGRAM.')
      END
      SUBROUTINE HTEST(V1,V2,NU1,NU2,PFQ,F,EQ1,SN,IERR)
C    * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C     THIS PROCEDURE CALCULATES THE F-RATIO AND THE PROBABILITY LEVEL
C        USING IT AND THE DEGREES OF FREEDOM INVOLVED.  SIGNIFICANT
C        VARIATION BETWEEN AND THE GIVEN AND CALCULATED
C        PROBABILITY LEVELS IS DETERMINED
C     ------------------------------------------------------------------
      DOUBLE PRECISION V,V1,V2
      CHARACTER*2 VAL(3),SN
      DATA VAL/'NS',' *','  '/
      IF(V2.LE.0) GO TO 10
      F=V1/V2
      V=V1/V2
      EQ1=FISH(V,NU1,NU2)
      SN=VAL(1)
      IF(EQ1.GT.PFQ) GO TO 20
      SN=VAL(2)
      GO TO 20
   10 F=0.0
      EQ1=0.0
      SN=VAL(3)
   20 RETURN
      END
      FUNCTION FISH (F,N1,N2)
C     ------------------------------------------------------------------
C     THIS FUNCTION COMPUTES THE AREA (FISH) OF THE F DISTRIBUTION WITH
C     N1 & N2 DEGREES OF FREEDOM FROM F TO INFINITY.
C     WHERE F = VARIANCE RATIO
C          N1 = DEGREES OF FREEDOM IN THE NUMERATOR
C          N2 = DEGREES OF FREEDOM IN THE DENOMINATOR
C        FISH = PROBABILITY OF OBSERVED F
C
C     TAKEN FROM R. G. GARRETT AND T. I., 1980, COMPUTERS & GEOSCIENCES,
C         V. 6, N. 1, P. 54-55.
C     METHOD FROM MILTON ABRAMOWITZ AND I. A. STEGUN, 1972, NBS HANDBOOK
C         55, P. 946.
C     ------------------------------------------------------------------
C
      REAL*8 F
C     LOGICAL*2 E1,E2,E3
      LOGICAL E1,E2,E3
C
C     INITIALISE AND SET LOGICALS TO .TRUE. FOR N1 AND/OR N2 EVEN
      E1=.FALSE.
      E2=.FALSE.
      E3=.FALSE.
      IF(MOD(N1,2).EQ.0)E1=.TRUE.
      IF(MOD(N2,2).EQ.0)E2=.TRUE.
      X=N2/(N2+N1*SNGL(F))
      IF(.NOT.(E1.OR.E2))GO TO 5
      IF(E1.AND..NOT.E2)GO TO 2
      IF(.NOT.E1.AND.E2)GO TO 1
      IF(N1.LE.N2)GO TO 2
    1 I=N1
      N1=N2
      N2=I
      X=1.0-X
      E3=.TRUE.
    2 Y=1.0-X
C
C     COMMENCE CALCULATION OF PROBABILITY FOR N1 AND/OR N2 EVEN
      FSH=0.0
      H=SQRT(X**N2)
      M=N1/2-1
      II=0
      DO 3 I=II,M
      FSH=FSH+H
    3 H=(H*Y*(N2+2.0*I))/(2.0*(I+1.0))
      IF(E3)GO TO 4
C
C     ADJUST CALCULATED PROBABILITY IF COMPLEMENT WAS COMPUTED, R
      FSH=1.0-FSH
      GO TO 9
    4 I=N1
      N1=N2
      N2=I
      GO TO 9
C
C     CALCULATION FOR BOTH N1 AND N2 ODD
    5 Y=1.0-X
      H=0.6366198*SQRT(X*Y)
      FSH=0.6366198*ACOS(SQRT(X))
      IF(N2.EQ.1)GO TO 7
      M=N2-2
      DO 6 I=1,M,2
      FSH=FSH+H
    6 H=H*X*(I+1)/(I+2)
    7 IF(N1.EQ.1)GO TO 9
      H=H*N2
      M=N1-2
      DO 8 I=1,M,2
      FSH=FSH-H
    8 H=H*Y*(N2+I)/(I+2)
    9 FSH=1.0-FSH
      FISH=FSH
      RETURN
      END
