$NOFLOATCALLS
$STORAGE:2
C  PROGRAM ANOV-2  TWO-WAY ANALYSIS OF VARIANCE - WITH REPLICATIONS.
C    LIMITS -  30 COLUMNS, 10 ROWS, 35 VARIABLES,
C              ANY NO. OF REPLICATES PER CELL
C  BY A.T. MIESCH, USGS, DENVER   APRIL,1975
C   SEE DIXON AND MASSEY, 1957, PAGES 163-168.
C  THE DATA VALUES MUST BE ORDERED REPLICATES, WITHIN COLS, ACROSS ROWS
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*32 UNIT15
      CHARACTER*4 ID(2),IVID(35,2),NAME(4)
      CHARACTER*1 IA(35),IBLANK
      INTEGER*4 LOC(2)
      REAL*4 X(35)
      DIMENSION CELSUM(35),SUM(35),SUMSQ(35),SUBTOT(35),
     1CORTRM(35),ROWSUM(35,12),COLSUM(35,100),ROWS(35),COLS(35),ACT(35),
     2WITHIN(35),TOTAL(35),VARR(35),VARC(35),VARA(35),VARW(35),
     3FRW(35),FCL(35),FAC(35),
     4POOL(35),FPRW(35),FPCL(35),POOLSS(35)
      DATA IBLANK/' '/
      WRITE(KT,1000)
 1000 FORMAT(' PROGAM ROWCOL LIMITATIONS',/,' 100 COLUMNS',/,'  12 ROWS'
     *,/,'  35 VARIABLES',/,' INTERACTION IS COMPUTED ONLY IF THERE IS M
     *ORE THAN ONE VALUE',/,' (REPLICATE) PER CELL')
      WRITE(KT,1002)
 1002 FORMAT(' DATA MUST BE ORDERED COLUMN-BY-COLUMN ON STATPAC FILE.')
      WRITE(*,50)
   50 FORMAT(' WHAT IS THE NAME OF THE STATPAC INPUT FILE ?  ',\)
      READ(*,52) UNIT15
   52 FORMAT(A32)
      KIN=15
      OPEN(KIN,FILE=UNIT15,STATUS='OLD',FORM='UNFORMATTED')
      READ(KIN) ID,N,M,(IVID(I,1),IVID(I,2),I=1,M)
      IF(M.GT.35) STOP 'PROGRAM IS LIMITED TO 35 VARIABLES'
  100 WRITE(KT,1020)
 1020 FORMAT(' GIVE NO. OF COLS IN TWO-WAY ANOV DESIGN :')
      READ (*,*) ICOL
      IF(ICOL.GT.100) GO TO 100
  105 WRITE(KT,1040)
 1040 FORMAT(' GIVE NO. OF ROWS IN TWO-WAY ANOV DESIGN :')
      READ (*,*) IROW
      IF(IROW.GT.12) GO TO 105
      WRITE(KT,1050)
 1050 FORMAT(' GIVE NO. OF VALUES IN EACH CELL :')
      READ (*,*) IREP
      ICHEK=IROW*ICOL*IREP
      IF(ICHEK.EQ.N) GO TO 150
      WRITE(KT,1060)
 1060 FORMAT(' COLS X ROWS X REPS DOES NOT EQUAL N ON INPUT FILE')
      GO TO 100
  150 FREP=FLOAT(IREP)
      DO 200 L=1,M
      SUBTOT(L)=0.0
      SUM(L)=0.0
      SUMSQ(L)=0.0
      DO 190 I=1,IROW
  190 ROWSUM(L,I)=0.0
      DO 200 I=1,ICOL
  200 COLSUM(L,I)=0.0
      DO 250 J=1,ICOL
      DO 250 I=1,IROW
      DO 210 L=1,M
  210 CELSUM(L)=0.0
      DO 240 K=1,IREP
      CALL JKGTLS (KIN,INO,NAME,LOC,X,IA,M,IERR)
      IF(IERR.NE.0) STOP 'UNEXPECTED END-OF-FILE'
      DO 212 KK=1,M
  212 IF(IA(KK).NE.IBLANK) GO TO 9998
      DO 240 L=1,M
      SUM(L)=SUM(L)+X(L)
      SUMSQ(L)=SUMSQ(L)+X(L)*X(L)
      ROWSUM(L,I)=ROWSUM(L,I)+X(L)
      COLSUM(L,J)=COLSUM(L,J)+X(L)
  240 CELSUM(L)=CELSUM(L)+X(L)
      DO 250 L=1,M
  250 SUBTOT(L)=SUBTOT(L)+CELSUM(L)*CELSUM(L)/FREP
      FN=FLOAT(N)
      DO 260 L=1,M
  260 CORTRM(L)=SUM(L)*SUM(L)/FN
      DO 270 L=1,M
  270 TOTAL(L)=SUMSQ(L)-CORTRM(L)
      FROW=FLOAT(IROW*IREP)
      FCOL=FLOAT(ICOL*IREP)
      IF(IREP.EQ.1) GO TO 302
      DO 300 L=1,M
  300 SUBTOT(L)=SUBTOT(L)-CORTRM(L)
  302 DO 365 L=1,M
      ROWS(L)=0.0
      DO 360 I=1,IROW
  360 ROWS(L)=ROWS(L)+(ROWSUM(L,I)*ROWSUM(L,I)/FCOL)
  365 ROWS(L)=ROWS(L)-CORTRM(L)
      DO 375 L=1,M
      COLS(L)=0.0
      DO 370 I=1,ICOL
  370 COLS(L)=COLS(L)+(COLSUM(L,I)*COLSUM(L,I)/FROW)
  375 COLS(L)=COLS(L)-CORTRM(L)
      IF(IREP.EQ.1) GO TO 402
      DO 400 L=1,M
      ACT(L)=SUBTOT(L)-ROWS(L)-COLS(L)
  400 WITHIN(L)=TOTAL(L)-SUBTOT(L)
      GO TO 405
  402 DO 403 L=1,M
  403 WITHIN(L)=TOTAL(L)-ROWS(L)-COLS(L)
  405 IRDF=IROW-1
      ICDF=ICOL-1
      IADF=IRDF*ICDF
      ISDF=IRDF+ICDF+IADF
      ITDF=N-1
      IWDF=ITDF-ISDF
      IF(IREP.GT.1) GO TO 410
      IWDF=IRDF*ICDF
  410 FIRDF=FLOAT(IRDF)
      FICDF=FLOAT(ICDF)
      FIADF=FLOAT(IADF)
      FIWDF=FLOAT(IWDF)
      DO 450 L=1,M
      VARR(L)=ROWS(L)/FIRDF
      VARC(L)=COLS(L)/FICDF
      VARA(L)=ACT(L)/FIADF
  450 VARW(L)=WITHIN(L)/FIWDF
      POOLDF=FLOAT(IADF+IWDF)
      DO 460 L=1,M
      FRW(L)=VARR(L)/VARW(L)
      FCL(L)=VARC(L)/VARW(L)
      IF(IREP.EQ.1) GO TO 460
      FAC(L)=VARA(L)/VARW(L)
      POOLSS(L)=ACT(L)+WITHIN(L)
      POOL(L)=POOLSS(L)/POOLDF
      FPRW(L)=VARR(L)/POOL(L)
      FPCL(L)=VARC(L)/POOL(L)
  460 CONTINUE
      IF(IREP.EQ.1) GO TO 550
      DO 500 L=1,M
      WRITE(KT,1070) L,(IVID(L,J),J=1,2)
      WRITE(KT,1080)
      WRITE(KT,1090) ROWS(L),IRDF,VARR(L),FRW(L),FPRW(L)
      WRITE(KT,1100) COLS(L),ICDF,VARC(L),FCL(L),FPCL(L)
      WRITE(KT,1110) ACT(L),IADF,VARA(L),FAC(L)
      WRITE(KT,1120) SUBTOT(L),ISDF
      WRITE(KT,1130) WITHIN(L),IWDF,VARW(L)
  500 WRITE(KT,1140) TOTAL(L),ITDF
      WRITE(KT,1150)
 1150 FORMAT(' *INTERACTION AND WITHIN VARIANCES POOLED')
      GO TO 9999
  550 DO 600 L=1,M
      WRITE(KT,1070) L,(IVID(L,J),J=1,2)
      WRITE(KT,1200)
      WRITE(KT,1210) ROWS(L),IRDF,VARR(L),FRW(L)
      WRITE(KT,1220) COLS(L),ICDF,VARC(L),FCL(L)
      WRITE(KT,1230) WITHIN(L),IWDF,VARW(L)
  600 WRITE(KT,1240) TOTAL(L),ITDF
      GO TO 9999
 9998 WRITE(KT,1160)
 1160 FORMAT(' QUALIFYING VALUES ARE PRESENT IN THE DATA')
 9999 STOP
 1070 FORMAT(///,' VARIABLE',I3,2X,2A4,/)
 1080 FORMAT(' SOURCE',9X,'SUM OF SQUARES',2X,'DF',3X,'MEAN SQUARE',5X,
     *'F',6X,'F*')
 1090 FORMAT(' ROWS',11X,F14.8,I4,F15.8,2F7.2)
 1100 FORMAT(' COLS',11X,F14.8,I4,F15.8,2F7.2)
 1110 FORMAT(' INTERACTION',4X,F14.8,I4,F15.8,F7.2)
 1120 FORMAT('    SUBTOTAL',4X,F14.8,I4)
 1130 FORMAT(' WITHIN',9X,F14.8,I4,F15.8)
 1140 FORMAT('    TOTAL',7X,F14.8,I4)
 1200 FORMAT(' SOURCE',9X,'SUM OF SQUARES',2X,'DF',3X,'MEAN SQUARE',5X,
     *'F')
 1210 FORMAT(' ROWS',11X,F14.8,I4,F15.8,F7.2)
 1220 FORMAT(' COLS',11X,F14.8,I4,F15.8,F7.2)
 1230 FORMAT(' RESIDUAL',7X,F14.8,I4,F15.8)
 1240 FORMAT('    TOTAL',7X,F14.8,I4)
      END
