$NOFLOATCALLS
$STORAGE:2
C     * * * * * * * * *  BASIS STATISTICS - STATPAC * * * * * * * * * *
C                           PROGRAM NO.  BASTAT
C                         U. S. GEOLOGICAL SURVEY
C                  GEOLOGIC DIVISION, DENVER, COLORADO
C                    WRITTEN BY GEORGE VAN TRUMP, JR.
C                            ON MARCH 26, 1978
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C          THIS PROGRAM COMPUTES MIN, MAX, MEAN, DEVIATION, AND DISTRI-
C     BUTION OF QUALIFYING CODES OVER SELECTED ROWS AND/OR SELECTED
C     COLUMNS OF A STATPAC DATA SET.  ALSO HISTOGRAMS OF SELECTED COLUMN
C     AND/OR SIMPLE CORRELATION COEFFICIENTS OF THE SELECTED DATA MAYBE
C     COMPUTED.  THE INPUT DATA MAYBE USED IN ITS ORIGINAL FORM OR CON-
C     VERTED TO LOG10 FOR COMPUTATIONS.  AS AN ADDITIONAL FEATURE, THE
C     PROGRAM WILL CREATE AN OUTPUT STATPAC FILE OF THE SELECTED DATA.
C     ------------------------------------------------------------------
C     RECODED FOR IBM PERSONAL COMPUTER BY W D. GRUNDY
C***  REVISED MARCH 1985 - DOUBLE PRECISION ARITHMETIC IMPLEMENTED.
C     LINKS REQUIRED: ASCIIZ, BYTMOV, CHGCAS, CHRKNT, CKSAFE,
C     CONCAT, DATE, FNDCUR, FSTDSP, GCLPSP, INT21H, IOS, MATCH,
C     MDYHMS, MOVCUR, ODOMTR, PCHVAR, SCREAD, SOUND, TIME
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*8 MDY
      CHARACTER*10 HMS
      LOGICAL SEL,INVERT,FILERR,FLAG
      REAL*4 X
      INTEGER*4 LOC
      CHARACTER*1 IA,IY,JY,ICODES,ILOG,IANS,IBLNK,TAIL(33)
      CHARACTER*4 IDRW,IVID,IDS,DAY
      CHARACTER*32 UNIT10
      CHARACTER*5 HEAD(6)
      DIMENSION SUM(100),VAR(100),ISELC(100,2),ICODES(5),LOC(2),IDRW(4)
      COMMON /RPARM/ IN,IOUT,IDS(2),NR,MC,IVID(100,2),NSR,
     1 ISELR(500,2),NROW,X(100),IA(100),NSC,ISV(100)
      COMMON /STATS/ XMAX(100),XMIN(100),IFREQ(100,6),ILOG
      COMMON /WORKA/ SUMXP(100,100)
      EQUIVALENCE(UNIT10,TAIL(2))
      DATA IY/'y'/,JY/'Y'/,ICODES/' ','B','L','N','G'/,IBLNK/' '/,
     1TAIL/33*' '/
C**********************************************************************
      CALL GCLPSP(KOUNT,TAIL)
      CALL FNDCUR(IRRR,ICCC,0)
      CALL CHGATR(79,2,IRRR-1,0,0)
      CALL MOVCUR(IRRR,ICCC,0)
      CALL DATE(DAY,MDY)
      ILOG=IBLNK
      IN=10
      IOUT=11
      SUMXP(1,1)=0.0
      IF(UNIT10.NE.' ') GO TO 30
   10 WRITE (*,'(A\)') ' ENTER INPUT STATPAC FILE NAME = '
      READ (*,20) UNIT10
   20 FORMAT(A32)
   30 CALL CKSAFE(UNIT10,2,FILERR)
      IF(FILERR) GO TO 10
      OPEN (IN,FILE=UNIT10,STATUS='OLD',IOSTAT=IERR,FORM='UNFORMATTED')
      IF(IERR.NE.0) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' '',''UNABLE TO OPEN FILE '',A32,/,'' IT MAY NOT ''
     1''BE A STATPAC FILE.'')') UNIT10
      GO TO 10
      ENDIF
      READ(IN) IDS,NR,MC
      IF(MC.GT.100) THEN
      WRITE(*,'(A)') ' INPUT FILE HAS TOO MANY VARIABLES.  LIMIT IS 100'
      STOP
      ENDIF
      ISET=0
      CALL TIME(HMS)
   40 NR=0
      MC=0
      SEL=.FALSE.
      REWIND IN
      READ(IN) IDS,NR,MC,(IVID(KK,1),IVID(KK,2),KK=1,MC)
      IF (ISET.EQ.0) THEN
      WRITE(*,'('' '',A4,2X,A8,/,'' '',A10)') DAY,MDY,HMS
      WRITE(*,50) NR,MC
   50 FORMAT(' NO OF ROWS   = ',I5,/,
     1        ' NO OF COLUMNS= ',I5)
      ENDIF
   60 ISET=1
      INVERT=.TRUE.
      NSR=1
      ISELR(1,1)=1
      ISELR(1,2)=NR
      NROW=NR
      WRITE (*,70)
   70 FORMAT(/' DO YOU WANT SELECTED ROWS ? ',\)
      READ (*,760) IANS
      IF (IANS.NE.IY.AND.IANS.NE.JY) GO TO 170
   80 WRITE (*,90)
   90 FORMAT(' HOW MANY ROW PAIRS ? ',\)
      READ (*,160) NSR
      IF (NSR.LE.500) GO TO 110
      WRITE (*,100)
  100 FORMAT(' ERROR --- MORE THAN 500 ROW PAIRS SELECTED. TRY AGAIN.')
      GO TO 80
  110 WRITE (*,120)
  120 FORMAT(' ROW SELECTOR PAIRS:')
      SEL=.TRUE.
      LAST=0
      NROW=0
      INVERT=.TRUE.
      DO 150 I=1,NSR
  130 WRITE (*,140)
  140 FORMAT('      FROM-TO (XXX,XXX) ? ',\)
      ISELR(I,2)=0
      READ (*,*) ISELR(I,1),ISELR(I,2)
      IF (ISELR(I,2).EQ.0) ISELR(I,2)=ISELR(I,1)
      IF (ISELR(I,2).LT.ISELR(I,1).OR.ISELR(I,1).LE.LAST) INVERT=.FALSE.
      LAST=ISELR(I,2)
      NROW=NROW+1+IABS(ISELR(I,2)-ISELR(I,1))
  150 CONTINUE
  160 FORMAT(BN,I4)
  170 NSC=MC
      DO 180 I=1,MC
  180 ISV(I)=I
      WRITE (*,190)
  190 FORMAT(/' DO YOU WANT SELECTED COLUMNS ? ',\)
      READ (*,760) IANS
      IF (IANS.NE.IY.AND.IANS.NE.JY) GO TO 290
  200 WRITE (*,210)
  210 FORMAT(' HOW MANY COLUMN PAIRS ? ',\)
      READ (*,160) NSP
      WRITE (*,220)
  220 FORMAT(' COLUMN SELECTOR PAIRS:')
      SEL=.TRUE.
      DO 240 I=1,NSP
      WRITE (*,230)
  230 FORMAT('      FROM-TO (XXX,XXX) ? ',\)
  240 READ (*,*) ISELC(I,1),ISELC(I,2)
      K=0
      DO 280 I=1,NSP
      N1=ISELC(I,1)
      N2=ISELC(I,2)
      IF (N2.EQ.0) N2=N1
      NA=1
      IF (N1.GT.N2) NA=-1
      J=N1
  250 K=K+1
      IF (K.LE.100) GO TO 270
      WRITE (*,260) K
  260 FORMAT(/' ERROR --- MORE THAN 100 VARIABLES SELECTED. ',I3,' SELE
     1TED. TRY AGAIN.')
      GO TO 200
  270 ISV(K)=J
      IF (J.EQ.N2) GO TO 280
      J=J+NA
      GO TO 250
  280 CONTINUE
      NSC=K
  290 IF (.NOT.SEL) GO TO 310
      WRITE (*,300)
  300 FORMAT(/' DO YOU WANT TO BUILD AN OUTPUT FILE OF SELECTED DATA? '
     1,\)
      READ (*,760) IANS
      IF (IANS.NE.IY.AND.IANS.NE.JY) GO TO 310
      CALL BDSTA(UNIT10)
      GO TO 860
  310 IF (INVERT) GO TO 330
      WRITE (*,320)
  320 FORMAT(/' STATS CANNOT BE RUN WHEN ROWS ARE NOT SELECTED IN SEQUE
     1NTIAL ORDER.'/' TRY AGAIN.')
      GO TO 60
  330 WRITE (*,340)
  340 FORMAT(/' WHAT DO YOU WANT INCLUDED IN BASIC STATISTICS ? ',/
     1 10X,'1-ONLY UNQUALIFIED DATA',/
     2 10X,'2-ONLY QUALIFIED DATA',/
     3 10X,'3-ALL DATA(IGNORING QUALIFYING CODES)')
  350 WRITE (*,360)
  360 FORMAT(' TYPE 1, 2, OR 3 : ',\)
      READ (*,760) IANS
      KIND=ICHAR(IANS)-48
      IF (KIND.GE.1.AND.KIND.LE.3) GO TO 380
      WRITE (*,370)
  370 FORMAT(' TRY AGAIN.')
      GO TO 350
  380 ILOG='N'
      IMAX=1
      IMEAN=1
      ISTD=1
      IF (KIND.NE.1) GO TO 440
      WRITE (*,390)
  390 FORMAT(/' DO YOU WANT TO CONVERT INPUT DATA TO LOGS ? ',\)
      READ (*,760) ILOG
      IF (ILOG.NE.IY.AND.ILOG.NE.JY) GO TO 440
      WRITE (*,400)
  400 FORMAT(/' STATE WHETHER FOLLOWING STATISTICS SHOULD BE EXPRESSED I
     1N TERMS OF'/5X,'1-ORIG  OR  2-LOG 10'/' TYPE 1 OR 2 FOR EACH STATI
     2STIC.')
      WRITE (*,410)
  410 FORMAT('      MAX-MIN ? ',\)
      READ (*,160) IMAX
      WRITE (*,420)
  420 FORMAT('      MEAN    ? ',\)
      READ (*,160) IMEAN
      WRITE (*,430)
  430 FORMAT('      STD DEV ? ',\)
      READ (*,160) ISTD
  440 IF (NSC.LE.100) GO TO 460
      WRITE(*,450)
  450 FORMAT(/' ERROR --- MORE THAN 100 COLS WERE SEL.  TRY SEL FEWER CO
     1LS.')
      GO TO 170
  460 DO 480 I=1,NSC
      SUM(I)=0.0
      VAR(I)=0.0D0
      XMAX(I)=-1.0D35
      XMIN(I)=1.0D35
      DO 470 J=1,6
  470 IFREQ(I,J)=0
      DO 480 J=1,NSC
  480 SUMXP(J,I)=0.0
      L=0
      IQC=0
      WRITE(*,'(''           READING DATA...'')')
      CALL FNDCUR(IRRR,ICCC,0)
      DO 570 II=1,NSR
      DO 570 I=ISELR(II,1),ISELR(II,2)
  490 CALL JKGTLS (IN,IR,IDRW,LOC,X,IA,MC,IERR)
      IF(IERR.NE.0) STOP ' UNEXPECTED END OF FILE'
      IF (IR.NE.I) GO TO 490
      L=L+1
      IF(MOD(L,10).EQ.0) CALL ODOMTR(IRRR,L)
      IF(KIND.NE.1) GO TO 510
      IF(ILOG.NE.IY.AND.ILOG.NE.JY) GO TO 510
      DO 500 JJ=1,NSC
      J=ISV(JJ)
      IF (IA(J).NE.ICODES(1)) GO TO 500
      X(J)=DLOG10(DBLE(X(J)))
  500 CONTINUE
  510 DO 570 JJ=1,NSC
      J=ISV(JJ)
      DO 520 K=1,5
      KX=K
  520 IF (IA(J).EQ.ICODES(K)) GO TO 530
      KX=6
  530 IFREQ(JJ,KX)=IFREQ(JJ,KX)+1
      IF (KIND.EQ.3) GO TO 550
      IF(IA(J).EQ.ICODES(1)) GO TO 540
      IQC=1
      IF (KIND.EQ.2) GO TO 550
      GO TO 570
  540 IF (KIND.NE.1) GO TO 570
  550 SUM(JJ)=SUM(JJ)+X(J)
      VAR(JJ)=VAR(JJ)+X(J)**2
      IF(X(J).GT.XMAX(JJ)) XMAX(JJ)=X(J)
      IF(X(J).LT.XMIN(JJ)) XMIN(JJ)=X(J)
      DO 560 KK=1,NSC
      K=ISV(KK)
  560 SUMXP(JJ,KK)=SUMXP(JJ,KK)+X(J)*X(K)
  570 CONTINUE
      WRITE(*,'(''+'',I5)') L
      DO 620 I=1,NSC
      L=IFREQ(I,1)+IFREQ(I,2)+IFREQ(I,3)+IFREQ(I,4)+IFREQ(I,5)
      IF (KIND.EQ.1) L=IFREQ(I,1)
      IF (KIND.EQ.2) L=IFREQ(I,2)+IFREQ(I,3)+IFREQ(I,4)+IFREQ(I,5)
     1 +IFREQ(I,6)
      IF (L.GT.1) GO TO 580
      VAR(I)=1.0D+35
      GO TO 600
  580 IF (XMIN(I).LT.XMAX(I)) GO TO 590
      VAR(I)=0.0
      GO TO 600
  590 VAR(I)=(VAR(I)-SUM(I)**2/L)/(L-1.0)
  600 DO 620 J=1,NSC
      IF (L.GT.1) GO TO 610
      SUMXP(I,J)=1.0D+35
      GO TO 620
  610 SUMXP(I,J)=(SUMXP(I,J)-SUM(I)/L*SUM(J))/(L-1.0)
  620 CONTINUE
      DO 640 I=1,NSC
      IF (KIND.EQ.1) L=IFREQ(I,1)
      IF (KIND.EQ.2) L=IFREQ(I,2)+IFREQ(I,3)+IFREQ(I,4)+IFREQ(I,5)
     1 +IFREQ(I,6)
      IF (L.GT.0) GO TO 630
      SUM(I)=1.0D+35
      GO TO 640
  630 SUM(I)=SUM(I)/L
  640 SUMXP(I,I)=VAR(I)
      DO 660 I=1,NSC
      DO 660 J=1,NSC
      IF (SUMXP(I,J).GT.1.0D34.OR.VAR(I).GT.1.0D34.OR.VAR(J).GT.1.0D34)
     1 GO TO 660
      IF (VAR(I).LE.1.0D-15) GO TO 650
      IF (VAR(J).LE.1.0D-15) GO TO 650
      SUMXP(I,J)=SUMXP(I,J)/(DSQRT(VAR(I)*VAR(J)))
      GO TO 660
  650 SUMXP(I,J)=0.D0
  660 CONTINUE
      WRITE (*,670)
  670 FORMAT(//,28X,'UNIVARIATE STATISTICS'/)
      IF (ILOG.NE.IY.AND.ILOG.NE.JY) GO TO 710
      DO 680 I=1,6
  680 HEAD(I)='     '
      HEAD(5)='GEOM.'
      HEAD(6)='GEOM.'
      IF (IMAX.LT.2) GO TO 690
      HEAD(1)='* * *'
      HEAD(2)='  LOG'
      HEAD(3)='S * *'
      HEAD(4)='*'
  690 IF (IMEAN.GE.2) HEAD(5)='ARITH'
      IF (ISTD.GE.2) HEAD(6)='ARITH'
      WRITE (*,700) HEAD
  700 FORMAT(14X,3A5,A2,4X,A5,5X,A5)
  710 WRITE (*,720)
  720 FORMAT(' VAR  COLUMN   MINIMUM   MAXIMUM    MEAN',4X,
     1 'DEVIATION  VALID B   L   N   G OTHER')
      DO 730 I=1,NSC
      II=ISV(I)
      XIM=XMIN(I)
      XAX=XMAX(I)
      XMN=SUM(I)
      STD=1.0D+35
      IF (VAR(I).LT.1.0D33.AND.VAR(I).GT.0.0) STD=DSQRT(VAR(I))
      IF (ILOG.NE.IY.AND.ILOG.NE.JY) GO TO 730
      IF (XIM.LT.1.0D33.AND.IMAX.LT.2) XIM=10.0**XIM
      IF (ABS(XAX).LT.1.0D33.AND.IMAX.LT.2) XAX=10.0**XAX
      IF (XMN.LT.1.0D33.AND.IMEAN.LT.2)XMN=10.0**XMN
      IF (XMN.LT.1.0D33.AND.ISTD.LT.2.AND.VAR(I).GT.0.0) STD=10.0**STD
      IF (VAR(I).EQ.0.0) STD=0.0
  730 WRITE (*,740) II,IVID(II,1),IVID(II,2),XIM,XAX,XMN,STD,
     1 (IFREQ(I,J),J=1,6)
  740 FORMAT(' ',I3,1X,2A4,3(1PE10.3),1PE11.4,6I4)
      IF (KIND.EQ.2) GO TO 820
      IF (KIND.EQ.1.AND.IQC.EQ.1) GO TO 820
      WRITE (*,750)
  750 FORMAT(/' DO YOU WANT TO SEE THE CORRELATIONS ? ',\)
      READ (*,760) IANS
  760 FORMAT(A1)
      IF (IANS.NE.IY.AND.IANS.NE.JY) GO TO 820
      IF (ILOG.NE.IY.AND.ILOG.NE.JY) WRITE (*,770)
  770 FORMAT(//,' CORRELATIONS  -  COMPUTED USING ORIGINAL DATA')
      IF (ILOG.EQ.IY.OR.ILOG.EQ.JY) WRITE (*,780)
  780 FORMAT(//,' CORRELATIONS  -  COMPUTED USING LOG 10 DATA')
      DO 800 I=1,NSC,15
      II=MIN0(I+14,NSC)
      WRITE (*,790) (J,J=I,II)
  790 FORMAT(/3X,15I5)
      DO 800 J=1,NSC
  800 WRITE (*,810) J,(SUMXP(J,K),K=I,II)
  810 FORMAT(' ',I3,1X,15F5.2)
  820 WRITE (*,830)
  830 FORMAT(/' DO YOU WANT HISTOGRAMS FOR ANY SELECTED COLUMNS ? ',\)
      READ (*,760) IANS
      IF (IANS.NE.IY.AND.IANS.NE.JY) GO TO 840
      CALL GRAPH
  840 WRITE (*,850)
  850 FORMAT(/' DO YOU WANT PERCENTILES FOR SELECTED DATA ? ',\)
      READ (*,760) IANS
      IF (IANS.NE.IY.AND.IANS.NE.JY) GO TO 860
      CALL PRCEN
  860 WRITE (*,870)
  870 FORMAT(/' DO YOU WANT ANOTHER SET OF COMPUTATIONS ? ',\)
      READ (*,760) IANS
      IF (IANS.EQ.IY.OR.IANS.EQ.JY) GO TO 40
      CLOSE (IN)
      WRITE (*,880)
  880 FORMAT(/' DO YOU WANT TO PROCESS DATA FROM ANOTHER FILE ? ',\)
      READ (*,760) IANS
      IF (IANS.NE.IY.AND.IANS.NE.JY) GO TO 890
      GO TO 10
  890 STOP 'NORMAL END OF PROGRAM'
      END
      SUBROUTINE BDSTA(UNIT10)
C***  THIS SUBPROGRAM WAS WRITTEN BY GEORGE VAN TRUMP
C***  RECODED FOR IBM PERSONAL COMPUTER BY W. D. GRUNDY
C***  REVISED MARCH 1985 - DOUBLE PRECISION ARITHMETIC IMPLEMENTED
C***  THIS SUBPROGRAM IS CALLED BY PROGRAM BASTAT
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*4 X,Y
      INTEGER*4 LOC
      CHARACTER*1 IA,IY,ICODES
      CHARACTER*4 IDRW,IVID,IDS,ID
      CHARACTER*32 UNIT10,FILNAM
      CHARACTER*5 HEAD(6)
      LOGICAL FILERR
      DIMENSION ID(2),Y(100),IY(100),LOC(2),IDRW(4)
      COMMON /RPARM/ IN,IOUT,IDS(2),NR,MC,IVID(100,2),NSR,
     1 ISELR(500,2),NROW,X(100),IA(100),NSC,ISV(100)
   10 WRITE(*,'(/'' ENTER OUTPUT STATPAC FILE NAME = '',\)')
      READ (*,20) FILNAM
   20 FORMAT(A32)
      IF(FILNAM.EQ.UNIT10) THEN
      CALL WARN
      WRITE(*,'(A)') ' STATPAC INPUT FILE CANNOT BE USED FOR OUTPUT'
      GO TO 10
      ENDIF
      CALL CKSAFE(FILNAM,1,FILERR)
      IF(FILERR) GO TO 10
      OPEN (IOUT,FILE=FILNAM,STATUS='NEW',FORM='UNFORMATTED')
      WRITE (*,30)
   30 FORMAT(/' ENTER OUTPUT DATA SET NAME TO BE USED = ',\)
      READ (*,40) ID
   40 FORMAT(2A4)
      WRITE (IOUT) ID,NROW,NSC,((IVID(ISV(I),J),J=1,2),I=1,NSC)
      ICT=0
      LAST=0
      WRITE(*,'(''           WRITING DATA...'')')
      CALL FNDCUR(IRRR,ICCC,0)
      DO 80 II=1,NSR
      N1=ISELR(II,1)
      N2=ISELR(II,2)
      IF (N2.EQ.0) N2=N1
      NA=1
      IF (N1.GT.N2) NA=-1
      I=N1
   50 IF (I.GT.LAST) GO TO 60
      REWIND IN
      READ(IN) IDS,NR,MC,(IVID(KK,1),IVID(KK,2),KK=1,MC)
   60 CALL JKGTLS (IN,IR,IDRW,LOC,X,IA,MC,IERR)
      IF(IERR.NE.0) STOP ' UNEXPECTED END OF FILE'
      IF (IR.NE.I) GO TO 60
      LAST=I
      DO 70 J=1,NSC
      JJ=ISV(J)
      Y(J)=X(JJ)
      IY(J)=IA(JJ)
   70 CONTINUE
      ICT=ICT+1
      IF(MOD(ICT,10).EQ.0) CALL ODOMTR(IRRR,ICT)
      CALL JKPTLS (IOUT,ICT,IDRW,LOC,Y,IY,NSC)
      IF (I.EQ.N2) GO TO 80
      I=I+NA
      GO TO 50
   80 CONTINUE
      WRITE(*,'(''+'',I5)') ICT
      CLOSE (IOUT)
      RETURN
      END
      SUBROUTINE GRAPH
C***  THIS SUBPROGRAM WAS WRITTEN BY GEORGE VAN TRUMP
C***  RECODED FOR IBM PERSONAL COMPUTER BY W. D. GRUNDY
C***  REVISED MARCH 1985 - DOUBLE PRECISION ARITHMETIC IMPLEMENTED
C***  THIS SUBPROGARAM IS CALLED BY PROGRAM BASTAT
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*4 X
      INTEGER*4 LOC
      CHARACTER*1 IA,IY,JY,IANS,ILOG,XXX
      CHARACTER*4 IDRW,IVID,IDS
      CHARACTER*5 HEAD(6)
      DIMENSION IDIST(44),IDRW(4),LOC(2)
      COMMON /RPARM/ IN,IOUT,IDS(2),NR,MC,IVID(100,2),NSR,
     1 ISELR(500,2),NROW,X(100),IA(100),NSC,ISV(100)
      COMMON /STATS/ XMAX(100),XMIN(100),IFREQ(100,6),ILOG
      DATA XXX/'X'/,IY/'Y'/,JY/'y'/
      IPRT=0
   10 REWIND IN
      READ(IN) IDS,NR,MC,(IVID(KK,1),IVID(KK,2),KK=1,MC)
   20 WRITE(*,'(/,'' ENTER COL NO. FOR WHICH HISTOGRAM IS DE'',''SIRED 
     1= '',\)')
      READ (*,*,ERR=30) ICOL
      GO TO 40
   30 WRITE(*,'(A)') ' INTEGER VALUE IS REQUIRED. REDO.'
      GO TO 20
   40 DO 50 I=1,NSC
      NX=I
   50 IF (ICOL.EQ.ISV(I)) GO TO 70
      WRITE (*,60)
   60 FORMAT(/' DESIRED COL NOT SELECTED INITIALLY.  TRY AGAIN.')
      GO TO 20
   70 WRITE (*,80)
   80 FORMAT(/' DO YOU WANT TO ENTER LWR LIMIT & CLASS INTERVAL FOR'
     1,' THIS COL?')
      IF (IPRT.NE.0) GO TO 100
      IPRT=1
      WRITE (*,90)
   90 FORMAT(5X, 'IF NOT THE MINIMUM VALUE FOR THIS COL AND STURGES''',
     1' RULE WILL BE USED TO'/5X,'COMPUTE THE HISTOGRAM.')
  100 READ (*,110) IANS
  110 FORMAT(A1)
      ALWR=XMIN(NX)
      AN=FLOAT(IFREQ(NX,1))
      IF(AN.LE.0.D0) THEN
      WRITE(*,'('' '',''NOT POSSIBLE TO COMPUTE HISTOGRAM OF THIS'','' 
     1VARIABLE - TRY SOME OTHER VARIABLE'')')
      GO TO 390
      ENDIF
      NM=IFIX(2.5+1.442726*LOG(SNGL(AN)))
      CLASIN=(XMAX(NX)-XMIN(NX))/DBLE(FLOAT(NM))
      IF(CLASIN.LE.0.D0) THEN
      WRITE(*,'('' MINIMUM OF VARIABLE EQUALS MAXIMUM -- NO'',
     1'' HISTOGRAM POSSIBLE'')')
      GO TO 390
      ENDIF
      AK=0.4344294D0*DLOG(CLASIN)
      K=IFIX(SNGL(AK))
      IF (AK.LT.0.) K=K-1
      ICI=IFIX(SNGL((CLASIN+5.0*10.0**(K-2))*10.0**(-K+1)))
      CLASIN=FLOAT(ICI)*10.0**(K-1)
      IF (IANS.NE.IY.AND.IANS.NE.JY) GO TO 160
  120 IF (ILOG.NE.IY.AND.ILOG.NE.JY) WRITE (*,130)
  130 FORMAT(' ENTER LWR LMT & INTERVAL (IN ORIG DATA) = ',\)
      IF (ILOG.EQ.IY.OR.ILOG.EQ.JY) WRITE (*,140)
  140 FORMAT(' ENTER LWR LMT & INTERVAL (IN LOGS) = ',\)
      READ (*,*,ERR=150) ALWR,CLASIN
      GO TO 160
  150 WRITE(*,'('' '',''REAL VALUES ARE REQUIRED.  REDO.'')')
      GO TO 120
  160 DO 190 K=1,40
      IF (ALWR+K*CLASIN.LE.XMAX(NX)) GO TO 190
      IF (K.LE.40) GO TO 180
      WRITE (*,170)
  170 FORMAT(' NO OF CLASSES EXCEEDS MAX NO (40) ALLOWED.  TRY AGAIN.')
      GO TO 70
  180 NM=K
      GO TO 200
  190 CONTINUE
      NM=40
  200 NGPS=(XMAX(NX)-ALWR)/CLASIN+1.0
      IF (NGPS.GT.40) WRITE (*,210) NGPS
  210 FORMAT(' WARNING --- NO OF CLASSES(',I4,') > MAX ALLOWED(40).'/
     1 5X,'ONLY THE 1ST 40 WILL BE USED.')
       IANS='N'
      IF (ILOG.NE.IY.AND.ILOG.NE.JY) GO TO 230
      WRITE (*,220)
  220 FORMAT(/' DO YOU WANT BOUNDARIES CONVERTED TO ANTILOGS ? ',\)
      READ (*,110) IANS
  230 DO 240 I=1,44
  240 IDIST(I)=0
      KMAX=2
      JSUM=0
      WRITE(*,'(''           READING DATA...'')')
      CALL FNDCUR(IRRR,ICCC,0)
      DO 270 I=1,NSR
      JSUM=JSUM+ISELR(I,2)-ISELR(I,1)+1
      DO 270 J=ISELR(I,1),ISELR(I,2)
  250 CALL JKGTLS (IN,IR,IDRW,LOC,X,IA,MC,IERR)
      IF(IERR.NE.0) STOP ' UNEXPECTED END OF FILE'
      IF (J.NE.IR) GO TO 250
      IF(MOD(IR,10).EQ.0) CALL ODOMTR(IRRR,IR)
      IF (IA(ICOL).NE.' ') GO TO 270
      XX=X(ICOL)
      IF (ILOG.EQ.IY.OR.ILOG.EQ.JY) XX=DLOG10(XX)
      DO 260 K=1,NM
      IF (XX.LT.ALWR+(K-1)*CLASIN) GO TO 260
      IF (XX.GE.ALWR+K*CLASIN) GO TO 260
      IDIST(K+2)=IDIST(K+2)+1
      IF (K.GT.KMAX) KMAX=K
      GO TO 270
  260 CONTINUE
  270 CONTINUE
      WRITE(*,'(''+'',I5)') IR
      JSUM=JSUM-IFREQ(NX,6)
      K1=KMAX+3
      K2=KMAX+4
      IDIST(1)=IFREQ(NX,4)
      IDIST(2)=IFREQ(NX,3)
      IDIST(K1)=IFREQ(NX,5)
      IDIST(K2)=IFREQ(NX,2)
      WRITE (*,280) ICOL,IVID(ICOL,1),IVID(ICOL,2)
  280 FORMAT(/' HISTOGRAM FOR COL NO. ',I3,'(' ,2A4,')'//
     1 23X,'OBS CUM  PER  CUM',7X,'CLASS',/4X,'LIMIT - UPPER',6X,
     1 'FRQ FRQ  FRQ  FRQ',6X,'MIDPOINT  DISTRIBUTION'/)
      ISUM=0
      DO 290 I=1,K1
  290 ISUM=ISUM+IDIST(I)
      IF (ISUM.GT.0) GO TO 310
      WRITE (*,300)
  300 FORMAT(/' NO DATA CONTAINED IN INTERVAL SELECTED.')
      GO TO 390
  310 ISUM1=0
      DO 380 I=1,K2
      ISUM1=ISUM1+IDIST(I)
      PER1=100.0*IDIST(I)/JSUM
      PER2=100.0*ISUM1/JSUM
      ALO=ALWR+(I-3)*CLASIN
      AHI=ALWR+(I-2)*CLASIN
      IF (IANS.NE.IY.AND.IANS.NE.JY) GO TO 320
      ALO=10.0**ALO
      AHI=10.0**AHI
  320 PTMID=(ALO+AHI)/2.0
      IPT=PER1/4.0+0.5
      IF (I.EQ.1) WRITE (*,330) IDIST(I),ISUM1,PER1,PER2
  330 FORMAT(10X,'N',11X,2I4,F5.1,F6.1)
      IF (I.EQ.2) WRITE (*,340) IDIST(I),ISUM1,PER1,PER2
  340 FORMAT(10X,'L',11X,2I4,F5.1,F6.1)
      IF (I.GE.3.AND.I.LE.KMAX+2.AND.IPT.GT.0) WRITE (*,350) ALO,AHI,
     1IDIST(I),ISUM1,PER1,PER2,PTMID,(XXX,K=1,IPT)
  350 FORMAT(1X,1PE10.3,'-',1PE10.3,2I4,0PF5.1,F6.1,3X,1PE10.3,1X,
     1 25A1)
      IF (I.GE.3.AND.I.LE.KMAX+2.AND.IPT.EQ.0) WRITE (*,350) ALO,AHI,
     1IDIST(I),ISUM1,PER1,PER2,PTMID
      IF (I.EQ.K1) WRITE (*,360) IDIST(I),ISUM1,PER1,PER2
  360 FORMAT(10X,'G',11X,2I4,F5.1,F6.1)
      IF (I.EQ.K2) WRITE (*,370) IDIST(I),ISUM1
  370 FORMAT(10X,'B',11X,2I4)
  380 CONTINUE
  390 WRITE (*,400)
  400 FORMAT(/' DO YOU WANT ANOTHER HISTOGRAM ? ',\)
      READ (*,110) IANS
      IF (IANS.EQ.IY.OR.IANS.EQ.JY) GO TO 10
      RETURN
      END
      SUBROUTINE PRCEN
C***  THIS SUBPROGRAM WAS WRITTEN BY GEORGE VAN TRUMP
C***  RECODED FOR IBM PERSONAL COMPUTER BY W. D. GRUNDY
C***  REVISED MARCH 1985 - DOUBLE PRECISION ARITHMETIC IMPLEMENTED
C***  THIS SUBPROGRAM IS CALLED BY PROGRAM BASTAT.
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*4 X
      INTEGER*4 LOC,IFREQ
      CHARACTER*1 IA,IY,ICODES,IANS,ICD,ILOG
      CHARACTER*4 IDRW,IVID,IDS,ID
      CHARACTER*5 HEAD(6)
      DIMENSION PRT(8),ICD(4),FR(18),IDRW(4),LOC(2),ID(2),BD(16),F(16)
      COMMON /RPARM/ IN,IOUT,IDS(2),NR,MC,IVID(100,2),NSR,
     1 ISELR(500,2),NROW,X(100),IA(100),NSC,ISV(100)
      COMMON /STATS/ XMAX(100),XMIN(100),IFRQCY(100,6),ILOG
      COMMON /WORKA/ IFREQ(100,18),PER(100,8),BOUND(100,18),REST(6500)
      EQUIVALENCE (ID(1),IDRW(1))
      DATA PRT/25.0,50.0,75.0,80.0,85.0,90.0,95.0,99.0/,ICD/' ','N',
     1 'L','G'/
      REWIND IN
      READ(IN) IDS,NR,MC,(IVID(KK,1),IVID(KK,2),KK=1,MC)
      IANS='N'
      IF (ILOG.NE.'y'.AND.ILOG.NE.'Y') GO TO 30
      WRITE (*,10)
   10 FORMAT(/' DO YOU WANT VALUES CONVERTED TO ANTILOGS ? ',\)
      READ (*,20) IANS
   20 FORMAT(A1)
      WRITE(*,'(''           READING DATA...'')')
      CALL FNDCUR(IRRR,ICCC,0)
   30 DO 40 I=1,18
      DO 40 J=1,100
      IF (I.LT.9) PER(J,I)=1.0D35
   40 IFREQ(J,I)=0
      DO 50 I=1,NSC
      DEL=(XMAX(I)-XMIN(I))/15.0
      DO 50 J=1,17
   50 BOUND(I,J)=(J-1)*DEL+XMIN(I)
      DO 150 I=1,NSR
      DO 150 J=ISELR(I,1),ISELR(I,2)
   60 CALL JKGTLS (IN,IR,IDRW,LOC,X,IA,MC,IERR)
      IF(IERR.NE.0) STOP ' UNEXPECTED END OF FILE'
      IF (J.NE.IR) GO TO 60
      IF(MOD(IR,10).EQ.0) CALL ODOMTR(IRRR,IR)
      IF (ILOG.NE.'Y'.AND.ILOG.NE.'y') GO TO 80
      DO 70 K=1,NSC
      L=ISV(K)
      IF (IA(L).NE.'    ') GO TO 70
      X(L)=ALOG10(X(L))
   70 CONTINUE
   80 DO 150 K=1,NSC
      CLASIN=(XMAX(K)-XMIN(K))/15.0
      M=ISV(K)
      DO 90 L=1,4
      NX=L
   90 IF (IA(M).EQ.ICD(L)) GO TO 100
      GO TO 150
  100 GO TO (130,110,110,120),NX
  110 IFREQ(K,1)=IFREQ(K,1)+1
      GO TO 150
  120 IFREQ(K,18)=IFREQ(K,18)+1
      GO TO 150
  130 DO 140 L=1,16
      IF (X(M).LT.XMIN(K)+(L-1)*CLASIN) GO TO 140
      IF (X(M).GE.XMIN(K)+L*CLASIN) GO TO 140
      IFREQ(K,L+1)=IFREQ(K,L+1)+1
      GO TO 150
  140 CONTINUE
  150 CONTINUE
      WRITE(*,'(''+'',I5)') IR
      DO 210 I=1,NSC
      SUM=0.0
      DO 160 J=1,18
  160 SUM=SUM+IFREQ(I,J)
      SUMA=0.0
      DO 170 J=1,18
      IF (SUM.EQ.0.0) GO TO 170
      FR(J)=100.0*IFREQ(I,J)/SUM+SUMA
      SUMA=FR(J)
  170 CONTINUE
      L=0
      DO 180 K=2,17
      IF (IFREQ(I,K).EQ.0) GO TO 180
      L=L+1
      BD(L)=BOUND(I,K)
      F(L)=FR(K)
  180 CONTINUE
      NL=L-1
      DO 210 J=1,8
      IF (PRT(J).LT.F(1)) GO TO 210
      IF (PRT(J).GT.F(L)) GO TO 210
      DO 200 K=1,NL
      IF (PRT(J).LT.F(K)) GO TO 200
      IF (PRT(J).GT.F(K+1)) GO TO 200
      PER(I,J)=BD(K)
      IF (F(K)-F(K+1).EQ.0.0) GO TO 190
      A=PRT(J)-F(K)
      PER(I,J)=(PRT(J)-F(K))*(BD(K)-BD(K+1))/(F(K)-F(K+1))+BD(K)
  190 IF (IANS.EQ.'Y'.OR.IANS.EQ.'y') PER(I,J)=10.0**PER(I,J)
      GO TO 210
  200 CONTINUE
  210 CONTINUE
      WRITE (*,220) PRT
  220 FORMAT(/,' VAR ID  ',8(F7.1,2X))
      DO 230 I=1,NSC
  230 WRITE (*,240) IVID(ISV(I),1),IVID(ISV(I),2),(PER(I,J),J=1,8)
  240 FORMAT(' ',2A4,8F9.4)
      RETURN
      END
