TITLE    SUBROUTINE LNREAD(STRING,NCHAR,IAH)
;
FRAME    STRUC
SAVEDI         DW         ?
SAVEBP         DW         ?
SAVERET        DD         ?
C              DD         ?                 ;POINTER TO IAH
B              DD         ?                 ;POINTER TO NCHAR
A              DD         ?                 ;POINTER TO IAH
FRAME          ENDS
;
_DATA          SEGMENT    'DATA'
_DATA          ENDS
;
LNRD_TEXT      SEGMENT    'CODE'
DGROUP         GROUP      _DATA
               ASSUME     CS:LNRD_TEXT,DS:DGROUP,SS:DGROUP
;
               PUBLIC     LNREAD
LNREAD         PROC       FAR
               PUSH       BP               ;SAVE CALLER'S BP
               PUSH       DI
               MOV        BP,SP
               LES        BX,[BP]+C
               MOV        AX,0
               MOV        ES:[BX],AX       ;PUT 0 IN IAH
               LES        DI,[BP]+B        ;GET ADDRESS OF NCHAR
               MOV        CX,ES:[DI]       ;SAVE AS A LOOP COUNTER
               MOV        BX,CX
               LES        DI,[BP]+A        ;GET ADDRESS OF STRING
               MOV        DX,DI
               CLD
               MOV        AL,20H           ;BLANK IN AL
               REP STOSB                   ;STORE BLANKS IN STRING
               MOV        DI,DX            ;RESTORE OFFSET AFTER STOSB
               MOV        CX,BX            ;RESTORE COUNTER IN CX
GET_KEY:       MOV        AX,0
               INT        16H              ;TEST FOR KEY PRESS
               CMP        AX,0
               JE         GET_KEY          ;LOOP UNTIL A KEY IS PRESSED
               CMP        AX,0E08H         ;BACKSPACE KEY?
               JE         RUB_OUT
               CMP        AL,0             ;WAS NON-ASCII KEY PRESSED?
               JNE        ASCII_KEY
               CMP        AH,3BH           ;WAS F1-F8 PRESSED?
               JB         ARROWS
               CMP        AH,42H
               JA         ARROWS
NOT_DATA:      LES        BX,[BP]+C
               XCHG       AH,AL
               LES        BX,[BP]+C        ;GET ADDRESS OF IAH
               MOV        ES:[BX],AX
               JMP SHORT  EXIT
ARROWS:        CMP        AX,4B00H         ;LEFT-ARROW PRESSED?
               JE         RUB_OUT
               CMP        AH,48H           ;UP ARROW?
               JE         NOT_DATA
               CMP        AH,50H           ;DOWN ARROW?
               JE         NOT_DATA
               JMP SHORT  GET_KEY
RUB_OUT:       CMP        CX,BX            ;AT FIRST CHARACTER?
               JE         GET_KEY          ;IF YES, DO NOTHING
               INC        CX               ;ADJUST LOOP COUNTER
               DEC        DI               ;ADJUST SCREEN ARRAY
               MOV        AL,20H           ;PUT BLANK IN SCREEN ARRAY
               MOV        BYTE PTR ES:[DI],AL
               PUSH       DX
               PUSH       CX
               MOV        AH,03H           ;REQUEST FIND CURSOR
               INT        10H
               MOV        AH,02H           ;REQUEST SET CURSOR POSITION
               DEC        DL               ;ONE COLUMN TO LEFT
               INT        10H
               MOV        AX,0A20H
               MOV        CX,1
               INT        10H              ;PUT BLANK ON SCREEN
               POP        CX
               POP        DX
               JMP        GET_KEY
ASCII_KEY:     CMP        AX,1C0DH         ;CARRIAGE RETURN PRESSED?
               JE         EXIT             ;IF YES, EXIT.
               MOV        BYTE PTR ES:[DI],AL
               INC        DI               ;UPDATE STRING OFFSET
               MOV        AH,14            ;DISPLAY CHARACTER ON THE
               INT        10H              ;SCREEN
               LOOP       GET_KEY          ;GET ANOTHER KEY
EXIT:          POP        DI
               POP        BP               ;RESTORE CALLER'S BP
               RET        12               ;RELEASE 12 BYTES.
LNREAD         ENDP
LNRD_TEXT      ENDS
               END
