$STORAGE:2
      SUBROUTINE MATKLO (A,N)
C***  A IS THE MATRIX TO BE INVERTED AND THE INVERSE ON RETURN
C***  N IS THE NUMBER OF ROWS AND COLUMNS IN A
C***  FROM J. E. KLOVAN, UNIV. OF CALGARY
C***  THIS SUBPROGRAM IS CALLED BY PROGRAM CURVES
C***  
C***  MATINV SUBROUTINE
C***  MATRIX INVERSION WITH ACCOMPANYING SOLUTION OF LINEAR EQUATIONS
C***  
C***  DIMENSION IPIVOT(10),A(10,10),B(10,1),INDEX(10,2),PIVOT(10)
C***  
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION IPIVOT(3), A(3,3), B(3,1), INDEX(3,2), PIVOT(3)
      EQUIVALENCE (IROW,JROW), (ICOLUM,JCOLUM), (AMAX,T,SWAP)
C***  
      DETERM=1.D0
      M=1
C***  
C***  INITIALIZATION
C***  
      DETERM=1.D0
      DO 10 J=1,N
   10 IPIVOT(J)=0
      DO 200 I=1,N
C***  
C***  SEARCH FOR PIVOT ELEMENT
C***  
      AMAX=0.D0
      DO 60 J=1,N
      IF (IPIVOT(J)-1) 20,60,20
   20 DO 50 K=1,N
      IF (IPIVOT(K)-1) 30,50,240
   30 IF (DABS(AMAX)-DABS(A(J,K))) 40,50,50
   40 IROW=J
      ICOLUM=K
      AMAX=A(J,K)
   50 CONTINUE
   60 CONTINUE
      IPIVOT(ICOLUM)=IPIVOT(ICOLUM)+1
C***  
C***  INTERCHANGE ROWS TO PUT ELEMENT ON DIAGONAL
C***  
      IF(IROW-ICOLUM) 70,110,70
   70 DETERM=-DETERM
      DO 80 L=1,N
      SWAP=A(IROW,L)
      A(IROW,L)=A(ICOLUM,L)
   80 A(ICOLUM,L)=SWAP
      IF (M) 110,110,90
   90 DO 100 L=1,M
      SWAP=B(IROW,L)
      B(IROW,L)=B(ICOLUM,L)
  100 B(ICOLUM,L)=SWAP
  110 INDEX(I,1)=IROW
      INDEX(I,2)=ICOLUM
      PIVOT(I)=A(ICOLUM,ICOLUM)
      DETERM=DETERM*PIVOT(I)
C***  
C***  DIVIDE PIVOT ROW BY PIVOT ELEMENT
C***  
      A(ICOLUM,ICOLUM)=1.D0
      DO 120 L=1,N
  120 A(ICOLUM,L)=A(ICOLUM,L)/PIVOT(I)
      IF (M) 150,150,130
  130 DO 140 L=1,M
  140 B(ICOLUM,L)=B(ICOLUM,L)/PIVOT(I)
C***  
C***  REDUCE NON-PIVOT ROWS
C***  
  150 DO 200 L1=1,N
      IF (L1-ICOLUM) 160,200,160
  160 T=A(L1,ICOLUM)
C***  
      A(L1,ICOLUM)=0.0
      DO 170 L=1,N
  170 A(L1,L)=A(L1,L)-A(ICOLUM,L)*T
      IF (M) 200,200,180
  180 DO 190 L=1,M
  190 B(L1,L)=B(L1,L)-B(ICOLUM,L)*T
  200 CONTINUE
C***  
C***  INTERCHANGE COLUMNS
C***  
      DO 230 I=1,N
      L=N+1-I
      IF (INDEX(L,1)-INDEX(L,2)) 210,230,210
  210 JROW=INDEX(L,1)
      JCOLUM=INDEX(L,2)
      DO 220 K=1,N
      SWAP=A(K,JROW)
      A(K,JROW)=A(K,JCOLUM)
      A(K,JCOLUM)=SWAP
  220 CONTINUE
  230 CONTINUE
  240 RETURN
C***  
      END
