$STORAGE:2
C PROGRAM MATRIX
C MUST BE LINKED WITH MATRIX1.FOR, EIGEN.FOR, MATKLO.FOR AND IOS.FOR
C FOR HONEYWELL
C BY A.T. MIESCH, USGS, DENVER, MARCH,1975
C EIGEN SUBROUTINE FROM D0096 PROGRAM BY D.S.HANDWERKER
C MATKLO SUBROUTINE FROM J.E. KLOVAN
      IMPLICIT REAL*8 (A-H,O-Z)
      CHARACTER*4 IT(26),ICOM
      CHARACTER*1 IY,JY,IANS
      INTEGER A,B,C
      DIMENSION XX(10,10),RW(10),CL(10),R(100),D(10),
     *XXX(100),E(10),XTMP(10)
      COMMON/XXXX/ ICOM
      COMMON/YYYY/ NN(20),MM(20),A,B,C
      COMMON/ZZZZ/ X(20,10,10),SCALE
      EQUIVALENCE (XX(1,1),XXX(1))
      DATA IT/'ENTR','INVT','TRPS','ROWN','COLS','CORR','PROM','PROR',
     1 'MULT','EGVL','MINP','MAJP','RMAT','CLSE','SAVE','RITE','QUIT',
     2'ADD ','SUBT','PART','READ','FIX ','SCAL','VCOV','SCOL','POWR'/
      DATA IY/'Y'/,JY/'y'/
      A=0
      DO 10 I=1,20
      DO 10 J=1,10
      DO 10 K=1,10
   10 X(I,J,K)=0.0
      WRITE(*,20)
   20 FORMAT(' DO YOU WANT A LIST OF STANDARD COMMANDS ?')
      READ (*,30) IANS
   30 FORMAT(A1)
      IF(IANS.NE.IY.AND.IANS.NE.JY) GO TO 90
      WRITE(*,40)
      WRITE(*,50)
      WRITE(*,60)
   40  FORMAT(' THE FOLLOWING STANDARD COMMANDS SHOULD BE USED',/,
     1' ENTR - TO ENTER A MATRIX',/,
     2' READ - TO READ A MATRIX FROM A STATPAC FILE',/,
     3' PART - TO PARTITION A MATRIX',/,
     4' COLS - TO COLUMN-STANDARDIZE A MATRIX',/,
     5' ROWN - TO ROW-NORMALIZE A MATRIX',/,
     6' PROM - TO TRANSFORM COLUMNS TO PROPORTIONS OF COL MAXIMUMS',/,
     7' PROR - TO TRANSFORM COLUMNS TO PROPORTIONS OF COL RANGES',/,
     8' CLSE - TO ADJUST MATRIX ROWS TO SUM TO 100',/,
     9' FIX  - TO CHANGE SPECIFIC ELEMENTS IN A MATRIX')
   50 FORMAT(' SCAL - TO MULTIPLY A MATRIX BY A SCALAR',/,
     1' SCOL - TO TRANSFORM THE COLUMNS OF A MATRIX BY Y=AX+B',/,
     2' CORR - TO TRANSFORM A MATRIX FOR CORRESPONDENCE ANALYSIS',/,
     3' TRPS - TO TRANSPOSE A MATRIX',/,
     4' MINP - TO COMPUTE THE MINOR (INNER) PRODUCT OF A MATRIX',/,
     5' MAJP - TO COMPUTE THE MAJOR (OUTER) PRODUCT OF A MATRIX',/,
     6' ADD  - TO ADD TWO MATRICES',/,
     7' SUBT - TO SUBTRACT ONE MATRIX FROM ANOTHER',/,
     8' MULT - TO MULTIPLY TWO MATRICES',/,
     9' POWR - TO RAISE A MATRIX TO A POWER')
   60 FORMAT(' RMAT - TO COMPUTE MEANS, STD DEVS, AND CORRELATIONS FOR T
     1HE',/,'        COLUMNS OF A MATRIX',/,
     2' VCOV - TO COMPUTE THE VARIANCE-COVARIANCE MATRIX',/,
     3' INVT - TO INVERT A MATRIX',/,
     4' EGVL - TO EXTRACT THE EIGENVALUES AND EIGENVECTORS OF A MATRIX A
     5ND',/,'        DERIVE THE PRINCIPAL COMPONENTS MATRIX',/,
     6' SAVE - TO SAVE A MATRIX BY RENUMBERING IT FROM 1 TO 10',/,
     7' RITE - TO WRITE A MATRIX ON A STATPAC FILE',/,
     8' QUIT - TO END COMPUTATIONS')
      WRITE(*,70)
   70 FORMAT(' MATRIX SIZES ARE LIMITED TO 10 ROWS AND 10 COLUMNS.',/,
     1' AFTER 20 MATRICES HAVE BEEN GENERATED, MATRICES 11 TO 20 WILL BE
     2 LOST.',/,'  MATRICES 1 TO 10 ARE PRESERVED UNLESS OVERWRITTEN BY
     3 SAVE COMMAND.')
      WRITE(*,80)
   80 FORMAT(' NOTE: ALL COMMANDS MUST BE GIVEN IN UPPER-CASE LETTERS!',
     1//)
C  **********
C  FIRST COMMAND SECTION
C  **********
   90 WRITE(*,100)
  100 FORMAT(' WHAT DO YOU WANT TO DO FIRST ?:')
      READ (*,320) ICOM
      IF(ICOM.EQ.IT(1).OR.ICOM.EQ.IT(21)) GO TO 120
      WRITE(*,110)
  110 FORMAT(' FIRST COMMAND MUST BE EITHER ENTR OR READ')
      GO TO 90
  120 IF(ICOM.EQ.IT(1)) GO TO 130
      CALL MATRIX1
      GO TO 270
C  **********
C  TO ENTER A MATRIX
C  **********
  130 A=A+1
      IF(A.GT.20) A=11
  140 WRITE(*,150)
  150 FORMAT(' NO. OF ROWS IN MATRIX TO BE ENTERED = ')
      READ (*,*) N
      IF(N.LT.1.OR.N.GT.10) GO TO 140
  170 WRITE(*,180)
  180 FORMAT(' NO. OF COLS IN MATRIX TO BE ENTERED = ')
      READ (*,*) M
      IF(M.LT.1.OR.M.GT.10) GO TO 170
      WRITE(*,190)
  190 FORMAT(' ENTER MATRIX - ROW BY ROW')
      DO 220 I=1,N
      READ (*,*) (X(A,I,J),J=1,M)
  220 WRITE(*,230) I
  230 FORMAT(' END OF ROW',I3,/)
      WRITE(*,240) A
  240 FORMAT(' THIS IS MATRIX',I3,'******')
      DO 250 I=1,N
  250 WRITE(*,260) (X(A,I,J),J=1,M)
  260 FORMAT(1X,5G14.7)
      NN(A)=N
      MM(A)=M
C  **********
C  CONTROL SECTION
C  **********
  270 WRITE(*,280)
  280 FORMAT(' WHAT DO YOU WANT TO DO NOW ?')
      GO TO 310
  290 WRITE(*,300)
  300 FORMAT(' USE STANDARD COMMANDS'/)
  310 READ (*,320) ICOM
  320 FORMAT(A4)
      IF(ICOM.EQ.IT(17)) GO TO 9999
      IF(ICOM.NE.IT(21)) GO TO 325
      CALL MATRIX1
      GO TO 270
  325 DO 330 I=1,26
      IF(ICOM.EQ.IT(I)) GO TO 340
  330 CONTINUE
      GO TO 290
  340 IF(ICOM.EQ.IT(1)) GO TO 130
      IF(ICOM.EQ.IT(9).OR.ICOM.EQ.IT(18).OR.ICOM.EQ.IT(19)) GO TO 390
      IF(A.GT.1) GO TO 350
      B=1
      GO TO 370
  350 WRITE(*,360)
  360 FORMAT(' WHICH MATRIX ? '/)
      READ (*,*) B
      IF(B.LE.0.OR.B.GT.20) GO TO 350
  370 IF(ICOM.NE.IT(23)) GO TO 450
      WRITE(*,380)
  380 FORMAT(' GIVE THE SCALAR VALUE:')
      READ (*,*) SCALE
      GO TO 450
  390 WRITE(*,400)
  400 FORMAT(' WHICH MATRICES ?  GIVE AS IN   1,2   '/)
      READ (*,*) B,C
      IF(B.GT.20.OR.C.GT.20) GO TO 390
      IF(B.LE.0.OR.C.LE.0) GO TO 390
      IF(ICOM.EQ.IT(18).OR.ICOM.EQ.IT(19)) GO TO 430
      IF(MM(B).EQ.NN(C)) GO TO 450
      WRITE(*,420)
  420 FORMAT(' NO. OF COLS IN FIRST MATRIX IS NOT EQUAL TO NO. OF ROWS I
     1N SECOND')
      GO TO 270
  430 IF(MM(B).EQ.MM(C).AND.NN(B).EQ.NN(C)) GO TO 450
      WRITE(*,440)
  440 FORMAT(' MATRICES ARE NOT THE SAME SIZE')
      GO TO 270
C  **********
C  TO INVERT
C  **********
  450 IF(ICOM.NE.IT(2)) GO TO 520
      IF(NN(B).EQ.MM(B)) GO TO 470
      WRITE(*,460) B
  460 FORMAT(' MATRIX',I3,' IS NOT SQUARE')
      GO TO 270
  470 A=A+1
      IF(A.GT.20) A=11
      NN(A)=NN(B)
      MM(A)=MM(B)
      N=NN(A)
      DO 480 I=1,N
      DO 480 J=1,N
  480 XX(I,J)=X(B,I,J)
      CALL MATKLO(XX,N)
      DO 490 I=1,N
      DO 490 J=1,N
  490 X(A,I,J)=XX(I,J)
      WRITE(*,240) A
      WRITE(*,500) B
  500 FORMAT(' INVERSE OF MATRIX',I3)
      DO 510 I=1,N
  510 WRITE(*,260) (X(A,I,J),J=1,N)
      GO TO 270
C  **********
C  TO TRANSPOSE
C  **********
  520 IF(ICOM.NE.IT(3)) GO TO 560
      A=A+1
      IF(A.GT.20) A=11
      NN(A)=MM(B)
      MM(A)=NN(B)
      N=NN(B)
      M=MM(B)
      DO 530 I=1,M
      DO 530 J=1,N
  530 X(A,I,J)=X(B,J,I)
      WRITE(*,240) A
      WRITE(*,540) B
  540 FORMAT(' TRANSPOSE OF MATRIX',I3)
      DO 550 I=1,M
  550 WRITE(*,260) (X(A,I,J),J=1,N)
      GO TO 270
C  **********
C  TO ROW-NORMALIZE
C  **********
  560 IF(ICOM.NE.IT(4)) GO TO 610
      A=A+1
      IF(A.GT.20) A=11
      NN(A)=NN(B)
      MM(A)=MM(B)
      N=NN(A)
      M=MM(A)
      DO 580 I=1,N
      SUM=0.0
      DO 570 J=1,M
  570 SUM=SUM+X(B,I,J)*X(B,I,J)
      SUM=DSQRT(SUM)
      DO 580 J=1,M
  580 X(A,I,J)=X(B,I,J)/SUM
      WRITE(*,240) A
      WRITE(*,590) B
  590 FORMAT(' MATRIX',I3,' ROW-NORMALIZED')
      DO 600 I=1,N
  600 WRITE(*,260) (X(A,I,J),J=1,M)
      GO TO 270
C  **********
C  TO COLUMN-STANDARDIZE
C  **********
  610 IF(ICOM.NE.IT(5)) GO TO 690
      A=A+1
      IF(A.GT.20) A=11
      NN(A)=NN(B)
      MM(A)=MM(B)
      N=NN(A)
      M=MM(B)
      FN=FLOAT(N)
      DO 660 J=1,M
      SUM=0.0
      SUMSQ=0.0
      DO 620 I=1,N
      SUM=SUM+X(B,I,J)
  620 SUMSQ=SUMSQ+X(B,I,J)*X(B,I,J)
      SUM=SUM/FN
      SUMSQ=(SUMSQ/FN)-(SUM*SUM)
      IF(SUMSQ.LE.0.0) GO TO 640
      SUMSQ=DSQRT(SUMSQ)
      DO 630 I=1,N
  630 X(A,I,J)=(X(B,I,J)-SUM)/SUMSQ
      GO TO 660
  640 DO 650 I=1,N
  650 X(A,I,J)=0.0
  660 CONTINUE
      WRITE(*,240) A
      WRITE(*,670) B
  670 FORMAT(' MATRIX',I3,' COLUMN STANDARDIZED')
      DO 680 I=1,N
  680 WRITE(*,260) (X(A,I,J),J=1,M)
      GO TO 270
C  **********
C  TO TRANSFORM FOR CORRESPONDENCE ANALYSIS.  CREATES X WHERE THE
C  MATRIX TO BE FACTORED IS Z=X'X.  USE MINP COMMAND ON X TO GET Z.
C  **********
  690 IF(ICOM.NE.IT(6)) GO TO 770
      A=A+1
      IF(A.GT.20) A=11
      NN(A)=NN(B)
      MM(A)=MM(B)
      N=NN(A)
      M=MM(A)
      SUM=0.0
      DO 700 I=1,N
      DO 700 J=1,M
  700 SUM=SUM+X(B,I,J)
      DO 710 I=1,N
      DO 710 J=1,M
  710 X(A,I,J)=X(B,I,J)/SUM
      DO 720 I=1,N
      RW(I)=0.0
      DO 720 J=1,M
  720 RW(I)=RW(I)+X(A,I,J)
      DO 730 J=1,M
      CL(J)=0.0
      DO 730 I=1,N
  730 CL(J)=CL(J)+X(A,I,J)
      DO 740 I=1,N
      DO 740 J=1,M
  740 X(A,I,J)=(X(A,I,J)-(RW(I)*CL(J)))/DSQRT(RW(I)*CL(J))
      WRITE(*,240) A
      WRITE(*,750) B
  750 FORMAT(' MATRIX',I3,' TRANSFORMED FOR CORRESPONDENCE ANALYSIS')
      DO 760 I=1,N
  760 WRITE(*,260) (X(A,I,J),J=1,M)
      GO TO 270
C  **********
C  TO TRANSFORM TO PROPORTIONS OF THE COLUMN MAXIMUMS
C  **********
  770 IF(ICOM.NE.IT(7)) GO TO 830
      A=A+1
      IF(A.GT.20) A=11
      NN(A)=NN(B)
      MM(A)=MM(B)
      N=NN(A)
      M=MM(A)
      DO 780 I=1,M
  780 CL(I)=-999999.9
      DO 790 J=1,M
      DO 790 I=1,N
      IF(X(B,I,J).GT.CL(J)) CL(J)=X(B,I,J)
  790 CONTINUE
      DO 800 I=1,N
      DO 800 J=1,M
  800 X(A,I,J)=X(B,I,J)/CL(J)
      WRITE(*,240) A
      WRITE(*,810) B
  810 FORMAT(' MATRIX',I3,' AS PROPORTIONS OF COLUMN MAXIMUMS')
      DO 820 I=1,N
  820 WRITE(*,260) (X(A,I,J),J=1,M)
      GO TO 270
C  **********
C  TO TRANSFORM TO PROPORTIONS OF THE COLUMN RANGES
C  **********
  830 IF(ICOM.NE.IT(8)) GO TO 890
      A=A+1
      IF(A.GT.20) A=11
      NN(A)=NN(B)
      MM(A)=MM(B)
      N=NN(A)
      M=MM(A)
      DO 840 I=1,M
      RW(I)=999999.9
  840 CL(I)=-999999.9
      DO 850 J=1,M
      DO 850 I=1,N
      IF(X(B,I,J).LT.RW(J)) RW(J)=X(B,I,J)
      IF(X(B,I,J).GT.CL(J)) CL(J)=X(B,I,J)
  850 CONTINUE
      DO 860 J=1,M
      DO 860 I=1,N
  860 X(A,I,J)=(X(B,I,J)-RW(J))/(CL(J)-RW(J))
      WRITE(*,240) A
      WRITE(*,870) B
  870 FORMAT(' MATRIX',I3,' AS PROPORTIONS OF COLUMN RANGES')
      DO 880 I=1,N
  880 WRITE(*,260) (X(A,I,J),J=1,M)
      GO TO 270
C  **********
C  TO MULTIPLY
C  **********
  890 IF(ICOM.NE.IT(9)) GO TO 930
      A=A+1
      IF(A.GT.20) A=11
      NN(A)=NN(B)
      MM(A)=MM(C)
      N=NN(A)
      M=MM(A)
      NC=MM(B)
      DO 900 I=1,N
      DO 900 J=1,M
      X(A,I,J)=0.0
      DO 900 K=1,NC
  900 X(A,I,J)=X(A,I,J)+X(B,I,K)*X(C,K,J)
      WRITE(*,240) A
      WRITE(*,910) B,C
  910 FORMAT(' PRODUCT OF MATRICES',I3,' AND',I3)
      DO 920 I=1,N
  920 WRITE(*,260) (X(A,I,J),J=1,M)
      GO TO 270
C  **********
C  TO EXTRACT EIGENVALUES AND EIGENVECTORS AND DERIVE THE MATRIX
C  OF PRINCIPAL COMPONENT LOADINGS.  ONLY THE LOADING MATRIX IS
C  PRESERVED.
C  **********
  930 IF(ICOM.NE.IT(10)) GO TO 1200
      IF(NN(B).EQ.MM(B)) GO TO 940
      WRITE(*,460) B
      GO TO 270
  940 N=NN(B)
      DO 950 I=1,N
      DO 950 J=1,N
      XDIF=DABS(X(B,I,J)-X(B,J,I))
      IF(XDIF.GT.0.000001) GO TO 960
  950 CONTINUE
      GO TO 980
  960 WRITE(*,970) B
  970 FORMAT(' MATRIX',I3,' IS NOT SYMMETRIC')
      GO TO 270
  980 A=A+1
      IF(A.GT.20) A=11
      NN(A)=N
      MM(A)=N
      DO 990 I=1,N
      DO 990 J=1,N
      IF(I.GT.J) GO TO 990
      L=I+(J*J-J)/2
      XXX(L)=X(B,I,J)
  990 CONTINUE
 1000 WRITE(*,1010)
 1010 FORMAT(' DO YOU WANT TO SAVE (1) THE EIGENVECTORS OR (2) THE PRINC
     1IPAL',/,' COMPONENTS ?  TYPE 1 OR 2')
      READ (*,*) ISA
      IF(ISA.NE.1.AND.ISA.NE.2) GO TO 1000
      CALL EIGEN(XXX,R,N,0)
      L=0
      DO 1020 I=1,N
      L=L+I
 1020 E(I)=XXX(L)
      WRITE(*,1030) B
 1030 FORMAT(' EIGENVALUES OF MATRIX',I3)
      WRITE(*,260) (E(I),I=1,N)
      SUM=0.0
      DO 1040 I=1,N
      IF(E(I).LT.-0.00001) GO TO 1040
      SUM=SUM+E(I)
 1040 CONTINUE
      K=0
      DO 1060 I=1,N
      IF(E(I)-0.00001) 1070,1050,1050
 1050 K=K+1
 1060 D(I)=E(I)/SUM
 1070 DO 1080 I=2,K
 1080 D(I)=D(I)+D(I-1)
      DO 1090 I=1,K
 1090 D(I)=100.0*D(I)
      WRITE(*,1100)
 1100 FORMAT(' CUMULATIVE PERCENTS')
      WRITE(*,1110) (D(I),I=1,K)
 1110 FORMAT(5(F10.2,4X))
      IF(ISA.EQ.1) WRITE(*,240) A
      WRITE(*,1120) B
 1120 FORMAT(' EIGENVECTORS OF MATRIX',I3)
      L=0
      DO 1130 I=1,N
      DO 1130 J=1,N
      L=L+1
 1130 XX(I,J)=R(L)
      DO 1140 I=1,N
 1140 WRITE(*,260) (XX(I,J),J=1,N)
      DO 1150 I=1,N
      IF(E(I).LT.0.0) E(I)=0.0
 1150 E(I)=DSQRT(E(I))
      DO 1160 I=1,N
      DO 1160 J=1,N
 1160 X(A,I,J)=E(J)*XX(J,I)
      IF(ISA.EQ.2) WRITE(*,240) A
      WRITE(*,1170) B
 1170 FORMAT(' PRINCIPAL COMPONENT LOADINGS FROM MATRIX',I3)
      DO 1180 I=1,N
 1180 WRITE(*,260) (X(A,I,J),J=1,N)
      IF(ISA.EQ.2) GO TO 270
      DO 1190 I=1,N
      DO 1190 J=1,N
 1190 X(A,I,J)=XX(I,J)
      GO TO 270
 1200 CALL MATRIX1
      GO TO 270
 9999 STOP
      END
