$NOFLOATCALLS
$STORAGE:2
      PROGRAM NORCHI
C***
C***  THIS PROGRAM PERFORMS A CHI-SQUARE TEST FOR NORMALITY OF
C***  A STATPAC VARIABLE.  THE PROBABILITY VALUE THAT IS REPORTED
C***  BY THIS PROGRAM IS THE PROBABILITY OF EXCEEDING THE COMPUTED
C***  VALUE OF CHI-SQUARE, GIVEN THE COMPUTED DEGREES OF FREEDOM.
C***  THE CHI-SQUARE TEST ASSUMES THE TESTED SAMPLE IS RANDOM.
C***  THE ASSUMPTION OF RANDOMNESS IS NOT MET IF THIS PROGRAM
C***  IS USED TO TEST KRIGING ESTIMATES, AND THE COMPUTED DEGREES OF
C***  FREEDOM WILL BE INCORRECT.  NEVERTHELESS, THE CHI-SQUARE TEST
C***  CAN BE OF VALUE IN MAKING A SUBJECTIVE JUDGMENT OF THE
C***  NORMALITY OF KRIGING ESTIMATES.
C***
C***  REFERENCES
C***  Young, Hugh D., 1962, Statistical treatment of experimental 
C***  data: McGraw-Hill, New York, 172 pages. (see pp.80-86)
c***
C***  Meehan, R.J., and Grundy, W.D., 1963, Estimation of uranium re-
C***  serves by statistical methods and a digital computer, United
C***  States Atomic Energy Commission RME-146
C***  ORIGINAL AUTHOR IS TED GARRATT OF THE SANDIA CORPORATION,
C***  ALBUQUERQUE, NEW MEXICO
C***  RECODED FOR IBM PC BY W. D. GRUNDY
C***
C***  LINKS REQUIRED: ASCIIZ, BYTMOV, CHRKNT, CKSAFE, CONCAT, INT21H,
C***                  SOUND
      CHARACTER*32 FILE10
      CHARACTER*4 ID,NAME,IVID,IDPR
      CHARACTER*1 IANS
      INTEGER*4 LOC
      LOGICAL FILERR
      DIMENSION ID(2),NAME(4),LOC(2),IVID(99,2),X(99),
     1VALUE(3000),IDPR(5)
      KI=10
   10 WRITE(*,20)
   20 FORMAT(' ','WHAT IS NAME OF STATPAC INPUT FILE? ',\)
      READ(*,'(A32)') FILE10
      CALL CKSAFE(FILE10,2,FILERR)
      IF(FILERR) GO TO 10
      OPEN(KI,FILE=FILE10,STATUS='OLD',FORM='UNFORMATTED')
   30 WRITE(*,40)
   40 FORMAT(//,' CHI-SQUARE TEST FOR NORMALITY OF STATPAC VARIABLE'//)
      READ(KI) ID,N,M,(IVID(I,1),IVID(I,2),I=1,M)
      WRITE(*,'(/,5X,''STATPAC INPUT FILE ID IS: '',2A4,''    COL'',
     1''UMN IDS ARE:'',/)') ID
      WRITE(*,'(5(2X,2A4))') (IVID(I,1),IVID(I,2),I=1,M)
      WRITE(*,50)
   50 FORMAT(/,1X,'WHAT IS COLUMN NUMBER OF THE VARIABLE? : ',\)
      READ(*,60) ICOL
   60 FORMAT(BN,I3)
      IFLAG = 0
      WRITE(*,70)
   70 FORMAT(1X,'LOGARITHMIC TRANSFORMATION WANTED? YES OR NO ? ',\)
      READ(*,80) IANS
   80 FORMAT(A1)
      IF((IANS.EQ.'Y').OR.(IANS.EQ.'y')) IFLAG=1
      IDPR(1)=ID(1)
      IDPR(2)=ID(2)
      IDPR(3)='  **'
      IDPR(4)=IVID(ICOL,1)
      IDPR(5)=IVID(ICOL,2)
      DO 90 I=1,N
      READ(KI) IROW,NAME,LOC,(X(L),L=1,M)
      VALUE(I)=X(ICOL)
   90 CONTINUE
      IF(IFLAG.EQ.0) GO TO 110
      DO 100 I=1,N
      VALUE(I)=ALOG(VALUE(I))
  100 CONTINUE
  110 CALL NRCHI(VALUE,N,IDPR)
  120 WRITE(*,130)
  130 FORMAT('0','DO YOU WANT TO TEST ANOTHER VARIABLE? Y/N :',\)
      READ(*,80) IANS
      IF(IANS.NE.'Y'.AND.IANS.NE.'y'.AND.IANS.NE.'N'.AND.IANS.NE.
     1'n') GO TO 120
      IF(IANS.EQ.'N'.OR.IANS.EQ.'n') GO TO 140
      REWIND(KI)
      GO TO 30
  140 WRITE(*,150)
  150 FORMAT(' ','DO YOU WANT TO PROCESS DATA FROM ANOTHER FILE? ',
     1'Y/N :',\)
      READ(*,80) IANS
      IF(IANS.NE.'Y'.AND.IANS.NE.'y'.AND.IANS.NE.'N'.AND.
     1IANS.NE.'n') GO TO 140
      IF(IANS.EQ.'N'.OR.IANS.EQ.'n') STOP 'NORMAL END OF PROGRAM'
      CLOSE(KI)
      GO TO 10
      END
      SUBROUTINE NRCHI(X,N,ID)
C***  THIS SUBROUTINE WAS WRITTEN BY TED GARRATT OF
C***  THE SANDIA CORPORATION, ALBUQUERQUE, NM FOR
C***  AN IBM 705 COMPUTER
      CHARACTER*4 ID
      DIMENSION ICCT(15),PROB(15),EXPNBR(15),EPOINT(15),X(1),ID(5)
      DATA PROB/0.00058,0.00240,0.00924,0.02784,0.06559,
     10.12098,0.17466,0.19742,0.17466,0.12098,0.06559,
     20.02784,0.00924,0.00240,0.00058/
      KO=0
   10 S1=0.
      S2=0.
      S3=0.
      S4=0.
      XMAX=X(1)
      XMIN=X(1)
      DO 50 J=1,N
      S1=S1+X(J)
      S2=S2+X(J)**2
      S3=S3+X(J)**3
      S4=S4+X(J)**4
      IF(XMAX-X(J))30,50,20
   20 IF(XMIN-X(J))50,50,40
   30 XMAX=X(J)
      GO TO 50
   40 XMIN=X(J)
   50 CONTINUE
      AN=FLOAT(N)
      XBAR=S1/AN
      RANGE=XMAX-XMIN
      VAR=(AN*S2-S1**2)/(AN*(AN-1.))
      SDEV=SQRT(VAR)
      GMU2=(AN*S2-S1**2)
      GMU3=(S3*AN**2-3.0*AN*S1*S2+2.0*S1**3)
      GMU4=(S4*AN**3-4.0*AN*AN*S1*S3+6.0*AN*S2*S1*S1-3.0*S1**4)
      SKEW=GMU3/(GMU2**1.5)
      CURT=GMU4/GMU2**2
      DO 60 J=1,15
   60 ICCT(J)=0
      DO 90 I=1,N
      DO 70 J=1,15
      AJ=J
      EPOINT(J)=XBAR+(0.5*AJ-3.75)*SDEV
      IF(X(I)-EPOINT(J)) 80,80,70
   70 CONTINUE
      J=15
   80 ICCT(J)=ICCT(J)+1
   90 CONTINUE
      DO 100 J=1,15
  100 EXPNBR(J)=AN*PROB(J)
      IDF=12
      DO 120 J=1,7
      IF(EXPNBR(J)-5.)110,130,130
  110 ICCT(J+1)=ICCT(J+1)+ICCT(J)
      EXPNBR(J+1)=EXPNBR(J+1)+EXPNBR(J)
      ICCT(J)=0
      EXPNBR(J)=0.
      IDF=IDF-1
  120 CONTINUE
  130 DO 150 J=1,7
      JJ=16-J
      IF(ICCT(JJ)-5)140,150,150
  140 ICCT(JJ-1)=ICCT(JJ-1)+ICCT(JJ)
      EXPNBR(JJ-1)=EXPNBR(JJ-1)+EXPNBR(JJ)
      ICCT(JJ)=0
      EXPNBR(JJ)=0.
      IDF=IDF-1
  150 CONTINUE
      CHISQR=0.0
      DO 170 J=1,15
      IF(ICCT(J)) 170,170,160
  160 ACT=ICCT(J)
      CHISQR=CHISQR+((ACT-EXPNBR(J))**2/EXPNBR(J))
  170 CONTINUE
      CHIPRB=1.0
      IF(IDF)190,190,180
  180 CHIPRB=1.0-WILHIL(CHISQR,IDF)
  190 WRITE(*,200) ID
  200 FORMAT(/,1X,5A4,/)
  210 WRITE(*,220) N,XBAR,VAR,SDEV,SKEW,CURT,XMAX,XMIN,RANGE
  220 FORMAT(1H ,19X,31HSERV-UR-SELF CHI-SQUARE PROGRAM/25X,14HNORMALITY
     1 TEST///4X,18HSUMMARY STATISTICS/8X,10HNO. POINTS,6X,I5/8X,4HMEAN,
     27X,E15.8/8X,8HVARIANCE,3X,E15.8/8X,8HSTD.DEV.,3X,E15.8/8X,8HSKEWNE
     3SS,3X,E15.8/8X,8HKURTOSIS,3X,E15.8,/
     48X,9HMAX VALUE,2X,E15.8,/8X,9HMIN VALUE,2X,E15.8,/
     58X,5HRANGE,6X,E15.8,//)
C***  CAUSE PROGRAM TO PAUSE UNTIL SPACE BAR IS PRESSED
      PAUSE
      WRITE(*,230)EPOINT(1),ICCT(1),EXPNBR(1)
  230 FORMAT(1H ,37X,22HOBSERVED   THEORETICAL/11X,14HCLASS INTERVAL,12X
     1,22HFREQUENCY    FREQUENCY//9X,9HLESS THAN,2X,E15.8,6X,I4,3X,E15.8
     2)
      WRITE(*,240)(EPOINT(J-1),EPOINT(J),ICCT(J),EXPNBR(J),
     1J=2,14)
  240 FORMAT(1H ,2X,E15.8,2X,E15.8,6X,I4,3X,E15.8)
      WRITE(*,250) EPOINT(14),ICCT(15),EXPNBR(15)
  250 FORMAT(1H ,5X,12HGREATER THAN,2X,E15.8,6X,I4,3X,E15.8)
      WRITE(*,260)CHISQR,IDF,CHIPRB
  260 FORMAT(1H ,7X,19HCOMPUTED CHI-SQUARE,2X,E15.8/8X,18HDEGREES OF FRE
     1EDOM,9X,I2/8X,17HPROBABILITY LEVEL,4X,E15.8)
  270 RETURN
      END
      FUNCTION WILHIL(Y,N)
      DOUBLE PRECISION X,AN,U,CDFN01
      X=DBLE(Y)
      AN=N
      U=((X/AN)**(1.D0/3.D0)-(9.D0*AN-2.D0)/(9.D0*AN))
     1/((2.D0/(9.D0*AN))**0.5D0)
      WILHIL=SNGL(CDFN01(U))
      RETURN
      END
      DOUBLE PRECISION FUNCTION CDFN01(X)
C***  THIS FUNCTION WAS WRITTEN BY C.E. FORD OF UNION
C***  CARBIDE CORPORATION, NUCLEAR DIVISION FOR A DEC-
C***  10 COMPUTER
C***
C***       CDFN01(X) = PROB( N(0,1) < X ) , WITH
C***       ERROR < 7.5D-8
C***
C***       SEE ABRAMOWITZ AND STEGUN,
C***       "HANDBOOK OF MATHEMATICAL FUNCTIONS," 1968, PAGE 932.
C***
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION B(5)
      DATA P/.2316419D0/,R2PI/0.3989422804D0/,
     1     B/.319381530D0,-.356563782D0,1.781477937D0,
     2      -1.821255978D0,1.330274429D0/
      T = 1D0/(1D0+DABS(X)*P)
      PX = B(5)
      DO 10 I = 1,4
      PX = T*PX+B(5-I)
   10 CONTINUE
      PX = T*PX
      ZZ=-.5D0*X**2
      IF(ZZ.LT.-88.028) ZZ=-88.028
      ZX = DEXP(ZZ)*R2PI
      CDFN01 = 1D0-ZX*PX
      IF(X.LT.0D0) CDFN01 = 1D0-CDFN01
      RETURN
      END
