Program NumLines;

{         Counts number of lines in an ASCII disk file.
          Program is invoked by typing the following:
                Numlines [d][path]filename
          The drive and path names are optional.
          Note: Program gives spurious values if called
          upon to count lines in a .EXE or a .COM file.

             Coded by W. D. Grundy, November, 1986    }


Var
  FileName     : string[32]; {name of disk file}
  Icol         : integer;    {column number on PC's screen}
  Irow         : integer;    {row number on PC's screen}
  Kount        : integer;    {Count of lines read}
  LogicalUnit  : text;

Procedure Odometer(Icol,Irow,Kount : integer);
Begin
  GoToXY(Icol,Irow);
  Write(Kount)
End;

Begin                             {main program begins here}
  If ParamCount = 0 then          {if file name was not typed}
    Begin                         { on the command line, have}
      Write('Enter name of ASCII file: ');
      Readln(FileName)            { user enter it from program}
    End                           {NOTE absence of semicolons here}
  Else FileName := ParamStr(1);   {get name from command line tail}

  Assign(LogicalUnit,FileName);
  {$I-} Reset(LogicalUnit); {$I+} {open the disk file}
  If IOResult <> 0 then           {test for successful open}
    Begin                         {if unsuccessful, tell user and quit}
      Writeln('Unable to open File ',FileName);
      Halt(1)
    End;

  Kount := 0;                     {file open successful; count lines}
  Write('        .....Counting records');
  Icol := 1;                      {Define arguments for Odometer}
  Irow := WhereY;
  While Not Eof(LogicalUnit) Do
    Begin
      Readln(LogicalUnit);
      Kount := Kount + 1;
      If Kount Mod 100 = 0 then Odometer(Icol,Irow,Kount)
    End;
  GoToXY(Icol,Irow);              {display the final count}
  Writeln(Kount,' Lines are present in File ',FileName);
  Close(LogicalUnit)
End.                              {End of Program NumLines}
