TITLE       SUBROUTINE PACK(CHIA,M,IY,N)
;           THIS ROUTINE PACKS 5 QUALIFYING CODES INTO 1
;           TWO BYTE INTEGER VARIABLE, OCCUPYING AS MANY AS
;           NECESSARY TO PACK M CODES
;           CHIA  - ARRAY OF UNPACKED CHARACTER*1 CODES
;           M     - NUMBER OF CODES CONTAINED IN ARRAY CHIA
;           IY    - ARRAY OF PACKED CODES (IN WORDS OF 5 CODES EACH)
;           N     - NUMBER OF WORDS IN ARRAY IY CONTAINING PACKED CODES
;
;           THIS SUBROUTINE IS USED BY SUBROUTINE JKPTLS
;
;CODED BY W. D. GRUNDY  JULY 1985
;
FRAME       STRUC
SAVESI      DW         ?
SAVEDI      DW         ?
SAVEDS      DW         ?               ;SAVE AREA FOR DS REGISTER
SAVEBP      DW         ?               ;SAVE AREA FOR CALLER'S BP
SAVERET     DD         ?               ;SAVE AREA FOR CALLER'S RETURN
D           DD         ?               ;POINTER TO N
C           DD         ?               ;POINTER TO IY
B           DD         ?               ;POINTER TO M
A           DD         ?               ;POINTER TO CHIA
FRAME       ENDS
;
_DATA       SEGMENT    'DATA'
_DATA       ENDS
;
PACK_TEXT   SEGMENT    'CODE'
DGROUP      GROUP      _DATA
            ASSUME     CS:PACK_TEXT,DS:DGROUP,SS:DGROUP
            PUBLIC     PACK
;
PACK        PROC       FAR
            PUSH       BP             ;SAVE CALLER'S BP
            PUSH       DS             ;SAVE DS REGISTER
            PUSH       DI
            PUSH       SI
            MOV        BP,SP
            LES        DI,[BP]+B      ;GET ADDRESS OF NUMBER OF CODES
            MOV        AX,ES:[DI]
            MOV        DX,AX          ;SAVE M FOR LATER USE IN LOOPING
            SUB        AH,AH
            MOV        BL,05H
            DIV        BL             ;COMPUTE LENGTH OF ARRAY IY
            CMP        AH,0           ;IS THERE A REMAINDER?
            JE         SAVE_N
            INC        AL
            SUB        AH,AH          ;GET RID OF REMAINDER
SAVE_N:     LES        DI,[BP]+D      ;GET ADDRESS OF NUMBER OF WORDS
            MOV        ES:[DI],AX     ;PASS VALUE OF N BACK TO CALLER
            MOV        BH,AL          ;SAVE N FOR A LOOP COUNTER
            LDS        SI,[BP]+A      ;GET ADDRESS OF CHARACTERS
            LES        DI,[BP]+C      ;GET ADDRESS OF PACKED WORDS
;
;PREPARE TO LOOP
            MOV        CL,3           ;COUNTER FOR ROTATING AX REGISTER
            DEC        DI             ;ADJUST OFFSETS BEFORE
            DEC        DI             ;STARTING TO LOOP
            DEC        SI
            ADD        DX,SI          ;COMPUTE OFFSET OF LAST CHIA
WORD_PACK:  MOV        AX,0
            MOV        CH,5
            INC        DI             ;UPDATE ADDRESS OF IY
            INC        DI
CONVT:      INC        SI             ;UPDATE ADDRESS OF CHIA
            CMP        SI,DX          ;FINISHED WITH LAST CHIA?
            JA         EXIT           ;IF YES, EXIT
            MOV        BL,BYTE PTR DS:[SI]
            AND        BL,11011111B   ;BE SURE CHARACTER IS UPPER-CASE.
            JNZ        B_TEST         ;IS CHARACTER A BLANK?
            JMP SHORT  VALID          ;IF YES, TEST NO FURTHER
B_TEST:     CMP        BL,'B'         ;TEST FOR OTHER QUALIFYING CODES
            JNE        L_TEST
            MOV        BL,01H
            JMP SHORT  VALID
L_TEST:     CMP        BL,'L'
            JNE        N_TEST
            MOV        BL,02H
            JMP SHORT  VALID
N_TEST:     CMP        BL,'N'
            JNE        G_TEST
            MOV        BL,03H
            JMP SHORT  VALID
G_TEST:     CMP        BL,'G'
            JNE        T_TEST
            MOV        BL,04H
            JMP SHORT  VALID
T_TEST:     CMP        BL,'T'
            JNE        H_TEST
            MOV        BL,05H
            JMP SHORT  VALID
H_TEST:     CMP        BL,'H'
            JNE        STAR_CODE
            MOV        BL,06H
            JMP SHORT  VALID
STAR_CODE:  MOV        BL,07H         ;NONE OF THE ABOVE CODES FOUND.
VALID:      ROL        AX,CL          ;ROTATE AX THREE BITS TO LEFT.
            ADD        AL,BL          ;BUILD UP PACKED CODES
            DEC        CH
            JNZ        CONVT
            MOV        ES:[DI],AX     ;RETURN CURRENT IY TO CALLER
            DEC        BH
            JNZ        WORD_PACK      ;LOOP UNTIL DONE.
EXIT:       MOV        ES:[DI],AX     ;BE SURE LAST IY IS RETURNED
            POP        SI
            POP        DI
            POP        DS             ;RESTORE DS REGISTER.
            POP        BP             ;RESTORE CALLER'S BP
            RET        16             ;FAR RETURN.  RELEASE 16 BYTES
PACK        ENDP
PACK_TEXT   ENDS
            END
