$STORAGE:2
      PROGRAM PACR2STP
C***  PROGRAM PACER_TO_STATPAC
C***  IBM PC VERSION
C***  ADAPTED BY W.D. GRUNDY FROM PROGRAM GSCUTM OF A.T. MIESCH, 1984
C***  THIS PROGRAM REQUIRES 35440 BYTES OF RAM
C***  COMBINES MULTIPLE SEAM THICKNESSES INTO A SINGLE THICKNESS.
C***  OPERATES ON A CHARACTER FILE PUT OUT BY PACER
C***  AND PLACES THE RESULTS ON A STATPAC FILE.  CARTESIAN NORTH
C***  AND EAST COORDINATES IN KILOMETER UNITS BASED ON THE UTM
C***  COORDINATE SYSTEM ARE ALSO PLACED ON THE STATPAC OUTPUT FILE.
C***  THE PACER FILE IS FIRST SEARCHED FOR THE
C***  FOLLOWING CONDITIONS:
C***  cond
C***  a. bed eq (name you need)
C***  b. lith eq coal
C***  c. <carriage return>
C***  logic
C***  a.and.b
C***  THE DATA  SELECTED BY THE PACER SEARCH COMMAND
C***  ARE THEN LISTED ONTO AN OUTPUT FILE WITH THE FOLLOWING
C***  USER'S SPECIFICATIONS:
C***  1.  fieldid 1 16 (4a4)
C***  2.  latitud 18 11 (i11)
C***  3.  longtud 30 11 (i11)
C***  4.  surfelv 42 6 (f6.0)
C***  5.  from 49 6 (f6.0)
C***  6.  to 56 6 (f6.0)
C***  7.  thk 63 6 (f6.1)
C***  8.  bed 70 20 (5a4)
C***  9.  key 92 8 (i8)
C*** 10.  <carriage return>
C***  BECAUSE THE LIST FILE MUST BE PROCESSED BY THIS FORTRAN
C***  PROGRAM, DO NOT INCLUDE HEADERS OR PAGE CONTROLS IN THE
C***  PACER LISTING.  IF THEY ARE INADVERTENTLY INCLUDED, THEY
C***  MUST BE REMOVED WITH A TEXT EDITOR PRIOR TO RUNNING THIS
C***  PROGRAM.
C***  DOWNLOAD THE PACER OUTPUT FILE TO THE IBM PC.
C***  AFTER DOWNLOADING IS COMPLETE, TYPE THE FOLLOWING
C***  PROGRAM COMMAND ON THE PC:
C***  PACR2STP
C***  NOTE: BED AND KEY VARIABLES ARE NOT PROCESSED BY THIS PROGRAM
C***  LINKS REQUIRED: BEEP, IOS, CKSAFE
      CHARACTER*16 NAMOLD,NAMNEW
      REAL*8 SPCM
      CHARACTER*4 NAME,ID,IVID
      CHARACTER*1 IA,IBLANK,BQUAL
      INTEGER*4 LOC
      DIMENSION NAME(4),LOC(2),ID(2),X(4),Y(4),Z(8),IVID(2,8),IA(8)
      EQUIVALENCE (NAME(1),NAMOLD),(X(1),Z(3))
      DATA IVID /'LATI','TUDE','LONG','ITUD','SURF','ELEV','TOP ','ELEV'
     1,'BOT ','ELEV','THIC','K FT','NORT','H KM','EAST','  KM'/,ID /
     2'ALL ','BEDS'/,IBLANK/' '/,BQUAL/'B'/
      WRITE(*,10)
   10 FORMAT(' THIS PROGRAM QUALIFIES ALL ZERO VALUES WITH A "B"')
      M=8
      KI=20
      KO=11
C***  GET NAMES OF PACER INPUT AND STATPAC OUTPUT FILES.
      CALL NAMFIL(KI,KO)
      WRITE(*,20)
   20 FORMAT(' WHAT IS THE LONGITUDE OF THE CENTRAL MERIDIAN ?: ',\)
      READ(*,*) SPCM
      ISCRCH=13
C***  SET UP TEMPORARY DISK FILE AND INITIALIZE DRILL HOLE COUNTER
      OPEN(ISCRCH,FILE='SCRATCH',STATUS='NEW',FORM='UNFORMATTED')
      KOUNT=0
C***  READ FIRST RECORD OF PACER INPUT FILE AND THEN ENTER A LOOP
C***  TO READ REMAINING PACER RECORDS.
      READ(KI,30) NAMOLD,LADOLD,LAMOLD,LASOLD,XASOLD,
     1LODOLD,LOMOLD,LOSOLD,XOSOLD,X
   30 FORMAT(A16,1X,I2,I2,I2,F4.4,1X,I3,I2,I2,F4.4,4F7.0,31X)
C***  BEGINNING OF LOOP TO READ PACER RECORDS
   40 LOC(1)=LADOLD*10000+LAMOLD*100+LASOLD+IFIX(XASOLD+.5)
      LOC(2)=LODOLD*10000+LOMOLD*100+LOSOLD+IFIX(XOSOLD+.5)
      Z(1)=(FLOAT(LADOLD*3600+LAMOLD*60+LASOLD)+XASOLD)/3600.
      Z(2)=(FLOAT(LODOLD*3600+LOMOLD*60+LOSOLD)+XOSOLD)/3600.
   50 READ(KI,30,END=70) NAMNEW,LADNEW,LAMNEW,LASNEW,XASNEW,
     1LODNEW,LOMNEW,LOSNEW,XOSNEW,Y
C***  IS THIS A NEW HOLE? IF YES, JUMP.
C***  IF NOT, INCREMENT THICKNESS, CHANGE BOTTOM ELEVATION AND
C***  KEEP CHECKING FOR HOLE CHANGE.
      IF(NAMNEW.NE.NAMOLD) GO TO 60
      X(4)=X(4)+Y(4)
      X(3)=Y(3)
      GO TO 50
C***  INCREMENT HOLE COUNT, WRITE RESULTS TO SCRATCH FILE AND
C***  EXCHANGE VALUES TO PROCESS THE NEW HOLE.
   60 KOUNT=KOUNT+1
      WRITE(ISCRCH) NAMOLD,LOC,Z
      NAMOLD=NAMNEW
      LADOLD=LADNEW
      LAMOLD=LAMNEW
      LASOLD=LASNEW
      XASOLD=XASNEW
      LODOLD=LODNEW
      LOMOLD=LOMNEW
      LOSOLD=LOSNEW
      XOSOLD=XOSNEW
      X(1)=Y(1)
      X(2)=Y(2)
      X(3)=Y(3)
      X(4)=Y(4)
      GO TO 40
C***  END OF LOOP TO READ PACER RECORDS IS IN ABOVE STATEMENT.
C***  FOLLOWING TWO STATEMENTS FLUSH THE LAST DRILL HOLE DATA
C***  FROM RAM ONTO THE TEMPORARY DISK FILE.
   70 KOUNT=KOUNT+1
      WRITE(ISCRCH) NAMOLD,LOC,Z
C***  READ DATA FROM TEMPORARY DISK FILE, COMPUTE NORTHINGS AND
C***  EASTINGS, QUALIFY ANY ZERO VALUES, AND WRITE STATPAC FILE.
      REWIND ISCRCH
C***  WRITE HEADER FOR STATPAC OUTPUT FILE
      WRITE(KO) ID,KOUNT,M,IVID
      DO 100 I=1,KOUNT
      READ(ISCRCH) NAMOLD,LOC,Z
      CALL UTMCNV(Z,SPCM)
      DO 80 IQ=1,M
      IA(IQ)=IBLANK
   80 CONTINUE
C***  QUALIFY ZERO VALUES HERE.
      DO 90 IQ=1,M
      IF(Z(IQ).EQ.0.) IA(IQ)=BQUAL
   90 CONTINUE
C***  WRITE DRILL HOLE DATA TO STATPAC OUTPUT FILE.
      CALL JKPTLS(KO,I,NAME,LOC,Z,IA,M)
  100 CONTINUE
C***  PREPARE TO EXIT FROM PROGRAM.
      WRITE(*,110) ID,KOUNT,M
  110 FORMAT(5X,'THE STATPAC FILE HAS BEEN WRITTEN',/,
     15X,'THE FILE ID IS ',2A4,5X,'N = ',I4,5X,'M = ',I2,/,
     25X,'RUN STATPAC FILE THROUGH PROGRAM COORDDUP TO FIND ANY DUPLI-'
     3,/,5X,'CATED LOCATIONS.')
      CLOSE(ISCRCH,STATUS='DELETE')
      STOP 'NORMAL END OF PROGRAM'
      END
      SUBROUTINE UTMCNV(X,SPCM)
C***  CONVERTS LATITUDE AND LONGITUDE GIVEN IN DECIMAL DEGREES
C***  INTO UTM NORTH AND EAST COORDINATES IN KILOMETERS.
C***  A.T. MIESCH, U.S.G.S., DENVER, COLORADO
      REAL*8 AA,BB,NORTH,EAST,SPCM
C***
      INTEGER SPZONE
      DIMENSION X(8)
      AA=X(1)
      BB=X(2)
      CALL TAS002(AA,BB,NORTH,EAST,SPZONE,SPCM)
C***  CONVERT FROM METERS TO KILOMETERS AND STORE IN STATPAC VARIABLES.
      X(7)=NORTH*0.001D0
      X(8)=EAST*0.001D0
      RETURN
      END
      DOUBLE PRECISION FUNCTION TAS005(DEG)
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA C1/0.9996D0/,        C2/1.11132089365419D5/,
     1     C3/1.6216944106D4/,  C4/0.1745329252D-1/,
     2     C5/1.7209357D1/,     C6/0.022723D0/
      TAS005 = C1*(C2*DEG-C3*DSIN(DEG*C4*2.0D0)+C5*DSIN(DEG*C4*4.0D0)-
     1 C6*DSIN(6.0D0*DEG*C4)+3.2D-5*DSIN(8.0D0*DEG*C4))
      RETURN
      END
      SUBROUTINE TAS002 (SPLAT,SPLONG, NORTH, EAST,SPZONE,SPCM)
C      SUBROUTINE TAS002 IS FROM THE GEOLOGICAL SURVEY OF CANADA,
C        COURTESY OF DR. R.G. GARRETT, AUGUST 8, 1978
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DOUBLE PRECISION NORTH,TAS005
      INTEGER SPZONE
C
      DATA RAD/1.745329252D-2/,ESQUAR/6.768657997291D-3/,SINSEC/4.848136
     1811D-6/,A/6.3782064D6/,DZERO/0.0D0/,D360/3.6D2/
C
C
C
      DEGLAT=DABS(SPLAT)
      SIGN = DEGLAT / SPLAT
      DEGLON = SPLONG
      DCM = SPCM
      DEGLON=DEGLON+D360
      DCM=DCM+D360
      EPRISQ=ESQUAR/(1.0D0-ESQUAR)
      DEPART=(DCM-DEGLON)*3600.0D0
      SSECSQ=SINSEC*SINSEC
      RADLAT=DEGLAT*RAD
      SINPHI=DSIN(RADLAT)
      COSPHI=DCOS(RADLAT)
      SINSQ=SINPHI*SINPHI
      COSSQ=COSPHI*COSPHI
      COSFOR=COSSQ*COSSQ
      CURVE=A/(DSQRT(1.0D0-ESQUAR*SINSQ))
      NORTH=TAS005(DEGLAT)+(CURVE*SINPHI*COSPHI*SSECSQ*DEPART**2*
     1 0.9996D0*0.5D0)
      NORTH=NORTH+((((SINSEC*DEPART)**4)*CURVE*COSPHI*COSSQ*SINPHI*
     1 0.9996D0)/24.0D0)*(5.0D0-(SINSQ/COSSQ)+
     2 9.0D0*EPRISQ*COSSQ+((2.0D0*EPRISQ*COSSQ)**2))
      EAST=((SINSEC*DEPART*CURVE*COSPHI*0.9996D0)/6.0D0)*(6.0D0+(((SINSE
     1C*DEPART)**2)*(COSSQ-SINSQ+EPRISQ*COSFOR)))+5.0D5
      IF (SIGN.LT.DZERO) NORTH=-NORTH
      RETURN
C
      END
      SUBROUTINE NAMFIL(KI,KO)
C***  THIS SUBROUTINE OBTAINS THE NAMES OF THE INPUT
C***  AND OUTPUT FILES AND EXECUTES THE OPEN COMMANDS.
      LOGICAL FILERR
      CHARACTER*14 UNIT20,UNIT11
   10 WRITE(*,'(A\)')' WHAT IS NAME OF PACER INPUT FILE ?: '
      READ(*,20) UNIT20
   20 FORMAT(A14)
      CALL CKSAFE(UNIT20,2,FILERR)
      IF(FILERR) GO TO 10
      OPEN(KI,FILE=UNIT20,STATUS='OLD',FORM='FORMATTED')      
   30 WRITE(*,'(A\)')' GIVE A NAME FOR THE STATPAC OUTPUT FILE : '
      READ(*,20) UNIT11
      CALL CKSAFE(UNIT11,1,FILERR)
      IF(FILERR) GO TO 30
      OPEN(KO,FILE=UNIT11,STATUS='NEW',FORM='UNFORMATTED')
      RETURN
      END
