$STORAGE:2
$NOFLOATCALLS
      SUBROUTINE PCHCEN(STRING,ICODE,IROW,IPAGE)
C***  PRINTS A CENTERED FORTRAN CHARACTER CONSTANT ON THE PC'S SCREEN
C***  WITH USER-SPECIFIED VIDEO ATTRIBUTES.
C***
C***  CODED BY W.D. GRUNDY  AUGUST  1986
C***
C***  FORTRAN USAGE
C***  INTEGER*2 IROW,ICODE,IPAGE
C***   .........
C***  CALL PCHCEN('any string you want&',ICODE,IROW,IPAGE)
C***
C***  WHERE
C***  THE FIRST ARGUMENT IS A FORTRAN CHARACTER CONSTANT TERMINATED
C***  BY AN AMPERSAND (&) AND ENCLOSED IN SINGLE QUOTES ('   ').
C***  THE STRING MUST NOT EXCEED 80 CHARACTERS AND THE AMPERSAND MUST
C***  OCCUR NO FURTHER THAN THE 81ST POSITION FROM THE START OF THE
C***  STRING.
C***
C***  ICODE  IS PC SCREEN ATTRIBUTE CODE, EXPRESSED IN DECIMAL (0-5).
C***
C***  CALLER'S  TRANSLATED
C***    CODE        TO
C***     0          00H   STRING DOES NOT DISPLAY.
C***     1          07H   PRINTS NORMAL WHITE ON BLACK.
C***     2          0FH   PRINTS WHITE ON BLACK, INTENSE.
C***     3          70H   PRINTS REVERSE BLACK ON WHITE.
C***     4          87H   PRINTS NORMAL WHITE ON BLACK, BLINKING.
C***     5          8FH   PRINTS INTENSE BLACK ON WHITE, BLINKING.
C***     6         0F0H   PRINTS REVERSE BLACK ON WHITE, BLINKING.
C***  IROW IS THE SCREEN ROW TO BE PRINTED (0-24)
C***  IPAGE IS THE DISPLAY PAGE (0-3) FOR MODES 2 AND 3.
C***
C***  EXAMPLE:
C***
C***  CALL PCHCEN('THIS IS A CENTERED STRING&',1,10,0)
C***  THIS WILL CAUSE THE LINE 
C***                    THIS IS A CENTERED STRING
C***  TO BE PRINTED IN NORMAL WHITE ON BLACK ON ROW 10 OF SCREEN 0.
C***
C***  NOTE: SUBROUTINE WILL NOT EXECUTE IF ANY ARGUMENTS ARE BAD
C***  SUBPROGRAMS REQUIRED: INTR
$INCLUDE:'PCREGS.INC'
      CHARACTER*1 STRING(81),AMPER
      DIMENSION KODE(7)
      DATA KODE /#00,#07,#0F,#70,#87,#8F,#F0/,AMPER /'&'/
      JCODE=ICODE+1
C***  TEST FOR VALID ARGUMENTS
      IF(JCODE.GE.1.AND.JCODE.LE.7.AND.
     1   IROW.GE.0.AND.IROW.LE.24.AND.
     2   IPAGE.GE.0.AND.IPAGE.LE.3     )
     3THEN
        DO 10 J=1,81
        IF(STRING(J).EQ.AMPER) GO TO 20
   10   CONTINUE
        J=0
   20   N=J-1
        ICOL=(80-N)/2
        IF(N.GE.1.AND.N+ICOL.LE.80)
     1  THEN
          BX=IPAGE*#100+KODE(JCODE)
          CX=#0001
          DO 30 I=1,N
            DX=IROW*#100+ICOL+I-1
            AX=#0200
            CALL INTR(#10,REGS)
            AX=#0900+ICHAR(STRING(I))
            CALL INTR(#10,REGS)
   30     CONTINUE
        ENDIF
      ENDIF
      RETURN
      END
