$STORAGE:2
$NOFLOATCALLS
      SUBROUTINE PCHCON(STRING,ICODE,IROW,ICOL,IPAGE)
C***  PRINTS A CHARACTER CONSTANT ON A LINE OF THE PC'S SCREEN WITH
C***  VIDEO ATTRIBUTES SPECIFIED BY THE CALLING PROGRAM.
C***
C***  CODED BY W.D. GRUNDY  AUGUST  1986
C***
C***  FORTRAN USAGE
C***  INTEGER*2 ICODE,IROW,ICOL
C***  .........
C***  CALL PCHCON('any desired string&',ICODE,IROW,ICOL,IPAGE)
C***
C***  WHERE
C***
C***  THE FIRST ARGUMENT IS A CHARACTER CONSTANT TERMINATED BY AN
C***  AMPERSAND (&) AND ENCLOSED IN SINGLE QUOTES ('  ').
C***  THE STRING NEED NOT BE PREVIOUSLY DECLARED IN EITHER A FORTRAN
C***  VARIABLE TYPE OR DIMENSION STATEMENT.
C***
C***  ICODE  IS PC SCREEN ATTRIBUTE CODE, EXPRESSED IN DECIMAL.
C***  CALLER'S  TRANSLATED
C***    CODE        TO
C***     0          00H   STRING DOES NOT DISPLAY.
C***     1          07H   PRINTS NORMAL WHITE ON BLACK.
C***     2          0FH   PRINTS WHITE ON BLACK, INTENSE.
C***     3          70H   PRINTS REVERSE BLACK ON WHITE.
C***     4          87H   PRINTS NORMAL WHITE ON BLACK, BLINKING.
C***     5          8FH   PRINTS INTENSE BLACK ON WHITE, BLINKING.
C***     6         0F0H   PRINTS REVERSE BLACK ON WHITE, BLINKING.
C***
C***  IROW IS SCREEN ROW NUMBER (0-24) FOR PRINTED STRING.
C***  ICOL IS STARTING SCREEN COLUMN NUMBER (0-79).
C***  IPAGE IS THE ACTIVE DISPLAY PAGE (0-3) FOR MODES 2 AND 3.
C***
C***  NOTE: THE STARTING COLUMN NUMBER PLUS THE NUMBER OF CHARACTERS TO
C***  PRINTED CANNOT EXCEED A TOTAL OF 80.
C***  SUBROUTINE WILL NOT EXECUTE IF ANY ARGUMENTS ARE BAD
C***
C***  SUBPROGRAMS REQUIRED: INTR
$INCLUDE:'PCREGS.INC'
      CHARACTER*1 STRING(81),AMPER
      DIMENSION KODE(7)
      DATA KODE /#00,#07,#0F,#70,#87,#8F,#F0/,AMPER /'&'/
      JCODE=ICODE+1
C***  TEST FOR VALID ARGUMENTS
      IF(JCODE.GE.1.AND.JCODE.LE.7.AND.
     1   IROW.GE.0.AND.IROW.LE.24.AND.
     2   ICOL.GE.0.AND.ICOL.LE.79.AND.
     3   IPAGE.GE.0.AND.IPAGE.LE.3     )
     4THEN
        DO 10 J=1,81
        IF(STRING(J).EQ.AMPER) GO TO 20
   10   CONTINUE
        J=0
   20   N=J-1
        IF(N.GE.1.AND.N+ICOL.LE.80)
     1  THEN
          BX=IPAGE*#100+KODE(JCODE)
          CX=#0001
          DO 30 I=1,N
            DX=IROW*#100+ICOL+I-1
            AX=#0200
            CALL INTR(#10,REGS)
            AX=#0900+ICHAR(STRING(I))
            CALL INTR(#10,REGS)
   30     CONTINUE
        ENDIF
      ENDIF
      RETURN
      END
