$STORAGE:2
$NOFLOATCALLS
      SUBROUTINE PCHVAR(STRING,ICODE,N,IROW,ICOL,IPAGE)
C***  PRINTS A FORTRAN CHARACTER  VARIABLE ON A LINE OF THE PC'S SCREEN
C***  WITH VIDEO ATTRIBUTES SPECIFIED BY THE CALLING PROGRAM.
C***
C***  CODED BY W.D. GRUNDY  AUGUST  1986
C***
C***    FORTRAN USAGE
C***    INTEGER*2 ICODE,IROW,ICOL
C***    CHARACTER*1 STRING(K)    OR, ALTERNATIVELY,
C***    CHARACTER*K STRING
C***    .........
C***    .........
C***    CALL PCHVAR(STRING,ICODE,J,IROW,ICOL,IPAGE)
C***
C***    WHERE
C***    STRING IS A FORTRAN STRING VARIABLE OR STRING ARRAY.
C***    ICODE  IS PC SCREEN ATTRIBUTE CODE, EXPRESSED IN DECIMAL.
C***    CALLER'S  TRANSLATED
C***      CODE        TO
C***       0          00H   STRING DOES NOT DISPLAY.
C***       1          07H   PRINTS NORMAL WHITE ON BLACK.
C***       2          0FH   PRINTS WHITE ON BLACK, INTENSE.
C***       3          70H   PRINTS REVERSE BLACK ON WHITE.
C***       4          87H   PRINTS NORMAL WHITE ON BLACK, BLINKING.
C***       5          8FH   PRINTS INTENSE BLACK ON WHITE, BLINKING.
C***       6         0F0H   PRINTS REVERSE BLACK ON WHITE, BLINKING.
C***   N IS THE NUMBER OF CHARACTERS TO BE PRINTED (N.LE.K).
C***   IROW IS SCREEN ROW NUMBER (0-24) FOR PRINTED STRING.
C***   ICOL IS STARTING SCREEN COLUMN NUMBER (0-79) FOR PRINTED STRING.
C***   IPAGE IS THE ACTIVE DISPLAY PAGE (0-3) FOR MODES 2 AND 3.
C***
C***  NOTE: THIS SUBROUTINE WILL NOT EXECUTE IF ARGUMENTS ARE BAD
C***
C***  SUBPROGRAMS REQUIRED: INTR
$INCLUDE:'PCREGS.INC'
      CHARACTER*1 STRING(N)
      DIMENSION KODE(7)
      DATA KODE /#00,#07,#0F,#70,#87,#8F,#F0/
C***  CHECK FOR VALID ARGUMENTS
      JCODE=ICODE+1
      IF(JCODE.GE.1.AND.JCODE.LE.7.AND.
     1   IROW.GE.0.AND.IROW.LE.24.AND.
     2   ICOL.GE.0.AND.ICOL+N.LE.80.AND.
     3   IPAGE.GE.0.AND.IPAGE.LE.3      )
     4THEN
      BX=IPAGE*#100+KODE(JCODE)
      CX=#0001
      DO 10 I=1,N
      DX=IROW*#100+ICOL+I-1
      AX=#0200
      CALL INTR(#10,REGS)
      AX=#0900+ICHAR(STRING(I))
      CALL INTR(#10,REGS)
   10 CONTINUE
      ENDIF
      RETURN
      END
