$NOFLOATCALLS
$STORAGE:2 
      PROGRAM PERMUTER
C***
C***  THIS PROGRAM REARRANGES (PERMUTES) THE ROWS OF A STATPAC
C***  DATA FILE IN A RANDOM ORDER.  THE RANDOM ORDER WILL DIFFER
C***  EACH TIME THE PROGRAM IS RUN BECAUSE THE RANDOM NUMBER
C***  GENERATOR USED IS SEEDED BY THE PC'S CLOCK.
C***  THE PERMUTED ROWS ARE WRITTEN ON A STATPAC OUTPUT FILE.
C***
C***  THIS PROGRAM WAS WRITTEN BY W. D. GRUNDY, APRIL, 1984
C***  LINKS REQUIRED: ASCIIZ, BYTMOV, CHRKNT, CKSAFE, CONCAT, FNDCUR,
C***                  FSORT, ODOMTR, RAND, SOUND, TICKER
C***
      LOGICAL FILERR
      INTEGER*4 LOC ,ISEED
      CHARACTER*32 FILE10,FILE11
      CHARACTER*16 NAME
      CHARACTER*8 ID,IVID(100)
      CHARACTER*1 IA 
      DIMENSION IRA(3000),LOC(2),X(100),R(3000),IPACK(20)
   10 WRITE(*,'(A\)')' ENTER NAME OF STATPAC INPUT FILE: '
      READ(*,20) FILE10 
   20 FORMAT(A32) 
      CALL CKSAFE(FILE10,2,FILERR)
      IF(FILERR) GO TO 10
   30 WRITE(*,'(A\)')' GIVE A NAME FOR THE STATPAC OUTPUT FILE: '
      READ(*,20) FILE11 
      IF(FILE11.EQ.FILE10) THEN
      CALL WARN
      WRITE(*,'(A)') ' STATPAC INPUT FILE CANNOT BE USED FOR OUTPUT'
      GO TO 30
      ENDIF
      CALL CKSAFE(FILE11,1,FILERR)
      IF(FILERR) GO TO 30
      KI=10
      KO=11 
      KSCR=13 
      OPEN(KI,FILE=FILE10,STATUS='OLD',FORM='UNFORMATTED') 
      OPEN(KO,FILE=FILE11,STATUS='NEW',FORM='UNFORMATTED') 
C***  READ HEADER RECORD OF STATPAC INPUT FILE
      READ(KI) ID,N,M,(IVID(I),I=1,M)
      IF(N.GT.3000) STOP 'TOO MANY ROWS - LIMIT IS 3000'
C***  COMPUTE RECORD LENGTH FOR DIRECT ACCESS SCRATCH FILE.
      NPACK=(M+4)/5
      LENREC=24+4*M+2*NPACK
C***  OPEN DIRECT ACCESS SCRATCH FILE
      OPEN(KSCR,FILE='SCRATCH',STATUS='NEW',FORM='UNFORMATTED',
     1ACCESS='DIRECT',RECL=LENREC)
C***  READ ROWS OF STATPAC FILE AND PUT THE ON SCRATCH FILE.
      WRITE(*,'(A)') '       ....READING STATPAC INPUT FILE'
      CALL FNDCUR(IRRR,ICCC,0)
      DO 60 I=1,N 
      READ(KI) IROW,NAME,LOC,(X(J),J=1,M),(IPACK(J),J=1,NPACK)
      WRITE(KSCR) NAME,LOC,(X(J),J=1,M),(IPACK(J),J=1,NPACK)
      IRA(I)=I
      IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
   60 CONTINUE 
      WRITE(*,'(''+'',I5)') N
      REWIND KSCR 
C***  GET STARTING SEED FOR RANDOM NUMBER GENERATOR
      CALL TICKER(ISEED)
C***  CREATE AN ARRAY OF N RANDOM NUMBERS
      WRITE(*,70) N
   70 FORMAT(' ','NOW COMPUTING ARRAY OF ',I4,' RANDOM NUMBERS')
      DO 80 I=1,N
      R(I)=RAND(ISEED)
   80 CONTINUE
C***  SORT ARRAY IRA ON R
      WRITE(*,90)
   90 FORMAT(' ','NOW SORTING ARRAY OF POINTERS')
      CALL FSORT(R,IRA,N)
C***  WRITE HEADER OF STATPAC OUTPUT FILE
      WRITE(*,'(A)') '       ....WRITING RANDOMLY PERMUTED OUTPUT FILE'
      CALL FNDCUR(IRRR,ICCC,0)
      WRITE(KO) ID,N,M,(IVID(I),I=1,M)
C***  NOW READ SCRATCH FILE IN RANDOM SEQUENCE AND WRITE OUTPUT FILE.
      DO 110 I=1,N
      READ(KSCR,REC=IRA(I)) NAME,LOC,(X(J),J=1,M),(IPACK(J),J=1,NPACK)
      WRITE(KO) I,NAME,LOC,(X(L),L=1,M),(IPACK(L),L=1,NPACK)
      IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
  110 CONTINUE 
      WRITE(*,'(''+'',I5)') N
      WRITE(*,120) ID,N,M 
  120 FORMAT(' THE STATPAC FILE HAS BEEN WRITTEN.',/,' THE DATA SET',
     1' ID IS',1X,A8,/,' N= ',I5,3X,'M= ',I3) 
      CLOSE(KSCR,STATUS='DELETE')
      DO 130 I=1,5
      CALL SOUND(1000,25)
  130 CONTINUE
      STOP 'NORMAL END OF PROGRAM'
      END
