$NOFLOATCALLS
$STORAGE:2
      PROGRAM POLYGRET
C***  CODED BY W. D. GRUNDY  SEPTEMBER 1983
C***
C***  THIS PROGRAM RETRIEVES FROM A STATPAC INPUT FILE THOSE
C***  ROWS WHOSE NORTH AND EAST COORDINATES LIE WITHIN A
C***  POLYGONAL BOUNDARY THAT IS DEFINED ON A CHARACTER DISK
C***  FILE WHICH WAS PREVIOUSLY CREATED BY THE USER.  THE USER
C***  IS GIVEN THE OPTION OF SELECTING ONLY THOSE STATPAC ROWS
C***  WHICH LIE WITHIN OR ON THE BOUNDARY, OR ONLY THOSE ROWS
C***  WHICH LIE WITHOUT THE BOUNDARY.  THE STATPAC OUTPUT FILE
C***  CREATED BY THIS PROGRAM CONTAINS THE SELECTED DATA.
C***
C***  THE DISK FILE CONTAINING THE BOUNDARY NODES CAN BE CREATED
C***  BY THE EDLIN EDITOR.  EACH BOUNDARY NODE MUST BE ENTERED
C***  ON A SINGLE LINE WITH THE NORTH COORDINATE (LATITUDE OR
C***  OTHER VERTICAL COORDINATE) TYPED FIRST AND THE EAST (LONG-
C***  ITUDE OR OTHER HORIZONTAL COORDINATE) TYPED SECOND.  THE
C***  NORTH AND EAST COORDINATES MUST BE SEPARATED BY AT LEAST
C***  ONE BLANK SPACE, OR BY A COMMA.  EMBEDDED BLANKS IN THE
C***  NORTH OR EAST COORDINATES ARE NOT PERMITTED.  THE BOUNDARY
C***  NODES MUST BE ENTERED IN A CLOCKWISE DIRECTION.
C***
C***  LINKS REQUIRED: AREA, ASCIIZ, BYTMOV, CHRKNT, CKSAFE, CONCAT,
C***                  FNDCUR, ODOMTR, PTLOC, SOUND
C***
      INTEGER*2 PTLOC
      INTEGER*4 LOC
      CHARACTER*16 NAME
      CHARACTER*32 UNIT11
      CHARACTER*8 IVID,ID
      DIMENSION LOC(2),IVID(100),X(100),IPACK(20),YN(1000),XE(1000)
      KI=10
      KO=11
      ISCRCH=12
      IBOUND=14
      CALL OPENFL(KI,KO,ISCRCH,IBOUND,UNIT11)
      READ(KI) ID,N,M,(IVID(I),I=1,M)
      NPACK=(M+4)/5
      CALL INPUT(NODES,YN,XE,IN,IE,YMIN,YMAX,XMIN,XMAX,IVID,ID,M,IFLAG)
C***  GET AREA WITHIN THE SPECIFIED POLYGON
      SQUNIT=AREA(NODES,YN,XE)
      WRITE(*,10) SQUNIT
   10 FORMAT(/,' THE AREA WITHIN THE POLYGONAL BOUNDARIES IS ',
     1E15.8,' SQUARE UNITS',/)
      KOUNT = 0
C***  READ STATPAC INPUT FILE
      WRITE(*,'('' '',''          ....READING STATPAC INPUT FILE'')')
      CALL FNDCUR(IRRR,ICCC,0)
      DO 30 II=1,N
      READ(KI) IROW,NAME,LOC,(X(I),I=1,M),(IPACK(I),I=1,NPACK)
      IF(MOD(II,10).EQ.0) CALL ODOMTR(IRRR,II)
      ITEST=0
C***  CHECK FOR POINT OBVIOUSLY OUTSIDE THE POLYGON.
      IF(X(IN).LT.YMIN.OR.X(IN).GT.YMAX.OR.X(IE).LT.XMIN.OR.X(IE).GT.
     1XMAX) ITEST=1
      IF(ITEST.EQ.1.AND.IFLAG.EQ.1)GO TO 30
      IF(ITEST.EQ.1.AND.IFLAG.EQ.2)GO TO 20
C***  POINT COULD BE WITHIN POLYGON, SO CHECK TO MAKE SURE.
      IOK=PTLOC(NODES,XE,YN,X(IE),X(IN))
      IF(IOK.LT.0.AND.IFLAG.EQ.1) GO TO 30
      IF(IOK.GE.0.AND.IFLAG.EQ.2) GO TO 30
C***  POINT IS WANTED, SO INCREMENT COUNT AND WRITE TO SCRATCH FILE.
   20 KOUNT = KOUNT + 1
      WRITE(ISCRCH) KOUNT,NAME,LOC,(X(IJ),IJ=1,M),(IPACK(IJ),IJ=1,NPACK)
   30 CONTINUE
      WRITE(*,'(''+'',I5)') N
C***  FINISHED WITH SEARCHING, SO NOW WRITE STATPAC OUTPUT FILE.
      REWIND ISCRCH
      WRITE(KO) ID,KOUNT,M,(IVID(I),I=1,M)
      DO 40 I=1,KOUNT
      READ (ISCRCH) IROW,NAME,LOC,(X(IJ),IJ=1,M),(IPACK(IJ),IJ=1,NPACK)
   40 WRITE(KO) I,NAME,LOC,(X(J),J=1,M),(IPACK(J),J=1,NPACK)
      WRITE(*,50) UNIT11,KOUNT,M
   50 FORMAT(' THE STATPAC FILE HAS BEEN WRITTEN.',/,' THE FILE NAME IS'
     1,1X,A32,/,' N= ',I5,3X,'M= ',I3)
      CLOSE(ISCRCH,STATUS='DELETE')
      STOP 'NORMAL END OF PROGRAM'
      END
      SUBROUTINE INPUT(NODES,YN,XE,INORTH,IEAST,YMIN,YMAX,XMIN,XMAX,
     1IVID,ID,M,IFLAG)
      CHARACTER*8 IVID(100),ID
      DIMENSION YN(1),XE(1)
      YMIN = 99999999.
      YMAX = -99999999.
      XMIN = 99999999.
      XMAX = -99999999.
   10 WRITE(*,20)
   20 FORMAT(5X,'DO YOU WANT THE NEW STATPAC FILE TO CONTAIN',/,
     15X,'1) ONLY THOSE POINTS WHICH ARE WITHIN OR ON THE POLY',
     2'GONAL BOUNDARIES OR',/,
     35X,'2) ONLY THOSE POINTS OUTSIDE THE POLYGONAL BOUNDARIES?',
     4/,5X,'ANSWER 1 OR 2 : '\)
      READ(*,*) IFLAG
      IF(IFLAG.LT.1.OR.IFLAG.GT.2)GO TO 10
      WRITE(*,'('' '',//,5X,''STATPAC INPUT FILE ID IS: '',A8,
     1'' ;  COLUMN IDS ARE:'',/)') ID
      WRITE(*,'(5(1X,I2,'')'',A8))') (I,IVID(I),I=1,M)
      WRITE(*,'(/,5X,''ENTER STATPAC FILE DESCRIPTORS'',/)')
      WRITE(*,30)
   30 FORMAT(5X,'WHAT IS COLUMN NUMBER OF THE NORTH COORDINATE? ',\)
      READ(*,*) INORTH
      WRITE(*,40)
   40 FORMAT(5X,'WHAT IS COLUMN NUMBER OF THE EAST COORDINATE? ',\)
      READ(*,*) IEAST
C***  ENTRY OF POLYGONAL NODES IS FROM A STORED FILE
   50 NODES=1
   60 READ(14,*,END=70) YN(NODES),XE(NODES)
      IF(YN(NODES).LT.YMIN) YMIN=YN(NODES)
      IF(YN(NODES).GT.YMAX) YMAX=YN(NODES)
      IF(XE(NODES).LT.XMIN) XMIN=XE(NODES)
      IF(XE(NODES).GT.XMAX) XMAX=XE(NODES)
      NODES=NODES+1
      GO TO 60
   70 XE(NODES)=XE(1)
      YN(NODES)=YN(1)
      RETURN
      END
      SUBROUTINE OPENFL(KI,KO,ISCRCH,IBOUND,UNIT11)
      LOGICAL FILERR
      CHARACTER*32 UNIT10,UNIT11,UNIT14
      OPEN(ISCRCH,FILE='SCRATCH',STATUS='NEW',FORM='UNFORMATTED')
   10 WRITE(*,'(A\)')' WHAT IS NAME OF STATPAC INPUT FILE? '
      READ(*,20) UNIT10
   20 FORMAT(A32)
      CALL CKSAFE(UNIT10,2,FILERR)
      IF(FILERR) GO TO 10
      OPEN(KI,FILE=UNIT10,STATUS='OLD',FORM='UNFORMATTED')
   30 WRITE(*,'(A\)')' GIVE A NAME FOR THE STATPAC OUTPUT FILE: '
      READ(*,20) UNIT11
      IF(UNIT11.EQ.UNIT10) THEN
      CALL WARN
      WRITE(*,'(A)') ' STATPAC INPUT FILE CANNOT BE USED FOR OUTPUT'
      GO TO 30
      ENDIF
      CALL CKSAFE(UNIT11,1,FILERR)
      IF(FILERR) GO TO 30
      OPEN(KO,FILE=UNIT11,STATUS='NEW',FORM='UNFORMATTED')
   40 WRITE(*,'(A\)')' WHAT IS NAME OF THE BOUNDARY NODES FILE? '
      READ(*,20) UNIT14
      IF(UNIT14.EQ.UNIT10.OR.UNIT14.EQ.UNIT11) THEN
      CALL WARN
      WRITE(*,'(A)') ' BOUNDARY FILE CANNOT BE A STATPAC FILE'
      GO TO 40
      ENDIF
      CALL CKSAFE(UNIT14,2,FILERR)
      IF(FILERR) GO TO 40
      OPEN(IBOUND,FILE=UNIT14,STATUS='OLD',FORM='FORMATTED')
      RETURN
      END
