$NOFLOATCALLS
$STORAGE:2
      INTEGER FUNCTION PTLOC(NP,X,Y,XP,YP)
C*****************************************************************
C***    THIS SUBPROGRAM DETERMINES WHETHER A POINT LIES WITHIN A
C***    CLOSED BOUNDARY.
C***    IF PTLOC =-1  THE POINT IS OUTSIDE.
C***               0  THE POINT LIES ON THE BOUNDARY.
C***               1  THE POINT LIES WITHIN THE BOUNDARY.
C***               2  THE POINT LIES ON A NODE
C***    PROGRAM PTLOC WAS WRITTEN BY JOHN K. HALL OF THE
C***    GEOLOGICAL SURVEY OF ISRAEL. DOCUMENTATION AND
C***    EXPLANATION OF THIS ALGORITHM WERE PUBLISHED IN
C***    MATHEMATICAL GEOLOGY, VOL 7,NO. 1, FEB., 1975
C***    PROGRAM SLIGHTLY MODIFIED BY W.D. GRUNDY,USGS,1979, JUNE 1985
C*****************************************************************
      DIMENSION X(1),Y(1)
      DOUBLE PRECISION C180
      DATA C180/.9999999998D0/
      IEC=0
      TSC=0.0
      SC=0.0
      SC1=0.0
      TCC=1.0
      CC=1.0
      X1=X(NP)-XP
      Y1=Y(NP)-YP
      R1=SQRT(X1*X1+Y1*Y1)
      IF(R1) 10,150,10
   10 DO 110 I=1,NP
      X2=X(I)-XP
      Y2=Y(I)-YP
      R2=SQRT(X2*X2+Y2*Y2)
      VPL=R1*R2
      IF(R2) 20,150,20
   20 ST=(X1*Y2-X2*Y1)/VPL
      CT=(X1*X2+Y1*Y2)/VPL
      IF(CT+C180) 130,130,30
   30 IF(I-NP) 50,40,40
   40 IF(MOD(IEC,2)) 120,120,140
   50 TSC=SC*CT+CC*ST
      TCC=CC*CT-SC*ST
      IF(TSC*SC) 60,60,90
   60 IF(TSC*SC1) 70,70,90
   70 IF(TSC*ST) 80,90,90
   80 IEC=IEC+1
   90 SC=TSC
      CC=TCC
      X1=X2
      Y1=Y2
      R1=R2
      IF(SC) 100,110,100
  100 SC1=SC
  110 CONTINUE
  120 PTLOC=-1
      GO TO 170
  130 PTLOC=0
      GO TO 170
  140 PTLOC=1
      GO TO 170
  150 PTLOC=2
  170 RETURN
      END
