$NOFLOATCALLS
      FUNCTION RAND(IX)
C--------------------------------------------------
C***  RAND IS A PORTABLE RANDOM NUMBER GENERATOR BASED
C***  ON THE RECURSION IX=IX*A MOD P.
C***  GENERATES UNIFORM RANDOM NUMBERS ON INTERVAL 0,1
C***
C***  FORTRAN CODE WAS WRITTEN BY LINUS SCHRAGE
C***  REFERENCE AND DOCUMENTATION IS IN
C***  ACM TRANSACTIONS JUNE 1979
C----------------------------------------------------
      INTEGER*4 A,P,IX,B15,B16,XHI,XALO,LEFTLO,FHI,K
      DATA A,B15,B16,P/16807,32768,65536,2147483647/
C***  GET 15 HI ORDER BITS OF IX
      XHI=IX/B16
C***  GET 16 LO ORDER BITS OF IX AND FORM LO PRODUCT
      XALO=(IX-XHI*B16)*A
C***  GET 15 HI ORDER BITS OF LO PRODUCT
      LEFTLO=XALO/B16
C***  FORM THE 31 HIGHEST BITS OF FULL PRODUCT
      FHI=XHI*A+LEFTLO
C***  GET OVERFLO PAST 31ST BIT OF FULL PRODUCT
      K=FHI/B15
C***  ASSEMBLE ALL THE PARTS AND PRESUBTRACT P
C***  THE PARENTHESES ARE ESSENTIAL
      IX=(((XALO-LEFTLO*B16)-P)+(FHI-K*B15)*B16)+K
C***  ADD P BACK IN IF NECESSARY
      IF(IX.LT.0) IX=IX+P
C***  MULTIPLY BY 1/(2**31-1)
      RAND=FLOAT(IX)*4.656612875D-10
      RETURN
      END
