$NOFLOATCALLS
$STORAGE:2
      PROGRAM REGRESS
C     * * *  STEPFORWARD REGRESSION ANALYSIS - USGS STATPAC * * * * * *
C                         PROGRAM NUMBER  D0094
C                         U S GEOLOGICAL SURVEY
C                 GEOLOGIC DIVISION, DENVER, COLORADO
C     -----------------------------------------------------------------
C        THIS PROGRAM PERFORMS A MULTIPLE STEPWISE REGRESSION ON A
C     STATPAC DATA SET AND SUPPLIES THE RELATED REGRESSION STATISTICS.
C     THE METHOD IS ESSENTIALLY THAT OF EFROYMSON(1960).  THE REGRESSION
C     RESIDUALS ARE ALSO CALCULATED.
C        THE TERMS INCLUDED IN THE DERIVED REGRESSION EQUATION ARE THOSE
C     WHICH ARE SIGNIFICANT AT A PRESCRIBED CONFIDENCE LEVEL(I.E., THOSE
C     WHICH, WHEN INCLUDED IN THE REGRESSION EQUATION, ACCOUNT FOR
C     SUFFICIENTLY LARGE PORTIONS OF THE VARIANCE IN THE DEPENDENT VARI-
C     ABLE THAT THE RELATIONSHIP IS UNLIKELY TO HAVE RESULTED FROM
C     CHANCE ALONE).
C
C     ORIGINALLY PROGRAMMED BY D.S. HANDWERKER, USGS, WASHINGTON, D.C.
C     ADAPTED TO IBM PC BY A.T. MIESCH, USGS, GRAND JUNCTION, COLO.
C      LINKS REQUIRED: ASCIIZ,BYTMOV,CHRKNT,CKSAFE,CONCAT,IOS,SOUND
C     -----------------------------------------------------------------
C    -----------------------------------------------------------------
      CHARACTER*32 UNIT15,UNIT17
      CHARACTER*4 TVID(60,2),CID(2),VID(60,2),IDROW(4),
     *IOBS(2),ICOM(2),IRES(2)
      CHARACTER*1 IANS,A(60),TEST,AA(60)
      LOGICAL FILERR
      INTEGER*4 LOC(2)
      INTEGER CN,CM,
     1 PROM,SV(60),SELV(60,2),PROUT,STAPAC,
     2 BOOL,C(60),DEGF,REVISE,CNO,CMO,
     3 SVL(60),IVA(60),SW(60),SUMW
      REAL MEANS(60)
      DIMENSION X(60),CORR(60,60),STDEV(60),V(60),B(60),R(60),XX(60)
      DATA IOBS/'OBSE','RVED'/,ICOM/'COMP','UTED'/,IRES/'RESI','DUAL'/
      DATA TEST/' '/,PROUT/3/,STAPAC,REVISE/15,17/
      ICODE=0
C     ----------------------------------------------------------------
      WRITE(*,'(5X,''BE SURE YOUR DOT-MATRIX PRINTER IS TURNED ON.'')')
   50 WRITE(*,'(/,5X,''ENTER NAME OF STATPAC INPUT FILE: '',\)')
      READ(*,60) UNIT15
   60 FORMAT(A32)
      CALL CKSAFE(UNIT15,2,FILERR)
      IF(FILERR) GO TO 50
      OPEN(STAPAC,FILE=UNIT15,STATUS='OLD',FORM='UNFORMATTED')
      OPEN(PROUT,FILE='LPT1',STATUS='NEW')
      WRITE(PROUT,'('' '',2A1,\)') CHAR(27),'@'
      WRITE(PROUT,'('' '',2A1,\)') CHAR(27),'G'
      WRITE(PROUT,'('' '',A1,13X,''STEP-FORWARD'',)') CHAR(14)
      WRITE(PROUT,'(/,'' '',A1,10X,''REGRESSION ANALYSIS'')') CHAR(14)
      WRITE(PROUT,'(/,'' '',A1,14X,''USGS STATPAC'')') CHAR(14)
      WRITE(PROUT,'('' '',2A1,\)') CHAR(27),'H'
C***  PUT PRINTER IN COMPRESSED MODE
      WRITE(PROUT,'('' '',A1,\)') CHAR(15)
      READ(STAPAC) CID,CN,CM,(TVID(I,1),TVID(I,2),I=1,CM)
      IF(CM.GT.60) STOP 'PROGRAM IS LIMITED TO 60 VARIABLES'
      WRITE(*,'(//,5X,''STATPAC INPUT FILE ID IS: '',2A4,/,5X,''N = '',
     1I4,''; M = '',I2,'';'',5X,''COLUMN IDs ARE:'')') CID,CN,CM
      WRITE(*,70) (I,TVID(I,1),TVID(I,2),I=1,CM)
   70 FORMAT(5X,I2,') ',2A4,1X,I2,') ',2A4,1X,I2,') ',2A4,1X,I2,') ',
     12A4,1X,I2,') ',2A4)
      WRITE(*,80)
   80 FORMAT(1X)
      WRITE(*,100) TVID(1,1),TVID(1,2),CM-1
  100 FORMAT(5X,'BY DEFAULT, THE DEPENDENT VARIABLE WILL BE ',2A4,
     1' AND THE',/,5X,'REMAINING ',I2,' VARIABLES WILL BE USED AS',
     2' INDEPENDENT VARIABLES.',/,10X,'IS THIS EXACTLY WHAT YOU WANT?',
     3' Y/N: ',\)
      READ(*,'(A1)') IANS
      IF(IANS.EQ.'N'.OR.IANS.EQ.'n') GO TO 130
      DO 120 I=1,60
      SW(I)=I
  120 SV(I)=I
      NSW=CM
      GO TO 175
C     ----------------------------------------------------------------
C     READ SELECTED COLUMN PAIRS (SELV)
C     ----------------------------------------------------------------
  130 WRITE(*,132)
  132 FORMAT(/,5X,'OKAY, YOU WILL HAVE TO SPECIFY WHICH VARIABLES',/,
     15X'TO USE BY INDICATING THEIR COLUMN NUMBERS.',/,10X,'HOW MANY',
     1' SEQUENCES OF VARIABLES WILL BE SELECTED? ',\)
      READ(*,134) PROM
  134 FORMAT(BN,I10)
      IF(PROM.LT.1.OR.PROM.GT.CM) GO TO 130
  135 WRITE(*,136) PROM
  136 FORMAT(5X,'ENTER THE ',I2,' SEQUENCES.  USE COMMA SEPARATOR ==',
     1'> XX,XX',/,5X,'REMEMBER THE DEPENDENT VARIABLE COMES FIRST.')
      DO 140 I=1,PROM
      WRITE(*,'(10X,''ENTER SEQUENCE NO. '',I2,'': '',\)') I
      READ(*,*) SELV(I,1),SELV(I,2)
      IF(SELV(I,1).LT.0.OR.SELV(I,1).GT.CM.OR.SELV(I,1).GT.SELV(I,2))
     * GO TO 135
      IF(SELV(I,2).LT.0.OR.SELV(I,2).GT.CM) GO TO 135
  140 CONTINUE
      NSV=0
      DO 150 I=1,PROM
      DO 150 J=SELV(I,1),SELV(I,2)
      NSV=NSV+1
      NSW=NSV
      SW(NSW)=J
  150 SV(NSV)=J
C     ----------------------------------------------------------------
C     READ PROBABILITY LEVEL (Q)
C     ----------------------------------------------------------------
  175 WRITE(*,177)
  177 FORMAT(/,5X,'AT WHAT PROBABILITY DO YOU WANT THESE INDEPENDENT ',
     1'VARIABLES TESTED?',/,5X,'COMMONLY USED VALUES ARE .01 OR .05. ',
     2'IF YOU SELECT A VALUE OF 1.0, ALL',/,5X,'THE INDEPENDENT ',
     3'VARIABLES WILL BE INCLUDED IN THE REGRESSION EQUATION.',/,
     410X,'ENTER A VALUE FROM ZERO TO ONE: ',\)

      READ(*,*) Q
      IF(Q.LE.0.0.OR.Q.GT.1.0) GO TO 175
      IORG=0
      WRITE(*,342)
  342 FORMAT(/,5X,'DO YOU WANT TO FORCE THE REGRESSION LINE THROUGH ',
     1'THE ORIGIN?',/,10X,'ANSWER Y/N: ',\)
      READ(*,'(A1)') IANS
      IF(IANS.EQ.'Y'.OR.IANS.EQ.'y') IORG=1
      IF(IORG.EQ.1) WRITE(*,1440)
      IF(IORG.EQ.1) WRITE(PROUT,1440)
      IF (PROM.EQ.0) NSV=CM
      DO 240 I=1,NSV
      M=SV(I)
      DO 240 J=1,2
  240 VID(I,J)=TVID(M,J)
  260 DO 270 I=1,NSV
      MEANS(I)=0.0
      STDEV(I)=0.0
      IVA(I)=0
      DO 270 J=1,NSV
  270 CORR(I,J)=0.0
C     ----------------------------------------------------------------
C     PRINT INPUT DATA
C     ----------------------------------------------------------------
      WRITE (PROUT,1330) NSV
      WRITE (PROUT,1000)
      WRITE (PROUT,1010) (SV(I),I=1,NSV)
      WRITE (PROUT,1040)
      WRITE (PROUT,1080) ((VID(I,J),J=1,2),I=1,NSV)
      WRITE (PROUT,1320) Q
      IF (NSV.GT.60) GO TO 895
      IB=0
      SUMW=0
      NSO=CN
      WRITE(*,275)
  275 FORMAT(5X,'READING DATA.....',/)
      DO 320 K=1,CN
      WRITE(*,280) K
  280 FORMAT('+',I10)
      CALL JKGTLS (STAPAC,TBLK,IDROW,LOC,X,A,CM,IERR)
      IF(IERR.NE.0) STOP 'UNEXPECTED END-OF-FILE'
      IF(IB.EQ.1) GO TO 297
      DO 295 I=1,NSV
      M=SV(I)
      IF(A(M).EQ.TEST) GO TO 295
      IB=1
      WRITE(*,290)
  290 FORMAT(' QUALIFYING CODES ARE PRESENT AND WILL BE IGNORED')
  295 CONTINUE
  297 DO 300 I=1,NSV
      M=SV(I)
  300 MEANS(I)=MEANS(I)+X(M)
      SUMW=SUMW+1
  320 CONTINUE
      FSUMW=FLOAT(SUMW)
      IF(ABS(SUMW-NSO).GT.1.0) WRITE(PROUT,1450) FSUMW,NSO
      REWIND STAPAC
      READ(STAPAC) CID,CN,CM,(TVID(I,1),TVID(I,2),I=1,CM)
C     ----------------------------------------------------------------
C     COMPUTE AND PRINT CORRELATION MATRIX
C     ----------------------------------------------------------------
      DO 340 I=1,NSV
  340 MEANS(I)=MEANS(I)/FSUMW
      WRITE (PROUT,1090)
      WRITE (PROUT,1100) (MEANS(I),I=1,NSV)
      WRITE(*,345)
  345 FORMAT(5X,'COMPUTING THE CORRELATION MATRIX.....',/)
      DO 380 K=1,CN
      WRITE(*,280) K
  350 CALL JKGTLS (STAPAC,TBLK,IDROW,LOC,X,A,CM,IERR)
      IF(IERR.NE.0) STOP 'UNEXPECTED END OF FILE'
      DO 370 I=1,NSV
      M=SV(I)
      IF(IORG.EQ.1) GO TO 363
      STDEV(I)=STDEV(I)+(X(M)-MEANS(I))**2
      GO TO 364
  363 STDEV(I)=STDEV(I)+X(M)**2
  364 DO 370 J=1,NSV
      M1=SV(J)
      IF(IORG.EQ.1) GO TO 365
      CORR(I,J)=CORR(I,J)+(X(M)-MEANS(I))*(X(M1)-MEANS(J))
      GO TO 370
  365 CORR(I,J)=CORR(I,J)+X(M)*X(M1)
  370 CONTINUE
  380 CONTINUE
      REWIND STAPAC
      READ(STAPAC) CID,CN,CM,(TVID(I,1),TVID(I,2),I=1,CM)
      DO 390 I=1,NSV
      IF (STDEV(I).LT.0) STDEV(I)=0.0
      DEN=FSUMW-1.0
      IF(IORG.EQ.1) DEN=FSUMW
  390 STDEV(I)=SQRT(STDEV(I)/DEN)
      BOOL=0
      DO 400 I=1,NSV
  400 IF (STDEV(I).EQ.0) BOOL=1
      WRITE (PROUT,1110)
      WRITE (PROUT,1100) (STDEV(I),I=1,NSV)
      DO 410 I=1,NSV
      DO 410 J=1,NSV
      DEN=FSUMW-1.0
      IF(IORG.EQ.1) DEN=FSUMW
  410 CORR(I,J)=(1.0/DEN)*(CORR(I,J)/(STDEV(I)*STDEV(J)))
C     --------------
C     AS AN OPTION, PRINT CORRELATION MATRIX
C     --------------
      WRITE(*,'(/,5X,''DO YOU WANT TO PRINT THE CORRELATION MATRIX?'',
     1/,10X,''ANSWER Y/N: '',\)')
      READ(*,'(A1)') IANS
      IF(IANS.EQ.'Y'.OR.IANS.EQ.'y') THEN
      WRITE (PROUT,1120)
      DO 420 I=1,NSV
      WRITE (PROUT,1140) I
  420 WRITE (PROUT,1130) (CORR(I,J),J=1,NSV)
      ENDIF
      DEGF=SUMW-1
      IF(IORG.EQ.1) DEGF=SUMW
      VAR=1.0
      DO 430 I=2,NSV
  430 C(I)=-1
  440 DO 450 I=2,NSV
  450 V(I)=(CORR(I,1)**2)/CORR(I,I)
C     ----------------------------------------------------------------
C     START COMPUTATION OF REGRESSION EQUATION
C     -----------------------------------------------------------------
      VMIN=0.9999E35
      DO 470 I=2,NSV
      IF ((C(I).NE.1).OR.(CORR(I,I).LE.1.0E-10)) GO TO 460
      IF (V(I).GE.VMIN) GO TO 460
      K=I
      VMIN=V(I)
  460 CONTINUE
  470 CONTINUE
      IF (VMIN.EQ.0.9999E35) GO TO 480
      IF(ABS(VAR).GT.1.0E-10) GO TO 475
      F=1.0E35
      GO TO 476
  475 F=(VMIN*FLOAT(DEGF))/VAR
  476 IDFN=1
      QF=FISH(F,IDFN,DEGF)
      IF (QF.LE.Q) GO TO 480
C     -----------------------------------------------------------------
C     ADD COLUMN TO REGRESSION EQUATION
C     -----------------------------------------------------------------
      VAR=VAR+VMIN
      DEGF=DEGF+1
      WRITE (PROUT,1170) K,VID(K,1),VID(K,2),F,DEGF,QF
      GO TO 560
C     -----------------------------------------------------------------
C     START OF 9B
C     -----------------------------------------------------------------
  480 VMAX=0.0
      DO 500 I=2,NSV
      IF ((C(I).NE.-1).OR.(CORR(I,I).LE.1.0E-10)) GO TO 490
      IF (V(I).LE.VMAX) GO TO 490
      K=I
      VMAX=V(I)
  490 CONTINUE
  500 CONTINUE
      IF (VMAX) 880,670,510
  510 IF((ABS(VAR-VMAX)).GT.1.0E-10) GO TO 511
      F=1.0E35
      GO TO 512
  511 F=(VMAX*FLOAT(DEGF))/(VAR-VMAX)
  512 IDFN=1
      QF=FISH(F,IDFN,DEGF)
      IF (QF.GT.Q) GO TO 670
C     -----------------------------------------------------------------
C     DELETE COLUMN FROM REGRESSION EQUATION
C     -----------------------------------------------------------------
      VAR=VAR-VMAX
      DEGF=DEGF-1
      WRITE (PROUT,1160) K,VID(K,1),VID(K,2),F,DEGF,QF
      IVA(K)=IVA(K)+1
      DO 520 II=1,NSV
      IF (IVA(II).GT.10) GO TO 530
  520 CONTINUE
      GO TO 550
  530 WRITE (PROUT,1350) II,SV(II)
      DO 540 JJ=II,NSV
      VID(JJ,1)=VID(JJ+1,1)
      VID(JJ,2)=VID(JJ+1,2)
  540 SV(JJ)=SV(JJ+1)
      NSV=NSV-1
      IF (NSV.GT.1) GO TO 260
      WRITE (PROUT,1360)
      GO TO 900
  550 CONTINUE
C     -----------------------------------------------------------------
C     START STEP 10
C     -----------------------------------------------------------------
  560 REC=1.0/CORR(K,K)
      IK=K-1
      KI=K+1
      IF (IK.LT.2) GO TO 610
      DO 600 I=2,IK
      FAC=CORR(I,K)*REC
      CORR(I,1)=CORR(I,1)-CORR(K,1)*FAC
      DO 570 J=I,IK
      PROD=CORR(J,K)*FAC
      IFAC=C(K)*C(J)
      IF (IFAC.NE.1) PROD=-PROD
      CORR(I,J)=CORR(I,J)-PROD
  570 CONTINUE
      IF (KI.GT.NSV) GO TO 590
      DO 580 J=KI,NSV
      PROD=CORR(K,J)*FAC
      CORR(I,J)=CORR(I,J)-PROD
  580 CONTINUE
  590 CORR(I,K)=-FAC
  600 CONTINUE
  610 IF (KI.GT.NSV) GO TO 640
      DO 630 I=KI,NSV
      FAC=CORR(K,I)*REC
      IFAC=C(K)*C(I)
      IF (IFAC.NE.1) FAC=-FAC
      CORR(I,1)=CORR(I,1)-CORR(K,1)*FAC
      DO 620 J=I,NSV
      PROD=CORR(K,J)*FAC
      CORR(I,J)=CORR(I,J)-PROD
  620 CONTINUE
      CORR(K,I)=CORR(K,I)*REC
  630 CONTINUE
  640 CORR(K,1)=CORR(K,1)*REC
      CORR(K,K)=REC
      IF (C(K).EQ.-1) GO TO 650
      C(K)=-1
      GO TO 660
  650 C(K)=1
  660 CONTINUE
      GO TO 440
C     -----------------------------------------------------------------
C     START STEP 11
C     -----------------------------------------------------------------
  670 J=2
      DO 690 I=2,NSV
      IF (C(I).NE.1) GO TO 680
      B(J)=(CORR(I,1)*STDEV(1))/STDEV(I)
      J=J+1
  680 CONTINUE
  690 CONTINUE
      K=J-1
      SUM=0
      J=2
      DO 710 I=2,NSV
      IF (C(I).NE.1) GO TO 700
      SUM=SUM+(B(J)*MEANS(I))
      J=J+1
  700 CONTINUE
  710 CONTINUE
      B(1)=MEANS(1)-SUM
      IF(IORG.EQ.1) B(1)=0.0
      WRITE (PROUT,1180)
      WRITE (PROUT,1100) (B(I),I=1,K)
      PSS=0
      DO 730 I=2,NSV
      IF (C(I).NE.1) GO TO 720
      PSS=PSS+(CORR(I,1)*CORR(1,I))
  720 CONTINUE
  730 CONTINUE
      IF (J.GT.2) GO TO 740
      WRITE (PROUT,1370)
      GO TO 900
  740 IDFN=J-2
      NDF=SUMW-1
      IF(IORG.EQ.1) NDF=SUMW
      IDFD=NDF-IDFN
      FAC=1.0-PSS
      IF((ABS(FAC*FLOAT(IDFN))).GT.1.0E-10) GO TO 745
      FR=1.0E35
      GO TO 746
  745 FR=PSS*FLOAT(IDFD)/(FAC*FLOAT(IDFN))
  746 CMR=SQRT(PSS)
      IF (CMR.GT.1.0) CMR=1.0
      PRF=FISH(FR,IDFN,IDFD)
      WRITE (PROUT,1220) CMR,IDFN,IDFD,FR,PRF
      SSQRS=NDF*FAC*STDEV(1)**2
      IF(SSQRS.LT.0.0) SSQRS=0.0
      WRITE (PROUT,1230) SSQRS
      ZZ=(SSQRS/IDFD)
      IF(ZZ.LT.0.0) ZZ=0.0
      SEOUW=SQRT(ZZ)
      J=2
      DO 760 I=2,NSV
      IF (C(I).NE.1) GO TO 750
      TERM=CORR(I,I)*FAC+CORR(I,1)**2
      IF(TERM.LE.0.0) X(J)=0.0
      IF(TERM.GT.0.0) X(J)=CORR(I,1)/SQRT(TERM)
      J=J+1
  750 CONTINUE
  760 CONTINUE
      WRITE (PROUT,1240)
      J=J-1
      WRITE (PROUT,1250) (X(I),I=2,J)
      FAC=NDF
      FAC=SEOUW/(STDEV(1)*SQRT(FAC))
      J=2
      DO 780 I=2,NSV
      IF (C(I).LT.1) GO TO 770
      R(J)=CORR(I,1)
      JJ=J+99
      IF(CORR(I,I).LT.0.0) CORR(I,I)=0.0
      R(JJ)=FAC*SQRT(CORR(I,I))
      J=J+1
  770 CONTINUE
  780 CONTINUE
      IDFN=J-1
C     -----------------------------------------------------------------
C     PRINT RESULTS OF CALCULATION OF REGRESSION EQUATION
C     -----------------------------------------------------------------
      WRITE (PROUT,1270)
      WRITE (PROUT,1100) (R(I),I=2,IDFN)
      WRITE (PROUT,1260)
      I1=IDFN+99
      WRITE (PROUT,1100) (R(I),I=101,I1)
      SUM=0.0
      J=2
      DO 820 I=2,NSV
      IF (C(I).LT.1) GO TO 810
      I1=J+99
      R(J)=STDEV(1)*R(I1)/STDEV(I)
      J=J+1
      SUM=SUM+CORR(I,I)*(MEANS(I)/STDEV(I))**2
      I1=I+1
      IF (I.EQ.NSV) GO TO 810
      DO 800 L=I1,NSV
      IF (C(L).LT.1) GO TO 790
      FAC=CORR(I,L)*MEANS(I)*MEANS(L)/(STDEV(I)*STDEV(L))
      SUM=SUM+FAC+FAC
  790 CONTINUE
  800 CONTINUE
  810 CONTINUE
  820 CONTINUE
      SUM=1.0/FSUMW+SUM/NDF
      R(1)=SEOUW*SQRT(SUM)
      IF(IORG.EQ.1) R(1)=0.0
      WRITE (PROUT,1280)
      WRITE (PROUT,1100) (R(I),I=1,IDFN)
      NDF=NSO-1
      SUM=FLOAT(NDF)
      SUM=SUM/FLOAT(NSO-IDFN)
      IF(IORG.EQ.1) SUM=(NDF+1.0)/(NSO-IDFN+1.0)
      STDERR=SQRT(STDEV(1)**2*(1.0-CMR**2)*SUM)
      WRITE (PROUT,1340) STDERR
      PSS=100.0*PSS
      WRITE (PROUT,1190) PSS
C     ----------------------------------------------------------------
C     CALCULATE AND PRINT RESIDUALS
C     ----------------------------------------------------------------
      WRITE(*,816)
  816 FORMAT(/,5X,'DO YOU WANT TO DERIVE THE COMPUTED AND RESIDUAL VAL'
     1,'UES FOR EACH SAMPLE',/,10X,'ANSWER Y/N: ',\)
      READ(*,'(A1)') IANS
      IF(IANS.NE.'Y'.AND.IANS.NE.'y') GO TO 900
  819 WRITE(*,817)
  817 FORMAT(/,5X,'DO YOU WANT THESE VALUES TO BE: (1) PRINTED;',/,
     15X,'(2) WRITTEN IN A STATPAC OUTPUT FILE; OR, (3) BOTH?',/,
     210X,'ANSWER 1, 2, OR 3: '\)
      READ(*,818) ICR
  818 FORMAT(I1)
      IF(ICR.NE.1.AND.ICR.NE.2.AND.ICR.NE.3) GO TO 819
      SVL(1)=SV(1)
      L=1
      IF(Q.LT.0.9999) GO TO 1500
      DO 1501 I=2,NSW
 1501 SVL(I)=SW(I)
      CMO=NSW+2
      L=NSW
      GO TO 1502
 1500 DO 815 I=2,NSV
      IF (C(I).NE.1) GO TO 815
      L=L+1
      SVL(L)=SV(I)
  815 CONTINUE
      CMO=L+2
 1502 IF(ICR.EQ.1) GO TO 829
  833 WRITE(*,'(/,5X,''GIVE A NAME FOR THE STATPAC OUTPUT FILE: '',\)')
      READ(*,60) UNIT17
      CALL CKSAFE(UNIT17,1,FILERR)
      IF(FILERR) GO TO 833
      WRITE(PROUT,920) CID,NSO,CMO
      WRITE(PROUT,1380)
      WRITE(PROUT,1400) SVL(1),SVL(1),SVL(1),(SVL(I),I=2,L)
      WRITE (PROUT,1430) IOBS,ICOM,IRES,(TVID(SVL(I),1),
     1 TVID(SVL(I),2),I=2,L)
      OPEN(REVISE,FILE=UNIT17,STATUS='NEW',FORM='UNFORMATTED')
      WRITE (REVISE) CID,NSO,CMO,IOBS,ICOM,IRES,
     1 (TVID(SVL(I),1),TVID(SVL(I),2),I=2,L)
  829 IF(ICR.EQ.2) GO TO 831
      WRITE(PROUT,832)
      WRITE(PROUT,832)
      WRITE(PROUT,832)
  832 FORMAT(' ')
      WRITE (PROUT,1200)
      WRITE(PROUT,1201)
  831 III = 0
      WRITE(*,432)
  432 FORMAT(/,5X,'DERIVING THE COMPUTED AND RESIDUAL VALUES')
      WRITE(*,275)
      DO 870 K=1,CN
      IF(ICR.EQ.2) WRITE(*,280) K
  830 CALL JKGTLS (STAPAC,TBLK,IDROW,LOC,X,A,CM,IERR)
      IF(IERR.NE.0) STOP 'UNEXPECTED END-OF-FILE'
      DO 823 I=1,3
      XX(I)=0.0
  823 AA(I)='B'
      IF(Q.LT.0.9999) GO TO 1503
      DO 1504 I=4,CMO
      J=I-2
      XX(I)=X(SW(J))
      AA(I)=A(SW(J))
 1504 CONTINUE
      GO TO 828
 1503 II=3
      DO 824 I=2,NSV
      IF (C(I).NE.1) GO TO 824
      II=II+1
      XX(II)=X(SV(I))
      AA(II)=A(SV(I))
  824 CONTINUE
  828 SUM=0
      J=2
      DO 860 I=2,NSV
      M=SV(I)
      IF (C(I).NE.1) GO TO 850
      SUM=SUM+(B(J)*X(M))
      J=J+1
  850 CONTINUE
  860 CONTINUE
      SUM=SUM+B(1)
      M=SV(1)
      RES=X(M)-SUM
      IF(ICR.NE.2) WRITE (PROUT,1210) K,IDROW(1),IDROW(2),X(M),SUM,RES
      XX(1)=X(M)
      XX(2)=SUM
      XX(3)=RES
      DO 865 I=1,3
  865 AA(I) = TEST
      III=III+1
      IF(ICR.NE.1) CALL JKPTLS (REVISE,III,IDROW,LOC,XX,AA,CMO)
  870 CONTINUE
      GO TO 900
C     ----------------------------------------------------------------
C     PRINT ERROR MESSAGES
C     ----------------------------------------------------------------
  880 WRITE (PROUT,980)
      GO TO 900
  895 WRITE(PROUT,1460)
  900 WRITE(PROUT,910)
  910 FORMAT(' ')
C***  PUT PRINTER BACK INTO NORMAL MODE
      WRITE(PROUT,'('' '',A1,\)') CHAR(18)
      STOP '    NORMAL END OF PROGRAM'
C     ----------------------------------------------------------------
C
  920 FORMAT ('0ID ON OUTPUT FILE=',2A4,4X,'N=',I5,4X,'M=',I3,/)
  980 FORMAT ('0VMAX LT 0.0')
 1000 FORMAT (' SELECTED VARIABLE INDICES ')
 1010 FORMAT (10(4X,I4,5X))
 1040 FORMAT (' SELECTED VARIABLE IDENTIFIERS')
 1080 FORMAT (10(2X,2A4,3X))
 1090 FORMAT ('0MEANS OF SELECTED VARIABLES')
 1100 FORMAT (10(1X,1PE12.5))
 1110 FORMAT (' STANDARD DEVIATIONS OF SELECTED VARIABLES')
 1120 FORMAT (' CORRELATION MATRIX')
 1130 FORMAT (10(6X,F7.4))
 1140 FORMAT (' ROW NUMBER ',I3)
 1160 FORMAT ('0VARIABLE ',I2,' (',2A4,') ADDED.    F = ',E14.6,' DEG OF
     1 FR = ',I5,'  Q COMPUTED = ',E14.6)
 1170 FORMAT ('0VARIABLE ',I2,' (',2A4,') DELETED.  F = ',E14.6,' DEG OF
     1 FR = ',I5,'  Q COMPUTED = ',E14.6)
 1180 FORMAT ('0REGRESSION CONSTANT AND COEFFICIENTS IN THE ORDER OF VAR
     1IABLE NO.')
 1190 FORMAT ('0PERCENT OF TOTAL SUMS OF SQUARES OF DEPENDENT ','VARIABL
     1E EXPLAINED = ',F7.3/)
 1200 FORMAT(8X,'LIST OF OBSERVED, COMPUTED, AND RESIDUAL VALUES')
 1201 FORMAT ('    ROW (ROW ID)      OBSERVED       COMPUTED   ','    RE
     1SIDUAL   '/)
 1210 FORMAT (1X,I5,' (',2A4,')',2X,1PE13.5,2X,1PE13.5,2X,1PE13.5)
 1220 FORMAT ('0MULTIPLE CORRELATION COEFFICIENT = ',F11.7,'   F VALUE F
     1OR ',I3,' AND ',I5,' DEG OF FR = ',F11.3/' THE PROBABILITY OF THIS
     2 F IS : ',F7.3)
 1230 FORMAT ('0WTD SUM OF RESIDUALS SQUARED = ',E14.7)
 1240 FORMAT ('0PARTIAL CORRELATION COEFFICIENTS')
 1250 FORMAT (10(1X,F12.5))
 1260 FORMAT ('0STANDARD ERRORS OF REGRESSION WEIGHTS')
 1270 FORMAT ('0REGRESSION WEIGHTS')
 1280 FORMAT ('0STANDARD ERRORS OF REGRESSION CONSTANT AND ','REGRESSION
     1 COEFFICIENTS')
 1320 FORMAT ('0PROBABILITY LEVEL = ',F7.3/)
 1330 FORMAT (/,' NUMBER OF SELECTED VARIABLES   = ',I4/)
 1340 FORMAT ('0STANDARD ERROR OF THE ESTIMATE OF THE DEPENDENT ','VARIA
     1BLE = ',1PE12.4)
 1350 FORMAT ('0VARIABLE ',I2,' (COLUMN ',I2,') IS BEING DROPPED PERMANE
     1NTLY FROM THE REGRESSION EQUATION.')
 1360 FORMAT ('0THE NUMBER OF SELECTED VARIABLES IS LESS THAN TWO.  THER
     1EFORE, THIS REGRESSION IS BEING ABORTED.')
 1370 FORMAT ('0REGRESSION IS IMPOSSIBLE BECAUSE NO VARIABLES ARE SIGNIF
     1ICANT AT THE SELECTED PROBABILITY LEVEL.')
 1380 FORMAT(' ORDER OF VARIABLES ON THE OUTPUT FILE'/' OBSERVED',
     1' - COMPUTED - RESIDUAL - INDEPENDENT VARIABLES REMAINING IN THE R
     *EGRESSION EQUATION')
 1400 FORMAT(4X,I4,' OBS',5X,I4,' COMP',
     15X,I4,' RESD ',7(4X,I4,5X),/(10(4X,I4,5X)))
 1430 FORMAT(' IDENTIFIERS FOR VARIABLES ON OUTPUT FILE'/(10(2X,2A4,3
     1X)))
 1440 FORMAT(' WARNING...WHEN THE EQUATION IS FORCED THRU THE ORIGIN',/,
     * ' ALL STD DEVIATIONS AND CORRELATIONS ARE COMPUTED ABOUT',/,
     * ' THE ORIGIN RATHER THAN THE MEAN',///)
 1450 FORMAT(4X,'WARNING...THE SUM OF THE WEIGHTS',F9.3,' IS NOT EQUAL T
     1O THE NUMBER OF ROWS IN THE REGRESSION',I5)
 1460 FORMAT('0NO MORE THAN 60 VARIABLES IN THE INPUT FILE')
      END
      FUNCTION FISH (F,N1,N2)
C     -----------------------------------------------------------------
C     THIS FUNCTION COMPUTES THE AREA (FISH) OF THE F DISTRIBUTION WITH
C     N1 & N2 DEGREES OF FREEDOM FROM F TO INFINITY.
C     WHERE F = VARIANCE RATIO
C          N1 = DEGREES OF FREEDOM IN THE NUMERATOR
C          N2 = DEGREES OF FREEDOM IN THE DENOMINATOR
C        FISH = PROBABILITY OF OBSERVED F
C
C     TAKEN FROM R. G. GARRETT AND T. I., 1980, COMPUTERS & GEOSCIENCES,
C         V. 6, N. 1, P. 54-55.
C     METHOD FROM MILTON ABRAMOWITZ AND I. A. STEGUN, 1972, NBS HANDBOOK
C         55, P. 946.
C     -----------------------------------------------------------------
C
      LOGICAL E1,E2,E3
C
C     INITIALISE AND SET LOGICALS TO .TRUE. FOR N1 AND/OR N2 EVEN
      IF(F.LT.1.0E30) GO TO 10
      FISH=0.9999
      GO TO 9999
   10 E1=.FALSE.
      E2=.FALSE.
      E3=.FALSE.
      IF(MOD(N1,2).EQ.0)E1=.TRUE.
      IF(MOD(N2,2).EQ.0)E2=.TRUE.
      X=N2/(N2+N1*F)
      IF(.NOT.(E1.OR.E2))GO TO 5
      IF(E1.AND..NOT.E2)GO TO 2
      IF(.NOT.E1.AND.E2)GO TO 1
      IF(N1.LE.N2)GO TO 2
    1 I=N1
      N1=N2
      N2=I
      X=1.0-X
      E3=.TRUE.
    2 Y=1.0-X
C
C     COMMENCE CALCULATION OF PROBABILITY FOR N1 AND/OR N2 EVEN
      FSH=0.0
      ZZ=X**N2
      IF(ZZ.LT.0.0) ZZ=0.0
      H=SQRT(ZZ)
      M=N1/2-1
      II=0
      DO 3 I=II,M
      FSH=FSH+H
    3 H=(H*Y*(N2+2.0*I))/(2.0*(I+1.0))
      IF(E3)GO TO 4
C
C     ADJUST CALCULATED PROBABILITY IF COMPLEMENT WAS COMPUTED, R
      FSH=1.0-FSH
      GO TO 9
    4 I=N1
      N1=N2
      N2=I
      GO TO 9
C
C     CALCULATION FOR BOTH N1 AND N2 ODD
    5 Y=1.0-X
      ZZ=X*Y
      IF(ZZ.LT.0.0) ZZ=0.0
      H=0.6366198*SQRT(ZZ)
      ZZ=X
      IF(ZZ.LT.0.0) ZZ=0.0
      IF(ZZ.GT.1.0) ZZ=1.0
      FSH=0.6366198*ACOS(SQRT(ZZ))
      IF(N2.EQ.1)GO TO 7
      M=N2-2
      DO 6 I=1,M,2
      FSH=FSH+H
    6 H=H*X*(I+1)/(I+2)
    7 IF(N1.EQ.1)GO TO 9
      H=H*N2
      M=N1-2
      DO 8 I=1,M,2
      FSH=FSH-H
    8 H=H*Y*(N2+I)/(I+2)
    9 FSH=1.0-FSH
      FISH=FSH
 9999 RETURN
      END
