$STORAGE:2
C REPLAC.FORTRAN PROGRAM TO REPLACE QUALIFIED VALUES IN A STATPAC
C DATA SET AND TAKE LOGS OF SELECTED VARIABLES.
C   QUALIFYING CODES OF "B" AND "H" ARE REPLACED WITH THE MEAN OF THE
C       UNQUALIFIED VALUES FOR THE SAME VARIABLE
C   QUALIFYING CODES OF "N" ARE REPLACED WITH EITHER 1) ONE-HALF
C       OF THE QUALIFIED VALUE, OR 2) ONE-HALF OF THE MINIMUM
C       UNQUALIFIED VALUE FOR THE SAME VARIABLE.
C   QUALIFYING CODES OF "L" OR "T" ARE REPLACED WITH EITHER 1) SEVEN-
C       TENTHS OF THE QUALIFIED VALUE, OR 2) SEVEN-TENTHS OF THE
C       MINIMUM UNQUALIFIED VALUE FOR THE SAME VARIABLE.
C   QUALIFYING CODES OF "G" ARE REPLACED WITH EITHER 1) THE QUALIFIED
C       VALUE DIVIDED BY 0.7, OR 2) THE MAXIMUM UNQUALIFIED VALUE
C       FOR THE VARIABLE DIVIDED BY 0.7.
C A.T. MIESCH, USGS, DENVER   APRIL, 1979
C
      CHARACTER*12 UNIT10,UNIT11
      CHARACTER*4 ID(2),NAME(4),IVID(60,2)
      CHARACTER*1 IA(60),KL,KN,KT,KG,KH,KB,IY,JY,IBLANK,IANS
      INTEGER*4 LOC(2)
      DIMENSION X(60),XMAX(60),XMIN(60),XB(60),XN(60),ILOG(60),
     *NQ(60)
      DATA KL/'L'/,KN/'N'/,KT/'T'/,KG/'G'/,KH/'H'/,
     *KB/'B'/,IY/'Y'/,JY/'y'/,IBLANK/' '/
      KI=10
      KO=11
      WRITE(*,10)
   10 FORMAT(' ENTER NAME OF THE STATPAC INPUT FILE: ',\)
      READ(*,20) UNIT10
      WRITE(*,15)
   15 FORMAT(' ENTER A NAME FOR THE STATPAC OUTPUT FILE: ',\)
      READ(*,20) UNIT11
   20 FORMAT(A12)
      OPEN(KI,FILE=UNIT10,STATUS='OLD',FORM='UNFORMATTED')
      OPEN(KO,FILE=UNIT11,STATUS='NEW',FORM='UNFORMATTED')
      READ(KI) ID,N,M,(IVID(I,1),IVID(I,2),I=1,M)
      DO 200 I=1,M
      XMAX(I)=-1.0E30
      XMIN(I)=1.0E30
      NQ(I)=0
      XB(I)=0.0
  200 XN(I)=0.0
      LOG=0
      WRITE(*,1100)
 1100 FORMAT(' DO YOU WANT TRANSFORMATION TO LOGS ?')
      READ (*,1110) IANS
 1110 FORMAT(A1)
      IF(IANS.EQ.IY.OR.IANS.EQ.JY) LOG=1
      DO 250 I=1,M
  250 ILOG(I)=1
      IF(LOG.EQ.0) GO TO 390
      WRITE(*,1120)
 1120 FORMAT(' OF ALL THE VARIABLES ?')
      READ (*,1110) IANS
      IF(IANS.EQ.IY.OR.IANS.EQ.JY) GO TO 390
      WRITE(*,1130)
 1130 FORMAT(' TYPE Y IF LOGS ARE TO BE TAKEN FOR THE INDICATED VARIABLE
     *:')
      DO 260 I=1,M
      WRITE(*,1140) I,IVID(I,1),IVID(I,2)
 1140 FORMAT(I5,2X,2A4,'  ',$)
      READ (*,1110) IANS
      IF(IANS.NE.IY.AND.IANS.NE.JY) ILOG(I)=0
  260 CONTINUE
  390 K100=0
      DO 410 I=1,N
      K100=K100+1
      IF(K100.LT.100) GO TO 392
      WRITE(*,391) I
  391 FORMAT(I5)
      K100=0
  392 CALL JKGTLS(KI,IROW,NAME,LOC,X,IA,M,IERR)
      IF(IERR.NE.0) STOP 'UNEXPECTED END-OF-FILE'
      DO 400 J=1,M
      IF(IA(J).EQ.IBLANK) GO TO 395
      NQ(J)=NQ(J)+1
      GO TO 400
  395 IF(X(J).GT.XMAX(J)) XMAX(J)=X(J)
      IF(X(J).LT.XMIN(J)) XMIN(J)=X(J)
      XB(J)=XB(J)+X(J)
      XN(J)=XN(J)+1.0
  400 CONTINUE
  410 CONTINUE
      IERR=0
      WRITE(*,8800)
 8800 FORMAT(' COMPLETED FIRST PASS THROUGH THE DATA FILE')
      DO 415 I=1,M
      IF(NQ(I).LT.N) GO TO 412
      WRITE(*,1200) I
 1200 FORMAT(' ALL VALUES OF VARIABLE',I3,' ARE QUALIFIED')
      IERR=1
      GO TO 415
  412 IF(XMAX(I).GT.XMIN(I)) GO TO 415
      EP1=ABS(XMAX(I))
      EP2=ABS(XMIN(I))
      IF(EP1.LT.1.0E-15.AND.EP2.LT.1.0E-15) GO TO 415
      WRITE(*,1205) I
 1205 FORMAT(' NO VARIANCE IN VARIABLE',I3)
      IERR=1
  415 CONTINUE
      IF (IERR.EQ.1) STOP
      DO 420 I=1,M
      XMAX(I)=XMAX(I)/0.7
      XMIN(I)=XMIN(I)*0.7
      IF(XN(I).LT.0.5) GO TO 420
      XB(I)=XB(I)/XN(I)
  420 CONTINUE
      REWIND KI
      READ(KI) ID,N,M,(IVID(I,1),IVID(I,2),I=1,M)
      WRITE(KO) ID,N,M,(IVID(I,1),IVID(I,2),I=1,M)
      K100=0
      DO 500 I=1,N
      K100=K100+1
      IF(K100.LT.100) GO TO 422
      WRITE(*,391) I
      K100=0
  422 CALL JKGTLS(KI,IROW,NAME,LOC,X,IA,M,IERR)
      IF(IERR.NE.0) STOP 'UNEXPECTED END-OF-FILE'
      DO 480 J=1,M
      IF(IA(J).NE.IBLANK) GO TO 430
      IF(LOG.EQ.1.AND.ILOG(J).EQ.1) X(J)=ALOG10(X(J))
      GO TO 480
  430 IF(IA(J).NE.KN.AND.IA(J).NE.KL.AND.IA(J).NE.KT) GO TO 450
      IF(IA(J).NE.KN) GO TO 440
      IF(X(J).GT.0.0) GO TO 435
      X(J)=0.7*XMIN(J)
      GO TO 437
  435 X(J)=0.5*X(J)
  437 IF(LOG.EQ.1.AND.ILOG(J).EQ.1) X(J)=ALOG10(X(J))
      GO TO 480
  440 IF(X(J).GT.0.0) GO TO 445
      X(J)=XMIN(J)
      GO TO 447
  445 X(J)=0.7*X(J)
  447 IF(LOG.EQ.1.AND.ILOG(J).EQ.1) X(J)=ALOG10(X(J))
      GO TO 480
  450 IF(IA(J).NE.KG) GO TO 460
      IF(X(J).GT.0.0) GO TO 455
      X(J)=XMAX(J)
      GO TO 457
  455 X(J)=X(J)/0.7
  457 IF(LOG.EQ.1.AND.ILOG(J).EQ.1) X(J)=ALOG10(X(J))
      GO TO 480
  460 X(J)=XB(J)
      IF(LOG.EQ.1.AND.ILOG(J).EQ.1) X(J)=ALOG10(X(J))
  480 CONTINUE
      DO 490 J=1,M
  490 IA(J)=IBLANK
      CALL JKPTLS(KO,I,NAME,LOC,X,IA,M)
  500 CONTINUE
      WRITE(*,8801)
 8801 FORMAT(' COMPLETED SECOND PASS THROUGH THE DATA FILE')
      WRITE(*,2000) ID,N,M
 2000 FORMAT(' THE REVISED DATA SET HAS BEEN WRITTEN',/,
     *' DAT SET ID = ',2A4,' N=',I5,' M=',I3)
      STOP
      END
