TITLE    SUBROUTINE RMOVE (SOURCE,DEST,KOUNT)
;MOVES AN ARRAY OF REAL*4 VARIABLES FROM SOURCE TO DESTINATION
;
;           FORTRAN USAGE:
;           CALL RMOVE(SOURCE,DEST,KOUNT)
;           SOURCE IS A REAL*4 VARIABLE OR DIMENSIONED ARRAY
;           DEST IS A REAL*4 VARIABLE OR DIMENSIONED ARRAY
;           KOUNT IS AN INTEGER*2 VARIABLE INDICATING THE
;           NUMBER OF VALUES OF ARRAY SOURCE TO BE MOVED INTO
;           ARRAY DEST.  THE VALUE STORED IN KOUNT CANNOT EXCEED THE
;           THE DECLARED DIMENSION OF EITHER ARRAY.
;
;CODED BY W. D. GRUNDY  MAY 1985
;THIS SUBROUTINE IS CALLED BY PROGRAM SS2DCONT
;
FRAME       STRUC
SAVESI      DW         ?
SAVEDI      DW         ?
SAVEDS      DW         ?
SAVEBP      DW         ?
SAVERET     DD         ?
C           DD         ?           ;POINTER TO KOUNT
B           DD         ?           ;POINTER TO DESTINATION
A           DD         ?           ;POINTER TO SOURCE
FRAME       ENDS
;
_DATA       SEGMENT    'DATA'
_DATA       ENDS
;
RMVE_TEXT   SEGMENT    'CODE'
DGROUP      GROUP      _DATA
            ASSUME     CS:RMVE_TEXT,DS:DGROUP,SS:DGROUP
            PUBLIC     RMOVE 
RMOVE       PROC       FAR
            PUSH       BP          ;SAVE CALLER'S BP.
            PUSH       DS          ;SAVE CALLER'S DS.
            PUSH       DI
            PUSH       SI
            MOV        BP,SP
            LES        BX,[BP]+C   ;PICK UP KOUNT VALUE AND
            MOV        CX,ES:[BX]  ;STORE IN CX. THEN MULTIPLY BY 2 TO
            SHL        CX,1        ;CONVERT TO NUMBER OF WORDS.
            CLD                    ;MOVE IS TO BE FORWARD.
            LDS        SI,[BP]+A   ;SOURCE OFFSET IN SI; SEGMENT IN DS.
            LES        DI,[BP]+B   ;DEST OFFSET IN DI; SEGMENT IN ES.
            REP MOVSW              ;PERFORM THE MOVE OPERATION.
            POP        SI
            POP        DI
            POP        DS          ;RESTORE CALLER'S DS.
            POP        BP          ;RESTORE CALLER'S BP.
            RET        12          ;FAR RETURN.  RELEASE 12 BYTES.
RMOVE       ENDP
RMVE_TEXT   ENDS
            END
