$NOFLOATCALLS
$STORAGE:2
      PROGRAM ROWIDRET
C***  CODED BY W. D. GRUNDY  MARCH 1984
C***
C***  THIS PROGRAM RETRIEVES FROM A STATPAC INPUT FILE THOSE
C***  ROWS WHOSE PRIMARY OR SECONDARY IDS ARE LISTED ON
C***  A CHARACTER DISK FILE WHICH WAS PREVIOUSLY CREATED BY
C***  THE USER.  THE USER IS GIVEN THE OPTION OF RETRIEVING
C***  ONLY THOSE ROWS WHICH ARE ON THE LIST, OR ONLY THOSE
C***  ROWS WHICH ARE NOT ON THE LIST.  THE SELECTED ROWS ARE 
C***  WRITTEN TO A STATPAC OUTPUT FILE.  THE LIST OF PRIMARY OR
C***  SECONDARY ROWIDS CAN ALSO BE TYPE IN AT RUN TIME.
C***
C***  THE DISK FILE CONTAINING THE PRIMARY OR SECONDARY ROW IDS
C***  CAN BE CREATED BY THE EDLIN EDITOR.  THE INDIVIDUAL ROW
C***  IDS (EITHER PRIMARY OR SECONDARY) ARE ENTERED IN FORTRAN
C***  FORMAT(A8) IN COLUMNS 1-8, WITH ONLY ONE ROW ID PER LINE.
C***  SPELLING OF THE ROW IDS MUST EXACTLY AGREE WITH THEIR SPELLING
C***  ON THE STATPAC INPUT FILE.  LEADING AND EMBEDDED BLANKS IN
C***  THE ROW IDS MUST BE TYPED IN EXACTLY THE SAME POSITION
C***  AS IN THE STATPAC FILE.  TRAILING BLANKS, HOWEVER, NEED NOT
C***  BE TYPED.  THE ASCII INPUT FILE CAN ALSO BE CREATED BY PROGRAM
C***  FILTER (q.v.)
C***
C***  LINKS REQUIRED: ASCIIZ, BYTMOV, CHGCAS, CHRKNT, CKSAFE, CONCAT,
C***                  DOSREN, FNDCUR, FSTDSP, ICSRCH, ODOMTR, SOUND
C***
      INTEGER*4 LOC 
      CHARACTER*32 FILE10,FILE11,FILE14
      LOGICAL FILERR,KBD,FILTER
      CHARACTER*1 IA ,IANS
      CHARACTER*8 ID,IRA,IVID,NAME(2)
      DIMENSION IRA(3000),LOC(2),X(100),IVID(100),IA(100),IPACK(20)
   10 WRITE(*,'(A\)')' ENTER NAME OF STATPAC INPUT FILE: '
      READ(*,'(A)') FILE10
      CALL CKSAFE(FILE10,2,FILERR)
      IF(FILERR) GO TO 10
   20 WRITE(*,'(A\)') ' GIVE A NAME FOR THE STATPAC OUTPUT FILE: '
      READ(*,'(A)') FILE11
      IF(FILE11.EQ.FILE10) THEN
      CALL WARN
      WRITE(*,'(A)') ' STATPAC INPUT FILE CANNOT BE USED FOR OUTPUT'
      GO TO 20
      ENDIF
      CALL CKSAFE(FILE11,1,FILERR)
      IF(FILERR) GO TO 20
   30 WRITE(*,'('' '',''DO YOU WANT TO ENTER THE LIST OF ROWIDS '',
     1''FROM:'',/,5X,''1) THE KEYBOARD; OR'',/,5X,''2) AN ASCII DISK'',
     2'' FILE?'',/,5X,''ANSWER 1 OR 2: '',\)')
      READ(*,'(A)') IANS
      IF(IANS.NE.'1'.AND.IANS.NE.'2') THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' YOU MUST ANSWER 1 OR 2'
      GO TO 30
      ENDIF
      KBD=IANS.EQ.'1'
      IF(KBD) THEN
      CALL KBDINP(IRA,NSZ)
      GO TO 50
      ENDIF
   40 WRITE(*,'('' ENTER NAME OF FILE WITH PRIMARY OR SECONDARY '',
     1''ROW ID LIST: '',\)')
      IF(FILE14.EQ.FILE10.OR.FILE14.EQ.FILE11) THEN
      CALL WARN
      WRITE(*,'(A)') ' ROW ID FILE MUST NOT BE A STATPAC FILE'
      GO TO 40
      ENDIF
      READ(*,'(A)') FILE14
      CALL CKSAFE(FILE14,2,FILERR)
      IF(FILERR) GO TO 40
   50 WRITE(*,60)
   60 FORMAT(5X,'DOES THE LIST CONTAIN',/,
     110X,'(1) THE PRIMARY ROW IDS, OR',/,10X,'(2) THE SECONDARY ',
     2'ROW IDS?',/,14X,'ANSWER 1 OR 2: ',\)
      READ(*,70,ERR=50) IRET
   70 FORMAT(BN,I1)
      IF(IRET.LT.1.OR.IRET.GT.2) GO TO 50
      IF(IRET.EQ.2.AND..NOT.KBD) THEN
      WRITE(*,'('' '',''WAS THE ASCII INPUT FILE CREATED BY PROGRAM '',
     1''FILTER? Y/N: '',\)')
      READ(*,'(A)') IANS
      FILTER=IANS.EQ.'Y'.OR.IANS.EQ.'y'
      ENDIF
   80 WRITE(*,90)
   90 FORMAT(5X,'DO YOU WANT THE OUTPUT FILE TO CONTAIN',/,
     110X,'(1) ONLY THOSE ROWS WHICH ARE ON THE LIST, OR',/,
     210X,'(2) ONLY THOSE ROWS WHICH ARE NOT ON THE LIST?',/,
     314X,'ANSWER 1 OR 2: ',\)
      READ(*,70,ERR=80) IFLAG
      IF(IFLAG.LT.1.OR.IFLAG.GT.2) GO TO 80
      KI=10
      KO=11 
      KI1=14 
      KSCR=13 
      OPEN(KI,FILE=FILE10,STATUS='OLD',FORM='UNFORMATTED') 
      OPEN(KO,FILE=FILE11,STATUS='NEW',FORM='UNFORMATTED') 
      OPEN(KSCR,FILE='SCRATCH',STATUS='NEW',FORM='UNFORMATTED') 
      IF(.NOT.KBD) THEN
      OPEN(KI1,FILE=FILE14,STATUS='OLD',FORM='FORMATTED') 
      NSZ=0 
C***  READ DISK FILE OF PRIMARY OR SECONDARY ROW IDS.
  100 NSZ=NSZ+1 
      IF(IRET.EQ.2.AND.FILTER) THEN
      READ(KI1,'(9X,A8)',END=120) IRA(NSZ)
      ELSE
      READ(KI1,'(A8)',END=120) IRA(NSZ)
      ENDIF
      GO TO 100 
  120 NSZ=NSZ-1 
      ENDIF
C***  SORT ARRAY IRA INTO THE COLLATING SEQUENCE
      CALL CHSORT(IRA,NSZ)
      READ(KI) ID,N,M,(IVID(I),I=1,M)
      NPACK=(M+4)/5
      KOUNT=0 
      WRITE(*,'('' '',''      ....READING STATPAC INPUT FILE'')')
      CALL FNDCUR(IRRR,ICCC,0)
      DO 130 I=1,N 
      READ(KI) IROW,NAME,LOC,(X(J),J=1,M),(IPACK(J),J=1,NPACK)
      IF(IERR.NE.0) STOP 'UNEXPECTED END OF FILE IN STATPAC FILE'
      IFIND=ICSRCH(NSZ,NAME(IRET),IRA)
      IF(IFIND.EQ.0.AND.IFLAG.EQ.1) GO TO 130 
      IF(IFIND.GT.0.AND.IFLAG.EQ.2) GO TO 130 
      KOUNT=KOUNT+1 
      WRITE(KSCR) KOUNT,NAME,LOC,(X(J),J=1,M),(IPACK(J),J=1,NPACK)
      IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
  130 CONTINUE 
      WRITE(*,'(''+'',I5)') N
      REWIND KSCR 
      WRITE(KO) ID,KOUNT,M,(IVID(I),I=1,M)
      WRITE(*,'('' '',''      ....WRITING STATPAC OUTPUT FILE'')')
      CALL FNDCUR(IRRR,ICCC,0)
      DO 140 I=1,KOUNT 
      READ(KSCR,END=160) IROW,NAME,LOC,(X(J),J=1,M),(IPACK(J),J=1,NPACK)
      WRITE(KO) IROW,NAME,LOC,(X(J),J=1,M),(IPACK(J),J=1,NPACK)
      IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
  140 CONTINUE 
      WRITE(*,'(''+'',I5)') KOUNT
      WRITE(*,150) FILE11,KOUNT,M 
  150 FORMAT(' THE STATPAC FILE HAS BEEN WRITTEN.',/,' THE FILE NAME',
     1' IS',1X,A32,/,' N= ',I4,3X,'M= ',I3) 
      CLOSE(KSCR,STATUS='DELETE')
      STOP 'NORMAL END OF PROGRAM'
  160 STOP 'AN END OF FILE WAS ENCOUNTERED IN SCRATCH FILE13'
      END
      SUBROUTINE CHSORT(CHAR8,N)
C***  THIS IS A SHELL SORTING ROUTINE WHICH SORTS AN ARRAY
C***  OF CHARACTER*8 VARIABLES INTO THE COLLATING SEQUENCE.
      CHARACTER*8 CHAR8,TEMP
      DIMENSION CHAR8(1)
      M=N
   10 IF(M-1) 50,50,20
   20 M=M/2
      ITER=N-M
   30 ITEST=0
      DO 40 I=1,ITER
      MI=M+I
      IF(CHAR8(I).LE.CHAR8(MI)) GO TO 40
      TEMP=CHAR8(I)
      CHAR8(I)=CHAR8(MI)
      CHAR8(MI)=TEMP
      ITEST=1
   40 CONTINUE
      IF(ITEST) 10,10,30
   50 RETURN
      END
      SUBROUTINE KBDINP(IRA,NSZ)
      CHARACTER*8 IRA(1),CHECK
      WRITE(*,'('' '',''ENTER THE ROWIDS ONE AT A TIME, ONE TO EIGHT'',
     1'' CHARACTERS EACH.'',/,'' FOLLOW EACH ROWID WITH A CARRIAGE '',
     2''RETURN.'',/,'' TERMINATE THE ENTRY OF ROWIDS BY TYPING '',
     3''LAST-ROW'',/,'' BEGINNING IN SCREEN COLUMN ONE.'',/)')
      NSZ=0
   10 NSZ=NSZ+1
      READ(*,'(A8)') IRA(NSZ)
      CHECK=IRA(NSZ)
      CALL CHGCAS(CHECK,8,1)
      IF(CHECK.NE.'LAST-ROW') GO TO 10
      RETURN
      END
