$NOFLOATCALLS
$STORAGE:2
      PROGRAM ROWPATCH
C -----------------------------------------------------------------------
C***
C***  DISPLAYS THE VARIABLES OF ANY REQUESTED STATPAC ROW ON
C***  THE PC'S SCREEN.  SEARCH CAN BE BY ROW-ID OR BY ROW NUMBER.
C***  ON OPTION, USER CAN EDIT THE VARIABLES OF ANY SELECTED ROW
C***  AS WELL AS THEIR QUALIFYING CODES.  CHANGED DATA ARE SAVED
C***  ON A STATPAC OUTPUT FILE.  INSTRUCTIONS FOR USE ARE PRINTED
C***  ON THE SCREEN DURING PROGRAM EXECUTION.
C***
C***  NOTE: PROGRAM IS CURRENTLY LIMITED TO 3000 ROWS AND 99 COLUMNS.
C***        PROGRAM REQUIRES AN IBM GRAPHICS BOARD (OR EQUIVALENT)
C***        AND MUST BE RUN IN MODE BW80 (ALPHA MODE WHITE ON BLACK).
C***        PROGRAM CAN BE RUN ON A MONOCHROME MONITOR.
C***        IF STATPAC FILES ARE LARGE, IT IS BEST TO HAVE A HARD DISK.
C***
C***  ADAPTED FROM PROGRAMS ROW, FINDNM, FIXIT, NEWIDS, AND NEWLOC
C***  OF A. T. MIESCH AND FROM UNPUBLISHED SEARCH PROGRAMS OF THE
C***  U.S. ATOMIC ENERGY COMMISSION, GRAND JUNCTION OFFICE.
C***  LINKS REQUIRED: ASCIIZ, BYTMOV, CHGATR, CHGCAS, CHGPAG,
C***                  CHRKNT, CKSAFE, CMDLIN, CONCAT, CRSOFF, CRSON,
C***                  DELAY, DSKSPC, FSTDSP, FNDCUR, IAND, ICSRCH,
C***                  INTR, INT16H, INT21H, IOFS, ISEG, KPRESS,
C***                  LNREAD, MATCH, MOVCUR, ODOMTR, PACK, PCHCEN,
C***                  PCHVAR, SAVRST, SCREAD, SORTER, SOUND, UNPK,
C***                  WDPEEK
C***  ADAPTED BY W.D. GRUNDY  JULY 1985
C***
C -----------------------------------------------------------------------
$INCLUDE:'PCREGS.INC'
      CHARACTER*32 UNIT10,UNIT11
      CHARACTER*1 IA,IANS
      INTEGER*4 LOC
      INTEGER F1,F2,F3,F4,F5,F6,F7,F8,UP,DOWN
      CHARACTER*8 ID,NAME,IVID,IRA,WANTED,SCREEN
      COMMON /PTRS/ IPOINT(5000),IRA(5000)
      COMMON X(100),KS,N,IVID(100),IWANT,
     1IROW,NAME(2),LOC(2),IA(100),M,IY(20),IBUF(2000)
      LOGICAL FILERR,FLAG,MODE,IOPEN
      DATA MAXN /5000/, MAXM /99/, IOPEN /.FALSE./
      DATA F1,F2,F3,F4,F5,F6,F7,F8 /59,60,61,62,63,64,65,66/
      DATA UP,DOWN /72,80/
C -----------------------------------------------------------------------
C***  CHECK FOR PRESENCE OF COLOR GRAPHICS ADAPTER IN 80 COL. MODE
C -----------------------------------------------------------------------
      CALL INTR(#11,REGS)
         IF(IAND(AX,#30).NE.#20) THEN
         WRITE(*,'('' '',''PROGRAM WILL NOT RUN BECAUSE THIS COMPUTER'',
     1   '' DOES NOT HAVE A GRAPHICS ADAPTER'',/,'' OR IF IT DOES, '',
     2   ''THE SCREEN WIDTH IS NOT 80 CHARACTERS.'')')
         STOP
         ENDIF
      KI=10
      KO=11
      KS=12
      CALL CMDLIN(UNIT10,'ROWPATCH',8,FLAG)
      IF(FLAG) GO TO 20
   10 WRITE(*,'(A\)') ' ENTER NAME OF STATPAC INPUT FILE: '
      READ(*,'(A32)') UNIT10
   20 CALL CKSAFE(UNIT10,2,FILERR)
      IF(FILERR) GO TO 10
      CALL CLEAR
      CALL MOVCUR(0,0,0)
      OPEN(KI,FILE=UNIT10,STATUS='OLD',FORM='UNFORMATTED',
     1IOSTAT=IERR)
         IF(IOSTAT.NE.0) THEN
         CALL SOUND(256,110)
         WRITE(*,'('' NOT A STATPAC FILE - FILE '',A32)') UNIT10
         GO TO 10
         ENDIF
C -----------------------------------------------------------------------
C***  CHECK FOR TOO MANY ROWS OR COLUMNS IN THE STATPAC INPUT FILE.
C -----------------------------------------------------------------------
      READ(KI) ID,N,M
      WRITE(*,'('' '',10X,''FILE ID= '',A8,/,11X,''NO. ROWS= '',I4,/,
     111X,''NO. COLS.=  '',I2)') ID,N,M
         IF(N.GT.MAXN.OR.M.GT.MAXM) THEN
         WRITE(*,'('' '',''PROGRAM CANNOT BE RUN.  LIMIT IS '',I4,
     1   '' ROWS AND '',I2,'' COLUMNS.'')') MAXN,MAXM
         STOP
         ENDIF
C -----------------------------------------------------------------------
C***  EVERYTHING OK SO PROCESS THE FILE.
C -----------------------------------------------------------------------
      REWIND(KI)
      READ(KI) ID,N,M,(IVID(I),I=1,M)
C -----------------------------------------------------------------------
C***  COMPUTE LENGTH OF RECORD FOR DIRECT ACCESS SCRATCH FILE
C -----------------------------------------------------------------------
      NPACK=(M+4)/5
      LENREC=24+4*M+2*NPACK
C -----------------------------------------------------------------------
C***  CHECK IF ENOUGH ROOM ON DEFAULT DISK DRIVE TO RUN ROWPATCH
C -----------------------------------------------------------------------
      CALL PROCED(LENREC,N,M)
C -----------------------------------------------------------------------
C***  OPEN DIRECT ACCESS SCRATCH FILE
C -----------------------------------------------------------------------
      OPEN(KS,FILE='SCRATCH',STATUS='NEW',ACCESS='DIRECT',FORM
     1='UNFORMATTED',RECL=LENREC)
      WRITE(*,'(''       ....READING STATPAC INPUT FILE'')')
      CALL FNDCUR(IRRR,ICCC,0)
         DO 30 I=1,N
         IPOINT(I)=I
         READ(KI) IROW,NAME,LOC,(X(J),J=1,M),(IY(J),J=1,NPACK)
         WRITE(KS) NAME,LOC,(X(J),J=1,M),(IY(J),J=1,NPACK)
         IRA(I)=NAME(1)
         IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
   30    CONTINUE
      WRITE(*,'(''+'',I5)') N
      CALL SORTER(IRA,IPOINT,N)
C -----------------------------------------------------------------------
C***  CHECK FOR DUPLICATE ROWIDS AND REPORT THEM TO USER IF FOUND.
C -----------------------------------------------------------------------
      CALL DUPCHK(IRA,IPOINT,N)
C -----------------------------------------------------------------------
C***  CLEAR SCREENS 0-3
C -----------------------------------------------------------------------
         DO 40 I=1,4
         CALL CHGPGE(I-1)
         CALL CLEAR
   40    CONTINUE
C -----------------------------------------------------------------------
C***  TURN CURSOR OFF
C -----------------------------------------------------------------------
      CALL CRSOFF(ICXSAV)
      CALL CHGPGE(0)
      WRITE(*,'('' '',''FILE = '',A32,'' FILE ID = '',A8,4X,
     1''N = '',I4,''  M = '',I2,/)') UNIT10,ID,N,M
      WRITE(*,'(A)') '    VARIABLE IDS ARE:'
      WRITE(*,'(5(3X,I2,'') '',A8))') (I,IVID(I),I=1,M)
      CALL PCHCEN('PRESS SPACE BAR TO CONTINUE&',3,24,0)
C -----------------------------------------------------------------------
C***  COPY IDS FROM SCREEN 0 TO SCREEN 2
C -----------------------------------------------------------------------
      CALL WDPEEK(#0B800,#0000,IBUF,2000)
      CALL SAVRST(IBUF,0,24,0,79,1,2)
   50 CALL KPRESS(IAH,IAL)
      IF(IAH.NE.57.OR.IAL.NE.32) GO TO 50
C -----------------------------------------------------------------------
C***  TURN CURSOR BACK ON
C -----------------------------------------------------------------------
      CALL CRSON(ICXSAV)
      CALL CLEAR
      REWIND(KS)
C -----------------------------------------------------------------------
C***  INITIALIZE THE DISPLAY VALUES
C -----------------------------------------------------------------------
      IROW=1
      READ(KS,REC=IROW) NAME,LOC,(X(J),J=1,M),(IY(J),J=1,NPACK)
      CALL UNPK(IA,M,IY)
      IWANT=ICSRCH(N,NAME(1),IRA)
         DO 60 KK=1,M
         IF(IA(KK).EQ.' ') IA(KK)='U'
   60    CONTINUE
C -----------------------------------------------------------------------
C***  PUT INSTRUCTIONS ON SCREEN 1
C***  TURN CURSOR OFF
C -----------------------------------------------------------------------
      CALL CRSOFF(ICXSAV)
      CALL INSTR
C -----------------------------------------------------------------------
C***  START THE SEARCH
C -----------------------------------------------------------------------
   70 CALL KPRESS(IAH,IAL)
      IF(IAH.NE.57.OR.IAL.NE.32) GO TO 70
C -----------------------------------------------------------------------
C***  TURN CURSOR BACK ON
C -----------------------------------------------------------------------
      CALL CRSON(ICXSAV)
      CALL CHGPGE(0)
      MODE=.TRUE.
C -----------------------------------------------------------------------
C***  REQUEST INPUT FROM USER
C -----------------------------------------------------------------------
   80    IF(MODE) THEN
         WRITE(*,'(/,'' WHAT STATPAC ROW NUMBER DO YOU WANT?  '',\)')
         ELSE
         WRITE(*,'(/,'' WHAT PRIMARY ROW-ID DO YOU WANT? '',\)')
         ENDIF
      CALL LNREAD(SCREEN,8,IAH)
C -----------------------------------------------------------------------
C***  TEST IF A FUNCTION KEY WAS PRESSED
C -----------------------------------------------------------------------
         IF(IAH.NE.0) THEN
C -----------------------------------------------------------------------
C***  IF YES, FIND OUT WHICH ONE AND TAKE APPROPRIATE ACTION.
C***  ELSE, SKIP DOWN TO END OF THIS OUTER IF-BLOCK
C***  WAS UP-ARROW PRESSED?
C -----------------------------------------------------------------------
            IF(IAH.EQ.UP) THEN
               IF(MODE) THEN
               IROW=IROW-1
               IF(IROW.EQ.0) IROW=N
               ELSE
               IWANT=IWANT-1
               IF(IWANT.EQ.0) IWANT=N
               IROW=IPOINT(IWANT)
               ENDIF
            GO TO 110
            ENDIF
C -----------------------------------------------------------------------
C***  WAS DOWN-ARROW PRESSED?
C -----------------------------------------------------------------------
            IF(IAH.EQ.DOWN) THEN
               IF(MODE) THEN
               IROW=IROW+1
               IF(IROW.GT.N) IROW=1
               ELSE
               IWANT=IWANT+1
               IF(IWANT.GT.N) IWANT=1
               IROW=IPOINT(IWANT)
               ENDIF
            GO TO 110
            ENDIF
            IF(IAH.EQ.F1) THEN
C -----------------------------------------------------------------------
C***  TURN CURSOR OFF
C -----------------------------------------------------------------------
            CALL CRSOFF(ICXSAV)
            CALL CHGPGE(1)
   90       CALL KPRESS(IAH,IAL)
            IF(IAH.NE.57.OR.IAL.NE.32) GO TO 90
C -----------------------------------------------------------------------
C***  TURN CURSOR BACK ON
C -----------------------------------------------------------------------
            CALL CRSON(ICXSAV)
            CALL CHGPGE(0)
            GO TO 80
            ENDIF
            IF(IAH.EQ.F2) THEN
            MODE=.NOT.MODE
            GO TO 80
            ENDIF
            IF(IAH.EQ.F3) THEN
C -----------------------------------------------------------------------
C***  TURN CURSOR OFF
C -----------------------------------------------------------------------
            CALL CRSOFF(ICXSAV)
            CALL CHGPGE(2)
  100       CALL KPRESS(IAH,IAL)
            IF(IAH.NE.57.OR.IAL.NE.32) GO TO 100
C -----------------------------------------------------------------------
C***  TURN CURSOR BACK ON
C -----------------------------------------------------------------------
            CALL CRSON(ICXSAV)
            CALL CHGPGE(0)
            GO TO 80
            ENDIF
            IF(IAH.EQ.F4) THEN
            IOPEN=.TRUE.
            CALL EDITOR
            WRITE(*,'('' YOU ARE NOW IN SEARCH MODE'')')
            GO TO 80
            ENDIF
         IF(IAH.EQ.F8) GO TO 140
            IF(IAH.EQ.F5.OR.IAH.EQ.F6.OR.IAH.EQ.F7) THEN
            WRITE(*,'(''  YOU ARE NOT IN EDIT MODE'')')
            GO TO 80
            ENDIF
         ENDIF
C -----------------------------------------------------------------------
C***  THIS IS THE END OF THE OUTER IF STARTED WITH TESTING FOR
C***  PRESSING OF FUNCTION KEY.
C -----------------------------------------------------------------------
         IF(MODE) THEN
         READ(SCREEN,'(BN,I8)',IOSTAT=IERR) IROW
            IF(IERR.NE.0.OR.IROW.LT.1.OR.IROW.GT.N) THEN
            WRITE(*,'(''  NEED INTEGER VALUE FROM 1 TO '',I4)') N
            GO TO 80
            ENDIF
         ELSE
         READ(SCREEN,'(A8)') WANTED
         IWANT=ICSRCH(N,WANTED,IRA)
            IF(IWANT.EQ.0) THEN
            WRITE(*,'(A)') ' REQUESTED ROW-ID NOT FOUND: TRY AGAIN'
            GO TO 80
            ENDIF
         IROW=IPOINT(IWANT)
         ENDIF
  110 READ(KS,REC=IROW) NAME,LOC,(X(J),J=1,M),(IY(J),J=1,NPACK)
      CALL UNPK(IA,M,IY)
      IWANT=ICSRCH(N,NAME(1),IRA)
         DO 120 KK=1,M
         IF(IA(KK).EQ.' ') IA(KK)='U'
  120    CONTINUE
      WRITE(*,130) IROW,NAME,LOC,(X(J),IA(J),J=1,M)
  130 FORMAT(/,' ROW NO. ',I4,' ROW-ID ',A8,1X,A8,' LOC ',I8,1X,I8,/,
     15(1X,E14.7,A1))
      GO TO 80
C -----------------------------------------------------------------------
C***  IF EDITING OPTION WAS CHOSEN, IT IS NECESSARY TO OPEN AN
C***  OUTPUT FILE TO SAVE THE EDITED FILE.
C -----------------------------------------------------------------------
  140    IF (IOPEN) THEN
  150    WRITE(*,'(/,'' GIVE A NAME FOR THE STATPAC OUTPUT FILE: '',\)')
         READ(*,'(A)') UNIT11
            IF(UNIT11.EQ.UNIT10) THEN
            CALL WARN
            WRITE(*,'(A)') ' STATPAC INPUT FILE MAY NOT BE USED FOR OUTP
     1      UT'
            GO TO 150
            ENDIF
         CALL CKSAFE(UNIT11,1,FILERR)
         IF(FILERR) GO TO 150
         OPEN(KO,FILE=UNIT11,STATUS='NEW',FORM='UNFORMATTED')
         REWIND(KS)
         WRITE(*,'(A)') '       ....WRITING STATPAC OUTPUT FILE'
         CALL FNDCUR(IRRR,ICCC,0)
         WRITE(KO) ID,N,M,(IVID(I),I=1,M)
            DO 160 I=1,N
            READ(KS) NAME,LOC,(X(J),J=1,M),(IY(K),K=1,NPACK)
            WRITE(KO) I,NAME,LOC,(X(J),J=1,M),(IY(K),K=1,NPACK)
            IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
  160       CONTINUE
         WRITE(*,'(''+'',I5)') N
         ENDIF
      CLOSE(KS,STATUS='DELETE')
      STOP 'NORMAL END OF PROGRAM'
      END
      SUBROUTINE DUPCHK(IRA,IPOINT,N)
C -----------------------------------------------------------------------
C***  THIS SUBROUTINE CHECKS FOR DUPLICATE PRIMARY ROW-IDS IN THE
C***  STATPAC INPUT FILE.  IF THER ARE ANY, THEY ARE REPORTED TO
C***  THE USER BY ROW NUMBER.
C***  NOTE: IF DUPLICATES OCCUR, ONLY THE FIRST WILL BE FOUND IN
C***  THE ROW-ID SEARCH MODE.  THE OTHER(S) MUST BE LOCATED USING
C***  THE ROW-NUMBER MODE.
C -----------------------------------------------------------------------
      CHARACTER*8 IRA
      LOGICAL DUPFLG
      DIMENSION IRA(N),IPOINT(N)
      DUPFLG=.FALSE.
         DO 10 I=2,N
            IF(IRA(I-1).EQ.IRA(I)) THEN
            WRITE(*,'(/,'' '',A8,'' ROW '',I4,'' DUPLICATES '',A8,
     1      '' ROW '',I4)') IRA(I-1),IPOINT(I-1),IRA(I),IPOINT(I)
            DUPFLG=.TRUE.
            CALL SOUND(256,100)
            ENDIF
   10    CONTINUE
         IF(DUPFLG) THEN
         WRITE(*,'(/)')
         CALL PCHCEN('PRESS SPACE BAR TO CONTINUE&',3,24,0)
   20    CALL KPRESS(IAH,IAL)
         IF(IAH.NE.57.OR.IAL.NE.32) GO TO 20
         ENDIF
      CALL CLEAR
      RETURN
      END
      SUBROUTINE INSTR
      CHARACTER*1 KEYDEF(58)
      CHARACTER*58 LINE(19)
      EQUIVALENCE(LINE(13),KEYDEF(1))
      DATA LINE(1)
     1/'INSTRUCTIONS FOR USE OF THIS PROGRAM&                     '/
      DATA LINE(2)
     1/'TO DISPLAY THESE INSTRUCTIONS.....................PRESS F1'/
      DATA LINE(3)
     1/'TO TOGGLE BETWEEN ROW-ID AND ROW-NUMBER SEARCH....PRESS F2'/
      DATA LINE(4)
     1/'TO DISPLAY VARIABLE IDS...........................PRESS F3'/
      DATA LINE(5)
     1/'TO EDIT THE CURRENTLY DISPLAYED STATPAC ROW.......PRESS F4'/
      DATA LINE(6)
     1/'TO SAVE NEW DATA ON DISK AND EXIT EDIT MODE.......PRESS F5'/
      DATA LINE(7)
     1/'TO EXIT EDIT MODE WITHOUT SAVING NEW DATA.........PRESS F6'/
      DATA LINE(8)
     1/'TO DISPLAY CURRENT CONTENTS OF EDIT BUFFER........PRESS F7'/
      DATA LINE(9)
     1/'TO EXIT THIS PROGRAM AND RETURN TO DOS............PRESS F8'/
      DATA LINE(10)
     1/'TO EDIT "LOC" ARRAY IN EDIT MODE: AT COLUMN NUMBER PROMPT '/
      DATA LINE(11)
     1/'TYPE L1 TO EDIT LOC(1) AND TYPE L2 TO EDIT LOC(2).        '/
      DATA LINE(12)
     1/'SIMILARLY, TYPE N1 TO EDIT ROWID(1); N2 TO EDIT ROWID(2). '/
      DATA LINE(13)
     1/'IN SEARCH MODE YOU CAN USE   AND   TO MOVE FROM ROW TO ROW'/
      DATA LINE(14)
     1/'IN SEARCH MODE, F5, F6, AND F7 KEYS ARE DISABLED.         '/
      DATA LINE(15)
     1/'IN EDIT MODE, F2, F4, AND F8 KEYS ARE DISABLED.           '/
      DATA LINE(16)
     1/'BLANK STATPAC QUALIFIER CODES ARE DISPLAYED AS AN ALPHA-  '/
      DATA LINE(17)
     1/'BETIC CHARACTER "U".  YOU CAN TYPE "U", "u", OR THE SPACE '/
      DATA LINE(18)
     1/'BAR WHEN ENTERING A BLANK QUALIFYING CODE.  BE SURE TO    '/
      DATA LINE(19)
     1/'ALIGN THE QUALIFIER WITH ITS TEMPLATE WHEN EDITING.       '/
      KEYDEF(28)=CHAR(24)
      KEYDEF(34)=CHAR(25)
      CALL CHGPGE(1)
      CALL PCHCEN(LINE(1),2,0,1)
      IROW=2
      ICOL=11
         DO 10 I=2,9
         CALL PCHVAR(LINE(I),1,58,IROW,ICOL,1)
         IROW=IROW+1
   10    CONTINUE
      CALL PCHVAR(LINE(10),1,58,11,ICOL,1)
      CALL PCHVAR(LINE(11),1,58,12,ICOL,1)
      CALL PCHVAR(LINE(12),1,58,13,ICOL,1)
      CALL PCHVAR(LINE(13),1,58,15,ICOL,1)
      CALL PCHVAR(LINE(14),1,58,16,ICOL,1)
      CALL PCHVAR(LINE(15),1,58,17,ICOL,1)
      CALL PCHVAR(LINE(16),1,58,19,ICOL,1)
      CALL PCHVAR(LINE(17),1,58,20,ICOL,1)
      CALL PCHVAR(LINE(18),1,58,21,ICOL,1)
      CALL PCHVAR(LINE(19),1,58,22,ICOL,1)
      CALL PCHCEN('PRESS SPACE BAR TO CONTINUE&',3,24,1)
      RETURN
      END
      SUBROUTINE EDITOR
C -----------------------------------------------------------------------
C***
C***  THIS SUBROUTINE IS CALLED BY PROGRAM ROWPATCH.  IT EDITS
C***  A STATPAC ROW ONE VARIABLE AND QUALIFYING CODE AT A TIME.
C***  IT REQUESTS THE NUMBER OF THE VARIABLE TO BE EDITED AND
C***  DISPLAYS THE CURRENT VALUE OF THE VARIABLE AND ITS QUAL-
C***  IFYING CODE AS A REVERSE VIDEO TEMPLATE IN FORMAT
C***  (E14.7,A1).  THE USER TYPES IMMEDIATELY BELOW THE TEMPLATE
C***  THE NEW VALUE OF THE VARIABLE AND ITS QUALIFYIER.  BLANK
C***  QUALIFYING CODES ARE DISPLAYED AS U'S, IN ORDER TO SHOW
C***  THEIR PRESENCE.  IN THE FINAL EDITED RECORD, ALL U'S
C***  ARE RECONVERTED TO BLANK CHARACTERS (ASCII CODE 32).
C***  AFTER ENTERING A NEW VALUE, THE USER CAN DETERMINE IF
C***  IT HAS "TAKEN" BY PRESSING THE F7 FUNCTION KEY.  THIS
C***  WILL DISPLAY THE ENTIRE STATPAC ROW INCLUDING THE CHANGES.
C***  IF THE CHANGED VALUE IS NOT CORRECT, THE USER CAN REENTER
C***  IT AND AGAIN TEST IT.
C***
C***  CODED BY W. D. GRUNDY  JULY 1985
C***
C -----------------------------------------------------------------------
      CHARACTER*15 SCREEN
      CHARACTER*2 LATLON
      CHARACTER*1 IA,IANS
      INTEGER F1,F2,F3,F4,F5,F6,F7,F8,UP,DOWN
      INTEGER*4 LOC
      CHARACTER*8 ID,NAME,IVID,IRA
      COMMON /PTRS/ IPOINT(5000),IRA(5000)
      COMMON X(100),KS,N,IVID(100),IWANT,
     1IROW,NAME(2),LOC(2),IA(100),M,IY(20)
      LOGICAL LFLAG,NFLAG,SFLAG
      EQUIVALENCE(LATLON,SCREEN)
      DATA F1,F2,F3,F4,F5,F6,F7,F8 /59,60,61,62,63,64,65,66/
      DATA UP,DOWN /72,80/
      SFLAG=.FALSE.
      WRITE(*,'(A)') ' YOU ARE NOW IN EDIT MODE'
   10 WRITE(*,'(/,'' ENTER COLUMN NUMBER OF STATPAC VARIABLE: '',\)')
      CALL LNREAD(SCREEN,15,IAH)
         IF(IAH.NE.0) THEN
            IF(IAH.EQ.F1) THEN
            CALL CRSOFF(ICXSAV)
            CALL CHGPGE(1)
C -----------------------------------------------------------------------
C***  TEST FOR PRESSING OF SPACE BAR
C -----------------------------------------------------------------------
   20       CALL KPRESS(IAH,IAL)
            IF(IAH.NE.57.OR.IAL.NE.32) GO TO 20
            CALL CRSON(ICXSAV)
            CALL CHGPGE(0)
            GO TO 10
            ENDIF
         IF(IAH.EQ.F2.OR.IAH.EQ.F4.OR.IAH.EQ.F8.OR.IAH.EQ.UP.
     1      OR.IAH.EQ.DOWN) THEN
            WRITE(*,'(A)') ' YOU ARE NOT IN SEARCH MODE'
            GO TO 10
            ENDIF
            IF(IAH.EQ.F3) THEN
            CALL CRSOFF(ICXSAV)
            CALL CHGPGE(2)
   30       CALL KPRESS(IAH,IAL)
            IF(IAH.NE.57.OR.IAL.NE.32) GO TO 30
            CALL CRSON(ICXSAV)
            CALL CHGPGE(0)
            GO TO 10
            ENDIF
            IF(IAH.EQ.F7) THEN
            WRITE(*,40) IROW,NAME,LOC,(X(J),IA(J),J=1,M)
   40       FORMAT(/,' ROW NO. ',I4, ' ROW-ID ',A8,1X,A8,' LOC ',I8,1X,
     1      I8,/,5(1X,E14.7,A1))
            GO TO 10
            ENDIF
         IF(IAH.EQ.F5) GO TO 100
         IF(IAH.EQ.F6) GO TO 120
         ENDIF
      LFLAG=(LATLON.EQ.'L1'.OR.LATLON.EQ.'l1'.OR.LATLON.EQ.'L2'.OR.
     1LATLON.EQ.'l2')
         IF(LFLAG)THEN
         IF(LATLON.EQ.'L1'.OR.LATLON.EQ.'l1') ISUB=1
         IF(LATLON.EQ.'L2'.OR.LATLON.EQ.'l2') ISUB=2
         WRITE(*,'(/)')
         WRITE(*,'('' PRESENT VALUE:   '',I8,/,'' ENTER NEW VALUE: '')'
     1   )LOC(ISUB)
         CALL FNDCUR(JROW,JCOL,0)
         CALL CHGATR(8,3,JROW-1,JCOL,0)
         CALL MOVCUR(JROW,JCOL,0)
         CALL LNREAD(SCREEN,8,IAH)
         GO TO 60
         ENDIF
      NFLAG=(LATLON.EQ.'N1'.OR.LATLON.EQ.'n1'.OR.LATLON.EQ.'N2'.OR.
     1LATLON.EQ.'n2')
         IF(NFLAG)THEN
            IF(LATLON.EQ.'N1'.OR.LATLON.EQ.'n1') THEN
            ISUB=1
            SFLAG=.TRUE.
            ENDIF
         IF(LATLON.EQ.'N2'.OR.LATLON.EQ.'n2') ISUB=2
         WRITE(*,'(/)')
         WRITE(*,'('' PRESENT ROWID:   '',A8,/,'' ENTER NEW ROWID: '')'
     1   )NAME(ISUB)
         CALL FNDCUR(JROW,JCOL,0)
         CALL CHGATR(8,3,JROW-1,JCOL,0)
         CALL MOVCUR(JROW,JCOL,0)
         CALL LNREAD(SCREEN,8,IAH)
         GO TO 60
         ENDIF
      READ(SCREEN,'(BN,I8)',IOSTAT=IERR) ICOL
         IF(IERR.NE.0.OR.ICOL.LT.1.OR.ICOL.GT.M) THEN
         WRITE(*,'('' '',''NEED INTEGER VALUE FROM 1 TO '',I4)') M
         GO TO 10
         ENDIF
      WRITE(*,'('' '',''VARIABLE ID: ''A8,/,
     1'' PRESENT VALUE:   '',G14.7,A1,/,'' ENTER NEW VALUE: '')')
     2IVID(ICOL),X(ICOL),IA(ICOL)
      CALL FNDCUR(JROW,JCOL,0)
      CALL CHGATR(15,3,JROW-1,JCOL,0)
      CALL MOVCUR(JROW,JCOL,0)
      NBUF=15
   50 CALL LNREAD(SCREEN,NBUF,IAH)
   60    IF(IAH.NE.0) THEN
            IF(IAH.EQ.F1) THEN
            CALL CRSOFF(ICXSAV)
            CALL CHGPGE(1)
   70       CALL KPRESS(IAH,IAL)
            IF(IAH.NE.57.OR.IAL.NE.32) GO TO 70
            CALL CRSON(ICXSAV)
            CALL CHGPGE(0)
            GO TO 10
            ENDIF
         IF(IAH.EQ.F2.OR.IAH.EQ.F4.OR.IAH.EQ.F8.OR.IAH.EQ.UP.
     1      OR.IAH.EQ.DOWN) THEN
            WRITE(*,'(A)') ' YOU ARE NOT IN SEARCH MODE'
            GO TO 10
            ENDIF
            IF(IAH.EQ.F3) THEN
            CALL CRSOFF(ICXSAV)
            CALL CHGPGE(2)
   80       CALL KPRESS(IAH,IAL)
            IF(IAH.NE.57.OR.IAL.NE.32) GO TO 80
            CALL CRSON(ICXSAV)
            CALL CHGPGE(0)
            GO TO 10
            ENDIF
            IF(IAH.EQ.F7) THEN
            WRITE(*,40) IROW,NAME,LOC,(X(J),IA(J),J=1,M)
            GO TO 10
            ENDIF
         IF(IAH.EQ.F5) GO TO 100
         IF(IAH.EQ.F6) GO TO 120
         ENDIF
   90    IF(LFLAG) THEN
         READ(SCREEN,'(BN,I8)',IOSTAT=IERR) LOC(ISUB)
            IF(IERR.NE.0) THEN
            WRITE(*,'('' NEED INTEGER VALUE FOR LOC'',/,
     1      '' ENTER NEW VALUE: '')')
            NBUF=8
            GO TO 50
            ENDIF
         GO TO 10
         ENDIF
         IF(NFLAG) THEN
         READ(SCREEN,'(A8)') NAME(ISUB)
         IF(ISUB.EQ.1) SFLAG=.TRUE.
         GO TO 10
         ENDIF
      READ(SCREEN,'(BN,F14.0,A1)',IOSTAT=IERR) X(ICOL),IA(ICOL)
         IF(IERR.NE.0) THEN
         WRITE(*,'('' NEED REAL VALUE FOR STATPAC VARIABLE'',/,
     1   '' ENTER NEW VALUE: '',\)')
         NBUF=15
         GO TO 50
         ENDIF
      IF(IA(ICOL).EQ.' '.OR.IA(ICOL).EQ.'u') IA(ICOL)='U'
      GO TO 10
  100    DO 110 I=1,M
         IF(IA(I).EQ.'U'.OR.IA(I).EQ.'u') IA(I)=' '
  110    CONTINUE
C -----------------------------------------------------------------------
C***  PACK THE QUALIFYING CODES AND WRITE THE EDITED ROW ON
C***  THE SCRATCH FILE.
C -----------------------------------------------------------------------
      CALL PACK(IA,M,IY,NPACK)
      WRITE(KS,REC=IROW) NAME,LOC,(X(J),J=1,M),(IY(KK),KK=1,NPACK)
C -----------------------------------------------------------------------
C***  REARRANGE POINTERS IF PRIMARY ROWID WAS EDITED.
C -----------------------------------------------------------------------
         IF(SFLAG) THEN
         IRA(IWANT)=NAME(1)
         CALL SORTER(IRA,IPOINT,N)
C -----------------------------------------------------------------------
C***  UPDATE VALUE OF IWANT
C -----------------------------------------------------------------------
         IWANT=ICSRCH(N,NAME(1),IRA)
         CALL DUPCHK(IRA,IPOINT,N)
         ENDIF
  120 RETURN
      END
      SUBROUTINE PROCED(LENREC,N,M)
      INTEGER*4 IFREE,ISIZE,LENTOT
      LOGICAL OK
      CALL DSKSPC(0,IFREE,OK)
      LENTOT=N*LENREC
         IF(IFREE.LT.LENTOT) THEN
         CALL WARN
         WRITE(*,'('' '',''NOT ENOUGH FREE SPACE ON DEFAULT DRIVE TO'',
     1   '' CONTAIN THE SCRATCH FILE.'')')
         STOP
         ENDIF
      ISIZE=12+8*M+N*(26+4*M+2*(M+4)/5)
         IF(IFREE.LT.LENTOT+ISIZE) THEN
         CALL WARN
         WRITE(*,'('' '',''NOT ENOUGH FREE SPACE ON DEFAULT DRIVE TO '',
     1   ''CONTAIN A STATPAC OUTPUT FILE'',/,'' YOU MAY WANT TO FREE'',
     2   '' UP SOME DISK SPACE BEFORE EDITING '')')
         ENDIF
      RETURN
      END

