$STORAGE:2
      SUBROUTINE RRFILE(UNIT13,UNIT14,UNIT15)
C SUBROUTINE RRFILE WRITES FILES OF DATA (WITH MEAN AND VARIANCE 
C  RESTORED) RECOMPUTED FROM THE PRINCIPAL COMPONENTS MODEL, THE 
C  RESIDUALS, AND/OR BADNESS-OF-FIT MEASURES FOR EACH SAMPLE.  ALL
C  OF THESE QUANTITIES ARE IDENTICAL (EXCEPT FOR ROUNDING ERRORS) 
C  WHETHER DERIVED FROM THE PRINCIPAL COMPONENTS MODEL, THE VARIMAX
C  MODEL, OR ANY VALID OBLIQUE MODEL.
C SUBROUTINE RRFILE IS CALLED BY SUBROUTINE "RRPCOM", AND CALLS
C  SUBROUTINES "JKGTLS" AND "JKPTLS".
C FILE "RRMODE.INC" CONTAINS FIVE COMMON STATEMENTS AND MUST BE
C  PRESENT WHEN COMPILING.
C A.T. MIESCH, USGS, GRAND JUNCTION, COLO.  JANUARY, 1984
C
C THE ARRAY "DXC(45,45)" IN COMMON BLOCK "X333" CONTAINS THE PRINCIPAL
C  COMPONENT LOADINGS.
C THE ARRAY "DF1(800,10)" IN COMMON BLOCK "X444" AND THE ARRAY
C  "DF2(800,10)" IN COMMON BLOCK "X555" CONTAIN THE PRINCIPAL
C  COMPONENT SCORES.
C
      IMPLICIT REAL*8 (D)
      CHARACTER*12 UNIT13,UNIT14,UNIT15
      CHARACTER*4 ID(2),NAME(4),IVID(45,2),KVID(2)
      CHARACTER*1 IQ(45)
      INTEGER*4 LOC(2)
C NOTE: SS SHOULD ALWAYS BE DIMENSIONED MS+1
      DIMENSION SS(46)
$INCLUDE: 'RRMODE.INC'
C
      NSHALF=NS/2
      KI=10
      KO1=13
      KO2=14
      KO3=15
      READ(KI) ID,N,M,(IVID(I,1),IVID(I,2),I=1,M)
      FM=FLOAT(M)
      IF(IRCMP.EQ.0) GO TO 120
      OPEN(KO1, FILE=UNIT13,STATUS='NEW',FORM='UNFORMATTED')
      ID(1)='RCMP'
      ID(2)='DATA'
      WRITE(KO1) ID,N,M,(IVID(I,1),IVID(I,2),I=1,M)
  120 IF(IRESD.EQ.0) GO TO 135
      OPEN(KO2,FILE=UNIT14,STATUS='NEW',FORM='UNFORMATTED')
      ID(1)='RESI'
      ID(2)='DUAL'
      WRITE(KO2) ID,N,M,(IVID(I,1),IVID(I,2),I=1,M)
  135 IF(IBDNS.EQ.0) GO TO 300
      OPEN(KO3,FILE=UNIT15,STATUS='NEW',FORM='UNFORMATTED')
      M1=M+1
      KVID(1)='AVER'
      KVID(2)='AGE '
      IQ(M1)=' '
      ID(1)='BDNS'
      ID(2)='OFIT'
      WRITE(KO3) ID,N,M1,(IVID(I,1),IVID(I,2),I=1,M),KVID(1),KVID(2)
C
  300 WRITE(*,310)
  310 FORMAT(' WRITING THE OUTPUT FILES.....',/)
      DO 500 I=1,N
      WRITE(*,320) I
  320 FORMAT('+',I5)
      CALL JKGTLS(KI,IROW,NAME,LOC,S,IQ,M,IERR)
      IF(IERR.NE.0) STOP 'UNEXPECTED END-OF-FILE IN RRFILE'
      IF(I.GT.NSHALF) GO TO 410
      DO 400 J=1,M
      DAX(J)=0.0
      DO 400 K=1,NF
  400 DAX(J)=DAX(J)+DF1(I,K)*DXC(J,K)
      GO TO 430
  410 L=I-NSHALF
      DO 420 J=1,M
      DAX(J)=0.0
      DO 420 K=1,NF
  420 DAX(J)=DAX(J)+DF2(L,K)*DXC(J,K)
  430 DO 440 J=1,M
  440 DAX(J)=DAX(J)*DXS(J)+DXB(J)
      DO 450 J=1,M
  450 SS(J)=SNGL(DAX(J))
      IF(IRCMP.EQ.1) CALL JKPTLS(KO1,I,NAME,LOC,SS,IQ,M)
C RESIDUALS EQUAL THE OBSERVED MINUS RECOMPUTED
      DO 470 J=1,M
  470 SS(J)=S(J)-SS(J)
      IF(IRESD.EQ.1) CALL JKPTLS(KO2,I,NAME,LOC,SS,IQ,M)
  475 IF(IBDNS.EQ.0) GO TO 500
      SS(M1)=0.0
      DO 480 J=1,M
      IF(S(J).LT.-0.0000001.OR.S(J).GT.0.0000001) GO TO 478
      GO TO 479
  478 SS(J)=SS(J)/S(J)
  479 SS(M1)=SS(M1)+SS(J)*SS(J)
  480 CONTINUE
C  COMPUTE QUADRATIC MEAN OF BADNESS-OF-FIT MEASURES FOR EACH SAMPLE
      SS(M1)=SQRT(SS(M1)/FM)
      CALL JKPTLS(KO3,I,NAME,LOC,SS,IQ,M1)
  500 CONTINUE
      REWIND KI
      RETURN
      END
