C RRMODE PROGRAM FOR R-MODE FACTOR ANALYSIS WITH THE "RR"-TYPE
C  PRINCIPAL COMPONENT SCORES PROPOSED BY ZHOU AND OTHERS (JOUR.
C  INTERN. ASSC. MATH. GEOLOGY, 1983, P.581-606).  RRMODE CALLS
C  SUBROUTINES "RRPCOM" AND "JKGTLS".  "JKGTLS" IS IN FILE IOS.FOR.
C  FILE "RRMODE.INC" CONTAINS FIVE COMMON STATEMENTS AND MUST BE
C  PRESENT WHEN COMPILING.
C  RRMODE MUST BE LINKED WITH THE FOLLOWING OBJECT FILES: RRPCOM,
C  RRFILE,RRVRMX,RROBLS,RROBLV,RREIGN,RRVROT,RRMATK,IOS.  SEE
C  FILE "RRMODE.LNK".  TO LINK, TYPE "LINK @RRMODE.LNK"
C ASIDE FROM THE PRINCIPAL COMPONENTS FACTOR SOLUTION, RRMODE ALSO
C  PROVIDES A VARIMAX SOLUTION OR TWO DIFFERENT TYPES OF OBLIQUE
C  SOLUTIONS - ONE BASED ON THE SAMPLES OF EXTREME COMPOSITON AND
C  THE OTHER BASED ON THE EXTREME VARIABLES.  BOTH LOADINGS AND
C  SCORES ARE DERIVED FOR EACH TYPE OF SOLUTION.  OTHER OPTIONS
C  ALLOW DERIVATION OF FILES OF DATA RECOMPUTED FROM THE FACTOR
C  MODEL AND/OR THE FACTOR RESIDUALS.  OTHER OPTIONAL FILES CONTAIN
C  (1)DATA THAT CAN BE USED TO PLOT A "FACTOR-VARIANCE" DIAGRAM OR
C  (2)BADNESS-OF-FIT MEASURES FOR EACH SAMPLE.
C A.T. MIESCH, USGS, GRAND JUNCTION, COLO.  JANUARY, 1984
C
$STORAGE:2
      IMPLICIT REAL*8 (D)
      CHARACTER*80 TITLE
      CHARACTER*12 UNIT10,UNIT12,UNIT13,UNIT14,UNIT15,UNIT16
      CHARACTER*4 ID(2),IVID(45,2),NAME(4)
      CHARACTER*1 IQ(45),IY,JY,IANS,IBL1
      INTEGER*4 LOC(2)
$INCLUDE: 'RRMODE.INC'
      DATA IBL1/' '/,IY/'y'/,JY/'Y'/
C NS IS THE MAXIMUM NUMBER OF SAMPLES WITHOUT REDIMENSIONING
C   ......NS IS ALWAYS AN EVEN NUMBER.....
C NV IS THE MAXIMUM NUMBER OF VARIABLES WITHOUT REDIMENSIONING
      NS=1500
      NV=45
      KI=10
      KP=0
      WRITE(*,100)
  100 FORMAT(' ENTER NAME OF THE STATPAC INPUT FILE: ',\)
      READ(*,110) UNIT10
  110 FORMAT(A12)
      OPEN(KI,FILE=UNIT10,STATUS='OLD',FORM='UNFORMATTED')
  115 WRITE(*,120)
  120 FORMAT(' DO YOU WANT THE ANSWERS ON 1) THE SCREEN, OR 2) THE PRINT
     *ER ? ',\)
      READ(*,130) ISP
  130 FORMAT(I1)
      IF(ISP.NE.1.AND.ISP.NE.2) GO TO 115
      IF(ISP.EQ.1) GO TO 160
      KP=11
      WRITE(*,140)
  140 FORMAT(' TURN ON PRINTER AND PRESS RETURN KEY')
      READ(*,150) IANS
  150 FORMAT(A1)
      OPEN(KP,FILE='LPT1',STATUS='NEW')
      WRITE(*,155)
  155 FORMAT(' ENTER A JOB TITLE  -  UP TO 80 CHARACTERS')
      READ(*,156) TITLE
  156 FORMAT(A80)
  160 READ(KI) ID,N,M,(IVID(I,1),IVID(I,2),I=1,M)
      IF(N.LE.NS.AND.M.LE.NV) GO TO 180
      WRITE(*,170) NS,NV
  170 FORMAT(' THE PROGRAM IS PRESENTLY LIMITED TO ',I4,' SAMPLES AND ',
     *I2,' VARIABLES')
      GO TO 9999
  180 DFN=DBLE(N)
      DO 190 I=1,M
      DXB(I)=0.0
      DXS(I)=0.0
      DO 190 J=1,M
  190 DXC(I,J)=0.0
C
      WRITE(*,200)
  200 FORMAT(' READING DATA.....',/)
      DO 230 I=1,N
      WRITE(*,210) I
  210 FORMAT('+',I5)
      CALL JKGTLS(KI,IROW,NAME,LOC,S,IQ,M,IERR)
      IF(IERR.NE.0) STOP 'UNEXPECTED END-OF-FILE'
      DO 225 J=1,M
      IF(IQ(J).EQ.IBL1) GO TO 215
      STOP 'QUALIFIED VALUES ARE PRESENT'
  215 DX=DBLE(S(J))
      DXB(J)=DXB(J)+DX
      DXS(J)=DXS(J)+DX*DX
      DO 220 K=1,M
      DY=DBLE(S(K))
  220 DXC(J,K)=DXC(J,K)+DX*DY
  225 CONTINUE
  230 CONTINUE
      REWIND KI
      DO 235 I=1,M
      DXB(I)=DXB(I)/DFN
  235 DXS(I)=DSQRT(DXS(I)/DFN-DXB(I)*DXB(I))
      DO 240 I=1,M
      DO 240 J=1,M
  240 DXC(I,J)=(DXC(I,J)/DFN-DXB(I)*DXB(J))/(DXS(I)*DXS(J))
      IF(KP.EQ.11) WRITE(KP,245) TITLE
  245 FORMAT(1X,A80)
      WRITE(*,250)
  250 FORMAT(' DO YOU WANT TO PRINT THE CORRELATION COEFFICIENTS ? ',\)
      READ(*,260) IANS
  260 FORMAT(A1)
      IF(IANS.NE.IY.AND.IANS.NE.JY) GO TO 305
      WRITE(KP,265)
  265 FORMAT(1X)
      WRITE(KP,270)
  270 FORMAT(/,' CORRELATIONS')
      DO 300 I=1,M
      WRITE(KP,280) (DXC(I,J),J=1,M)
  280 FORMAT(1X,10F6.2)
  300 CONTINUE
      WRITE(KP,265)
      WRITE(KP,265)
  305 WRITE(*,310)
  310 FORMAT(/,' DO YOU WANT 1.A PRINCIPAL COMPONENTS SOLUTION, 2.A VARI
     1MAX SOLUTION,',/,' 3.AN OBLIQUE SOLUTION, OR 4.NO FURTHER COMPUTAT
     2IONS ?',/,' TYPE 1, 2, 3 OR 4')
      READ(*,350) IAXES
      IF(IAXES.LT.1.OR.IAXES.GT.4) GO TO 305
      IF(IAXES.EQ.4) GO TO 9999
      JAXES=0
      IF(IAXES.NE.3) GO TO 360
  330 WRITE(*,340)
  340 FORMAT(' DO YOU WANT TO USE AS END MEMBERS 1.THE EXTREME SAMPLES,
     1 OR',/,' 2.THE EXTREME VARIABLES       TYPE 1 OR 2')
      READ(*,350) JAXES
  350 FORMAT(I1)
      IF(JAXES.NE.1.AND.JAXES.NE.2) GO TO 330
  360 ISCOR=0
      IRCMP=0
      IRESD=0
      IBDNS=0
      IDGRM=0
      WRITE(*,370)
  370 FORMAT(' DO YOU WANT A FILE OF SAMPLE SCORES ? ',\)
      READ(*,260) IANS
      IF(IANS.NE.IY.AND.IANS.NE.JY) GO TO 379
      ISCOR=1
      IF(IAXES.EQ.1) WRITE(*,371)
  371 FORMAT(20X,' ENTER A NAME FOR THE FILE OF PRINCIPAL COMPONENT SCOR
     *ES ',\)
      IF(IAXES.EQ.2) WRITE(*,372)
  372 FORMAT(20X,' ENTER A NAME FOR THE FILE OF VARIMAX SCORES: ',\)
      IF(IAXES.EQ.3) WRITE(*,373)
  373 FORMAT(20X,' ENTER A NAME FOR THE FILE OF OBLIQUE SCORES: ',\)
      READ(*,110) UNIT12
      IF(IAXES.NE.1) GO TO 379
      WRITE(*,374)
  374 FORMAT(' DO YOU WANT THE PRINCIPAL COMPONENT SCORES SCALED BY THE 
     *SQUARE ROOTS',/,' OF THE EIGENVALUES, AS SUGGESTED BY ZHOU AND OTH
     *ERS, (J. MATH. GEOLOGY,',/,' V.15, N.5, P.589,1983)')
      READ(*,260) IANS
      ISC=0
      IF(IANS.EQ.IY.OR.IANS.EQ.JY) ISC=1
  379 WRITE(*,380)
  380 FORMAT(' DO YOU WANT A FILE OF RECOMPUTED DATA ? ',\)
      READ(*,260) IANS
      IF(IANS.NE.IY.AND.IANS.NE.JY) GO TO 389
      IRCMP=1
      WRITE(*,500)
  500 FORMAT(20X,' ENTER A NAME FOR THE FILE OF RECOMPUTED DATA: ',\)
      READ(*,110) UNIT13
  389 WRITE(*,390)
  390 FORMAT(' DO YOU WANT A FILE OF FACTOR RESIDUALS ? ',\)
      READ(*,260) IANS
      IF(IANS.NE.IY.AND.IANS.NE.JY) GO TO 399
      IRESD=1
      WRITE(*,510)
  510 FORMAT(20X,' ENTER A NAME FOR THE FILE OF RESIDUALS: ',\)
      READ(*,110) UNIT14
  399 WRITE(*,400)
  400 FORMAT(' DO YOU WANT A FILE OF BADNESS-OF-FIT MEASURES ON THE SAMP
     *LES ? ',\)
      READ(*,260) IANS
      IF(IANS.NE.IY.AND.IANS.NE.JY) GO TO 540
      IBDNS=1
      WRITE(*,520)
  520 FORMAT(20X,' ENTER A NAME FOR THE FILE OF BADNESS-OF-FIT DATA: ',\
     *)
      READ(*,110) UNIT15
  540 WRITE(*,550)
  550 FORMAT(' DO YOU WANT A FILE OF DATA FOR PLOTTING THE FACTOR-VARIAN
     *CE DIAGRAM ? ',\)
      READ(*,260) IANS
      IF(IANS.NE.IY.AND.IANS.NE.JY) GO TO 600
      IDGRM=1
      WRITE(*,560)
  560 FORMAT(20X,' ENTER A NAME FOR THE FACTOR-VARIANCE DIAGRAM DATA: ',
     *\)
      READ(*,110) UNIT 16
  600 CALL RRPCOM(UNIT12,UNIT13,UNIT14,UNIT15,UNIT16)
 9999 STOP
      END
