$NOFLOATCALLS
$STORAGE:2
      SUBROUTINE RROBLS(UNIT12)
C SUBROUTINE RROBLS COMPUTES THE OBLIQUE FACTOR SOLUTION BASED ON
C  THE SAMPLES (OBSERVATIONS) OF EXTREME COMPOSITION.  STARTING WITH
C  THE VARIMAX SCORE MATRIX, THE PROGRAM SEARCHES FOR 2 TO 10
C  (DEPENDING ON THE NO. OF FACTORS SPECIFIED) SAMPLES THAT CAN BE
C  USED AS REFERENCE AXES SO THAT NO SAMPLES WILL HAVE ANY SCORE
C  GREATER THAN UNITY.  THE NEW LOADINGS FOR THE VARIABLES ARE THEN
C  DERIVED FROM THE INVERSE OF THE TRANSFORMATION MATRIX AND THE
C  MATRIX OF VARIMAX LOADINGS.  CORRELATIONS BETWEEN THE DERIVED
C  SAMPLE SCORES AND THE RAW DATA ARE ALSO COMPUTED.
C SUBROUTINE RROBLS IS CALLED BY SUBROUTINE "RRVRMX" AND CALLS
C  SUBROUTINES "RRMATK", "JKGTLS", AND "JKPTLS".  SUBROUTINES
C  "JKGTLS" AND "JKPTLS" ARE IN FILE "IOS.FOR".
C FILE "RRMODE.INC" CONTAINS FIVE COMMON STATEMENTS AND MUST BE
C  PRESENT WHEN COMPILING.
C A.T. MIESCH, USGS, GRAND JUNCTION, COLO.   JANUARY, 1984
C
      IMPLICIT REAL*8 (D)
      CHARACTER*32 UNIT12
      CHARACTER*1 IQ(45),IANS,IY,JY
      CHARACTER*4 IVID(45,2),JVID(10,2),KVID(10,2),NAME(4),ID(2)
      INTEGER*4 LOC(2)
      DIMENSION SS(10),DS(10),IROW(10),DXCOR(45,45)
$INCLUDE: 'RRMODE.INC'
      EQUIVALENCE (DXCOR(1,1),DRX(1))
      DATA IY/'Y'/,JY/'y'/
      NSHALF=NS/2
      KI=10
      KO=12
      WRITE(*,50)
   50 FORMAT(' LOOKING FOR THE EXTREME SAMPLES.....',/)
C FIND AN INITIAL SET OF EXTREME SAMPLES
      DO 130 J=1,NF
      DXMX=0.0
      DO 100 I=1,N
      IF(I.GT.NSHALF) GO TO 110
      WRITE(*,90) I
   90 FORMAT('+',I5)
      IF(DABS(DF1(I,J)).LT.DXMX) GO TO 100
      IROW(J)=I
      DXMX=DABS(DF1(I,J))
  100 CONTINUE
      GO TO 130
  110 DO 120 I=NSHALF+1,N
      WRITE(*,90) I
      K=I-NSHALF
      IF(DABS(DF2(K,J)).LT.DXMX) GO TO 120
      IROW(J)=I
      DXMX=DABS(DF2(K,J))
  120 CONTINUE
  130 CONTINUE
C FILL THE TRANSFORMATION MATRIX (DT)
      DO 190 I=1,NF
      IF(IROW(I).GT.NSHALF) GO TO 150
      DO 140 J=1,NF
  140 DT(I,J)=DF1(IROW(I),J)
      GO TO 190
  150 K=IROW(I)-NSHALF
      DO 160 J=1,NF
  160 DT(I,J)=DF2(K,J)
  190 CONTINUE
      ITIMES=0
C
C SAVE THE TRANSFORMATION MATRIX (IN DG) BEFORE INVERTING
  195 DO 200 I=1,NF
      DO 200 J=1,NF
  200 DG(I,J)=DT(I,J)
      CALL RRMATK(DT,NF)
C CHECK THE INVERSE
      INV=0
      DO 220 I=1,NF
      DO 220 J=1,NF
      DX=0.0
      DO 210 K=1,NF
  210 DX=DX+DT(I,K)*DG(K,J)
      IF(I.EQ.J) DX=1.0-DX
      IF(DABS(DX).GT.0.00001) GO TO 230
  220 CONTINUE
      GO TO 240
  230 INV=1
C COMPUTE THE OBLIQUE SAMPLE SCORES AND SAVE THE HIGHEST VALUES
C  FOR EACH FACTOR AND THEIR LOCATIONS
  240 WRITE(*,245)
  245 FORMAT(' COMPUTING AND TESTING A SCORES MATRIX.....',/)
C FIND THE ROW(II) AND COLUMN(JJ) NOS. FOR THE HIGHEST OBLIQUE SCORE
      DXXX=0.0
      DXMX=0.0
      DO 300 I=1,N
      WRITE(*,90) I
      IF(I.GT.NSHALF) GO TO 270
      DO 260 J=1,NF
      DX=0.0
      DO 250 K=1,NF
  250 DX=DX+DF1(I,K)*DT(K,J)
      DX=DABS(DX)
      IF(DX.GT.DXXX) DXXX=DX
      IF(DX.LT.DXMX) GO TO 260
      DO 252 K=1,NF
  252 IF(I.EQ.IROW(K)) GO TO 260
      II=I
      JJ=J
      DXMX=DX
  260 CONTINUE
      GO TO 300
  270 L=I-NSHALF
      DO 290 J=1,NF
      DX=0.0
      DO 280 K=1,NF
  280 DX=DX+DF2(L,K)*DT(K,J)
      DX=DABS(DX)
      IF(DX.GT.DXXX) DXXX=DX
      IF(DX.LT.DXMX) GO TO 290
      DO 282 K=1,NF
  282 IF(I.EQ.IROW(K)) GO TO 290
      II=I
      JJ=J
      DXMX=DX
  290 CONTINUE
  300 CONTINUE
C
      ITIMES=ITIMES+1
      WRITE(*,305) ITIMES
  305 FORMAT(' PASS ',I2,' COMPLETED')
      IF(INV.NE.0) GO TO 310
      IF(DXXX.LT.1.00005) GO TO 400
C
C SET UP A NEW TRANSFORMATION MATRIX (DT)
  310 IROW(JJ)=II
      DO 320 I=1,NF
      DO 320 J=1,NF
  320 DT(I,J)=DG(I,J)
      IF(II.GT.NSHALF) GO TO 340
      DO 330 I=1,NF
  330 DT(JJ,I)=DF1(II,I)
      GO TO 351
  340 K=II-NSHALF
      DO 350 I=1,NF
  350 DT(JJ,I)=DF2(K,I)
  351 IF(ITIMES.LT.20) GO TO 195
C
      WRITE(*,360) ITIMES
  360 FORMAT(1X,I3,' ITERATIONS AND COULD NOT FIND THE EXTREME SAMPLES',
     */,' TRY USING A DIFFERENT NUMBER OF FACTORS')
      GO TO 9999
C
C COMPUTE THE FILE OF SAMPLE SCORES
  400 DO 410 I=1,NF
      JVID(I,1)=' EXS'
  410 WRITE(JVID(I,2),420) IROW(I)
  420 FORMAT(I4)
      IF(ISCOR.EQ.0) GO TO 422
      OPEN(KO,FILE=UNIT12,STATUS='NEW',FORM='UNFORMATTED')
      ID(1)='OSSC'
      ID(2)='ORES'
      WRITE(KO) ID,N,NF,(JVID(I,1),JVID(I,2),I=1,NF)
  422 READ(KI) ID,N,M,(IVID(I,1),IVID(I,2),I=1,M)
      DO 425 I=1,M
      DO 425 J=1,NF
  425 DXCOR(I,J)=0.0
      DO 426 I=1,NF
      DEG(I)=0.0
  426 DAX(I)=0.0
      IF(ISCOR.EQ.1) WRITE(*,427)
  427 FORMAT(' WRITING THE FILE OF EXTREME-SAMPLE OBLIQUE SCORES.....',/
     *)
      IF(ISCOR.EQ.0) WRITE(*,428)
  428 FORMAT(' COMPUTING CORRELATIONS BETWEEN THE FACTORS AND VARIABLES.
     *....',/)
      DO 480 I=1,N
      WRITE(*,90) I
      IF(I.GT.NSHALF) GO TO 440
      DO 430 J=1,NF
      DS(J)=0.0
      DO 430 K=1,NF
  430 DS(J)=DS(J)+DF1(I,K)*DT(K,J)
      GO TO 460
  440 L=I-NSHALF
      DO 450 J=1,NF
      DS(J)=0.0
      DO 450 K=1,NF
  450 DS(J)=DS(J)+DF2(L,K)*DT(K,J)
  460 CALL JKGTLS(KI,JROW,NAME,LOC,S,IQ,M,IERR)
      IF(IERR.NE.0) STOP 'UNEXPECTED END-OF-FILE IN RROBLS'
      DO 462 J=1,NF
      IF(I.NE.IROW(J)) GO TO 462
      KVID(J,1)=NAME(1)
      KVID(J,2)=NAME(2)
      GO TO 465
  462 CONTINUE
  465 DO 472 J=1,M
      DX=DBLE(S(J))
      DO 472 K=1,NF
  472 DXCOR(J,K)=DXCOR(J,K)+DX*DS(K)
      DO 473 J=1,NF
      DEG(J)=DEG(J)+DS(J)
      DAX(J)=DAX(J)+DS(J)*DS(J)
  473 SS(J)=SNGL(DS(J))
      IF(ISCOR.EQ.1) CALL JKPTLS(KO,I,NAME,LOC,SS,IQ,NF)
  480 CONTINUE
C
      IF(ISCOR.EQ.1) WRITE(KP,492) UNIT12,N,NF
  492 FORMAT(' FILE ',A32,/,'   CONTAINS THE EXTREME-SAMPLE OBLIQUE SCOR
     *ES   N=',I4,' M=',I2)
C COMPUTE CORRELATIONS BETWEEN THE FACTORS AND THE VARIABLES
      DFN=DBLE(N)
      DO 500 I=1,NF
      DEG(I)=DEG(I)/DFN
  500 DAX(I)=DSQRT(DAX(I)/DFN-DEG(I)*DEG(I))
      DO 510 I=1,M
      DO 510 J=1,NF
  510 DXCOR(I,J)=(DXCOR(I,J)/DFN-DXB(I)*DEG(J))/(DXS(I)*DAX(J))
C COMPUTE THE LOADINGS FOR THE VARIABLES
  530 DO 540 I=1,NF
      DO 540 J=1,M
      DE(I,J)=0.0
      DO 540 K=1,NF
  540 DE(I,J)=DE(I,J)+DG(I,K)*DXC(J,K)
      WRITE(KP,550)
  550 FORMAT(//,' EXTREME-SAMPLE OBLIQUE LOADINGS',/)
      IB=0
  560 WRITE(KP,570) (JVID(I,1),JVID(I,2),I=1,NF)
      WRITE(KP,570) (KVID(I,1),KVID(I,2),I=1,NF)
  570 FORMAT(9X,16A4)
      DO 580 I=1,M
  580 WRITE(KP,590) IVID(I,1),IVID(I,2),(DE(J,I),J=1,NF)
  590 FORMAT(1X,2A4,8F8.4,/,(9X,8F8.4))
      IF(IB.NE.0) GO TO 595
      IF(ISCOR.EQ.0) GO TO 712
      IFLAG=1
      CALL RRCOEF(NF,M,IVID,IFLAG)
  712 WRITE(KP,591)
  591 FORMAT(//,' RECOMPUTED COMPOSITIONS OF THE EXTREME SAMPLES',/)
      DO 592 I=1,NF
      DO 592 J=1,M
  592 DE(I,J)=DE(I,J)*DXS(J)+DXB(J)
      WRITE(*,620)
  620 FORMAT(' WERE ALL OF THE INPUT DATA GIVEN AS LOGS(BASE e OR BASE 1
     *0) ? ',\)
      READ(*,630) IANS
  630 FORMAT(A1)
      IF(IANS.NE.IY.AND.IANS.NE.JY) GO TO 710
      WRITE(*,632)
  632 FORMAT(' DO YOU WANT THE RECOMPUTED COMPOSITIONS IN THE ORIGINAL (
     *NON-LOG) UNITS ?',/,' WARNING-----IF ORIGINAL UNITS ARE OTHER THAN
     * % OR PPM, ANSWER ''NO'' ',\)
      READ(*,630) IANS
      IF(IANS.NE.IY.AND.IANS.NE.JY) GO TO 710
  635 WRITE(*,640)
  640 FORMAT(' LOGS TO THE (1) BASE e OR (2) BASE 10 ?   TYPE ''1'' OR '
     *'2'' ',\)
      READ(*,*) IBASE
      IF(IBASE.NE.1.AND.IBASE.NE.2) GO TO 635
  645 WRITE(*,650)
  650 FORMAT(' WERE THE LOGS OF (1) PERCENTAGES OR (2) PPM ?  TYPE ''1''
     * OR ''2'' ',\)
      READ(*,*) IUNIT
      IF(IUNIT.NE.1.AND.IUNIT.NE.2) GO TO 645
      IF(IBASE.EQ.2) GO TO 670
      DO 660 I=1,NF
      DO 660 J=1,M
  660 DE(I,J)=EXP(DE(I,J))
      GO TO 690
  670 DO 680 I=1,NF
      DO 680 J=1,M
  680 DE(I,J)=10**DE(I,J)
  690 IF(IUNIT.EQ.1) GO TO 710
      DO 700 I=1,NF
      DO 700 J=1,M
  700 DE(I,J)=DE(I,J)*0.0001
  710 IB=1
      GO TO 560
  595 WRITE(KP,600)
  600 FORMAT(//,' CORRELATIONS BETWEEN THE SAMPLE SCORES AND THE VARIABL
     *ES',/)
      WRITE(KP,570) (JVID(I,1),JVID(I,2),I=1,NF)
      WRITE(KP,570) (KVID(I,1),KVID(I,2),I=1,NF)
      DO 610 I=1,M
  610 WRITE(KP,590) IVID(I,1),IVID(I,2),(DXCOR(I,J),J=1,NF)
 9999 STOP
      END
