$STORAGE:2
      SUBROUTINE RROBLV(UNIT12)
C SUBROUTINE RROBLV COMPUTES THE OBLIQUE FACTOR SOLUTION BASED ON
C  THE EXTREME VARIABLES.  STARTING WITH THE MATRIX OF VARIMAX
C  LOADING FOR THE VARIABLES, THE PROGRAM FINDS THE 2 TO 10
C  (DEPENDING ON THE NO. OF FACTORS SPECIFIED) VARIABLES THAT CAN
C  BE USED AS REFERENCE AXES SO THAT NO VARIABLE WILL HAVE ANY
C  LOADING GREATER THAN UNITY.  THE NEW SCORES FOR THE SAMPLES ARE
C  THEN DERIVED FROM THE INVERSE OF THE TRANSFORMATION MATRIX AND
C  THE MATRIX OF VARIMAX SCORES.  CORRELATIONS BETWEEN THE SAMPLE
C  SCORES AND THE RAW DATA ARE ALSO COMPUTED.  THE DERIVED SCORES
C  ARE COMPRISED OF FILTERED DATA FOR THE EXTREME VARIABLES, AND
C  THE VARIABLE LOADINGS SHOW THE DEGREES TO WHICH FILTERED DATA
C  FOR THE OTHER VARIABLES CORRELATE WITH THE EXTREME VARIABLES.
C SUBROUTINE RROBLV IS CALLED BY SUBROUTINE "RRVRMX", AND CALLS
C  SUBROUTINES "RRMATK", "JKGTLS", AND "JKPTLS".  SUBROUTINES
C  "JKGTLS" AND "JKPTLS" ARE IN FILE "IOS.FOR".
C FILE "RRMODE.INC" CONTAINS FIVE COMMON STATEMENTS AND MUST BE
C  PRESENT WHEN COMPILING.
C A.T. MIESCH, USGS, GRAND JUNCTION, COLO.  JANUARY, 1984
C
      IMPLICIT REAL*8 (D)
      CHARACTER*12 UNIT12
      CHARACTER*1 IQ(45)
      CHARACTER*4 IVID(45,2),JVID(10,2),NAME(4),ID(2)
      INTEGER*4 LOC(2)
      DIMENSION SS(10),DS(10),IROW(10),DXCOR(45,45)
$INCLUDE: 'RRMODE.INC'
      EQUIVALENCE (DXCOR(1,1),DRX(1))
      NSHALF=NS/2
      KI=10
      KO=12
      WRITE(*,50)
   50 FORMAT(' LOOKING FOR THE EXTREME VARIABLES.....')
C FIND AN INITIAL SET OF EXTREME VARIABLES
      DO 130 J=1,NF
      DXMX=0.0
      DO 100 I=1,M
      IF(DABS(DXC(I,J)).LT.DXMX) GO TO 100
      IROW(J)=I
      DXMX=DABS(DXC(I,J))
  100 CONTINUE
  130 CONTINUE
C FILL THE TRANSFORMATION MATRIX (DT)
      DO 190 I=1,NF
      DO 140 J=1,NF
  140 DT(J,I)=DXC(IROW(I),J)
  190 CONTINUE
      ITIMES=0
C
C SAVE THE TRANSFORMATION MATRIX (IN DG) BEFORE INVERTING
  195 DO 200 I=1,NF
      DO 200 J=1,NF
  200 DG(I,J)=DT(I,J)
      CALL RRMATK(DT,NF)
C CHECK THE INVERSE
      INV=0
      DO 220 I=1,NF
      DO 220 J=1,NF
      DX=0.0
      DO 210 K=1,NF
  210 DX=DX+DT(I,K)*DG(K,J)
      IF(I.EQ.J) DX=1.0-DX
      IF(DABS(DX).GT.0.00001) GO TO 230
  220 CONTINUE
      GO TO 240
  230 INV=1
C COMPUTE THE OBLIQUE VARIABLE LOADINGS AND SAVE THE HIGHEST VALUES
C  FOR EACH FACTOR AND THEIR LOCATIONS
  240 WRITE(*,245)
  245 FORMAT(' COMPUTING AND TESTING A LOADINGS MATRIX.....',/)
C FIND THE ROW(II) ANS COLUMN(JJ) NOS. OF THE HIGHEST OBLIGUE LOADING
      DXXX=0.0
      DXMX=0.0
      DO 300 I=1,M
      DO 260 J=1,NF
      DX=0.0
      DO 250 K=1,NF
  250 DX=DX+DT(J,K)*DXC(I,K)
      DX=DABS(DX)
      IF(DX.GT.DXXX) DXXX=DX
      IF(DX.LT.DXMX) GO TO 260
      DO 252 K=1,NF
  252 IF(I.EQ.IROW(K)) GO TO 260
      II=I
      JJ=J
      DXMX=DX
  260 CONTINUE
  300 CONTINUE
C
      ITIMES=ITIMES+1
      WRITE(*,305) ITIMES
  305 FORMAT(' PASS ',I2,' COMPLETED')
      IF(INV.NE.0) GO TO 310
      IF(DXXX.LT.1.00005) GO TO 400
C
C SET UP A NEW TRANSFORMATION MATRIX (DT)
  310 IROW(JJ)=II
      DO 320 I=1,NF
      DO 320 J=1,NF
  320 DT(I,J)=DG(I,J)
      DO 330 I=1,NF
  330 DT(I,JJ)=DXC(II,I)
      IF(ITIMES.LT.20) GO TO 195
C
      WRITE(*,360) ITIMES
  360 FORMAT(1X,I3,' ITERATIONS AND COULD NOT FIND THE EXTREME VARIABLES
     *',/,' TRY USING A DIFFERENT NUMBER OF FACTORS')
      GO TO 9999
C
C COMPUTE THE FILE OF SAMPLE SCORES
  400 DO 410 I=1,NF
      JVID(I,1)=' EXV'
  410 WRITE(JVID(I,2),420) IROW(I)
  420 FORMAT(I4)
      IF(ISCOR.EQ.0) GO TO 422
      OPEN(KO,FILE=UNIT12,STATUS='NEW',FORM='UNFORMATTED')
      ID(1)='OVSC'
      ID(2)='ORES'
      WRITE(KO) ID,N,NF,(JVID(I,1),JVID(I,2),I=1,NF)
  422 READ(KI) ID,N,M,(IVID(I,1),IVID(I,2),I=1,M)
      DO 425 I=1,M
      DO 425 J=1,NF
  425 DXCOR(I,J)=0.0
      DO 426 I=1,NF
      DEG(I)=0.0
  426 DAX(I)=0.0
      IF(ISCOR.EQ.1) WRITE(*,427)
  427 FORMAT(' WRITING THE FILE OF EXTREME-VARIABLE OBLIQUE SCORES.....'
     *,/)
      IF(ISCOR.EQ.0) WRITE(*,428)
  428 FORMAT(' COMPUTING CORRELATIONS BETWEEN THE FACTORS AND VARIABLES.
     *....',/)
      DO 480 I=1,N
      WRITE(*,90) I
   90 FORMAT('+',I5)
      IF(I.GT.NSHALF) GO TO 440
      DO 430 J=1,NF
      DS(J)=0.0
      DO 430 K=1,NF
  430 DS(J)=DS(J)+DF1(I,K)*DG(K,J)
      GO TO 460
  440 L=I-NSHALF
      DO 450 J=1,NF
      DS(J)=0.0
      DO 450 K=1,NF
  450 DS(J)=DS(J)+DF2(L,K)*DG(K,J)
  460 CALL JKGTLS(KI,JROW,NAME,LOC,S,IQ,M,IERR)
      IF(IERR.NE.0) STOP 'UNEXPECTED END-OF-FILE IN RROBLV'
      DO 472 J=1,M
      DX=DBLE(S(J))
      DO 472 K=1,NF
  472 DXCOR(J,K)=DXCOR(J,K)+DX*DS(K)
      DO 473 J=1,NF
      DEG(J)=DEG(J)+DS(J)
      DAX(J)=DAX(J)+DS(J)*DS(J)
  473 SS(J)=SNGL(DS(J))
      IF(ISCOR.EQ.1) CALL JKPTLS(KO,I,NAME,LOC,SS,IQ,NF)
  480 CONTINUE
C
      IF(ISCOR.EQ.1) WRITE(KP,492) UNIT12,N,NF
  492 FORMAT(' FILE ',A12,' CONTAINS THE EXTREME-VARIABLE OBLIQUE SCORES
     *  N=',I4,' M=',I2)
C COMPUTE CORRELATIONS BETWEEN THE FACTORS AND THE VARIABLES
      DFN=DBLE(N)
      DO 500 I=1,NF
      DEG(I)=DEG(I)/DFN
  500 DAX(I)=DSQRT(DAX(I)/DFN-DEG(I)*DEG(I))
      DO 510 I=1,M
      DO 510 J=1,NF
  510 DXCOR(I,J)=(DXCOR(I,J)/DFN-DXB(I)*DEG(J))/(DXS(I)*DAX(J))
C COMPUTE THE LOADINGS FOR THE VARIABLES
  530 DO 540 I=1,NF
      DO 540 J=1,M
      DE(I,J)=0.0
      DO 540 K=1,NF
  540 DE(I,J)=DE(I,J)+DT(I,K)*DXC(J,K)
      WRITE(KP,550)
  550 FORMAT(//,' EXTREME-VARIABLE OBLIQUE LOADINGS',/)
  560 WRITE(KP,570) (JVID(I,1),JVID(I,2),I=1,NF)
      WRITE(KP,570) (IVID(IROW(I),1),IVID(IROW(I),2),I=1,NF)
  570 FORMAT(9X,16A4)
      DO 580 I=1,M
  580 WRITE(KP,590) IVID(I,1),IVID(I,2),(DE(J,I),J=1,NF)
  590 FORMAT(1X,2A4,8F8.4,/,(9X,8F8.4))
      IF(ISCOR.EQ.0) GO TO 712
      IFLAG=2
      CALL RRCOEF(NF,M,IVID,IFLAG)
  712 WRITE(KP,600)
  600 FORMAT(//,' CORRELATIONS BETWEEN THE SAMPLE SCORES AND THE VARIABL
     *ES',/)
      WRITE(KP,570) (JVID(I,1),JVID(I,2),I=1,NF)
      WRITE(KP,570) (IVID(IROW(I),1),IVID(IROW(I),2),I=1,NF)
      DO 610 I=1,M
  610 WRITE(KP,590) IVID(I,1),IVID(I,2),(DXCOR(I,J),J=1,NF)
 9999 STOP
      END
