$STORAGE:2
      SUBROUTINE RRPCOM(UNIT12,UNIT13,UNIT14,UNIT15,UNIT16)
C SUBROUTINE RRPCOM IS CALLED BY PROGRAM "RRMODE" AND CALLS
C  SUBROUTINES "RRFILE", "RRVRMX", "RREIGN", "JKGTLS", AND "JKPTLS".
C  SUBROUTINES "JKGTLS" AND "JKPTLS" ARE IN FILE "IOS.FOR".
C  FILE "RRMODE.INC" CONTAINS FIVE COMMON STATEMENTS AND MUST BE
C  PRESENT WHEN COMPILING.
C SUBROUTINE RRPCOM COMPUTES THE PRINCIPAL COMPONENT LOADINGS
C  AND SCORES, PRINTS THE EIGENVALUES, AND ALSO DERIVES THE DATA
C  USED TO PLOT A "FACTOR-VARIANCE" DIAGRAM.
C A.T. MIESCH, USGS, GRAND JUNCTION, COLO.  JANUARY, 1984
C
      IMPLICIT REAL*8 (D)
      CHARACTER*12 UNIT12,UNIT13,UNIT14,UNIT15,UNIT16
      CHARACTER*4 ID(2),NAME(4),IVID(45,2),IBL4,JVID(45,2),IPC
      CHARACTER*1 IY,JY,IANS,IQ(45),IBL1
      INTEGER*4 LOC(2)
$INCLUDE: 'RRMODE.INC'
      DATA IY/'y'/,JY/'Y'/,IBL1/' '/,IBL4/'    '/,IQ/45*' '/
      NSHALF=NS/2
      KI=10
      KO=12
      KO1=16
      NAME(3)=IBL4
      NAME(4)=IBL4
      LOC(1)=0
      LOC(2)=0
C
      WRITE(*,100)
  100 FORMAT(' COMPUTING THE EIGENVALUES AND EIGENVECTORS.....',/)
      DO 110 I=1,M
      DO 110 J=1,M
      IF(I.GT.J) GO TO 110
      L=I+(J*J-J)/2
      DAX(L)=DXC(I,J)
  110 CONTINUE
      CALL RREIGN(DAX,DRX,M,0)
      L=0
      DO 120 I=1,M
      L=L+I
  120 DEG(I)=DAX(L)
      L=0
      DO 130 I=1,M
      DO 130 J=1,M
      L=L+1
  130 DXC(J,I)=DRX(L)
      NF=M
      DO 140 I=1,M
      IF(DEG(I).GT.0.00001) GO TO 140
      NF=I-1
      GO TO 150
  140 CONTINUE
  150 DO 160 I=1,NF
  160 DEG(I)=DSQRT(DEG(I))
      DO 170 I=1,M
      DO 170 J=1,NF
  170 DXC(I,J)=DXC(I,J)*DEG(J)
      DO 180 I=1,NF
  180 DEG(I)=DEG(I)*DEG(I)
      DO 200 I=1,M
      DO 190 J=1,M
  190 DE(I,J)=0.0
  200 DE(I,I)=1.0/DEG(I)
      DO 210 I=1,M
      DO 210 J=1,M
      DG(I,J)=0.0
      DO 210 K=1,NF
  210 DG(I,J)=DG(I,J)+DXC(I,K)*DE(K,J)
      DO 220 I=1,NF
      JVID(I,1)='  PC'
  220 WRITE(JVID(I,2),230) I
  230 FORMAT(I4)
      READ(KI) ID,N,M,(IVID(I,1),IVID(I,2),I=1,M)
      WRITE(*,240)
  240 FORMAT(/,' DO YOU WANT TO PRINT THE PRINCIPAL COMPONENTS ? ',\)
      READ(*,250) IANS
  250 FORMAT(A1)
      IF(IANS.NE.IY.AND.IANS.NE.JY) GO TO 305
      WRITE(KP,260)
  260 FORMAT(1X)
      WRITE(KP,270)
  270 FORMAT(' PRINCIPAL COMPONENTS MATRIX',/,' (THESE ARE THE CORRELATI
     1IONS BETWEEN THE PRINCIPAL COMPONENTS AND',/,' THE VARIABLES)')
      WRITE(KP,280) (JVID(I,1),JVID(I,2),I=1,NF)
  280 FORMAT(9X,16A4)
      DO 290 I=1,M
  290 WRITE(KP,300) IVID(I,1),IVID(I,2),(DXC(I,J),J=1,NF)
  300 FORMAT(1X,2A4,8F8.4,/,(9X,8F8.4))
  305 WRITE(KP,260)
      WRITE(*,310)
  310 FORMAT(' DO YOU WANT TO PRINT THE DATA FOR THE FACTOR-VARIANCE DIA
     1GRAM ? ',\)
      IFV=0
      NN=NF
      IF(NN.GT.10) NN=10
      READ(*,250) IANS
      IF(IANS.NE.IY.AND.IANS.NE.JY) GO TO 340
      IFV=1
      WRITE(KP,320) NN
  320 FORMAT(/,' PROPORTIONS OF VARIABLES EXPLAINED BY 1 TO ',I2,' FACTO
     1RS',/)
      DO 330 I=1,NN
  330 JVID(I,1)=' FAC'
      WRITE(KP,280) (JVID(I,1),JVID(I,2),I=1,NN)
  340 IF(IFV.EQ.0.AND.IDGRM.EQ.0) GO TO 390
      IF(IDGRM.EQ.0) GO TO 350
      OPEN(KO1,FILE=UNIT16,STATUS='NEW',FORM='UNFORMATTED')
      ID(1)='FV--'
      ID(2)='DGRM'
      WRITE(KO1) ID,M,NN,(JVID(I,1),JVID(I,2),I=1,NN)
  350 DO 380 I=1,M
      DAX(1)=DXC(I,1)*DXC(I,1)
      DO 360 J=2,NN
      K=J-1
      DAX(J)=DAX(K)+DXC(I,J)*DXC(I,J)
  360 S(J)=SNGL(DAX(J))
      S(1)=SNGL(DAX(1))
      IF(IFV.EQ.1) WRITE(KP,370) IVID(I,1),IVID(I,2),(S(J),J=1,NN)
  370 FORMAT(1X,2A4,8F8.2,/,9X,2F8.2)
      IF(IDGRM.EQ.0) GO TO 380
      NAME(1)=IVID(I,1)
      NAME(2)=IVID(I,2)
      CALL JKPTLS(KO1,I,NAME,LOC,S,IQ,NN)
  380 CONTINUE
  390 WRITE(KP,260)
      WRITE(KP,400)
  400 FORMAT(10X,' EIGENVALUES',5X,'CPM')
      DSUM=0.0
      DFM=DBLE(M)
      DO 420 I=1,NF
      DSUM=DSUM+DEG(I)
      DCPM=DSUM/DFM
      WRITE(KP,410) I,DEG(I),DCPM
  410 FORMAT(1X,I5,3X,F10.4,4X,F10.4)
  420 CONTINUE
      WRITE(KP,260)
      IF(IAXES.EQ.1.AND.ISCOR.EQ.0.AND.IRCMP.EQ.0.AND.IRESD.EQ.0
     *.AND.IBDNS.EQ.0) GO TO 9990
      IF(IAXES.EQ.1) GO TO 430
      IF(NF.GT.10) NF=10
  430 WRITE(*,440) NF
  440 FORMAT(' HOW MANY FACTORS DO YOU WANT TO USE - UP TO',I3,' ? ',\)
      READ(*,*) NNF
      IF(NNF.LT.1.OR.NNF.GT.NF) GO TO 430
      IF(NNF.GE.2.OR.IAXES.EQ.1) GO TO 460
      WRITE(*,450)
  450 FORMAT(' CANNOT ROTATE FEWER THAN 2 FACTORS')
      GO TO 430
  460 NF=NNF
      NC=NF
      IF(NC.GT.10) NC=10
      IF(IAXES.NE.1) GO TO 490
      IF(ISCOR.EQ.0) GO TO 490
      WRITE(*,462)
  462 FORMAT(/,' COEFFICIENTS FOR COMPUTING THE PRINCIPAL COMPONENT SCOR
     *ES',/)
      WRITE(*,463) (IVID(I,1),IVID(I,2),I=1,M)
  463 FORMAT(10X,16A4)
      DO 464 I=1,NC
  464 WRITE(*,465) I,(DG(J,I),J=1,M)
  465 FORMAT(' FACTOR ',I2,8F8.4,/,(10X,8F8.4))
      OPEN(KO,FILE=UNIT12,STATUS='NEW',FORM='UNFORMATTED')
      DO 470 I=1,NF
      JVID(I,1)='  PC'
  470 DEG(I)=DSQRT(DEG(I))
      ID(1)='PCSC'
      ID(2)='ORES'
  480 WRITE(KO) ID,N,NF,(JVID(I,1),JVID(I,2),I=1,NF)
C
  490 WRITE(*,500)
  500 FORMAT(/,' COMPUTING THE PRINCIPAL COMPONENT SCORES.....',/)
      NC=NF
      IF(NC.GT.10) NC=10
      DO 610 I=1,N
      WRITE(*,510) I
  510 FORMAT('+',I5)
      CALL JKGTLS(KI,IROW,NAME,LOC,S,IQ,M,IERR)
      IF(IERR.NE.0) STOP 'UNEXPECTED END-OF-FILE'
      DO 520 J=1,M
  520 DAX(J)=(DBLE(S(J))-DXB(J))/DXS(J)
      DO 530 J=1,NF
      DRX(J)=0.0
      DO 530 K=1,M
  530 DRX(J)=DRX(J)+DAX(K)*DG(K,J)
      IF(I.GT.NSHALF) GO TO 550
      DO 540 J=1,NC
  540 DF1(I,J)=DRX(J)
      GO TO 570
  550 K=I-NSHALF
      DO 560 J=1,NC
  560 DF2(K,J)=DRX(J)
  570 IF(IAXES.NE.1.OR.ISCOR.EQ.0) GO TO 610
      IF(ISC.EQ.0) GO TO 590
      DO 580 J=1,NF
  580 DRX(J)=DRX(J)*DEG(J)
  590 DO 600 J=1,NF
  600 S(J)=SNGL(DRX(J))
      CALL JKPTLS(KO,I,NAME,LOC,S,IQ,NF)
  610 CONTINUE
C
      REWIND KI
      IF(IRCMP.EQ.1.OR.IRESD.EQ.1.OR.IBDNS.EQ.1) CALL RRFILE(UNIT13,
     1UNIT14,UNIT15)
      IF(IAXES.NE.1) GO TO 630
      IF(ISCOR.EQ.1) WRITE(KP,620) UNIT12,N,NF
  620 FORMAT(' FILE ',A12,' CONTAINS THE PRINCIPAL COMPONENT SCORES  N='
     1,I4,' M=',I2)
  630 IF(IRCMP.EQ.1) WRITE(KP,640) UNIT13,N,M
  640 FORMAT(' FILE ',A12,' CONTAINS THE RECOMPUTED DATA  N=',I4,' M=',
     1I2)
      IF(IRESD.EQ.1) WRITE(KP,650) UNIT14,N,M
  650 FORMAT(' FILE ',A12,' CONTAINS THE FACTOR RESIDUALS  N=',I4,' M=',
     1I2)
      IF(IBDNS.EQ.1) WRITE(KP,660) UNIT15,N,M+1
  660 FORMAT(' FILE ',A12,' CONTAINS THE BADNESS-OF-FIT DATA ON THE SAMP
     1LES  N=',I4,' M=',I2)
 9990 IF(IDGRM.EQ.1) WRITE(KP,670) UNIT16,M,NN
  670 FORMAT(' FILE ',A12,' CONTAINS THE DATA FOR THE FACTOR-VARIANCE DI
     *AGRAM  N=',I4,' M=',I2)
      IF(IAXES.EQ.1) GO TO 9999
      IF(NF.GT.10) NF=10
      CALL RRVRMX(UNIT12)
 9999 STOP
      END
 
 
 
