$STORAGE:2
      SUBROUTINE RRVRMX(UNIT12)
C SUBROUTINE RRVRMX IS CALLED BY SUBROUTINE "RRPCOM" AND CALLS SUB-
C  ROUTINES "RRVROT", "RROBLS", "RROBLV", "RRMATK", "JKGTLS", AND
C  "JKPTLS".  "JKGTLS" AND "JKPTLS" ARE IN FILE "IOS.FOR".
C  FILE "RRMODE.INC" CONTAINS FIVE COMMON STATMENTS AND MUST BE
C  PRESENT WHEN COMPILING.
C  RRVRMX DERIVES THE VARIMAX LOADINGS AND SCORES AND CALLS THE
C  OBLIQUE SOLUTION SUBROUTINES ACCORDING TO THE OPTIONS SELECTED.
C A.T. MIESCH, USGS, GRAND JUNCTION, COLO.  JANUARY, 1984
C
C  THE ARRAY "DXC(45,45)" IN COMMON BLOCK "X333" CONTAINS THE FACTOR
C     LOADINGS.
C  THE ARRAY "DF1(800,10)" IN COMMON BLOCK "X444" AND THE ARRAY
C     "DF2(800,10)" IN COMMON BLOCK "X555" CONTAIN THE FACTOR SCORES.
C
      IMPLICIT REAL*8 (D)
      CHARACTER*12 UNIT12
      CHARACTER*4 ID(2),NAME(4),IVID(45,2),JVID(10,2),IVX
      CHARACTER*1 IQ(45),IY,JY,IANS,IBL1
      INTEGER*4 LOC(2)
      DIMENSION SS(45)
$INCLUDE: 'RRMODE.INC'
      DATA IY/'Y'/,JY/'y'/,IVX/'  VX'/,IBL1/' '/
      NSHALF=NS/2
      KI=10
      KO=12
      CALL RRVROT(NF,M,DXC,DT)
      DO 10 I=1,NF
      DO 10 J=1,NF
   10 DE(I,J)=DT(I,J)
      DO 20 I=1,NF
      JVID(I,1)=IVX
   20 WRITE(JVID(I,2),25) I
   25 FORMAT(I4)
      IF(IAXES.NE.2) GO TO 185
      OPEN(KO,FILE=UNIT12,STATUS='NEW',FORM='UNFORMATTED')
      READ(KI) ID,N,M,(IVID(I,1),IVID(I,2),I=1,M)
      IF(ISCOR.EQ.0) GO TO 110
      ID(1)='VXSC'
      ID(2)='ORES'
      WRITE(KO) ID,N,NF,(JVID(I,1),JVID(I,2),I=1,NF)
  110 WRITE(KP,120)
  120 FORMAT(/,' VARIMAX LOADINGS',/,' (THESE ARE THE CORRELATIONS BETWE
     *EN THE VARIMAX SCORES AND THE VARIABLES)')
      WRITE(KP,150) (JVID(I,1),JVID(I,2),I=1,NF)
  150 FORMAT(9X,16A4,/,9X,4A4)
      DO 160 I=1,M
  160 WRITE(KP,170) IVID(I,1),IVID(I,2),(DXC(I,J),J=1,NF)
  170 FORMAT(1X,2A4,8F8.4,/,9X,2F8.4)
C
      IF(ISCOR.EQ.0) GO TO 9999
      WRITE(*,30)
   30 FORMAT(/,' COEFFICIENTS FOR COMPUTING THE VARIMAX SCORES',/)
      WRITE(*,35) (IVID(I,1),IVID(I,2),I=1,M)
   35 FORMAT(10X,16A4)
      DO 40 I=1,NF
      DO 40 J=1,NF
      DT(I,J)=0.0
      DO 40 K=1,M
   40 DT(I,J)=DT(I,J)+DXC(K,I)*DXC(K,J)
      CALL RRMATK(DT,NF)
      DO 50 I=1,M
      DO 50 J=1,NF
      DG(I,J)=0.0
      DO 50 K=1,NF
   50 DG(I,J)=DG(I,J)+DXC(I,K)*DT(K,J)
      DO 60 I=1,NF
   60 WRITE(*,70) I,(DG(J,I),J=1,M)
   70 FORMAT(' FACTOR ',I2,8F8.4,/,(10X,8F8.4))
C
  185 WRITE(*,186)
  186 FORMAT(/,' COMPUTING VARIMAX SCORES.....',/)
      DO 250 I=1,N
      WRITE(*,187) I
  187 FORMAT('+',I5)
      IF(I.GT.NSHALF) GO TO 200
      DO 190 J=1,NF
      DAX(J)=0.0
      DO 190 K=1,NF
  190 DAX(J)=DAX(J)+DF1(I,K)*DE(K,J)
      DO 195 J=1,NF
  195 DF1(I,J)=DAX(J)
      GO TO 220
  200 L=I-NSHALF
      DO 210 J=1,NF
      DAX(J)=0.0
      DO 210 K=1,NF
  210 DAX(J)=DAX(J)+DF2(L,K)*DE(K,J)
      DO 215 J=1,NF
  215 DF2(L,J)=DAX(J)
  220 IF(IAXES.NE.2.OR.ISCOR.EQ.0) GO TO 250
      CALL JKGTLS(KI,IROW,NAME,LOC,SS,IQ,M,IERR)
      IF(IERR.NE.0) STOP 'UNEXPECTED END-OF-FILE IN RRVRMX'
      DO 230 J=1,NF
      IQ(J)=IBL1
  230 S(J)=SNGL(DAX(J))
      CALL JKPTLS(KO,I,NAME,LOC,S,IQ,NF)
  250 CONTINUE
      REWIND KI
C
      IF(IAXES.EQ.2.AND.ISCOR.EQ.1) WRITE(KP,300) UNIT12,N,NF
  300 FORMAT(' FILE ',A12,' CONTAINS THE VARIMAX SCORES  N=',I4,
     *' M=',I2)
C
      IF(JAXES.EQ.1) CALL RROBLS(UNIT12)
      IF(JAXES.EQ.2) CALL RROBLV(UNIT12)
 9999 STOP
      END
