TITLE   SUBROUTINE SAVRST(SAVE,IRSTRT,IRSTOP,ICSTRT,ICSTOP,ICODE,IPAGE)
;COPIES THE CHARACTERS CONTAINED WITHIN A RECTANGULAR AREA OF THE PC'S
;SCREEN INTO A CHARACTER ARRAY, OR RESTORES PREVIOUSLY COPIED CHARACTERS
;INTO A RECTANGULAR AREA ON THE SCREEN.  CHARACTER ATTRIBUTES ARE
;ALSO COPIED AND RESTORED.
;
;      FORTRAN USAGE
;      CHARACTER*2 SAVE(2000)
;      INTEGER*2 IRSTRT,IRSTOP,ICSTRT,ICSTOP,ICODE,IPAGE
;      ............
;      ............
;      CALL SAVRST(SAVE,IRSTRT,IRSTOP,ICSTRT,ICSTOP,ICODE,IPAGE)
;
;      WHERE
;      SAVE = ARRAY TO RECEIVE SCREEN CHARACTERS AND TRHEIR ATTRIBUTES
;      (BYTES 0,2,4,6,... CONTAIN THE CHARACTER, BYTES 1,3,5,7,...
;      CONTAIN THE ATTRIBUTE)
;      IRSTRT = STARTING SCREEN ROW NUMBER (0-24)
;      IRSTOP = ENDING   SCREEN ROW NUMBER (0-24)
;      ICSTRT = STARTING SCREEN COL NUMBER (0-79)
;      ICSTOP = ENDING   SCREEN COL NUMBER (0-79)
;      (IRSTOP MUST NOT BE LESS THAN IRSTRT AND
;      ICSTOP MUST NOT BE LESS THAN ICSTRT)
;      ICODE = 0    SAVE SCREEN
;      ICODE = 1    RESTORE SCREEN
;      IPAGE = PC SCREEN PAGE (0-3) FOR MODES 2 AND 3
;
;CODED BY W. D. GRUNDY  JULY 1985; REVISED APRIL 1987
;
GET_PARM   MACRO        SEQ, TOT
           LES          DI, DWORD PTR SS:[BP+(TOT-SEQ)*4+6]
           ENDM
;
_DATA      SEGMENT      WORD PUBLIC 'DATA'
_DATA      ENDS
;
SRST_TEXT  SEGMENT      BYTE PUBLIC 'CODE'
DGROUP     GROUP        _DATA
           ASSUME       CS:SRST_TEXT,DS:DGROUP,SS:DGROUP
           PUBLIC       SAVRST
SAVRST     PROC         FAR
;
           PUSH         BP              ;SAVE CALLER'S BP
           MOV          BP,SP
           SUB          SP,4            ;MAKE VACANT SPACE ON STACK
           PUSH         DI
ROW_STOP   EQU          [BP-3]          ;TEMPORARY VARIABLES
COL_STOP   EQU          [BP-2]          ;STORED ON THE STACK.
COL_START  EQU          [BP-1]
;
           GET_PARM     7,7             ;GET ADDRESS OF IPAGE
           MOV          BH,BYTE PTR ES:[DI]
;
           GET_PARM     2,7             ;GET ADDRESS OF IRSTRT
           MOV          DH,BYTE PTR ES:[DI]
;
           GET_PARM     4,7             ;GET ADDRESS OF ICSTRT
           MOV          DL,BYTE PTR ES:[DI]
           MOV          COL_START,DL    ;SAVE STARTING COLUMN
;
           GET_PARM     3,7             ;GET ADDRESS OF IRSTOP
           MOV          DL,BYTE PTR ES:[DI]
           MOV          ROW_STOP,DL     ;SAVE STOPPING ROW
;
           GET_PARM     5,7             ;GET ADDRESS OF ICSTOP
           MOV          DL,BYTE PTR ES:[DI]
           MOV          COL_STOP,DL     ;SAVE ICSTOP
;
           GET_PARM     6,7             ;GET ADDRESS OF SAVE OR RESTORE
           MOV          CX,ES:[DI]      ;CODE AND SAVE IN CX.
;
           GET_PARM     1,7             ;GET ADDRESS OF SAVE ARRAY
           DEC          DI
;
;              READY TO MOVE CHARACTERS TO OR FROM THE SCREEN
RESET_COL:
           MOV          DL,COL_START
           DEC          DL
SET_CUR:   MOV          AH,2            ;REQUEST SET CURSOR
           INC          DL              ;NEXT SCREEN COLUMN
           CMP          DL,COL_STOP
           JG           NEXT_ROW
           INT          10H
           INC          DI              ;NEXT CHARACTER
           CMP          CX,0            ;SAVE OR RESTORE SCREEN?
           JG           PRNT_SC         ;CX=1, RESTORE SCREEN
           MOV          AH,8            ;REQUEST READ SCREEN
           INT          10H
           MOV          BYTE PTR ES:[DI],AL
           INC          DI              ;NEXT ATTRIBUTE
           MOV          BYTE PTR ES:[DI],AH
           JMP SHORT    SET_CUR
PRNT_SC:   MOV          AH,9            ;REQUEST PRINT SCREEN
           MOV          AL,BYTE PTR ES:[DI]
           INC          DI              ;NEXT ATTRIBUTE
           MOV          BL,BYTE PTR ES:[DI]
           INT          10H             ;NOTE: CX=1
           JMP SHORT    SET_CUR
NEXT_ROW:  INC          DH
           CMP          DH,ROW_STOP
           JLE          RESET_COL
;
EXIT:      POP          DI
           MOV          SP,BP           ;DISCARD TEMPORARY VARIABLES.
           POP          BP              ;RESTORE CALLER'S BP
           RET          28              ;FAR RETURN.  RELEASE 28 BYTES
SAVRST     ENDP
SRST_TEXT  ENDS
           END
