$STORAGE:2
$NOFLOATCALLS
      SUBROUTINE SCROLL(IRSTRT,IRSTOP,ICSTRT,ICSTOP,NSCRL,ICODE)
C***  SCROLLS UP A WINDOW ON THE ACTIVE SCREEN.
C***  FORTRAN USAGE:
C***  INTEGER*2 IRSTRT,IRSTOP,ICSTRT,ICSTOP,NSCRL,ICODE
C*** ............
C*** ............
C***  CALL SCROLL(IRSTRT,IRSTOP,ICSTRT,ICSTOP,NSCRL,ICODE)
C***
C***  WHERE:
C***  IRSTRT = STARTING SCREEN ROW OF WINDOW
C***  IRSTOP = LAST SCREEN ROW OF WINDOW
C***  ICSTRT = STARTING SCREEN COLUMN OF WINDOW
C***  ICSTOP = LAST SCREEN COLUMN OF WINDOW
C***  NSCRL  = NUMBER OF LINES TO SCROLL UP WITHIN THE WINDOW
C***  ICODE  = ATTRIBUTE TO BE USED ON SCROLLED LINE (0-6)
C***  CALLER'S  TRANSLATED
C***    CODE        TO
C***     0          00H   STRING DOES NOT DISPLAY.
C***     1          07H   PRINTS NORMAL WHITE ON BLACK.
C***     2          0FH   PRINTS WHITE ON BLACK, INTENSE.
C***     3          70H   PRINTS REVERSE BLACK ON WHITE.
C***     4          87H   PRINTS NORMAL WHITE ON BLACK, BLINKING.
C***     5          8FH   PRINTS INTENSE BLACK ON WHITE, BLINKING.
C***     6         0F0H   PRINTS REVERSE BLACK ON WHITE, BLINKING.
C***
C***  NOTE:
C***  ROW NUMBERS MUST BE IN THE RANGE 0-24.
C***  COLUMN NUMBERS MUST BE IN THE RANGE 0-79.
C***  ENDING ROW NUMBER MUST NOT BE LESS THAN THE
C***  STARTING ROW NUMBER AND ENDING COLUMN NUMBER
C***  MUST NOT BE LESS THAN THE STARTING COLUMN NUMBER.
C***  NSCRL (NUMBER OF LINES TO BE SCROLLED) MUST NOT
C***  BE LARGER THAN THE WINDOW.  A VALUE OF 0 FOR
C***  NSCRL WILL CAUSE THE ENTIRE WINDOW TO SCROLL.
C***  THIS SUBROUTINE WILL NOT EXECUTE IF ANY ARGUMENTS ARE BAD
C***
C***  CODED BY W. D. GRUNDY  AUGUST  1986
C***
C***  SUBPROGRAM REQUIRED: INTR
$INCLUDE:'PCREGS.INC'
C***  CHECK FOR PROPER ARGUMENTS
      DIMENSION KODES(7)
      DATA KODES /#00,#07,#0F,#70,#87,#8F,#0F0/
      JCODE=ICODE+1
      IF(IRSTRT.GE.0.AND.IRSTOP.LE.24.AND.
     1   ICSTRT.GE.0.AND.ICSTOP.LE.79.AND.
     2   IRSTOP.GE.IRSTRT.AND.ICSTOP.GE.ICSTRT.AND.
     3   NSCRL.EQ.0.OR.NSCRL.LE.IRSTOP-IRSTRT+1.AND.
     4   JCODE.GE.1.AND.JCODE.LE.7                )
     5THEN
        AX=#0600+NSCRL
        CX=IRSTRT*#100+ICSTRT
        DX=IRSTOP*#100+ICSTOP
        BX=KODES(JCODE)*#100
        CALL INTR(#10,REGS)
      ENDIF
      RETURN
      END
