TITLE      SUBROUTINE SIZCUR(ITOP,IBOT)
;CHANGES SIZE OF CURSOR ON THE PC'S SCREEN
;
;        FORTRAN USAGE
;        INTEGER*2 ITOP, IBOT      ITOP AND IBOT RANGE FROM 0 TO 7.
;        .......                   A SQUARE CURSOR IS OBTAINED WITH
;        .......                   ITOP=2 AND IBOT=6.
;        CALL SIZCUR(ITOP,IBOT)    NORMAL CURSOR IS ITOP=6 AND IBOT=7.
;
;NOTE: THIS SUBROUTINE DOES NOT CHECK FOR PROPER LIMITS ON ITOP
;OR IBOT.  CONSEQUENTLY, STRANGE THINGS HAPPEN TO THE CURSOR IF
;THESE LIMITS ARE NOT OBSERVED.  FOR EXAMPLE, A VALUE OF ITOP
;OF -5 AND A VALUE OF IBOT OF 7 WILL CAUSE THE CURSOR TO VANISH
;FROM THE SCREEN.  THE PROGRAM DOES NOT CRASH WHEN THIS HAPPENS.
;
;CODED BY W.D. GRUNDY   MARCH 1985
;
FRAME     STRUC
SAVEBP    DW        ?              ;SAVE AREA FOR CALLER'S BP
SAVERET   DD        ?              ;SAVE AREA FOR FAR RETURN.
B         DD        ?              ;POINTER TO ITOP.
A         DD        ?              ;POINTER TO IBOT.
FRAME     ENDS
_DATA     SEGMENT   'DATA'
_DATA     ENDS
SIZ_TEXT  SEGMENT   'CODE'
DGROUP    GROUP     _DATA
          ASSUME    CS:SIZ_TEXT,DS:DGROUP,SS:DGROUP
          PUBLIC    SIZCUR
SIZCUR    PROC      FAR
          PUSH      BP                ;SAVE CALLER'S BP.
          MOV       BP,SP             ;POINT BP TO FORTRAN ARGUMENTS.
          MOV       DX,03D4H          ;POINT 6845 INDEX REGISTER TO
                                      ;CURSOR START REGISTER.
          MOV       AL,10             ;CURSOR START.
          OUT       DX,AL
          INC       DX
          LES       BX,[BP]+A         ;GET ADDRESS FOR ITOP
          MOV       AL,BYTE PTR ES:[BX]
          OUT       DX,AL
          DEC       DX
          MOV       AL,11
          OUT       DX,AL
          LES       BX,[BP]+B         ;GET ADDRESS FOR IBOT
          MOV       AL,BYTE PTR ES:[BX]
          INC       DX
          OUT       DX,AL
          MOV       SP,BP             ;RESTORE CALLER'S SP.
          POP       BP                ;RESTORE CALLER'S BP.
          RET       8                 ;FAR RETURN.  RELEASE 8 BYTES
SIZCUR    ENDP
SIZ_TEXT  ENDS
          END
