$NOFLOATCALLS
$STORAGE:2
      FUNCTION CBAR4(XMIN,XMAX,YMIN,YMAX)
C***  THIS FUNCTION COMPUTES THE VARIANCE OF A RECTANGULAR
C***  BLOCK, USING THE CAUCHY-GAUSS ALGORITHM. THE SIDES OF
C***  THE RECTANGLE MUST BE PARALLEL TO THE COORDINATE AXES.
C***  THIS FUNCTION IS ADAPTED FROM JOURNEL AND HUIJBREGTS FUNCTION F
C***  SEE MINING GEOSTATISTICS, PP. 106-108
C***  THIS SUBROUTINE WAS WRITTEN BY W.D. GRUNDY, MARCH 1981
C***  SUBPROGRAM REQUIRED: COVAR4
      DIMENSION P(4),W(4),P1(2),H(2)
      DATA P/.0571,.2768,.5836,.86025/
      DATA W/.2710,.4069,.25969,.06235/
      DATA P1/2*0./
      CBAR4=0.
      DO 20 I=1,4
      DO 20 J=1,4
      C=0.
      D1=XMAX-XMIN
      D2=YMAX-YMIN
      J1=-1
      J2=-1
      DO 10 IN=1,2
      J1=-J1
      DO 10 IM=1,2
      J2=-J2
      H(1)=J1*P(I)*D1
      H(2)=J2*P(J)*D2
      C=C+COVAR4(P1,H)
   10 CONTINUE
      CBAR4=CBAR4+W(I)*W(J)*0.25*C
   20 CONTINUE
      RETURN
      END
