Program CharConv;

{         Converts characters of an ASCII disk file from
          lower case to upper case or from upper to lower.
             Coded by W. D. Grundy, November, 1986    }


Var
  FileName1    : string[32]; {name of input disk file}
  FileName2    : string[32]; {name of output disk file}
  Ians         : char;    {user response}
  Icol         : integer;    {column number on PC's screen}
  Irow         : integer;    {row number on PC's screen}
  I            : integer;    {index of do loop}
  N            : integer;    {number of characters in a record}
  Kount        : integer;    {count of lines read}
  OK           : boolean;
  Line         : string[255];
  LogicalIn    : text;
  LogicalOut   : text;

Procedure Odometer(Icol,Irow,Kount : integer);
Begin
  GoToXY(Icol,Irow);
  Write(Kount)
End;

Begin                             {main program begins here}
  Repeat
    Write('Enter name of ASCII input file: ');
    Readln(FileName1);
    Assign(LogicalIn,FileName1);
    {$I-} Reset(LogicalIn); {$I+} {open the disk file}
    OK := IOResult = 0;
    If not OK then                  {test for successful open}
      Writeln('Unable to open File ',FileName1);
  Until OK;

  Repeat
    Write('Enter name of ASCII output file: ');
    Readln(FileName2);
    Assign(LogicalOut,FileName2);
    {$I-} Reset(LogicalOut); {$I+}
    OK := (IOResult <> 0);
    If Not OK then Writeln('Output file already exists.')
  Until OK;
  Rewrite(LogicalOut);

  Repeat
    Writeln;
    Writeln('Do you want to convert from');
    Writeln('     1) lower case to upper case, or');
    Writeln('     2) upper case to lower case?');
    Write  ('        Answer 1 or 2: ');
    Readln(Ians)
  Until (Ians = '1') or (Ians = '2');

  OK := (Ians = '1');
  Kount := 0;
  Write('        .....Converting characters');
  Icol := 1;                      {Define arguments for Odometer}
  Irow := WhereY;

  While Not Eof(LogicalIn) Do
    Begin
      Readln(LogicalIn,Line);     {read input file line-by-line}
      Kount := Kount + 1;
      If Kount Mod 100 = 0 then Odometer(Icol,Irow,Kount);
      N := Length(Line);
      For I := 1 to N Do          {examine each character in a line}
        Begin                     { and change case if necessary}
          If OK and (Line[I] >= 'a') and (Line[I] <= 'z') then
            Line[I] :=  Chr(Ord(Line[I]) - 32);
          If Not OK and (Line[I] >= 'A') and (Line[I] <= 'Z') then
            Line[I] :=  Chr(Ord(Line[I]) + 32)
        End;
      Writeln(LogicalOut,Line);
    End;

  GoToXY(Icol,Irow);              {display the final count}
  Writeln(Kount,' lines have been converted.     ');
  Close(LogicalIn);
  Close(LogicalOut)
End.                              {End of Program CharConv}
