$NOFLOATCALLS
$STORAGE:2
      PROGRAM CHARSORT
C***  ADAPTED BY W. D. GRUNDY FROM UNPUBLISHED SORTING PROGRAMS OF
C***  THE U.S. ATOMIC ENERGY COMMISSION, GRAND JUNCTION OFFICE
C***  THIS PROGRAM SORTS A CHARACTER FILE OF 3000 LINES OR LESS
C***  IN EITHER ASCENDING OR DESCENDING ORDER.  NO LINE CAN EX-
C***  CEED A LENGTH OF 254 CHARACTERS.  LINE LENGTHS NEED NOT BE
C***  UNIFORM.  THE USER CAN SELECT FROM ONE TO TEN SORT FIELDS
C***  OF VARYING WIDTHS IN ANY DESIRED SEQUENCE.  THE SUM OF THE
C***  WIDTHS OF THE SELECTED SORT FIELDS CANNOT EXCEED 48 CHAR-
C***  ACTERS.  THE SORTED RECORDS ARE WRITTEN ON A CHARACTER OUT-
C***  PUT FILE.  TRAILING BLANKS ARE STRIPPED OFF EACH RECORD.
C***
C***  AS CURRENTLY DIMENSIONED, THIS PROGRAM OCCUPIES 189092 BYTES
C***  OF RAM.  DEPENDING ON THE NUMBER OF RECORDS IN THE FILE TO BE
C***  SORTED, A HARD DISK MAY BE REQUIRED.
C***
C***  LINKS REQUIRED: ASCIIZ,C2SORT,CHRKNT,CKSAFE,CONCAT,DOSREN,FNDCUR,
C***                  FSTDSP,ODOMTR,ROSORT,SOUND,TICKER
C***
      LOGICAL FILERR,OVRLAP
      INTEGER*4 ITIME1,ITIME2
      CHARACTER*127 PCLINE(2)
      CHARACTER*32 UNIT15,UNIT16
      CHARACTER*1 LINCOL(254),COLS(48),IANS,ICHAR(32)
      CHARACTER*8 HOLD(6)
      CHARACTER*8 FIELD1,FIELD2,FIELD3,FIELD4,FIELD5,FIELD6
      EQUIVALENCE (PCLINE,LINCOL(1)),(HOLD(1),COLS(1)),(UNIT16,ICHAR(1))
      COMMON FIELD1(3000),ISTART(10),IWIDTH(10)
      COMMON /KEY2/ FIELD2(3000)
      COMMON /KEY3/ FIELD3(3000)
      COMMON /KEY4/ FIELD4(3000)
      COMMON /KEY5/ FIELD5(3000)
      COMMON /KEY6/ FIELD6(3000)
      DIMENSION IPOINT(3000)
C**********************************************************************
C***
C***  SET INITIAL VALUES OF NECESSARY VARIABLES
C***
C***  GET STARTING CLOCK TIME OF RUN
      CALL TICKER(ITIME1)
C***  KS IS SCRATCH FILE. KI IS INPUT FILE. KO IS OUTPUT FILE.
      KS=13
      KI=15
      KO=16
C***  IFLAG=1 INDICATES FIRST RUN THROUGH THIS PROGRAM
C***  IFLAG=2 INDICATES A SECOND OR LATER SORT USING A PREVIOUSLY
C***  SPECIFIED INPUT FILE.
C***  IFLAG=3 INDICATES A NEW INPUT FILE IS BEING USED
      IFLAG=1
C**********************************************************************
C***
C***  OPEN DIRECT ACCESS SCRATCH FILE.  GET NAMES OF I/O FILES.
C***
      OPEN(KS,FILE='SCRATCH',ACCESS='DIRECT',RECL=254,
     1FORM='UNFORMATTED',STATUS='NEW')
   10 WRITE(*,'(/,'' WHAT IS NAME OF THE CHARACTER INPUT FILE? ''
     1,\)')
      READ(*,20) UNIT15
   20 FORMAT(A32)
C***  CHECK IF INPUT FILE EXISTS.
      CALL CKSAFE(UNIT15,2,FILERR)
      IF (FILERR) GO TO 10
      OPEN(KI,FILE=UNIT15,STATUS='OLD',FORM='FORMATTED')
   30 WRITE(*,'('' '',''GIVE A NAME FOR THE SORTED OUTPUT FILE: '',\)')
      READ(*,20) UNIT16
C***  CHECK IF OUTPUT FILE ALREADY EXISTS.
      CALL CKSAFE(UNIT16,1,FILERR)
      IF(FILERR) GO TO 30
C***
      OPEN(KO,FILE=UNIT16,STATUS='NEW',FORM='FORMATTED')
C**********************************************************************
C***
C***  GET USER'S SPECIFICATIONS FOR THE SORT
C***
      IF(IFLAG.EQ.3) THEN
      WRITE(*,'(/,'' '',''DO YOU WANT TO KEEP THE SAME SORT'',
     1'' SPECIFICATIONS? Y/N: '',\)')
      READ(*,'(A1)') IANS
      IF(IANS.EQ.'Y'.OR.IANS.EQ.'y') GO TO 100
      ENDIF
   40 IERR=1
      WRITE(*,'('' '',''HOW MANY SORT FIELDS DO YOU WANT? (MAX=10) ''
     1,\)')
      READ(*,50,ERR=230) ISORT
   50 FORMAT(BN,I2)
      IF(ISORT.LT.1.OR.ISORT.GT.10) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' '',''ERROR**  RESPECIFY NO. OF FIELDS'')')
      GO TO 40
      ENDIF
C***  ENTER LOOP TO READ SORT FIELDS
      ITOT=0
      IERR=2
      I=0
   60 I=I+1
      IF(I.GT.ISORT) GO TO 80
   70 WRITE(*,'(5X,''ENTER STARTING CHARACTER POSITION AND NUMBER'',/,
     15X,''OF CHARACTERS IN FIELD NO. '',I2,'' (XXX,XX) : '',\)') I
      READ(*,*,ERR=230) ISTART(I),IWIDTH(I)
      IF(IWIDTH(I).LT.1) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' '',''ERROR**  FIELD WIDTH MUST BE GREATER THAN'',
     1'' ZERO.  REDO.'')')
      GO TO 70
      ENDIF
      IF(ISTART(I).LT.1.OR.(ISTART(I)+IWIDTH(I)).GT.255) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' '',''ERROR**  SPECIFIED SORT FIELD OUT OF BOUNDS.'',
     1/,'' SORT FIELDS MUST LIE WITHIN CHARACTER POSITIONS 1-254.  '',
     2''REDO.'')')
      GO TO 70
      ENDIF
      ITOT=ITOT+IWIDTH(I)
      IF(ITOT.GT.48) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' '',''ERROR**  TOO MANY CHARACTERS SPECIFIED. TOTAL''
     1,/,'' WIDTH OF FIELDS CANNOT EXCEED 48.  REDO FROM START.'')')
      GO TO 40
      ENDIF
      GO TO 60
C***  END OF LOOP TO INPUT SORT FIELD SPECIFICATIONS.
C***  CHECK FOR OVERLAPPING SORT FIELDS
   80 IF(OVRLAP(ISORT)) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' '',''ERROR**  SORTING FIELDS OVERLAP.  REDO '',
     1''FROM START.'',)')
      GO TO 40
      ENDIF
   90 IERR=3
      WRITE(*,'(/,5X,''DO YOU WANT TO SORT 1) IN ASCENDING ORDER, OR''
     1,/,5X,''2) IN DESCENDING ORDER? ANSWER 1 OR 2: '',\)')
      READ(*,50,ERR=230) IORDER
      IF(IORDER.LT.1.OR.IORDER.GT.2) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' '',''ERROR**  YOU MUST ANSWER 1 OR 2'')')
      GO TO 90
      ENDIF
C**********************************************************************
C***
C***  READ INPUT FILE AND STORE EACH RECORD ON SCRATCH FILE
C***
  100 KOUNT=0
      WRITE(*,'(/,'' '',''      READING INPUT FILE'')')
      CALL FNDCUR(IRRR,ICCC,0)
  110 READ(KI,'(2A127)',END=150) PCLINE
      KOUNT=KOUNT+1
      IF(KOUNT.GT.3000) THEN
      CALL SOUND(256,100)
      KOUNT=KOUNT-1
      WRITE(*,'('' '',''ERROR**  MORE THAN 3000 RECORDS ARE IN'',
     1'' THE INPUT FILE'',/,'' DO YOU WANT TO SORT ONLY THE FIRST'',
     2'' 3000 RECORDS? Y/N: '',\)')
      READ(*,'(A1)') IANS
      IF(IANS.EQ.'Y'.OR.IANS.EQ.'y') GO TO 160
      GO TO 220
      ENDIF
C***  WRITE RECORD TO TEMPORARY DISK FILE
      IF(IFLAG.NE.2) WRITE(KS,REC=KOUNT) PCLINE
C***  BUILD A SORT KEY FOR EACH RECORD AND STORE IN RAM
      KOLUMN=0
      DO 130 I=1,ISORT
      KSTART=ISTART(I)
      KSTOP=KSTART+IWIDTH(I)-1
      DO 120 J=KSTART,KSTOP
      KOLUMN=KOLUMN+1
      COLS(KOLUMN)=LINCOL(J)
  120 CONTINUE
  130 CONTINUE
      FIELD1(KOUNT)=HOLD(1)
      IF(ITOT.GT.8 ) FIELD2(KOUNT)=HOLD(2)
      IF(ITOT.GT.16) FIELD3(KOUNT)=HOLD(3)
      IF(ITOT.GT.24) FIELD4(KOUNT)=HOLD(4)
      IF(ITOT.GT.32) FIELD5(KOUNT)=HOLD(5)
      IF(ITOT.GT.40) FIELD6(KOUNT)=HOLD(6)
      IF(MOD(KOUNT,10).EQ.0) CALL ODOMTR(IRRR,KOUNT)
  140 FORMAT('+',I5)
C***  UPDATE POINTER TO TEMPORARY DISK FILE
      IPOINT(KOUNT)=KOUNT
      GO TO 110
C**********************************************************************
C***
C***  DETERMINE IF INPUT FILE ACTUALLY CONTAINS DATA
C***
  150 IF(KOUNT.EQ.0) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' '',''ERROR**  INPUT FILE CONTAINS NO DATA.  '',
     1''CANNOT SORT.'')')
      CLOSE(KO)
      GO TO 220
      ENDIF
C**********************************************************************
C***
C***  INPUT OF RECORDS COMPLETED, NOW SORT ARRAY OF POINTERS
C***
  160 WRITE(*,'(''+'',I5,''  RECORDS WILL BE SORTED.'')') KOUNT
      WRITE(*,'('' '',''SORTING PASS 1'')')
      CALL ROSORT(FIELD1,IPOINT,KOUNT)
      IPAS=2
      IF(ITOT.GT.40) CALL C2SORT(FIELD1,FIELD6,IPOINT,KOUNT,IPAS)
      IF(ITOT.GT.32) CALL C2SORT(FIELD1,FIELD5,IPOINT,KOUNT,IPAS)
      IF(ITOT.GT.24) CALL C2SORT(FIELD1,FIELD4,IPOINT,KOUNT,IPAS)
      IF(ITOT.GT.16) CALL C2SORT(FIELD1,FIELD3,IPOINT,KOUNT,IPAS)
      IF(ITOT.GT.8 ) CALL C2SORT(FIELD1,FIELD2,IPOINT,KOUNT,IPAS)
C**********************************************************************
C***
C***  SORTING COMPLETED,  NOW WRITE OUTPUT FILE
C***
      NP1=KOUNT+1
      REWIND KS
      WRITE(*,'('' '',''      WRITING OUTPUT FILE'')')
      CALL FNDCUR(IRRR,ICCC,0)
      DO 200 I=1,KOUNT
      K=I
C***  CHECK FOR SORT IN DESCENDING ORDER
      IF(IORDER.EQ.2) K=NP1-I
      READ(KS,REC=IPOINT(K)) PCLINE
C***  STRIP TRAILING BLANKS
      CALL CHRKNT(LINCOL,IBLANK,254)
      WRITE(KO,'(254A1)') (LINCOL(J),J=1,IBLANK)
      IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
  200 CONTINUE
      WRITE(*,140) KOUNT
      CLOSE(KO)
      WRITE(*,'('' SORTED OUTPUT IS ON FILE '',A32)') UNIT16
C**********************************************************************
C***
C***  ASK USER IF MORE SORTING IS WANTED
C***
      REWIND KS
      DO 210 I=1,5
      CALL SOUND(1000,25)
  210 CONTINUE
      WRITE(*,'(/,'' DO YOU WANT TO SORT THE PRESENT INPUT'',/,
     1'' FILE USING NEW FIELDS? Y/N: '',\)')
      READ(*,'(A1)') IANS
      IF(IANS.EQ.'Y'.OR.IANS.EQ.'y') THEN
      IFLAG=2
      REWIND KI
      GO TO 30
      ENDIF
  220 WRITE(*,'(/,'' DO YOU WANT TO SORT A DIFFERENT FILE? '',
     1''Y/N: '',\)')
      READ(*,'(A1)') IANS
      IF(IANS.EQ.'Y'.OR.IANS.EQ.'y') THEN
      IFLAG=3
      CLOSE(KI)
      GO TO 10
      ENDIF
C**********************************************************************
C***
C***  PREPARE TO EXIT FROM PROGRAM
C***
      CLOSE(KI)
      CLOSE(KS,STATUS='DELETE')
      CALL TICKER(ITIME2)
      TIME=FLOAT(ITIME2-ITIME1)/6000.
      WRITE(*,'('' '',''RUN TIME WAS '',F6.2,'' MINUTES.'')') TIME
      STOP 'NORMAL END OF PROGRAM'
C**********************************************************************
C***
C***  INFORM USER OF IMPROPER VARIABLE IN SORT SPECIFICATIONS
C***
  230 CALL SOUND(256,100)
      WRITE(*,'('' '',''ERROR**  INTEGER VALUE WAS EXPECTED.  REDO.'')
     1')
      GO TO(40,70,80), IERR
      END
      LOGICAL FUNCTION OVRLAP(ISORT)
C***
C***  THIS FUNCTION RETURNS A VALUE OF TRUE IF THE SORTING FIELDS
C***  ARE OVERLAPPED.  OTHERWISE IT RETURNS A FALSE.
C***
      CHARACTER*8 FIELD1
      COMMON FIELD1(3000),ISTART(10),IWIDTH(10)
      DIMENSION NCOUNT(254)
      DO 10 I=1,254
      NCOUNT(I)=0
   10 CONTINUE
      OVRLAP=.FALSE.
      DO 30 I=1,ISORT
      KSTART=ISTART(I)
      KSTOP=ISTART(I)+IWIDTH(I)-1
      DO 20 J=KSTART,KSTOP
      NCOUNT(J)=NCOUNT(J)+1
   20 CONTINUE
   30 CONTINUE
C***  IF FIELDS OVERLAP, AT LEAST ONE VALUE OF NCOUNT WILL BE GREATER
C***  THAN ONE.
      DO 40 I=1,254
      IF(NCOUNT(I).GT.1) THEN
      OVRLAP=.TRUE.
      GO TO 50
      ENDIF
   40 CONTINUE
   50 RETURN
      END
