$NOFLOATCALLS
$STORAGE:2
      PROGRAM CHARSRCH
C***
C***  SEARCHES EACH LINE OF A CHARACTER INPUT FILE FOR THE PRESENCE
C***  OF A USER-SPECIFIED SUBSTRING OF 127 OR FEWER CHARACTERS.
C***  EACH LINE IN THE FILE MUST BE LESS THAN 255 CHARACTERS
C***  LONG BUT LINES NEED NOT BE OF UNIFORM LENGTH.
C***  LINES CONTAINING THE SUBSTRING ARE WRITTEN ON A CHARACTER
C***  OUTPUT FILE.  THE USER MAY CHOOSE TO RETRIEVE ONLY THOSE
C***  LINES WHERE THE SUBSTRING IS FOUND OR ONLY THOSE LINES
C***  WHERE THE SUBSTRING IS NOT FOUND.  TRAILING BLANKS ARE
C***  STRIPPED FROM THE LINES.
C***  WILD CARDS ARE PERMITTED IN THE SEARCH SUBSTRING, BUT THE
C***  FIRST CHARACTER OF THE SUBSTRING MUST NOT BE WILD.  A
C***  CARAT (^) IS USED FOR THE WILD CARDS.
C***
C***  CODED BY W.D. GRUNDY     JANUARY  1985
C***
C***  LINKS REQUIRED: CKSAFE, FNDCUR, MATCH, MOVCUR, SOUND
C***
      CHARACTER*127 LINE(2),SRCH
      CHARACTER*1 WILD,SUB(127),COL(254),ANS
      CHARACTER*32 INFILE,OUTFIL
      LOGICAL FLAG,WANT
      EQUIVALENCE (SRCH,SUB(1)),(LINE,COL(1))
      DATA WILD/'^'/
C***  GET NAMES OF I/O FILES
   10 WRITE(*,'('' '')')
      WRITE(*,'(A\)') ' ENTER NAME OF CHARACTER INPUT FILE: '
      READ(*,'(A)') INFILE
      CALL CKSAFE(INFILE,2,FLAG)
      IF(FLAG) GO TO 10
   20 WRITE(*,'(A\)') ' GIVE A NAME FOR THE CHARACTER OUTPUT FILE: '
      READ(*,'(A)') OUTFIL
      CALL CKSAFE(OUTFIL,1,FLAG)
      IF(FLAG) GO TO 20
      KI=20
      KO=21
      OPEN(KI,FILE=INFILE,STATUS='OLD')
      OPEN(KO,FILE=OUTFIL,STATUS='NEW')
C***  GET USER'S SPECIFICATIONS FOR THE SEARCH
   30 WRITE(*,'('' ENTER STARTING CHARACTER POSITION IN RECORD: '',\)')
      READ(*,*,ERR=40) ISTART
      GO TO 50
   40 CALL SOUND(256,100)
      WRITE(*,'(A)') ' INTEGER VALUE WAS EXPECTED.  REDO.'
      GO TO 30
   50 IF(ISTART.LT.1.OR.ISTART.GT.254) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' STARTING POSITION MUST BE IN THE RANGE 1 TO 254'
      GO TO 30
      ENDIF
   60 WRITE(*,'(A\)') ' HOW MANY CHARACTERS ARE TO BE SEARCHED? '
      READ(*,*,ERR=70) NSRCH
      GO TO 80
   70 CALL SOUND(256,100)
      WRITE(*,'(A)') ' INTEGER VALUE WAS EXPECTED.  REDO.'
      GO TO 60
   80 IF(NSRCH.LT.1.OR.NSRCH+ISTART.GT.255) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' NUMBER ENTERED IS OUT OF POSSIBLE BOUNDS.  REDO.'
      GO TO 60
      ENDIF
   90 WRITE(*,'(A\)') ' ENTER NUMBER OF CHARACTERS IN SEARCH SUBSTRING: 
     1'
      READ(*,*,ERR=100) NSUB
      GO TO 110
  100 CALL SOUND(256,100)
      WRITE(*,'(A)') ' INTEGER VALUE WAS EXPECTED.  REDO.'
      GO TO 90
  110 IF(NSUB.LT.1.OR.NSUB.GT.NSRCH) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' NUMBER ENTERED IS OUT OF POSSIBLE BOUNDS.  REDO.'
      GO TO 90
      ENDIF
  120 WRITE(*,'('' ENTER '',I3,'' -CHARACTER SEARCH STRING'',/,
     1'' USE A CARAT (^) FOR WILD CARDS'',/,
     2'' DO NOT PUT A WILD CARD IN THE FIRST POSITION: '',\)') NSUB
      READ(*,'(A)') SRCH
      IF(SUB(1).EQ.WILD) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' WILD CARD NOT ALLOWED IN POSITION 1.'
      GO TO 120
      ENDIF
      WRITE(*,'(/,'' YOU ENTERED THE FOLLOWING SEARCH STRING:'',/,
     1'' '',80A1,/,'' '',47A1)') (SUB(I),I=1,NSUB)
      WRITE(*,'(A\)') ' IS THIS OKAY? Y/N: '
      READ(*,'(A)') ANS
      IF(ANS.EQ.'N'.OR.ANS.EQ.'n') GO TO 120
  130 WRITE(*,'('' '',''DO YOU WANT THE OUTPUT FILE TO CONTAIN:'',/,
     1'' 1) ONLY THOSE RECORDS WHERE THE SUBSTRING IS FOUND, OR'',/,
     2'' 2) ONLY THOSE RECORDS WHERE THE SUBSTRING IS NOT FOUND?'',/,
     3''    ANSWER 1 OR 2: '',\)')
      READ(*,'(A)') ANS
      IF(ANS.NE.'1'.AND.ANS.NE.'2') THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' YOU MUST ANSWER 1 OR 2'
      GO TO 130
      ENDIF
      WANT=(ANS.EQ.'1')
C***  BEGIN SEARCH
      WRITE(*,'('' '')')
      WRITE(*,'(A)') '         CURRENT LINE IN OUTPUT FILE'
      WRITE(*,'(A)') '         CURRENT LINE IN INPUT FILE'
C***  FIND CURRENT LOCATION OF CURSOR ON THE SCREEN.
      CALL FNDCUR(IROW,ICOL,0)
      KOUNTL=0
      KOUNTF=0
  140 READ(KI,'(2A127)',END=170) LINE
      KOUNTL=KOUNTL+1
      IF(MOD(KOUNTL,10).EQ.0) WRITE(*,'(''+'',I4)') KOUNTL
      FLAG=(MATCH(COL(ISTART),NSRCH,SUB,NSUB,WILD).GT.0)
      IF((FLAG.AND.WANT).OR.(.NOT.FLAG.AND..NOT.WANT)) THEN
      DO 150 I=1,254
      IBLANK=255-I
      IF(COL(IBLANK).NE.' ') GO TO 160
  150 CONTINUE
  160 WRITE(KO,'(254A1)') (COL(I),I=1,IBLANK)
      KOUNTF=KOUNTF+1
C***  MOVE CURSOR TO POSITION NEXT PRINT ON THE SCREEN.
      CALL MOVCUR(IROW-1,0,0)
      WRITE(*,'(''+'',I4)') KOUNTF
      CALL MOVCUR(IROW,0,0)
      ENDIF
      GO TO 140
  170 WRITE(*,'(''+'',I4)') KOUNTL
      WRITE(*,'('' THE OUTPUT FILE OF '',I4,'' RECORDS IS '',A32)')
     1KOUNTF,OUTFIL
      DO 180 I=1,5
      CALL SOUND(1000,25)
  180 CONTINUE
      WRITE(*,'(A\)') ' DO YOU WANT TO RERUN THIS PROGRAM? Y/N: '
      READ(*,'(A)') ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') THEN
      CLOSE(KI)
      CLOSE(KO)
      GO TO 10
      ENDIF
      STOP 'NORMAL END OF FORTRAN PROGRAM'
      END
