$NOFLOATCALLS
$STORAGE:2
      SUBROUTINE CKSAFE(UNITNO,IFLAG,FILERR)
C***
C***  CODED BY W. D. GRUNDY  JULY 1984  REVISION FEBRUARY 1985
C***
C***  THIS SUBROUTINE CHECKS FOR ILLEGAL CHARACTERS IN A PATH AND/OR
C***  FILE NAME SUBMITTED BY THE USER AND THEN TESTS FOR THE EXISTENCE
C***  OF THE FILE PRIOR TO ANY ATTEMPT AT OPENING THE FILE.
C***
C***  IF AN ILLEGAL CHARACTER IS FOUND, A MESSAGE IS PRINTED TO THE 
C***  SCREEN AND AN ERROR FLAG (LOGICAL VARIABLE FILERR) IS SET TO
C***  THE VALUE .TRUE.
C***
C***  IF A FILE EXTENSION OF MORE THAN THREE CHARACTERS IS SPECIFIED,
C***  AN ERROR MESSAGE IS WRITTEN, AND FILERR IS SET TO .TRUE.
C***
C***  NO TEST IS MADE FOR A FILE ROOT NAME EXCEEDING 8 CHARACTERS.
C***  MS-DOS 2 DOES NOT RECOGNIZE THIS AS A FATAL ERROR AND MERELY
C***  TRUNCATES OFF THE CHARACTERS IN EXCESS OF 8 IN CREATING THE 
C***  DISK FILE.
C***
C***  IF A FILE DESIGNATED FOR OUTPUT ALREADY EXISTS:
C***  THIS SUBROUTINE WILL PRINT A WARNING MESSAGE ON THE PC'S
C***  SCREEN, AND ASK THE USER IF THE FILE SHOULD BE OVERWRITTEN.
C***  IF THE USER'S RESPONSE IS NO, THIS SUBROUTINE RETURNS A VALUE
C***  OF .TRUE. FOR LOGICAL VARIABLE FILERR. IF THE RESPONSE IS YES,
C***  FILERR IS RETURNED AS .FALSE.
C***
C***  IF A FILE DESIGNATED FOR INPUT CANNOT BE FOUND:
C***  THIS SUBROUTINE WILL PRINT AN ERROR MESSAGE ON THE SCREEN AND
C***  SET THE VALUE OF FILERR TO .TRUE.
C***
C***  SUBPROGRAMS REQUIRED: ASCIIZ, CONCAT, INT21H, IOFS, ISEG, SOUND
C***
C***  INPUT AND OUTPUT VARIABLES:
C***  UNITNO   NAME OF PATH AND/OR FILE
C***  IFLAG=1  INDICATES FILE IS INTENDED FOR OUTPUT
C***  IFLAG=2  INDICATES FILE IS INTENDED FOR INPUT
C***  FILERR   LOGICAL VARIABLE SET TO TRUE IF OUTPUT
C***           FILE EXISTS OR INPUT FILE DOES NOT EXIST
C***
C***  NOTE: THE CHARACTER `\' IS CONSIDERED TO BE ILLEGAL ONLY IF
C***  IT OCCURS TWICE IN SUCCESSION IN THE PATH AS `\\', OR IF A
C***  FILE NAME IS TERMINATED BY A BACKSLASH.
C***  THIS PARTICULAR SUBROUTINE CONSIDERS LEADING BLANKS IN THE
C***  PATH/FILE NAME TO BE ILLEGAL, EVEN THOUGH DOS WILL ACCEPT THEM.
C***
      CHARACTER*32 UNITNO,TEMP,NEWNAM
      CHARACTER*80 ERRMSG
      CHARACTER*1 IANS
      LOGICAL FILCHK,FILERR
      FILERR=.FALSE.
C***  CHECK FOR ILLEGAL CHARACTERS IN PATH AND/OR FILE NAME.
      CALL LEGAL(UNITNO,FILERR)
      IF(FILERR) GO TO 20
      INQUIRE(FILE=UNITNO,EXIST=FILCHK)
      IF(FILCHK.AND.IFLAG.EQ.1) THEN
      FILERR=.TRUE.
      CALL WARN
      WRITE(ERRMSG,'(''WARNING** OUTPUT FILE '',A32)') UNITNO
      CALL CONCAT(ERRMSG,80,' ALREADY EXISTS **',18,IDUM)
      WRITE(*,'(/,'' '',A80)') ERRMSG
   10 WRITE(*,'('' '',''DO YOU WANT TO:'',/,6X,''1) OVERWRITE THE E'',
     1''XISTING FILE;'',/,6X,''2) RENAME THE EXISTING FILE TO PREVE'',
     2''NT AN OVERWRITE; OR,'',/,6X,''3) ENTER A DIFFERENT NAME FOR'',
     3'' THE OUTPUT FILE?'',/,9X,''ANSWER 1, 2, OR 3: '',\)')
      READ(*,'(A1)') IANS
      IF(IANS.LT.'1'.OR.IANS.GT.'3') THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' YOU MUST ANSWER 1, 2, OR 3'
      GO TO 10
      ENDIF
      IF(IANS.EQ.'1') THEN
      FILERR=.FALSE.
      GO TO 20
      ENDIF
      IF(IANS.EQ.'2') THEN
      TEMP=UNITNO
      CALL FILREN(TEMP,FILERR,32)
      GO TO 20
      ENDIF
      GO TO 20
      ENDIF
      IF(.NOT.FILCHK.AND.IFLAG.EQ.2) THEN
      FILERR=.TRUE.
      CALL SOUND(256,100)
      WRITE(ERRMSG,'(''ERROR** INPUT FILE '',A32)') UNITNO
      CALL CONCAT(ERRMSG,80,' WAS NOT FOUND--TRY AGAIN **',28,IDUM)
      WRITE(*,'(/,'' '',A80)') ERRMSG
      ENDIF
   20 RETURN
      END
      SUBROUTINE LEGAL(UNITNO,FILERR)
C***  THIS SUBROUTINE CHECKS FOR ILLEGAL CHARACTERS IN PATH AND/OR
C***  FILE NAME
      CHARACTER*1 UNITNO(32),ILEGAL(13),DOT,BSLASH
      LOGICAL FILERR
      DATA ILEGAL /' ','+','=','[',']','?','/','>','<','|',',','*',
     1';'/
      DATA DOT /'.'/,BSLASH /'\'/
C***  FIND NUMBER OF CHARACTERS TYPED IN BY USER
      DO 10 I=1,32
      IBLANK=33-I
      IF(UNITNO(IBLANK).NE.' ') GO TO 20
   10 CONTINUE
C***  NOW LOOK FOR ILLEGAL CHARACTERS
   20 IDOT=0
      MARK=0
      DO 50 I=1,IBLANK
      DO 40 J=1,13
      IF(UNITNO(I).EQ.ILEGAL(J)) THEN
      FILERR=.TRUE.
      CALL SOUND(256,100)
      WRITE(*,30) ILEGAL(J)
   30 FORMAT(' ','ERROR** THE PATH AND/OR FILE NAME TYPED IN CONTAINS',
     1/,' THE FOLLOWING ILLEGAL CHARACTER: `',A1,'''')
      GO TO 60
      ENDIF
   40 CONTINUE
      IF(UNITNO(I).EQ.DOT) THEN
      MARK=I
      IDOT=IDOT+1
      ENDIF
      IF(IDOT.GT.1) THEN
      FILERR=.TRUE.
      CALL SOUND(256,100)
      WRITE(*,30) DOT
      GO TO 60
      ENDIF
      IF(UNITNO(I).EQ.BSLASH) THEN
      IF(UNITNO(I).EQ.UNITNO(I+1)) THEN
      FILERR=.TRUE.
      CALL SOUND(256,100)
      WRITE(*,30) BSLASH
      GO TO 60
      ENDIF
      ENDIF
   50 CONTINUE
      IF(MARK.NE.0.AND.IBLANK-MARK.GT.3) THEN
      FILERR=.TRUE.
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' ERROR**  FILE EXTENSION EXCEEDS 3 CHARACTERS'
      GO TO 60
      ENDIF
      IF(UNITNO(IBLANK).EQ.BSLASH) THEN
      FILERR=.TRUE.
      CALL SOUND(256,100)
      WRITE(*,'('' '',''ERROR**  FILE NAME WAS TERMINATED BY A '',
     1''BACKSLASH'')')
      ENDIF
   60 RETURN
      END
      SUBROUTINE WARN
      DO 10 I=1,500,16
      CALL SOUND(500,2)
      CALL SOUND(100,3)
   10 CONTINUE
      RETURN
      END
      SUBROUTINE FILREN(OLDNAM,FILERR,N)
$INCLUDE:'PCREGS.INC'
      CHARACTER*32 OLDNAM,NEWNAM
      LOGICAL FILERR,OK
      WRITE(*,'('' '',''GIVE A NEW NAME FOR CURRENT FILE '',A32)')
     1OLDNAM
      READ(*,'(A)') NEWNAM
      CALL ASCIIZ(OLDNAM,N,LENER1)
      CALL ASCIIZ(NEWNAM,N,LENER2)
      OK=LENER1.EQ.0.AND.LENER2.EQ.0
      IF(OK)
     1THEN
C***  REQUEST DOS RENAME FUNCTION
        AX=#5600
        ES=ISEG(NEWNAM)
        DI=IOFS(NEWNAM)
        DS=ISEG(OLDNAM)
        DX=IOFS(OLDNAM)
        CALL INT21H(REGS)
      ENDIF
      FILERR=.NOT.OK.OR.MOD(FLAGS,2).NE.0
      IF(FILERR)
     1THEN
        WRITE(*,'('' FILE RENAME WAS UNSUCCESSFUL-START OVER BY '',
     1  ''NAMING OUTPUT FILE ONCE MORE.'')')
      ENDIF
      RETURN
      END
