$NOFLOATCALLS
$STORAGE:2
      SUBROUTINE CMDLIN(FILNAM,PROGRM,N,FLAG)
C***
C***  READS THE COMMAND LINE THAT THE USER HAD JUST TYPED ON THE
C***  SCREEN AND SCANS IT FOR THE PRESENCE OF ADDITIONAL TEXT AFTER
C***  THE PROGRAM NAME.  IF ADDITIONAL TEXT IS PRESENT, IT IS PLACED
C***  IN VARIABLE FILNAM, AND FLAG IS SET TO TRUE.  IF NO ADDITIONAL
C***  TEXT WAS TYPED ON THE SCREEN, OR THE ADDITIONAL TEXT REPRESENTS
C***  A DOS RESPONSE FILE, FILNAM IS RETURNED AS BLANK AND FLAG IS
C***  RETURNED AS FALSE.  THIS SUBROUTINE MUST BE INVOKED IMMEDIATELY
C***  AFTER THE USER HAS TYPED THE COMMAND LINE AND PRESSED RETURN.
C***  IF THE USER INTENDS THE ADDITIONAL TEXT TO REPRESENT A DISK
C***  FILE NAME, EXACTLY ONE SPACE MUST BE TYPED AFTER THE PROGRAM
C***  NAME, AND THE DISK FILE NAME CANNOT CONTAIN ANY ILLEGAL
C***  CHARACTERS.  IF THE ADDITIONAL TEXT REPRESENTS A RESPONSE FILE,
C***  THERE IS NO RESTRICTION ON THE NUMBER OF BLANKS BETWEEN THE
C***  PROGRAM NAME AND THE '<' CHARACTER.
C***
C***  SUBPROGRAMS REQUIRED: BYTMOV, CHGCAS, FNDCUR, INT10H, MATCH,
C***                        MOVCUR, PCHVAR, SCREAD
C***
C***  CODED BY W. D. GRUNDY   JUNE  1985
C***
      CHARACTER*1 COMAND(80)
      CHARACTER*1 PROGRM(N)
      CHARACTER*32 FILNAM
      LOGICAL FLAG
      FILNAM=' '
      FLAG=.FALSE.
      M=N+1
C***  FIND THE COMMAND LINE THAT WAS TYPED ON THE SCREEN AND READ IT.
      CALL FNDCUR(IROW,ICOL,0)
      CALL SCREAD(COMAND(1),80,IROW-1,0,0)
C***  MAKE SURE COMMAND LINE IS IN UPPER CASE.
      CALL CHGCAS(COMAND,80,1)
C***  REWRITE COMMAND LINE ON SCREEN IN INTENSE VIDEO
      CALL PCHVAR(COMAND,2,80,IROW-1,0,0)
C***  MOVE THE CURSOR TO WHERE IT WAS
      CALL MOVCUR(IROW,ICOL,0)
      I=MATCH(COMAND(1),80,PROGRM,N,' ')+M
C***  MAKE SURE COMMAND LINE DID NOT EXCEED 80 CHARACTERS
      IF(I.EQ.M) GO TO 10
C***  MAKE SURE THE LINE DOES NOT CONTAIN A RESPONSE FILE.
      J=MATCH(COMAND,80,'<',1,' ')
      IF(J.GT.0) GO TO 10
C***  CHECK FOR LEADING BLANK OR FILE NAME GREATER THAN 32 CHARACTERS
      IF(COMAND(I).EQ.' '.OR.COMAND(I+32).NE.' ') GO TO 10
      CALL BYTMOV(COMAND(I),FILNAM,32)
      FLAG=FILNAM.NE.' '
   10 RETURN
      END
