$STORAGE:2
$NOFLOATCALLS
      PROGRAM COOR
C COOR.FORTRAN PROGRAM TO CREATE VARIABLES CONTAINING LATITUDE AND
C  LONGITUDE FROM THE "LOC" ARRAY IN A STATPAC FILE.
C***  ON OPTION, PROGRAM WILL CONVERT STATPAC DECIMAL DEGREES LAT-
C***  ITUDE AND LONGITUDE INTO INTEGER DEGREES-MINUTES-SECONDS AND
C***  STORE THESE VALUES IN THE "LOC" ARRAY.
C***  NOTE: CONVERSION OF DEGREES-MINUTES-SECONDS INTO DECIMAL
C***  DEGREES ENTAILS A LOSS OF PRECISION IN THE RESULTING STATPAC
C***  VARIABLES.
C A.T. MIESCH, USGS, DENVER.
C
C***  LINKS REQUIRED: ASCIIZ, BYTMOV, CHGCAS, CHRKNT, CKSAFE, CMDLIN,
C***                  CONCAT, DOSREN, FNDCUR, FSTDSP, MATCH, MOVCUR,
C***                  ODOMTR, PACK, PCHVAR, SCREAD, SOUND, UNPK
C     PROGRAM WAS MODIFIED FOR IBM PERSONAL COMPUTER BY W. D. GRUNDY
      CHARACTER*32 UNIT10,UNIT11
      CHARACTER*16 NAME
      CHARACTER*8 ID,IVID(100),LAT,LONG
      CHARACTER*1 IA(100),IANS
      LOGICAL FLAG
      INTEGER*4 LOC(2)
      DIMENSION X(100),IPACK(20)
      DATA IA /100*' '/
      KI=10
      KO=11
      CALL CMDLIN(UNIT10,'COOR',4,FLAG)
      IF(FLAG) GO TO 20
   10 WRITE(*,'(A\)') ' ENTER NAME OF STATPAC INPUT FILE: '
      READ(*,'(A)') UNIT10
   20 CALL CKSAFE(UNIT10,2,FLAG)
      IF(FLAG) GO TO 10
   30 WRITE(*,'(A\)') ' GIVE A NAME FOR THE STATPAC OUTPUT FILE: '
      READ(*,'(A)') UNIT11
      IF(UNIT11.EQ.UNIT10) THEN
      CALL WARN
      WRITE(*,'(A)') ' STATPAC INPUT FILE CANNOT BE USED FOR OUTPUT'
      GO TO 30
      ENDIF
      CALL CKSAFE(UNIT11,1,FLAG)
      IF(FLAG) GO TO 30
      OPEN(KI,FILE=UNIT10,STATUS='OLD',FORM='UNFORMATTED')
      OPEN(KO,FILE=UNIT11,STATUS='NEW',FORM='UNFORMATTED')
      READ(KI) ID,N,M,(IVID(I),I=1,M)
   40 WRITE(*,'('' '',''DO YOU WANT TO CONVERT FROM'',/,6X,''1) '',
     1''INTEGER DEG-MIN-SEC INTO DECIMAL DEGREES (LOC TO VAR), OR'',
     2/,6X,''2) DECIMAL DEGREES INTO INTEGER DEG-MIN-SEC (VAR TO '',
     3''LOC)?'',/,9X,''ANSWER 1 OR 2: '',\)')
      READ(*,'(A)') IANS
      IF(IANS.NE.'1'.AND.IANS.NE.'2') THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' YOU MUST ANSWER 1 OR 2.'
      GO TO 40
      ENDIF
      FLAG=IANS.EQ.'1'
      MM=M
      IF(FLAG) THEN
      MM=M+2
      M1=M+1
      M2=M+2
      IVID(M1)='LAT'
      IVID(M2)='LONG'
      ENDIF
      WRITE(KO) ID,N,MM,(IVID(I),I=1,MM)
      IF(.NOT.FLAG) CALL GETCOL(M,ID,IVID,M1,M2)
      MPACK=(M+4)/5
      MMPACK=(MM+4)/5
      WRITE(*,'(A)') '       ....CONVERTING DATA'
      CALL FNDCUR(IRRR,ICCC,0)
      DO 50 II=1,N
      READ(KI) IROW,NAME,LOC,(X(J),J=1,M),(IPACK(J),J=1,MPACK)
C*********************************************************************
      IF(FLAG) THEN
C***  DEGREES-MINUTES-SECONDS INTO DECIMAL DEGREES
      CALL UNPK(IA,M,IPACK)
      CALL LL2VAR(X(M1),LOC(1))
      CALL LL2VAR(X(M2),LOC(2))
      CALL PACK(IA,MM,IPACK,MMPACK)
      ELSE
C***  DECIMAL DEGREES INTO DEGREES-MINUTES-SECONDS
      CALL VAR2LL(X(M1),LOC(1))
      CALL VAR2LL(X(M2),LOC(2))
C*********************************************************************
      ENDIF
      WRITE(KO) IROW,NAME,LOC,(X(J),J=1,MM),(IPACK(J),J=1,MMPACK)
      IF(MOD(II,10).EQ.0) CALL ODOMTR(IRRR,II)
   50 CONTINUE
      WRITE(*,'(''+'',I5)') N
      WRITE(*,60) UNIT11,N,MM
   60 FORMAT(' THE STATPAC FILE HAS BEEN WRITTEN.',/,' THE FILE NAME ',
     1'IS',1X,A32/,' N= ',I4,3X,'M= ',I3)
      STOP 'NORMAL END OF PROGRAM'
      END
      SUBROUTINE GETCOL(M,ID,IVID,M1,M2)
      CHARACTER*8 ID,IVID(1)
      CHARACTER*1 IANS
      WRITE(*,'(//,5X,''STATPAC INPUT FILE ID IS: '',A8,'' ;'',
     1''   COLUMN IDS ARE:'',/)') ID
      WRITE(*,'(5(1X,I2,'')'',A8))') (I,IVID(I),I=1,M)
      L=8*M
      CALL CHGCAS(IVID,L,1)
      I=MATCH(IVID,L,'LAT',3,IDUM)-1
      IF(I.LT.0.OR.I/8.NE.(I+3)/8) GO TO 10
      M1=I/8+1
      I=MATCH(IVID,L,'LON',3,IDUM)-1
      IF(I.LT.0.OR.I/8.NE.(I+3)/8) GO TO 10
      M2=I/8+1
      IF(M1.NE.M2) THEN
      WRITE(*,'(/,'' LATITUDE =  VARIABLE '',I3,/,
     1            '' LONGITUDE = VARIABLE '',I3,/,
     2            '' IS THIS CORRECT? Y/N: '',\)') M1,M2
      READ(*,'(A)') IANS
      IF(IANS.EQ.'Y'.OR.IANS.EQ.'y') GO TO 70
      ENDIF
   10 WRITE(*,'(/,5X,''ENTER STATPAC FILE DESCRIPTORS'',/)')
      GO TO 40
   20 CALL SOUND(256,100)
      WRITE(*,30) M
   30 FORMAT(' ','NEED AN INTEGER FROM 1 TO ',I3,'   REENTER VALUE')
   40 WRITE(*,'(5X,''ENTER COLUMN NUMBER OF THE  LATITUDE: '',\)')
      READ(*,'(BN,I3)',ERR=20) M1
      IF(M1.LE.0.OR.M1.GT.M) GO TO 20
      GO TO 60
   50 CALL SOUND(256,100)
      WRITE(*,30) M
   60 WRITE(*,'(5X,''ENTER COLUMN NUMBER OF THE LONGITUDE: '',\)')
      READ(*,'(BN,I3)',ERR=50) M2
      IF(M2.LE.0.OR.M2.GT.M) GO TO 50
      IF(M1.EQ.M2) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' SPECIFIED COLUMNS ARE NOT UNIQUE.  REDO.'
      GO TO 40
      ENDIF
   70 RETURN
      END
      SUBROUTINE VAR2LL(X,LOC)
      INTEGER*4 LOC,IDEG,IMIN,ISEC
      IDEG=IFIX(X)
      TEMP=(X-FLOAT(IDEG))*3600.
      IMIN=IFIX(TEMP/60.)
      ISEC=NINT(TEMP)-IMIN*60
      LOC=IDEG*10000+IMIN*100+ISEC
      RETURN
      END
      SUBROUTINE LL2VAR(X,LOC)
      INTEGER*4 LOC,IDD,ILL,IMM,ISS
      IDD=LOC/10000
      ILL=LOC-IDD*10000
      IMM=ILL/100
      ISS=ILL-IMM*100
      X=FLOAT(IDD)+FLOAT(IMM)/60.0+FLOAT(ISS)/3600.0
      RETURN
      END
