$NOFLOATCALLS
$STORAGE:2
      PROGRAM D0060
C     * * * * * * DISCRIMINANT ANALYSIS - U S G S STATPAC * * * * * * *
C                           PROGRAM NUMBER  D0060
C                           U S GEOLOGICAL SURVEY
C                  GEOLOGIC DIVISION, DENVER, COLORADO
C     -----------------------------------------------------------------
C    THIS PROGRAM IS USED TO PERFORM A TWO GROUP DISCRIMINANT ANALYSIS.
C    AN OPTION IS PROVIDED FOR DELETING COLUMNS IN A STEPWISE FASHION,
C    ACCORDING TO ESTIMATES OF THEIR PERCENTAGE CONTRIBUTION TO THE
C    TOTAL DISCRIMINANT.  STARTING WITH "M" COLUMNS IN THE DISCRIMNANT
C    FUNCTION, THE STEPWISE PROCEDURE REDUCES THE FUNCTION TO ONE
C    INDEPENDENT COLUMN.
C     -----------------------------------------------------------------
C***  LINKS REQUIRED: ASCIIZ, CHRKNT, CKSAFE, CONCAT, DOSREN, IOS,
C***                  MDYHMS, SOUND, TICKER
C***  RECODED FOR IBM PC BY W. D. GRUNDY   APRIL 1985
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*4 X
      INTEGER*4 LOC(2),ITIME1,ITIME2
      CHARACTER*1 A,NA,NB,BLANK,TITLEA(30),TITLEB(30),IANS
      CHARACTER*8 IVID(199),TVID(199),IVIDS,TVIDS,CIDA,CIDB
      CHARACTER*16 ROWID
      CHARACTER*32 FILE10,FILE12,FILE21
      LOGICAL FILERR,PRDPRT
      COMMON /DATA1/ AMEAN(50),BMEAN(50),SA(50,50),X(50),A(50),C(50),
     1E(50),PCT(50),ISV(50),TID(2)
      COMMON /DATA2/ SB(50,50),SC(50,50),Z1(999),Z2(999)
C
      DIMENSION D(50)
      EQUIVALENCE (C(1),D(1))
      DATA NA,NB/'A','B'/,BLANK/' '/
      CALL TICKER(ITIME1)
      ICODE=0
      INPT1=10
      INPT2=12
      IOUT=21
      IOPTB=10
   10 WRITE(*,'(A\)') ' WHAT IS NAME OF FIRST  STATPAC INPUT FILE? '
      READ(*,'(A)') FILE10
      CALL CKSAFE(FILE10,2,FILERR)
      IF(FILERR) GO TO 10
      OPEN(INPT1,FILE=FILE10,FORM='UNFORMATTED',STATUS='OLD')
   20 WRITE(*,'(A\)') ' WHAT IS NAME OF SECOND STATPAC INPUT FILE? '
      READ(*,'(A)') FILE12
      IF(FILE12.EQ.FILE10) THEN
      CALL WARN
      WRITE(*,'(A)') ' YOU MUST HAVE TWO DIFFERENT STATPAC INPUT FILES'
      GO TO 10
      ENDIF
      CALL CKSAFE(FILE12,2,FILERR)
      IF(FILERR) GO TO 20
      OPEN(INPT2,FILE=FILE12,FORM='UNFORMATTED',STATUS='OLD')
   30 WRITE(*,'(A\)') ' GIVE A NAME FOR THE CHARACTER OUTPUT FILE: '
      READ(*,'(A)') FILE21
      IF(FILE21.EQ.FILE10.OR.FILE21.EQ.FILE11) THEN
      CALL WARN
      WRITE(*,'(A)') ' AN INPUT FILE CANNOT BE USED FOR OUTPUT'
      GO TO 30
      ENDIF
      CALL CKSAFE(FILE21,1,FILERR)
      IF(FILERR) GO TO 30
      OPEN(IOUT,FILE=FILE21,FORM='FORMATTED',STATUS='NEW')
      CALL MDYHMS (IMO,IDY,IYR,IDUM,IDUM,IDUM,IDUM)
      IYR=IYR-1900
      ICODE=0
      ICODE2=0
      PRDPRT=.FALSE.
      WRITE(*,'(A\)') ' PRODUCT-CROSS-PRODUCT MATRICES WANTED? Y/N '
      READ(*,'(A)') IANS
      IF(IANS.EQ.'Y'.OR.IANS.EQ.'y') PRDPRT=.TRUE.
   40 IF(IOPTB.EQ.0) THEN
      WRITE(*,'('' DO YOU WANT TO RERUN THIS PROGRAM WITH STEPWISE '',
     1''DELETION? Y/N '',\)')
      READ(*,'(A)') IANS
      IF(IANS.NE.'Y'.AND.IANS.NE.'y') GO TO 730
      IOPTB=1
      ENDIF
      WRITE(*,'(A)') ' ENTER ALPHANUMERIC IDENTIFIER FOR FIRST DATA SET'
      READ(*,'(30A1)') TITLEA
      WRITE(*,'(A)')' ENTER ALPHANUMERIC IDENTIFIER FOR SECOND DATA SET'
      READ(*,'(30A1)') TITLEB
      IF(IOPTB.EQ.1) GO TO 50
      WRITE(*,'(A\)')' STEPWISE DELETION OF VARIABLES WANTED? Y/N: '
      READ(*,'(A)') IANS
      IOPTB=0
      IF(IANS.EQ.'Y'.OR.IANS.EQ.'y') IOPTB=1
   50 IOPTA=IOPTB
      REWIND INPT1
      REWIND INPT2
      READ(INPT1) CIDA,KNA,KMA,(TVID(I),I=1,KMA)
      READ(INPT2) CIDB,KNB,KMB,(IVID(I),I=1,KMB)
      NDF=KNA+KNB-2
      IF (IOPTB.EQ.1) NDF=1
      IF (KMA.GT.50.OR.KMB.GT.50) GO TO 710
      DO 60 I=1,KMA
      AMEAN(I)=0.D0
      BMEAN(I)=0.D0
      DO 60 J=1,KMA
      SA(I,J)=0.D0
   60 SB(I,J)=0.D0
      WRITE(*,'(A)')'          READING FIRST  STATPAC INPUT FILE'
      DO 80 K=1,KNA
      CALL JKGTLS (INPT1,IROW,ROWID,LOC,X,A,KMA,IERR)
      IF(IERR.NE.0) STOP 'UNEXPECTED END OF FILE'
      DO 70 I=1,KMA
      IF (A(I).NE.BLANK) GO TO 680
   70 AMEAN(I)=AMEAN(I)+X(I)
      IF(MOD(K,10).EQ.0) WRITE(*,'(''+'',I4)') K
   80 CONTINUE
      WRITE(*,'(''+'',I4)') KNA
      REWIND INPT1
      READ(INPT1) CIDA,KNA,KMA,(TVID(I),I=1,KMA)
      DO 90 I=1,KMA
   90 AMEAN(I)=AMEAN(I)/KNA
      WRITE(*,'(A)')'          READING FIRST  STATPAC INPUT FILE'
      DO 110 K=1,KNA
      CALL JKGTLS (INPT1,IROW,ROWID,LOC,X,A,KMA,IERR)
      IF(IERR.NE.0) STOP 'UNEXPECTED END OF FILE'
      DO 100 I=1,KMA
      DEVI=(X(I)-AMEAN(I))
      DO 100 J=1,KMA
  100 SA(I,J)=SA(I,J)+(X(J)-AMEAN(J))*DEVI
      IF(MOD(K,10).EQ.0) WRITE(*,'(''+'',I4)') K
  110 CONTINUE
      WRITE(*,'(''+'',I4)') KNA
      WRITE (IOUT,120) IMO,IDY,IYR
  120 FORMAT (' D0060 DISCRIMINANT ANALYSIS - USGS STATPAC (9/14/77)'
     1,T60,'DATE',I4,'/',I2,'/',I2//)
      WRITE(IOUT,'(//,7X,''TITLE - DATA SET '',A1,9X,''INPUT ID'',7X,
     1''N'',5X,''M'',4X,''  <<< OPTIONS >>>'',/,1X,30A1,''  -'',A8,
     2''-'',I7,I6,3X,I2,//)') NA,TITLEA,CIDA,KNA,KMA,IOPTA
      WRITE (IOUT,130) NA,(IVID(I),I=1,KMA)
  130 FORMAT (' COLUMN IDENTIFIERS - DATA SET ',A1,':',/
     1 (5(2X,A8,1X)))
      WRITE (IOUT,140) CIDA
  140 FORMAT (' MEANS FOR DATA SET ',A8/)
      WRITE (IOUT,150) (AMEAN(I),I=1,KMA)
  150 FORMAT (5(1X,1PE11.4,1X))
      IF(PRDPRT) THEN
      WRITE (IOUT,160) CIDA
  160 FORMAT (' PRODUCT CROSS-PRODUCT MATRIX FOR DATA SET ',A8/)
      DO 180 I=1,KMA
      WRITE (IOUT,170) I
  170 FORMAT (' ROW NUMBER ',I5)
      WRITE (IOUT,150) (SA(I,J),J=1,KMA)
  180 CONTINUE
      ENDIF
      WRITE(*,'(A)') '          READING SECOND STATPAC INPUT FILE'
      DO 200 K=1,KNB
      CALL JKGTLS (INPT2,IROW,ROWID,LOC,X,A,KMB,IERR)
      IF(IERR.NE.0) STOP 'UNEXPECTED END OF FILE'
      DO 190 I=1,KMB
      IF (A(I).NE.BLANK) GO TO 700
  190 BMEAN(I)=BMEAN(I)+X(I)
      IF(MOD(K,10).EQ.0) WRITE(*,'(''+'',I4)') K
  200 CONTINUE
      WRITE(*,'(''+'',I4)') KNB
      DO 210 I=1,KMB
  210 BMEAN(I)=BMEAN(I)/DBLE(FLOAT(KNB))
      REWIND INPT2
      READ(INPT2) CIDB,KNB,KMB,(IVID(I),I=1,KMB)
      WRITE(*,'(A)') '          READING SECOND STATPAC INPUT FILE'
      DO 230 K=1,KNB
      CALL JKGTLS (INPT2,IROW,ROWID,LOC,X,A,KMB,IERR)
      IF(IERR.NE.0) STOP 'UNEXPECTED END OF FILE'
      DO 220 I=1,KMB
      DEVI=X(I)-BMEAN(I)
      DO 220 J=1,KMB
  220 SB(I,J)=SB(I,J)+(X(J)-BMEAN(J))*DEVI
      IF(MOD(K,10).EQ.0) WRITE(*,'(''+'',I4)') K
  230 CONTINUE
      WRITE(*,'(''+'',I4)') KNB
      WRITE (IOUT,120) IMO,IDY,IYR
      WRITE(IOUT,'(//,7X,''TITLE - DATA SET '',A1,9X,''INPUT ID'',7X,
     1''N'',5X,''M'',4X,''  <<< OPTIONS >>>'',/,1X,30A1,''  -'',A8,
     2''-'',I7,I6,3X,I2,//)') NB,TITLEB,CIDB,KNB,KMB,IOPTB
      WRITE (IOUT,130) NB,(IVID(I),I=1,KMB)
      WRITE (IOUT,140) CIDB
      WRITE (IOUT,150) (BMEAN(I),I=1,KMB)
      IF(PRDPRT) THEN
      WRITE (IOUT,160) CIDB
      DO 240 I=1,KMB
      WRITE (IOUT,170) I
      WRITE (IOUT,150) (SB(I,J),J=1,KMB)
  240 CONTINUE
      ENDIF
      NV=KMA
      DO 250 I=1,NV
  250 ISV(I)=I
  260 IBAD=0
      DO 270 I=1,NV
      M=ISV(I)
      D(I)=(AMEAN(M)-BMEAN(M))*DBLE(FLOAT(KNA+KNB-2))
      IF (D(I).NE.0.0) IBAD=1
      E(I)=AMEAN(M)-BMEAN(M)
      DO 270 J=1,NV
      N=ISV(J)
  270 SC(I,J)=SA(M,N)+SB(M,N)
      IF ((IOPTB.EQ.1).AND.(NV.NE.KMA)) GO TO 320
      IF(PRDPRT) THEN
      WRITE (IOUT,280)
  280 FORMAT (' SUM OF PRODUCT-CROSS-PRODUCT MATRICES'/)
      DO 290 I=1,NV
      WRITE (IOUT,170) I
  290 WRITE (IOUT,150) (SC(I,J),J=1,NV)
      WRITE (IOUT,300)
  300 FORMAT(' CONSTANT VECTOR '/)
      WRITE (IOUT,150) (D(I),I=1,NV)
      ENDIF
      IF (IBAD.NE.0) GO TO 320
      WRITE (IOUT,310)
  310 FORMAT (/' ERROR...DATA SET A IDENTICAL TO(SAME AS) DATA SET B.'/
     1 ' RUN ABORTED.'///)
      WRITE(*,310)
      GO TO 740
  320 CALL MATINV(SC,NV,D,50,1,DETER)
      WRITE (IOUT,330) DETER
  330 FORMAT (' DETERMINANT OF PRODUCT-CROSS-PRODUCT MATRIX =',E14.5/)
      WRITE (IOUT,340)
  340 FORMAT (' COEFFICIENTS'/)
      DO 350 I=1,NV
  350 C(I)=C(I)/NDF
      WRITE (IOUT,150) (C(I),I=1,NV)
      IF (DETER.EQ.0) GO TO 660
      IK=1
      SUMZ1=0.D0
      SUMZ2=0.D0
      REWIND INPT1
      READ(INPT1) CIDA,KNA,KMA,(IVID(I),I=1,KMA)
      WRITE(*,'(A)') '          READING FIRST  STATPAC INPUT FILE'
      DO 370 K=1,KNA
      CALL JKGTLS (INPT1,IROW,ROWID,LOC,X,A,KMA,IERR)
      IF(IERR.NE.0) STOP 'UNEXPECTED END OF FILE'
      Z=0.D0
      DO 360 I=1,NV
      M=ISV(I)
  360 Z=Z+X(M)*C(I)
      Z1(K)=Z
      IF(MOD(K,10).EQ.0) WRITE(*,'(''+'',I4)') K
  370 SUMZ1=SUMZ1+Z
      WRITE(*,'(''+'',I4)') KNA
      REWIND INPT2
      READ(INPT2) CIDB,KNB,KMB,(IVID(I),I=1,KMB)
      WRITE(*,'(A)') '          READING SECOND STATPAC INPUT FILE'
      DO 390 K=1,KNB
      CALL JKGTLS (INPT2,IROW,ROWID,LOC,X,A,KMB,IERR)
      IF(IERR.NE.0) STOP 'UNEXPECTED END OF FILE'
      Z=0.D0
      DO 380 I=1,NV
      M=ISV(I)
  380 Z=Z+X(M)*C(I)
      Z2(K)=Z
      IF(MOD(K,10).EQ.0) WRITE(*,'(''+'',I4)') K
  390 SUMZ2=SUMZ2+Z
      WRITE(*,'(''+'',I4)') KNB
      SUMZ1=SUMZ1/DBLE(FLOAT(KNA))
      SUMZ2=SUMZ2/DBLE(FLOAT(KNB))
      CZ=(SUMZ1+SUMZ2)/2.D0
      MISS1=0
      IF (SUMZ1.LT.CZ) GO TO 410
      DO 400 I=1,KNA
  400 IF (Z1(I).LT.CZ) MISS1=MISS1+1
      GO TO 430
  410 DO 420 I=1,KNA
  420 IF (Z1(I).GT.CZ) MISS1=MISS1+1
  430 MISS2=0
      IF (SUMZ2.LT.CZ) GO TO 450
      DO 440 I=1,KNB
  440 IF (Z2(I).LT.CZ) MISS2=MISS2+1
      GO TO 470
  450 DO 460 I=1,KNB
  460 IF (Z2(I).GT.CZ) MISS2=MISS2+1
  470 WRITE (IOUT,480) CIDA
  480 FORMAT (' Z-VALUES FOR DATA SET ',A8/)
      WRITE (IOUT,490) (Z1(I),I=1,KNA)
  490 FORMAT (5(1X,F11.5,1X))
      WRITE (IOUT,500) CIDA,SUMZ1
  500 FORMAT (' AVERAGE Z FOR DATA SET ',A8,' = ',F11.5/)
      WRITE (IOUT,480) CIDB
      WRITE (IOUT,490) (Z2(I),I=1,KNB)
      WRITE (IOUT,500) CIDB,SUMZ2
      WRITE (IOUT,510) CZ
  510 FORMAT (' CRITICAL Z = ',F11.5/)
      WRITE (IOUT,520) MISS1,CIDA
  520 FORMAT (1X,I4,' MISCLASSIFIED IN DATA SET ',A8)
      WRITE (IOUT,520) MISS2,CIDB
      MISS=MISS1+MISS2
      WRITE (IOUT,530) MISS
  530 FORMAT (' TOTAL MISSCLASSIFIED =',I4)
      DSQR=0.D0
      DO 540 I=1,NV
  540 DSQR=DSQR+C(I)*E(I)*DBLE(FLOAT(NDF))
      F=DBLE(((FLOAT(KNA)*FLOAT(KNB))/(FLOAT(KNA+KNB)*FLOAT(KNA+KNB-2)
     1))*(FLOAT(KNA+KNB-NV-1)/FLOAT(NV)))*DSQR
      SUM=0.D0
      DO 550 I=1,NV
      PCT(I)=((C(I)*E(I))/DSQR)*100.D0
  550 SUM=SUM+PCT(I)
      DO 560 I=1,NV
  560 PCT(I)=100.0*PCT(I)/SUM
      WRITE (IOUT,570) DSQR
  570 FORMAT (' D SQUARE = ',F11.5/)
      I=KNA+KNB-NV-1
      WRITE (IOUT,580) F,NV,I
  580 FORMAT (' F = ',F11.5,' WITH',I4,' AND',I4,' DEGREES OF FREEDOM'/)
      WRITE (IOUT,590) (TVID(I),I=1,NV)
  590 FORMAT (/' COLUMN IDENTIFIERS',/,(5(2X,A8,3X)))
      WRITE (IOUT,600)
  600 FORMAT (' PERCENT CONTRIBUTION OF COLUMNS ARE '/)
      WRITE (IOUT,490) (PCT(I),I=1,NV)
      IF (IOPTB.EQ.0) GO TO 40
      PMIN=0.999D35
      DO 610 I=1,NV
      IF (PCT(I).GE.PMIN) GO TO 610
      L=ISV(I)
      K=I
      PMIN=PCT(I)
      TVIDS=TVID(I)
  610 CONTINUE
      N=K+1
      DO 620 I=N,NV
      M=I-1
      TVID(M)=TVID(I)
  620 ISV(M)=ISV(I)
      NV=NV-1
      IF (NV.EQ.1) GO TO 730
      WRITE (IOUT,630) L,TVIDS
  630 FORMAT (' COLUMN ',I2,'(',A8,') DROPPED')
      WRITE (IOUT,640)
  640 FORMAT (' COLUMNS REMAINING')
      WRITE (IOUT,650) (ISV(I),TVID(I),I=1,NV)
  650 FORMAT (5(1X,I3,1X,A8))
      GO TO 260
  660 WRITE (IOUT,670)
  670 FORMAT (/' ERROR...PRODUCT-CROSS-PRODUCT MATRIX SINGULAR.')
      GO TO 740
  680 WRITE (IOUT,690) IROW,CIDA
  690 FORMAT (/' QUAL CODE ENCOUNT AT ROW',I4,' IN DATA SET ',A8)
      WRITE(*,690) IROW,CIDA
      GO TO 740
  700 WRITE (IOUT,690) IROW,CIDB
      WRITE(*,690) IROW,CIDB
      GO TO 740
  710 WRITE (IOUT,720)
  720 FORMAT (' THE NO. OF INPUT COLUMNS EXCEEDS THE MAXIMUM(50 COLUMN)
     1ALLOWED BY THE PROGRAM.')
      GO TO 740
  730 WRITE(*,'('' TYPE OUT FILE '',A32,/,'' ON THE PRINTER'')') FILE21
      CALL TICKER(ITIME2)
      RTIME=FLOAT(ITIME2-ITIME1)/6000.
      WRITE(*,'('' PROGRAM ACTIVE TIME WAS '',F6.2,'' MINUTES'')')RTIME
      STOP 'NORMAL END OF PROGRAM'
C
C     -----------------------------------------------------------------
C
  740 STOP
      END
      SUBROUTINE MATINV (A,N,B,NMAX,M,DET)
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C     THIS SUBROUTINE SOLVES THE MATRIX EQUATION A X = B WHERE 'A' IS A
C     SQUARE COEFFICIENT MATRIX AND 'B' IS A MATRIX OF CONSTANT VECTORS
C           A = SQUARE COEFFICIENT MATRIX OR THE INVERSE OF 'A'
C           N = NO OF ROWS IN COEFF MATRIX 'A'
C       NMAX = MAXIMUM NUMBER OF ROWS OR COLUMNS IN DIMENSIONED IN MAIN
C                  PROGRAM
C           M = NO OF COLUMNS IN CONSTANT VECTOR
C                  IF M=0, THEN THE INVERSE OF 'A' IS COMPUTED AND NO
C                  CONSTANT VECTORS ARE ASSUMED.
C         DET = THE DETERMINANT OF THE COEFF MATRIX 'A'
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C     -----------------------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION INDEX1(50),INDEX2(50),PIVOT(50),IPIVOT(50),A(2500),
     1 B(50)
C     -----------------------------------------------------------------
C     INITIALIZATION
C     -----------------------------------------------------------------
   10 DET=1.D0
      DO 20 J=1,N
   20 IPIVOT(J)=0
      DO 220 I=1,N
C     -----------------------------------------------------------------
C     SEARCH FOR PIVOT ELEMENT
C     -----------------------------------------------------------------
      AMAX=0.D0
      DO 70 J=1,N
      IF (IPIVOT(J)-1) 30,70,30
   30 DO 60 K=1,N
      IF (IPIVOT(K)-1) 40,60,260
   40 LL=(K-1)*NMAX+J
      IF (DABS(AMAX)-DABS(A(LL))) 50,60,60
   50 IROW=J
      ICOLUM=K
      AMAX=A(LL)
   60 CONTINUE
   70 CONTINUE
      IPIVOT(ICOLUM)=IPIVOT(ICOLUM)+1
C     -----------------------------------------------------------------
C     INTERCHANGE ROWS TO PUT ELEMENT ON DIAGONAL
C     -----------------------------------------------------------------
      IF (IROW-ICOLUM) 80,120,80
   80 DET=-DET
      DO 90 L=1,N
      JCON=(L-1)*NMAX
      NROW=JCON+IROW
      NCOL=JCON+ICOLUM
      SWAP=A(NROW)
      A(NROW)=A(NCOL)
   90 A(NCOL)=SWAP
      IF (M) 120,120,100
  100 DO 110 L=1,M
      JCON=(L-1)*NMAX
      NROW=JCON+IROW
      NCOL=JCON+ICOLUM
      SWAP=B(NROW)
      B(NROW)=B(NCOL)
  110 B(NCOL)=SWAP
  120 INDEX1(I)=IROW
      INDEX2(I)=ICOLUM
      LL=(ICOLUM-1)*NMAX+ICOLUM
      PIVOT(I)=A(LL)
      IF (DET.GT.1.D30) GO TO 130
      DET=DET*PIVOT(I)
C     -----------------------------------------------------------------
C     DIVIDE PIVOT ROW BY PIVOT ELEMENT
C     -----------------------------------------------------------------
  130 A(LL)=1.D0
      DO 140 L=1,N
      NCOL=(L-1)*NMAX+ICOLUM
  140 A(NCOL)=A(NCOL)/PIVOT(I)
      IF (M) 170,170,150
  150 DO 160 L=1,M
      NCOL=(L-1)*NMAX+ICOLUM
  160 B(NCOL)=B(NCOL)/PIVOT(I)
C
C     -----------------------------------------------------------------
C     REDUCE NON-PIVOT ROWS
C     -----------------------------------------------------------------
  170 JCON=(ICOLUM-1)*NMAX
      DO 220 L1=1,N
      IF (L1-ICOLUM) 180,220,180
  180 LL=JCON+L1
      T=A(LL)
      A(LL)=0.D0
      DO 190 L=1,N
      NCON=(L-1)*NMAX
      NL1=NCON+L1
      NCOL=NCON+ICOLUM
  190 A(NL1)=A(NL1)-A(NCOL)*T
      IF (M) 220,220,200
  200 DO 210 L=1,M
      NCON=(L-1)*NMAX
      NL1=NCON+L1
      NCOL=NCON+ICOLUM
  210 B(NL1)=B(NL1)-B(NCOL)*T
  220 CONTINUE
C     -----------------------------------------------------------------
C     INTERCHANGE COLUMNS
C     -----------------------------------------------------------------
      DO 250 I=1,N
      L=N+1-I
      IF (INDEX1(L)-INDEX2(L)) 230,250,230
  230 JROW=INDEX1(L)
      JCOLUM=INDEX2(L)
      JCON=(JROW-1)*NMAX
      NCON=(JCOLUM-1)*NMAX
      DO 240 K=1,N
      NROW=JCON+K
      NCOL=NCON+K
      SWAP=A(NROW)
      A(NROW)=A(NCOL)
      A(NCOL)=SWAP
  240 CONTINUE
  250 CONTINUE
  260 RETURN
      END
