$NOFLOATCALLS
$STORAGE:2
      PROGRAM DIG2STP
C***  PROGRAM CREATES A STATPAC FILE OF LATITUDES AND LONGITUDES
C***  WITH OPTIONAL UTM COORDINATES.  INPUT TO THIS PROGRAM IS AN
C***  ASCII FILE CREATED BY J. O. KORK'S PROGRAM "JKDIGIT".
C***  THE DATE HEADER(S) OF THE ASCII INPUT FILE NEED NOT BE RE-
C***  MOVED PRIOR TO RUNNING THIS PROGRAM.
C***  THE ASCII DIGITIZED INPUT FILE MUST HAVE THE FILE EXTENSION
C***  .DIG.  THE STATPAC OUTPUT FILE WILL AUTOMATICALLY BE GIVEN THE
C***  FILE EXTENSION .STP.
C***
C***  CODED BY W.D. GRUNDY
C***  LINKS REQUIRED: ASCIIZ, BYTMOV, CHEKER, CHGCAS, CHRKNT, CKSAFE,
C***                  CMDLIN, CONCAT, DELAY, ERRMSG, FNDCUR, MATCH,
C***                  FNDCUR, MATCH, ODOMTR, PCHVAR, SAVRST, SCREAD,
C***                  SOUND
C***
      CHARACTER*80 BUFFER
      CHARACTER*32 UNIT20,UNIT11 
      CHARACTER*16 NAME
      CHARACTER*8 IVID(4),ID
      CHARACTER*4 EXT20,EXT11
      CHARACTER*1 IANS
      INTEGER*4 LOC(2),LAD,LAM,LOD,LOM
      REAL*8 Z(4),SPCM
      LOGICAL FILERR,UTM,IFLAG
      DIMENSION X(4)
      DATA ID/'LOCATION'/,IVID/'LATITUDE','LONGITUD','UTMN__Km',
     1'UTME__Km'/
      DATA EXT20/'.DIG'/,EXT11/'.STP'/,UTM/.FALSE./
      CALL CMDLIN(UNIT20,'DIG2STP',7,IFLAG)
      WRITE(*,'('' NOTE: THIS PROGRAM DOES NOT REQUIRE YOU TO '',/,
     1'' REMOVE THE DATE HEADER(S) FROM THE INPUT FILE.'',//)')
C***  KI=LOGICAL NUMBER OF FILE CREATED BY PROGRAM JKDIGIT
C***  KO=STATPAC OUTPUT FILE CONTAINING DECIMAL DEGREES LAT-LONG VALUES.
C***  KS=TEMPORARY SCRATCH FILE DELETED AT NORMAL END OF PROGRAM.
      M=2
      KI=20 
      KO=11 
      KS=14
      IF(IFLAG) GO TO 30
   10 WRITE(*,'('' ENTER ROOT NAME OF ASCII FILE OF DIGITIZED '',
     1''POINTS: '',\)')
      READ(*,20) UNIT20 
   20 FORMAT(A32) 
   30 CALL CHEKER(UNIT20,EXT20,FILERR)
      IF(FILERR) GO TO 10
      CALL CKSAFE(UNIT20,2,FILERR)
      IF(FILERR) GO TO 10
   40 WRITE(*,'('' GIVE A ROOT NAME FOR THE STATPAC OUTPUT FILE: '',\)')
      READ(*,20) UNIT11 
      CALL CHEKER(UNIT11,EXT11,FILERR)
      IF(FILERR) GO TO 40
      CALL CKSAFE(UNIT11,1,FILERR)
      IF(FILERR) GO TO 40
      OPEN(KI,FILE=UNIT20,STATUS='OLD',FORM='FORMATTED') 
      OPEN(KO,FILE=UNIT11,STATUS='NEW',FORM='UNFORMATTED') 
      OPEN(KS,FILE='SCRATCH',STATUS='NEW',FORM='UNFORMATTED')
      WRITE(*,'('' '',''DO YOU WANT UTM COORDINATES ADDED TO THE '',
     1''OUTPUT FILE? Y/N '',\)')
      READ(*,'(A)') IANS
      IF(IANS.EQ.'Y'.OR.IANS.EQ.'y') THEN
      M=4
      UTM=.TRUE.
      WRITE(*,'('' '',''UTMS WILL BE COMPUTED AS KILOMETERS NORTH '',
     1''AND EAST'')')
   50 WRITE(*,'('' '',''ENTER THE VALUE OF THE CENTRAL MERIDIAN '',
     1''IN DECIMAL DEGREES: '',\)')
      READ(*,*,IOSTAT=IERR) SPCM
      IF(IERR.NE.0) CALL ERRMSG(2,*50)
      ENDIF
      IKNT=0 
      JERR=0
      CALL FNDCUR(IRRR,ICCC,0)
C***  BEGIN LOOP
C***  READ AND COUNT EACH INPUT RECORD AND WRITE TO SCRATCH FILE.
C***  A HEADER RECORD WILL FORCE A BRANCH TO STATEMENT 90, WHERE
C***  THE USER WILL BE NOTIFIED OF ITS OCCURRENCE, AND THE PROGRAM
C***  WILL CONTINUE READING UNTIL AN END OF FILE IS ENCOUNTERED.
C***  THE USE OF AN INTERNAL FILE IS A WORK AROUND OF A V3.31
C***  COMPILER BUG WHICH DEALS WITH ERROR CHECKING AND BRANCHING.
   60 READ(KI,'(A80)',END=100) BUFFER
      READ(BUFFER,70,ERR=90) LAD,LAM,SECLA,LOD,LOM,SECLO,NAME
   70 FORMAT(BN,I3,7X,I2,8X,F8.0,2X,I3,7X,I2,8X,F8.0,1X,A16)
C***  COMBINE DEG, MIN, SEC INTO INTEGER*4 VALUES
      LOC(1)=LAD*10000+LAM*100+IFIX(SECLA+.5)
      LOC(2)=LOD*10000+LOM*100+IFIX(SECLO+.5)
C***  CREATE DECIMAL DEGREE STATPAC VARIABLES
      Z(1)=DBLE(FLOAT(LAD))+DBLE(FLOAT(LAM))/60.D0+DBLE(SECLA)/
     13600.D0
      Z(2)=DBLE(FLOAT(LOD))+DBLE(FLOAT(LOM))/60.D0+DBLE(SECLO)/
     13600.D0
      X(1)=SNGL(Z(1))
      X(2)=SNGL(Z(2))
      IF(UTM) THEN
      CALL UTMCNV(Z,SPCM)
      X(3)=SNGL(Z(3))
      X(4)=SNGL(Z(4))
      ENDIF
      IKNT=IKNT+1 
      WRITE(KS) NAME,LOC,(X(K),K=1,M)
      IF(MOD(IKNT,10).EQ.0) CALL ODOMTR(IRRR,IKNT)
      GO TO 60
   90 JERR=JERR+1
      II=JERR+IKNT
      WRITE(*,'(''+'',''          HEADER(?) AT RECORD NO. '',I4)') II
      GO TO 60
C***  END OF DATA INPUT LOOP
  100 WRITE(*,'(''+'',I5)') IKNT
      N=IKNT
      WRITE(KO) ID,N,M,(IVID(K),K=1,M)
      REWIND(KS)
      IZERO=0
      DO 110 I=1,N
      READ(KS) NAME,LOC,(X(K),K=1,M)
      WRITE(KO) I,NAME,LOC,(X(J),J=1,M),IZERO
  110 CONTINUE 
      WRITE(*,120) UNIT20,UNIT11,N,M
  120 FORMAT(' ','THE STATPAC FILE HAS BEEN WRITTEN',/, 
     1' ','THE ASCII DIGITIZED INPUT FILE WAS ',A32,/,
     2' ','THE STATPAC OUTPUT FILE IS ',A32,/,
     1' ','THE DATA SET ID IS LOCATION:  N=',I4,3X,'M='I3) 
      CLOSE(KS,STATUS='DELETE')
      IF(JERR.NE.0) WRITE(*,'('' '',I3,'' HEADER(?) RECORD(S) WAS'',
     1''/WERE ENCOUNTERED'')') JERR
      DO 130 I=1,5
      CALL SOUND(1000,25)
  130 CONTINUE
      STOP 'NORMAL END OF PROGRAM' 
      END 
      SUBROUTINE UTMCNV(Z,SPCM)
C***  CONVERTS LATITUDE AND LONGITUDE GIVEN IN DECIMAL DEGREES
C***  INTO UTM NORTH AND EAST COORDINATES IN KILOMETERS.
C***  A.T. MIESCH, U.S.G.S., DENVER, COLORADO
      REAL*8 Z(4),NORTH,EAST,SPCM
C***
      INTEGER SPZONE
      CALL TAS002(Z(1),Z(2),NORTH,EAST,SPZONE,SPCM)
C***  CONVERT FROM METERS TO KILOMETERS AND STORE IN STATPAC VARIABLES.
      Z(3)=NORTH*0.001D0
      Z(4)=EAST*0.001D0
      RETURN
      END
      DOUBLE PRECISION FUNCTION TAS005(DEG)
      IMPLICIT REAL*8 (A-H,O-Z)
      DATA C1/0.9996D0/,        C2/1.11132089365419D5/,
     1     C3/1.6216944106D4/,  C4/0.1745329252D-1/,
     2     C5/1.7209357D1/,     C6/0.022723D0/
      TAS005 = C1*(C2*DEG-C3*DSIN(DEG*C4*2.0D0)+C5*DSIN(DEG*C4*4.0D0)-
     1 C6*DSIN(6.0D0*DEG*C4)+3.2D-5*DSIN(8.0D0*DEG*C4))
      RETURN
      END
      SUBROUTINE TAS002 (SPLAT,SPLONG, NORTH, EAST,SPZONE,SPCM)
C      SUBROUTINE TAS002 IS FROM THE GEOLOGICAL SURVEY OF CANADA,
C        COURTESY OF DR. R.G. GARRETT, AUGUST 8, 1978
C
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 NORTH
      INTEGER SPZONE
C
      DATA RAD/1.745329252D-2/,ESQUAR/6.768657997291D-3/,SINSEC/4.848136
     1811D-6/,A/6.3782064D6/,DZERO/0.0D0/,D360/3.6D2/
C
C
C
      DEGLAT=DABS(SPLAT)
      SIGN = DEGLAT / SPLAT
      DEGLON = SPLONG
      DCM = SPCM
      DEGLON=DEGLON+D360
      DCM=DCM+D360
      EPRISQ=ESQUAR/(1.0D0-ESQUAR)
      DEPART=(DCM-DEGLON)*3600.0D0
      SSECSQ=SINSEC*SINSEC
      RADLAT=DEGLAT*RAD
      SINPHI=DSIN(RADLAT)
      COSPHI=DCOS(RADLAT)
      SINSQ=SINPHI*SINPHI
      COSSQ=COSPHI*COSPHI
      COSFOR=COSSQ*COSSQ
      CURVE=A/(DSQRT(1.0D0-ESQUAR*SINSQ))
      NORTH=TAS005(DEGLAT)+(CURVE*SINPHI*COSPHI*SSECSQ*DEPART**2*
     1 0.9996D0*0.5D0)
      NORTH=NORTH+((((SINSEC*DEPART)**4)*CURVE*COSPHI*COSSQ*SINPHI*
     1 0.9996D0)/24.0D0)*(5.0D0-(SINSQ/COSSQ)+
     2 9.0D0*EPRISQ*COSSQ+((2.0D0*EPRISQ*COSSQ)**2))
      EAST=((SINSEC*DEPART*CURVE*COSPHI*0.9996D0)/6.0D0)*(6.0D0+(((SINSE
     1C*DEPART)**2)*(COSSQ-SINSQ+EPRISQ*COSFOR)))+5.0D5
      IF (SIGN.LT.DZERO) NORTH=-NORTH
      RETURN
C
      END
