$NOFLOATCALLS
$STORAGE:2
      SUBROUTINE DOLITL(N,IFSKIP,IER)
C***  THIS SUBROUTINE WAS WRITTEN BY SKRIVAN AND KARLINGER
C***  MODIFIED BY  W.D. GRUNDY, JANUARY, 1980
C***  MODIFIED DOOLITTLE METHOD FOR A SYMMETRIC MATRIX.
C***  REFERENCE "INTRODUCTION TO MATRICES WITH APPLICATIONS IN
C***  STATISTICS", BY F.A. GRAYBILL.
C***  IF P IS SYMMETRIC, THEN P = S*T WHERE T = S'/D AND D IS THE
C***  DIAGONAL MATRIX FROM S.
C***  THE DECOMPOSITION COMPUTES S ONLY WHICH REPLACES P.
C***  P IS ASSUMED A LOWER TRIANGULAR MATRIX STORED BY COLUMNS.
C***  R IS THE RIGHT-HAND-SIDE KNOWN VECTOR.
C***  W IS AN WORKSPACE VECTOR IN WHICH THE SOLUTION WILL BE STORED.
C***  ID IS A POINTER VECTOR GIVING THE LOCATION OF THE DIAGONAL
C***  ELEMENTS IN P.
C***  IFSKIP = 0 FOR DECOMPOSITION, FORWARD AND BACKWARD SUBSTITUTION.
C***         = 1 FOR FORWARD AND BACKWARD SUBSTITUTION ONLY.
C***     IER = 1 IF P(1) = 0. WHEN THE ALGORITHM WILL FAIL.
C***         = 0 OTHERWISE.
      DOUBLE PRECISION SUM,P1,P2
$INCLUDE:'PTKRIG.INC'
      IER=0
      IF (P(1)) 20,10,20
   10 IER=1
      GO TO 160
   20 IF (IFSKIP) 110,30,110
C***  DECOMPOSITION TO GET LOWER TRIANGULAR S MATRIX
   30 P(1)=1./P(1)
      DO 100 J=2,N
      DO 100 I=J,N
      KS=ID(I)
      JM1=J-1
      SUM=0.
      DO 60 K=1,JM1
      JS=ID(K)
      IS=JS+I-K
      IS1=JS+J-K
      P1=P(IS)
      P2=P(IS1)
      IF (P1) 40,60,40
   40 IF (P2) 50,60,50
   50 SUM=SUM+P1*P2*P(JS)
   60 CONTINUE
      I1=ID(J)+I-J
      P(I1)=P(I1)-SUM
      IF (I-J) 100,70,100
   70 IF(P(KS)) 90,80,90
   80 IER=1
      GO TO 160
   90 P(KS)=1./P(KS)
  100 CONTINUE
C***  FORWARD SUBSTITUTION FOR SYSTEM S*W = R
  110 W(1)=R(1)*P(1)
      DO 130 I=2,N
      IS=ID(I)
      SUM=0.
      IM1=I-1
      DO 120 J=1,IM1
      JS=ID(J)+I-J
  120 SUM=SUM+W(J)*P(JS)
  130 W(I)=(R(I)-SUM)*P(IS)
C***  BACKWARD SUBSTITUTION FOR SYSTEM T*V = W
C***  WHERE V IS STORED IN W
      DO 150 I=2,N
      SUM=0.
      II=N-I+1
      JS=ID(II)
      IIP1=II+1
      DO 140 J=IIP1,N
      IIS=JS+J-II
  140 SUM=SUM+W(J)*P(IIS)
  150 W(II)=W(II)-SUM*P(JS)
  160 RETURN
      END
