$NOFLOATCALLS
$STORAGE:2
      SUBROUTINE DRFTRM(IFLAG)
C***  THIS SUBROUTINE INPUTS THE DRIFT TERMS
C***  THIS SUBROUTINE WAS WRITTEN BY W.D. GRUNDY, JANUARY, 1981
C***
C**********************************************************************
C***
C***                REMARKS ON ENTRY OF DRIFT TERMS
C***
C***  DRIFT TERMS USED IN UNIVERSAL KRIGING ARE REPRESENTED BY A SERIES
C***  OF MONOMIAL TERMS INVOLVING EXPONENTS OF THE X- AND Y-COORDINATES.
C***  FOR EXAMPLE, TO REPRESENT A LINEAR DRIFT OF THE FOLLOWING 
C***  GENERAL FORM:
C***  Z = A + B*X +C*Y
C***  THE X- AND Y- EXPONENTS OF THE CONSTANT TERM A ARE BOTH ENTERED
C***  AS 0. THE NEXT TERM HAS AN X-EXPONENT OF 1 AND A Y-EXPONENT OF 0.
C***  THE THIRD TERM HAS AN X-EXPONENT OF 0 AND A Y-EXPONENT OF 1.
C***  IN UNIVERSAL KRIGING, THERE IS NO NEED TO KNOW THE ACTUAL VALUES
C***  OF THE COEFFICIENTS A, B, AND C.
C***  THIS SUBROUTINE DOES NOT ALLOW THE ENTRY OF NEGATIVE OR NON-
C***  INTEGER EXPONENTS.   ENTRIES WITH DECIMAL POINTS WILL NOT BE
C***  ACCEPTED.
C***
C**********************************************************************
$INCLUDE:'PTKRIG.INC'
      IF(IFLAG) 10,10,55
   10 WRITE(*,20)
   20 FORMAT(//,5X,'DO YOU WANT 1) ORDINARY OR 2) ',
     1'UNIVERSAL KRIGING? ',/,20X,'ANSWER 1 OR 2 : ',\)
      CALL ERRCHK(1,IANS,DUM)
   30 FORMAT(BN,I2)
      IF(IANS.GE.1.AND.IANS.LE.2) GO TO 50
      CALL SOUND(256,100)
      WRITE(*,40)
   40 FORMAT(' YOU MUST TYPE 1 OR 2')
      GO TO 10
   50 IF(IANS.EQ.1) GO TO 200
C***  UNIVERSAL KRIGING IS WANTED
   55 WRITE(*,60)
   60 FORMAT(//,5X,'ENTER DRIFT TERM EXPONENTS')
   70 WRITE(*,80)
   80 FORMAT(5X,'ENTER NUMBER OF MONOMIALS (MAX=10) : ',\)
      CALL ERRCHK(1,NT,DUM)
      IF(NT.GE.1.AND.NT.LE.10) GO TO 100
      CALL SOUND(256,100)
      WRITE(*,90)
   90 FORMAT(' YOU MUST ENTER A NUMBER FROM 1 TO 10')
      GO TO 70
  100 WRITE(*,110)
  110 FORMAT(/,5X,'REMEMBER THAT THE X- AND Y-EXPONENTS OF THE',
     1' FIRST (CONSTANT) TERM',/,5X,'ARE BOTH ENTERED AS',
     2' ZEROES')
      I=1
  120 WRITE(*,130) I
  130 FORMAT(5X,'ENTER THE X-EXPONENT OF TERM ',I2,' : ',\)
      CALL ERRCHK(1,EX(I),DUM)
  140 WRITE(*,150) I
  150 FORMAT(5X,'ENTER THE Y-EXPONENT OF TERM ',I2,' : ',\)
      CALL ERRCHK(1,EY(I),DUM)
      IF(EX(I).GE.0.AND.EY(I).GE.0) GO TO 170
      CALL SOUND(256,100)
      WRITE(*,160)
  160 FORMAT(' ','THE EXPONENTS MUST NOT BE NEGATIVE')
      GO TO 120
  170 IF(I.GT.1) GO TO 180
      IF(EX(1).EQ.0.AND.EY(1).EQ.0) GO TO 180
      CALL SOUND(256,100)
      GO TO 100
  180 I=I+1
      IF(I-NT) 120,120,190
  190 RETURN
C***  ORDINARY KRIGING IS WANTED
  200 NT=1
      EX(1)=0
      EY(1)=0
      GO TO 190
      END
