$STORAGE:2
$NOFLOATCALLS
      SUBROUTINE DRWBOX(IRSTRT,IRSTOP,ICSTRT,ICSTOP,ICODE,IPAGE,ITYPE)
C***  DRAWS A BOX ON THE PC'S SCREEN
C***
C***  FORTRAN USAGE
C***  INTEGER*2 IRSTRT,IRSTOP,ICSTRT,ICSTOP,ICODE,IPAGE
C***  ........
C***  CALL DRWBOX(IRSTRT,IRSTOP,ICSTRT,ICSTOP,ICODE,IPAGE,ITYPE)
C***
C***  WHERE
C***  IRSTRT IS TOP SCREEN ROW NUMBER OF BOX (0-22
C***  IRSTOP IS BOTTOM SCREEN ROW NUMBER OF BOX (2-24)
C***  (IRSTOP MUST BE AT LEAST 2 GREATER THAN IRSTRT AND LESS THAN 25)
C***  ICSTRT IS LEFT HAND SCREEN COLUMN NUMBER OF BOX (0-77)
C***  ICSTOP IS RIGHT HAND SCREEN COLUMN NUMBER OF BOX (2-79)
C***  (ICSTOP MUST BE AT LEAST 2 GREATER THAN ICSTRT AND LESS THAN 80)
C***  ICODE=PC SCREEN ATTRIBUTE CODE, EXPRESSED IN DECIMAL
C***   CALLER'S  TRANSLATED
C***     CODE        TO
C***      0          00H   STRING DOES NOT DISPLAY.
C***      1          07H   PRINTS NORMAL WHITE ON BLACK.
C***      2          0FH   PRINTS WHITE ON BLACK, INTENSE.
C***      3          70H   PRINTS REVERSE BLACK ON WHITE.
C***      4          87H   PRINTS NORMAL WHITE ON BLACK, BLINKING.
C***      5          8FH   PRINTS INTENSE BLACK ON WHITE, BLINKING.
C***      6         0F0H   PRINTS REVERSE BLACK ON WHITE, BLINKING.
C***  IPAGE=ACTIVE DISPLAY PAGE (0-3) FOR MODES 2 AND 3
C***  ITYPE=1    DRAWS A THICK BOX
C***  ITYPE=2    DRAWS A THIN BOX
C***  ITYPE=3    DRAWS THICK SIDES, THIN TOP AND BOTTOM
C***  ITYPE=4    DRAWS THIN SIDES, THICK TOP AND BOTTOM
C***
C***  SUBROUTINE WILL NOT EXECUTE IF ANY ARGUMENT IS BAD
C***
C***  CODED BY W. D. GRUNDY  AUGUST  1986
C***  
C***  SUBPROGRAM REQUIRED: INTR
$INCLUDE:'PCREGS.INC'
      DIMENSION KODE(7)
      DIMENSION IULC(4),IHORIZ(4),IURC(4),ISIDES(4),ILLC(4),ILRC(4)
      DATA KODE /#00,#07,#0F,#70,#87,#8F,#F0/
      DATA IULC(1),IHORIZ(1),IURC(1),ISIDES(1),ILLC(1),ILRC(1)
     1/     201,    205,       187,   186,      200,    188   /
      DATA IULC(2),IHORIZ(2),IURC(2),ISIDES(2),ILLC(2),ILRC(2)
     1/     218,    196,       191,   179,      192,    217   /
      DATA IULC(3),IHORIZ(3),IURC(3),ISIDES(3),ILLC(3),ILRC(3)
     1/     214,    196,       183,   186,      211,    189   /
      DATA IULC(4),IHORIZ(4),IURC(4),ISIDES(4),ILLC(4),ILRC(4)
     1/     213,    205,       184,   179,      212,    190   /
      JCODE=ICODE+1
C***  TEST FOR VALID ARGUMENTS
      IF(IRSTRT.GE.0.AND.IRSTRT.LE.22.AND.
     1   IRSTOP.GE.IRSTRT+2.AND.IRSTOP.LT.25.AND.
     2   ICSTRT.GE.0.AND.ICSTRT.LE.77.AND.
     3   ICSTOP.GE.ICSTRT+2.AND.ICSTOP.LT.80.AND.
     4   JCODE.GE.1.AND.JCODE.LE.7.AND.
     5   IPAGE.GE.0.AND.IPAGE.LE.3.AND.
     6   ITYPE.GE.1.AND.ITYPE.LE.4              )
     7THEN
      IWIDTH=ICSTOP-ICSTRT+1
      IHEIGT=IRSTOP-IRSTRT+1
C***  DRAW TOP OF BOX STARTING WITH UPPER LEFT CORNER AND ENDING
C***  AT UPPER RIGHT.
      CALL GOTOXY(IRSTRT,ICSTRT)
C***  NOTE: CONTENTS OF BX WILL NOT CHANGE FOR DURATION OF SUBROUTINE.
      BX=IPAGE*#100+KODE(JCODE)
      CX=#0001
      AX=#0900+IULC(ITYPE)
      CALL INTR(#10,REGS)
      DO 10 I=1,IWIDTH-2
      CALL GOTOXY(IRSTRT,ICSTRT+I)
      AX=#0900+IHORIZ(ITYPE)
      CALL INTR(#10,REGS)
   10 CONTINUE
      CALL GOTOXY(IRSTRT,ICSTOP)
      AX=#0900+IURC(ITYPE)
      CALL INTR(#10,REGS)
C***  DRAW SIDES OF BOX
      DO 20 I=1,IHEIGT-2
      CALL GOTOXY(IRSTRT+I,ICSTRT)
      AX=#0900+ISIDES(ITYPE)
      CALL INTR(#10,REGS)
      CALL GOTOXY(IRSTRT+I,ICSTOP)
      AX=#0900+ISIDES(ITYPE)
      CALL INTR(#10,REGS)
   20 CONTINUE
C***  NOW DRAW BOTTOM OF BOX, STARTING AT LOWER LEFT CORNER AND
C***  ENDING AT LOWER RIGHT.
      CALL GOTOXY(IRSTOP,ICSTRT)
      AX=#0900+ILLC(ITYPE)
      CALL INTR(#10,REGS)
      DO 30 I=1,IWIDTH-2
      CALL GOTOXY(IRSTOP,ICSTRT+I)
      AX=#0900+IHORIZ(ITYPE)
      CALL INTR(#10,REGS)
   30 CONTINUE
      CALL GOTOXY(IRSTOP,ICSTOP)
      AX=#0900+ILRC(ITYPE)
      CALL INTR(#10,REGS)
      ENDIF
      RETURN
      END
      SUBROUTINE GOTOXY(IROW,ICOL)
$INCLUDE:'PCREGS.INC'
      DX=IROW*#100+ICOL
      AX=#0200
      CALL INTR(#10,REGS)
      RETURN
      END
