$STORAGE:2
      PROGRAM DUPFINDR
C***  THIS PROGRAM LISTS THE ROW NUMBER AND PRIMARY ID OF DATA POINTS
C***  IN A STATPAC FILE THAT ARE WITHIN A SPECIFIED DISTANCE
C***  OF ONE ANOTHER.  THE PROGRAM REQUESTS THIS DISTANCE FROM
C***  THE USER AT RUN TIME.  IF SAMPLE POINTS SHARING IDENTICAL
C***  LOCATIONS ARE WANTED, THE DISTANCE SPECIFIED IS GIVEN BY
C***  RESPONDING WITH A VALUE OF 0.
C***  LINKS REQUIRED: IOS,FSORT,SOUND,TICKER
C***  THIS PROGRAM WAS WRITTEN BY W. D. GRUNDY, MARCH, 1984
C***
      INTEGER*4 LOC(2)
      INTEGER*4 ITIME1,ITIME2
      CHARACTER*14 FILE10,FILE21
      CHARACTER*8 TEMP,IHOLID(3000)
      CHARACTER*4 IDS(2),NAME(4),IVID(2,99)
      CHARACTER*1 IA(99)
      DIMENSION XE(3000),YN(3000),X(99),IPOINT(3000)
      EQUIVALENCE (TEMP,NAME(1))
C***  INITIATE TIMING OF PROGRAM RUN
      CALL TICKER(ITIME1)
C***  KI IS INPUT UNIT; KO IS OUTPUT UNIT
      KI=10
      KO=21
C***  INITIALIZE COUNT OF DUPLICATES
      IDUP=0
C***  GET NAMES OF INPUT/OUTPUT FILES
      WRITE(*,10)
   10 FORMAT(' WHAT IS NAME OF STATPAC INPUT FILE? ',\)
      READ(*,20) FILE10
   20 FORMAT(A14)
      OPEN(KI,FILE=FILE10,STATUS='OLD',FORM='UNFORMATTED')
      WRITE(*,30)
   30 FORMAT(' GIVE A NAME FOR THE CHARACTER OUTPUT FILE: ',\)
      READ(*,20) FILE21
      OPEN(KO,FILE=FILE21,STATUS='NEW',FORM='FORMATTED')
C***  READ STATPAC HEADER RECORD
      READ(KI) IDS,N,M,(IVID(1,I),IVID(2,I),I=1,M)
      IF(N.LT.2) STOP 'NOT ENOUGH ROWS - MINIMUM IS 2'
      IF(M.LT.2) STOP 'NOT ENOUGH COLUMNS - MINIMIM IS 2'
      IF(N.GT.3000) STOP 'TOO MANY ROWS - LIMIT IS 3000'
      IF(M.GT.99) STOP 'TOO MANY COLUMNS - LIMIT IS 99'
      WRITE(*,40) IDS
   40 FORMAT(' ',//,5X,'STATPAC INPUT FILE ID IS: ',2A4,
     1' ;   COLUMN ID''S ARE:',/)
      WRITE(*,50) (IVID(1,I),IVID(2,I),I=1,M)
   50 FORMAT(5(2X,2A4))
      WRITE(*,60)
   60 FORMAT(/,5X,'ENTER STATPAC FILE DESCRIPTORS',/)
      WRITE(*,70)
   70 FORMAT(5X,'WHAT IS COLUMN NUMBER OF THE NORTH COORDINATE? ',\)
      READ(*,80) INORTH
   80 FORMAT(BN,I2)
      WRITE(*,90)
   90 FORMAT(5X,'WHAT IS COLUMN NUMBER OF THE  EAST COORDINATE? ',\)
      READ(*,80) IEAST
      WRITE(*,100)
  100 FORMAT(/,5X,'ENTER MAXIMUM ALLOWABLE DISTANCE BETWEEN PAIRS: ',\)
      READ(*,110) DMAX
  110 FORMAT(BN,F10.0)
      DMAX2=DMAX*DMAX
      WRITE(*,120)
  120 FORMAT(//,' NOW READING STATPAC INPUT FILE',/)
      DO 140 I=1,N
      CALL JKGTLS(KI,IROW,NAME,LOC,X,IA,M,IER)
      IF(IER.NE.0) STOP 'UNEXPECTED END OF FILE'
      XE(I)=X(IEAST)
      YN(I)=X(INORTH)
      IHOLID(I)=TEMP
      IPOINT(I)=I
      IF(I/10*10.EQ.I) WRITE(*,130) I
  130 FORMAT('+',I4)
  140 CONTINUE
      WRITE(*,130) N
C***  WRITE HEADER FOR CHARACTER OUTPUT FILE
      WRITE(KO,150) FILE10
  150 FORMAT(6X,'RECORD OF DUPLICATED COORDINATES IN FILE ',A14,//,
     11X,'PRIMARY-ID  ROW-NUMBER  MATCHES  PRIMARY-ID  ROW-NUMBER',
     2'  DISTANCE APART',/)
C***  NOW SORT ON THE Y-COORDINATE
      WRITE(*,160)
  160 FORMAT(' NOW SORTING ARRAY OF POINTERS BY NORTH-COORDINATE')
      CALL FSORT(YN,IPOINT,N)
C***  NOW LOOP TO SEARCH FOR MATCHED COORDINATES
      WRITE(*,170)
  170 FORMAT(' NOW SEARCHING FOR DUPLICATES',/)
      NM1=N-1
      DO 210 I=1,NM1
      IP1=I+1
      DO 190 J=IP1,N
      YD=ABS(YN(IPOINT(I))-YN(IPOINT(J)))
      IF(YD.GT.DMAX) GO TO 200
      XD=ABS(XE(IPOINT(I))-XE(IPOINT(J)))
      IF(XD.GT.DMAX) GO TO 190
      DISQ=XD*XD+YD*YD
      IF(DISQ.GT.DMAX2) GO TO 190
      IDUP=IDUP+1
      DIS=SQRT(DISQ)
      WRITE(KO,180) IHOLID(IPOINT(I)),IPOINT(I),IHOLID(IPOINT(J)),
     1IPOINT(J),DIS
  180 FORMAT(1X,A8,4X,I4,17X,A8,4X,I4,8X,E13.6)
  190 CONTINUE
  200 WRITE(*,130) I
  210 CONTINUE
      WRITE(*,130) N
      IF(IDUP.EQ.0) THEN
      WRITE(*,220)
      WRITE(KO,220)
  220 FORMAT(' NO DUPLICATED LOCATIONS WERE FOUND')
      ELSE
      WRITE(*,230) IDUP,FILE21
  230 FORMAT(' ',I4,' DUPLICATES WERE FOUND.  EXAMINE OUTPUT FILE ',A14
     1,' AND RESOLVE',/,' THE DUPLICATES.  THEN REMOVE UNWANTED ROWS '
     2,'FROM THE STATPAC FILE WITH PRO-',/,' GRAMS DLROWS OR ROWIDRET')
      ENDIF
      DO 240 I=1,5
      CALL SOUND(1000,25)
  240 CONTINUE
      CALL TICKER(ITIME2)
      TIME=FLOAT(ITIME2-ITIME1)/6000.
      WRITE(*,250) TIME
  250 FORMAT(' ','RUN TIME WAS ',F6.2,' MINUTES')
      STOP 'NORMAL END OF PROGRAM'
      END
