$STORAGE:2
      SUBROUTINE EIGEN (A,R,N,MV)
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C        THIS ROUTINE IS USED TO COMPUTE EIGENVALUES AND EIGENVECTORS.
C     DIAGONALIZATION METHOD ORIGINATED BY JACOBI AND ADAPTED BY VON
C     NEUMANN IS USED IN THIS ROUTINE.
C     WHERE   A = ORIGINAL MATRIX(SYMMETRIC).  RESULTANT EIGENVALUES ARE
C                  DEVELOPED IN DIAGONAL OF MATRIX A IN DESCENDING ORDER
C             R = RESULTANT MATRIX OF EIGENVECTORS
C             N = ORDER OF MATRICES A AND R
C     FROM U. S. GEOLOGICAL SURVEY PROGRAM D0096, BY D.S. HANDWERKER
C     * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
C     THIS SUBROUTINE IS CALLED BY THE FOLLOWING DRIVERS-
C        1. MAIN
C     ------------------------------------------------------------------
C DIMENSIONS IN NEXT STATEMENT ARE SET FOR 37 VARIABLES!!!
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION A(703), R(1369)
      IF (MV-1) 100,130,100
  100 IQ=-N
      DO 120 J=1,N
      IQ=IQ+N
      DO 120 I=1,N
      IJ=IQ+I
      R(IJ)=0.0
      IF (I-J) 120,110,120
  110 R(IJ)=1.0
  120 CONTINUE
  130 ANORM=0.0
      DO 150 I=1,N
      DO 150 J=I,N
      IF (I-J) 140,150,140
  140 IA=I+(J*J-J)/2
      ANORM=ANORM+A(IA)*A(IA)
  150 CONTINUE
      IF (ANORM) 410,410,160
  160 ANORM=1.414*DSQRT(ANORM)
      ANRMX=ANORM*1.0E-6/FLOAT(N)
      IND=0
      THR=ANORM
  170 THR=THR/FLOAT(N)
  180 L=1
  190 M=L+1
  200 MQ=(M*M-M)/2
      LQ=(L*L-L)/2
      LM=L+MQ
      IF (DABS(A(LM))-THR) 340,210,210
  210 IND=1
      LL=L+LQ
      MM=M+MQ
      X=0.5*(A(LL)-A(MM))
      Y=-A(LM)/DSQRT(A(LM)*A(LM)+X*X)
      IF (X) 220,230,230
  220 Y=-Y
  230 SINX=Y/DSQRT(2.0*(1.0+(DSQRT(1.0-Y*Y))))
      SINX2=SINX*SINX
      COSX=DSQRT(1.0-SINX2)
      COSX2=COSX*COSX
      SINCS=SINX*COSX
      ILQ=N*(L-1)
      IMQ=N*(M-1)
      DO 330 I=1,N
      IQ=(I*I-I)/2
      IF (I-L) 240,310,240
  240 IF (I-M) 250,310,260
  250 IM=I+MQ
      GO TO 270
  260 IM=M+IQ
  270 IF (I-L) 280,290,290
  280 IL=I+LQ
      GO TO 300
  290 IL=L+IQ
  300 X=A(IL)*COSX-A(IM)*SINX
      A(IM)=A(IL)*SINX+A(IM)*COSX
      A(IL)=X
  310 IF (MV-1) 320,330,320
  320 ILR=ILQ+I
      IMR=IMQ+I
      X=R(ILR)*COSX-R(IMR)*SINX
      R(IMR)=R(ILR)*SINX+R(IMR)*COSX
      R(ILR)=X
  330 CONTINUE
      X=2.0*A(LM)*SINCS
      Y=A(LL)*COSX2+A(MM)*SINX2-X
      X=A(LL)*SINX2+A(MM)*COSX2+X
      A(LM)=(A(LL)-A(MM))*SINCS+A(LM)*(COSX2-SINX2)
      A(LL)=Y
      A(MM)=X
  340 IF (M-N) 350,360,350
  350 M=M+1
      GO TO 200
  360 IF (L-(N-1)) 370,380,370
  370 L=L+1
      GO TO 190
  380 IF (IND-1) 400,390,400
  390 IND=0
      GO TO 180
  400 IF (THR-ANRMX) 410,410,170
  410 IQ=-N
      DO 450 I=1,N
      IQ=IQ+N
      LL=I+(I*I-I)/2
      JQ=N*(I-2)
      DO 450 J=I,N
      JQ=JQ+N
      MM=J+(J*J-J)/2
      IF (A(LL)-A(MM)) 420,450,450
  420 X=A(LL)
      A(LL)=A(MM)
      A(MM)=X
      IF (MV-1) 430,450,430
  430 DO 440 K=1,N
      ILR=IQ+K
      IMR=JQ+K
      X=R(ILR)
      R(ILR)=R(IMR)
  440 R(IMR)=X
  450 CONTINUE
      RETURN
      END
