$STORAGE:2
$NOFLOATCALLS
C -----------------------------------------------------------------------
C GXFIXX.FOR PROGRAM TO ADJUST VARIABLE LOWER AND UPPER LIMITS
C IN GEOCHEMICAL DATA.  FOR EXAMPLE, LOWER LIMITS OF, SAY,
C <10 AND <20 FOR, SAY, CU, PROHIBIT ANY MEANINGFUL STATISTICAL
C ANALYSIS OF THIS VARIABLE.  GXFIXX ADJUSTS ALL THE CU DATA TO
C ONE CUTOFF.  THE CUTOFFS CONSIDERED IN THIS CASE WILL BE
C 10, 20, AND THE LOWEST CU VALUE PRESENT IN THE DATA.  THE
C LOWER LIMIT SELECTED WILL BE THE ONE THAT REQUIRES FEWEST
C CHANGES IN THE DATA.  IF, SAY, THE VALUE OF 20 IS SELECTED,
C THEN ALL VALUES LESS THAN 20 WILL BE CHANGED TO <20.  VALUES
C OF <X, WHERE X IS A NUMBER LARGER THAN 20, WILL BE CHANGED TO
C BLANKS (0.0B IN STATPAC TERMINOLOGY).  GXFIXX WILL CAUSE SOME
C DATA TO BE DISCARDED IN THIS MANNER, BUT THIS IS THE ONLY WAY
C TO MAKE THE REST OF THE DATA USEABLE FOR ANY KIND OF STATISTICAL
C ANALUSIS.
C A.T. MIESCH, USGS, GRAND JUNCTION, COLO.  1983
C ***  MODIFIED BY W. D. GRUNDY, MARCH 1987, FOR "BULLET-PROOFING",
C ***  RENUMBERING, AND STRUCTURING.
C ***  LINKS REQUIRED: ASCIIZ, BYTMOV, CHGCAS, CHRKNT, CKSAFE, CMDLIN,
C ***                  CONCAT, FNDCUR, FSTDSP, INT21H, INTR, IOFS, ISEG,
C ***                  MATCH, MOVCUR, ODOMTR, PACK, PCHVAR, SCREAD,
C ***                  SOUND, UNPK
C ***
C -----------------------------------------------------------------------
      CHARACTER*8 ROWID(2)
      CHARACTER*4 ID(2),IVID(100,2),ID1
      CHARACTER*1 IA(100),IX(1300,10),IN,IL,IT,IB,IH,IG,IBL,IY,JY
      CHARACTER*6 PROGRM
      CHARACTER*32 UNIT10,UNIT11
      LOGICAL FLAG
      INTEGER*4 LOC(2)
      DIMENSION X(100),PLL(1300),PUL(1300),FLL(100),FUL(100),
     *IIGS(10),IGS(100),IPACK(20)
      COMMON/X111/ XX(1300,10)
      DATA IN/'N'/,IL/'L'/,IT/'T'/,IB/'B'/,IH/'H'/,IG/'G'/
      DATA IBL/' '/,ID1/'FIXX'/
      DATA IY/'Y'/,JY/'y'/
      DATA PROGRM /'GXFIXX'/
      KI=10
      KO=11
      KS=12
      CALL CMDLIN(UNIT10,PROGRM,6,FLAG)
      IF(FLAG) GO TO 20
   10 WRITE(*,'(A\)') ' ENTER NAME OF THE STATPAC INPUT FILE: '
      READ(*,'(A)') UNIT10
   20 CALL CKSAFE(UNIT10,2,FLAG)
      IF(FLAG) GO TO 10
   30 WRITE(*,'(A\)') ' GIVE A NAME FOR THE STATPAC OUTPUT FILE: '
      READ(*,'(A)') UNIT11
      CALL CKSAFE(UNIT11,1,FLAG)
      IF(FLAG) GO TO 30
      OPEN(KI,FILE=UNIT10,STATUS='OLD',FORM='UNFORMATTED')
      OPEN(KO,FILE=UNIT11,STATUS='NEW',FORM='UNFORMATTED')
      OPEN(KS,FILE='SCRATCH',STATUS='NEW',FORM='UNFORMATTED')
      READ(KI) ID,N,M,(IVID(I,1),IVID(I,2),I=1,M)
      NPACK=(M+4)/5
      IF(N.GT.1300.OR.M.GT.100)
     1STOP 'PROGRAM IS LIMITED TO 1300 SAMPLES AND 100 VARIABLES'
      WRITE(*,40) ID,N,M
   40 FORMAT(' THE INPUT DATA FILE HAS ID=',2A4,3X,'N=',I4,2X,'M=',I2)
   50 WRITE(*,390) (I,IVID(I,1),IVID(I,2),I=1,M)
   60 WRITE(*,'(A)') '     ....READING DATA'
      CALL FNDCUR(IRRR,ICCC,0)
         DO 70 I=1,N
         IF(MOD(I,25).EQ.0) CALL ODOMTR(IRRR,I)
         READ(KI) IROW,ROWID,LOC,(X(K),K=1,M),(IPACK(K),K=1,NPACK)
         CALL UNPK(IA,M,IPACK)
         WRITE(KS) ROWID,LOC,(X(J),J=1,M),(IA(J),J=1,M)
   70    CONTINUE
      WRITE(*,'(''+'',I5)') N
      REWIND KS
      NT=(M-1)/10+1
      IS=-9
      IE=0
      JJJ=0
      KKK=0
         DO 80 I=1,M
   80    IGS(I)=0
C
         DO 270 II=1,NT
         IS=IS+10
         IE=IE+10
         IF(IE.GT.M) IE=M
         INN=IE-IS+1
            DO 90 I=1,INN
   90       IIGS(I)=0
         WRITE(*,100) IS,IE
  100    FORMAT(' WORKING ON VARIABLES',I3,' TO',I3)
            DO 120 I=1,N
            READ(KS) ROWID,LOC,(X(J),J=1,M),(IA(J),J=1,M)
            JJ=IS-1
               DO 120 J=1,INN
               JJ=JJ+1
               XX(I,J)=X(JJ)
               IX(I,J)=IBL
               IF(IA(JJ).NE.IG) GO TO 110
               IX(I,J)=IG
               IIGS(J)=1
               GO TO 120
  110          IF(IA(JJ).EQ.IL.OR.IA(JJ).EQ.IN.OR.IA(JJ).EQ.IT)
     1         IX(I,J)=IL
               IF(IA(JJ).EQ.IB.OR.IA(JJ).EQ.IH) IX(I,J)=IB
  120          CONTINUE
         REWIND KS
C -----------------------------------------------------------------------
C LOOKING FOR LOWER LIMITS
C -----------------------------------------------------------------------
            DO 190 I=1,INN
            KNT=0
            NLL=0
            XMIN=1.0E30
               DO 160 J=1,N
               IF(IX(J,I).NE.IBL) GO TO 130
               IF(XX(J,I).LT.XMIN) XMIN=XX(J,I)
               GO TO 160
  130          IF(IX(J,I).NE.IL) GO TO 160
               IF(NLL.NE.0) GO TO 140
               NLL=1
               PLL(1)=XX(J,I)
               GO TO 160
  140             DO 150 K=1,NLL
                  IF(XX(J,I).NE.PLL(K)) GO TO 150
                  GO TO 160
  150             CONTINUE
               NLL=NLL+1
               PLL(NLL)=XX(J,I)
  160          CONTINUE
            NLL=NLL+1
            PLL(NLL)=XMIN
            KNTMIN=32767
               DO 180 J=1,NLL
               IF(PLL(J).LT.0.000001.AND.NLL.GT.1) GO TO 180
               KNTL=0
               KNTB=0
                  DO 170 K=1,N
                  IF(IX(K,I).EQ.IB.OR.IX(K,I).EQ.IG) GO TO 170
                  IF(XX(K,I).EQ.PLL(J)) GO TO 170
                  IF(XX(K,I).LT.PLL(J).AND.IX(K,I).EQ.IBL) KNTL=KNTL+1
                  IF(XX(K,I).GT.PLL(J).AND.IX(K,I).EQ.IL) KNTB=KNTB+2
  170             CONTINUE
               KNTC=KNTL+KNTB
               IF(KNTC.GE.KNTMIN) GO TO 180
               KNTMIN=KNTC
               JSAVE=J
  180          CONTINUE
            JJJ=JJJ+1
            IF(IIGS(I).EQ.1) IGS(JJJ)=1
            FLL(JJJ)=PLL(JSAVE)
  190       CONTINUE
C -----------------------------------------------------------------------
C LOOKING FOR UPPER LIMITS
C -----------------------------------------------------------------------
            DO 260 I=1,INN
            KNT=0
            NUL=0
            XMAX=-1.0E30
               DO 230 J=1,N
               IF(IX(J,I).NE.IBL) GO TO 200
               IF(XX(J,I).GT.XMAX) XMAX=XX(J,I)
               GO TO 230
  200          IF(IX(J,I).NE.IG) GO TO 230
               IF(XX(J,I).LT.0.000001) XX(J,I)=100000.0
               IF(NUL.NE.0) GO TO 210
               NUL=1
               PUL(1)=XX(J,I)
               GO TO 230
  210             DO 220 K=1,NUL
                  IF(XX(J,I).NE.PUL(K)) GO TO 220
                  GO TO 230
  220             CONTINUE
               NUL=NUL+1
               PUL(NUL)=XX(J,I)
  230          CONTINUE
            NUL=NUL+1
            PUL(NUL)=XMAX
            KNTMIN=32767
               DO 250 J=1,NUL
               KNTG=0
               KNTB=0
                  DO 240 K=1,N
                  IF(IX(K,I).EQ.IL) GO TO 240
                  IF(XX(K,I).EQ.PUL(J)) GO TO 240
                  IF(XX(K,I).GT.PUL(J).AND.IX(K,I).EQ.IBL) KNTG=KNTG+1
                  IF(XX(K,I).LT.PUL(J).AND.IX(K,I).EQ.IG) KNTB=KNTB+2
  240             CONTINUE
               KNTC=KNTG+KNTB
               IF(KNTC.GE.KNTMIN) GO TO 250
               KNTMIN=KNTC
               JSAVE=J
  250          CONTINUE
            KKK=KKK+1
            FUL(KKK)=PUL(JSAVE)
  260       CONTINUE
  270    CONTINUE
C -----------------------------------------------------------------------
C CORRECTING THE DATA AND WRITING THE OUTPUT FILE
C -----------------------------------------------------------------------
      WRITE(KO) ID1,ID1,N,M,(IVID(I,1),IVID(I,2),I=1,M)
      WRITE(*,'(A)') '     ....WRITING THE REVISED DATA'
      CALL FNDCUR(IRRR,ICCC,0)
         DO 360 II=1,N
         IF(MOD(II,25).EQ.0) CALL ODOMTR(IRRR,II)
         READ(KS) ROWID,LOC,(X(I),I=1,M),(IA(I),I=1,M)
            DO 350 I=1,M
            IF(FUL(I).GT.FLL(I)) GO TO 280
            IF(IGS(I).EQ.0) GO TO 280
            IF(IA(I).EQ.IBL) GO TO 350
            IA(I)=IB
            X(I)=0.0
            GO TO 350
  280       IF(IA(I).NE.IBL) GO TO 300
            IF(X(I).GE.FLL(I)) GO TO 290
            X(I)=FLL(I)
            IA(I)=IL
            GO TO 350
  290       IF(X(I).LE.FUL(I)) GO TO 350
            X(I)=FUL(I)
            IA(I)=IG
            GO TO 350
  300       IF(IA(I).NE.IN.AND.IA(I).NE.IL.AND.IA(I).NE.IT) GO TO 320
            IF(X(I).LE.FLL(I)) GO TO 310
            X(I)=0.0
            IA(I)=IB
            GO TO 350
  310       X(I)=FLL(I)
            IA(I)=IL
            GO TO 350
  320       IF(IA(I).NE.IG) GO TO 340
            IF(X(I).GE.FUL(I)) GO TO 330
            X(I)=0.0
            IA(I)=IB
            GO TO 350
  330       X(I)=FUL(I)
            IA(I)=IG
            GO TO 350
  340       X(I)=0.0
            IA(I)=IB
  350       CONTINUE
         CALL PACK(IA,M,IPACK,NPACK)
         WRITE(KO) II,ROWID,LOC,(X(K),K=1,M),(IPACK(K),K=1,NPACK)
  360    CONTINUE
      WRITE(*,'(''+'',I5)') N
         DO 380 I=1,M
         IF(FUL(I).LT.-1.0E29.OR.FLL(I).GT.1.0E29) GO TO 370
         IF(FUL(I).GT.FLL(I)) GO TO 380
         IF(IGS(I).EQ.0) GO TO 380
  370    FUL(I)=1.0E30
         FLL(I)=1.0E30
  380    CONTINUE
C
      WRITE(*,390) (I,IVID(I,1),IVID(I,2),I=1,M)
  390 FORMAT(//,(5(1X,I2,')',1X,2A4)))
      WRITE(*,400)
  400 FORMAT(' SELECTED UPPER LIMITS')
      WRITE(*,410) (FUL(I),I=1,M)
  410 FORMAT(5F14.2)
      WRITE(*,420)
  420 FORMAT(1X)
      WRITE(*,430)
  430 FORMAT(' SELECTED LOWER LIMITS')
      WRITE(*,410) (FLL(I),I=1,M)
      WRITE(*,420)
      WRITE(*,420)
      WRITE(*,440) ID1,ID1,N,M
  440 FORMAT(' THE STATPAC OUTPUT FILE HAS ID=',2A4,3X,'N=',I4,' M=',I2)
      CLOSE(KS,STATUS='DELETE')
      STOP 'NORMAL END OF PROGRAM'
      END

