TITLE     SUBROUTINE INT21H(REGS)
; INVOKES INTERRUPT 21H USING THE SERVICE REQUESTS STORED IN REGS
; EMULATES TURBOPASCAL FUNCTION "MSDOS(REGS)" TO OBTAIN DOS
; SERVICES FROM FORTRAN PROGRAMS.
;
; CODED BY W. D. GRUNDY  AUGUST 1986
;
;C***  INCLUDE FILE FOR FORTRAN ROUTINES WHICH CALL DOS OR BIOS SERVICES
;      COMMON /RGSTRS/ AX,BX,CX,DX,BP,SI,DI,DS,ES,FLAGS
;      INTEGER*4 AX,BX,CX,DX,BP,SI,DI,DS,ES,FLAGS
;      EQUIVALENCE (AX,REGS)
;C***  END OF INCLUDE FILE PCREGS.INC
;
; SAMPLE FORTRAN CALL FOLLOWS   {ROUTINE GETS THE TIME FROM DOS}
;      AX=#2C00                 {DOS GET TIME FUNCTION}
;      CALL INT21H(REGS)        {INVOKES DOS INTERRUPT 21H}
;      IHOUR=IREGHI(CX)         {TIME IN HOURS (MILITARY)}
;      MIN  =IREGLO(CX)         {TIME IN MINUTES}
;      ISEC =IREGHI(DX)         {TIME IN SECONDS}
;      IHSEC=IREGLO(DX)         {TIME IN HUNDREDTHS OF A SECOND}
;      ..........
; NOTE: IREGHI AND IREGLO ARE INTEGER*4 FUNCTIONS CODED IN FORTRAN
; AND WHICH MIMIC THE HI AND LO FUNCTIONS OF TURBO PASCAL.
; OTHER SUBPROGRAMS WHICH MIGHT BE USED ALONG WITH INT21H ARE:
;       ISEG==> MIMICS TURBOPASCAL FUNCTION SEG (GET SEGMENT ADDRESS
;               OF A VARIABLE).
;       IOFS==> MIMICS TURBOPASCAL FUNCTION OFS (GET OFFSET ADDRESS
;               OF A VARIABLE).
;       ASCIIZ> CONVERT A FORTRAN CHARACTER VARIABLE INTO AN ASCII "Z"
;               STRING.
;
FRAME          STRUC
SAVEBP         DW              ?
SAVERET        DD              ?
REGS           DD              ?            ;POINTS TO REGISTERS
FRAME          ENDS
;
_DATA          SEGMENT         WORD PUBLIC 'DATA'
_DATA          ENDS
;
MSDO_TEXT      SEGMENT         BYTE PUBLIC 'CODE'
DGROUP         GROUP           _DATA
               ASSUME          CS:MSDO_TEXT,DS:DGROUP,SS:DGROUP
               PUBLIC          INT21H
INT21H         PROC            FAR
               PUSH            BP
               MOV             BP,SP
               PUSH            DS               ; DS, DI, AND SI
               PUSH            DI               ; REGISTERS WILL BE
               PUSH            SI               ; CHANGED.
               LES             BX,[BP][REGS]    ; GET ADDRESS OF REGS
               MOV             AX,ES:[BX]       ; LOAD THE REGISTERS
               MOV             CX,ES:[BX]+8     ; WITH VALUES SUPPLIED
               MOV             DX,ES:[BX]+12    ; BY THE CALLING PROGRAM
               MOV             SI,ES:[BX]+20
               MOV             DI,ES:[BX]+24
               MOV             DS,ES:[BX]+28
               MOV             BX,ES:[BX]+4
               PUSH            BX
               LES             BX,[BP][REGS]
               MOV             ES,ES:[BX]+32
               POP             BX
               INT             21H              ; INVOKE DOS INTERRUPT
               PUSH            ES               ; NEED ES AND BX REGS
               PUSH            BX               ; TO RETURN VALUES.
;
; RETURN VALUES TO CALLING PROGRAM REGISTER-BY-REGISTER
;
               LES             BX,[BP][REGS]
               MOV             ES:[BX],AX       ; AX RETURNED
               POP             AX
               MOV             ES:[BX]+4,AX     ; BX
               MOV             ES:[BX]+8,CX
               MOV             ES:[BX]+12,DX
               MOV             ES:[BX]+16,BP
               MOV             ES:[BX]+20,SI
               MOV             ES:[BX]+24,DI
               MOV             ES:[BX]+28,DS
               POP             AX
               MOV             ES:[BX]+32,AX    ; ES
               PUSHF
               POP             AX
               MOV             ES:[BX]+36,AX    ; FLAGS
               POP             SI
               POP             DI
               POP             DS
               POP             BP
               RET             4
INT21H         ENDP
MSDO_TEXT      ENDS
               END
