$NOFLOATCALLS
$STORAGE:2 
      SUBROUTINE JKGTLS(IUNIT,IR,CHRID,LOC,X,CHIA,M,IERR) 
C***
C***  IBM PERSONAL COMPUTER VERSION
C***  REPLACES SUBROUTINES PUTLST AND GETLST FROM MULTICS.
C***  THIS MODULE WAS WRITTEN BY J. O. KORK, USGS, DENVER AND
C***  MODIFIED AND COMMENTED BY W. D. GRUNDY.
C***  REVISED BY W. D. GRUNDY APRIL  1985
C***
C***  NOTE: THE STATPAC FILES CREATED BY THESE SUBPROGRAMS ARE NOT
C***  COMPATIBLE WITH STATPAC FILES CREATED BY THE ORIGINAL
C***  SUBROUTINES PUTLST AND GETLST, BECAUSE OF DIFFERING WAYS
C***  IN WHICH THE QUALIFYING CODES ARE PACKED.
C***
C***  THIS ROUTINE READS ONE STATPAC RECORD AND UNPACKS THE QUALIFY-
C***  ING CODES.
C***
C***  ARGUMENTS
C***   IUNIT  - INPUT UNIT NO.
C***   IR     - SEQUENCE NUMBER OF THE ROW.
C***   CHRID  - 4-WORD ALPHAMERIC ROW IDENTIFIER AS 2 PARTS
C***            WORDS 1&2- PRIMARY ROW ID
C***                  3&4- SECONDARY ROW ID
C***   LOC    - LATITUDE AND LONGITUDE FOUR-BYTE INTEGERS
C***            OF DEGREES, MINUTES, AND SECONDS.
C***   X      - ARRAY OF DATA VALUES.
C***   CHIA   - ARRAY OF ONE-CHARACTER ALPHABETIC QUALIFYING
C***            CODES.
C***   M      - NUMBER OF STATPAC DATA COLUMNS IN THE DATA SET.
C***   IERR   - NON-ZERO RETURN FLAGS UNEXPECTED END OF FILE.
C***
C***  THIS PROGRAM IS INTENDED FOR COMPILATION WITH MS
C***  FORTRAN V3.1
C***  IF THE PROGRAM IS TO BE COMPILED WITH IBM PERSONAL
C***  COMPUTER FORTRAN COMPILER V1.00, THE DATA STATEMENTS
C***  MUST BE REWRITTEN.
C***
C***       CONTENTS
C***      NO. NAME       DESCRIPTION
C***       1. JKGTLS   - READS A STATPAC RECORD FROM A FILE
C***       2. JKGET    - (USED BY GETLST)
C***       3. JKPACK   - (USED BY JKPTLS)
C***       4. JKPTLS   - WRITES ONE STATPAC RECORD INTO A FILE
C***       5. JKPUT    - (USED BY JKPTLS)
C***       6. JKUNPK   - (USED BY JKGTLS)
C***
      INTEGER*4 LOC 
      DIMENSION LOC(2),X(M),IY(99)
      CHARACTER*4 CHRID(4) 
      CHARACTER*1 CHIA(M) 
      IERR=0 
      N=(M+4)/5 
      CALL JKGET(IUNIT,IR,CHRID,LOC,X,M,IY,N,IEND,IERR) 
      CALL JKUNPK(CHIA,M,IY,N) 
      IF(IEND.EQ.1) IERR=1 
      RETURN 
      END 
      SUBROUTINE JKGET(IUNIT,IR,CHRID,LOC,X,M,IY,N,IEND,IERR) 
C***
C***  THIS ROUTINE READS ONE STATPAC RECORD WITH THE QUALIFYING
C***  CODES PACKED.
C***
      INTEGER*4 LOC 
      DIMENSION LOC(2),X(M),IY(99) 
      CHARACTER*4 CHRID(4) 
      IEND=0 
      READ(IUNIT,END=10)IR,CHRID,(LOC(I),I=1,2),(X(I),I=1,M), 
     1  (IY(I),I=1,N) 
      GO TO 20 
   10 IEND=1 
   20 RETURN 
      END 
      SUBROUTINE JKPACK(CHIA,M,IY,N) 
C***
C***  REVISED APRIL 1985 BY W. D. GRUNDY TO CHANGE ILLEGAL QUALIFYING
C***  CODES TO ASTERISKS.
C***
C***
C***  THIS ROUTINE PACKS 5 QUALIFYING CODES INTO 1
C***  TWO-BYTE WORD, OCCUPYING AS MANY AS NECESSARY TO
C***  PACK M CODES.
C***     CHIA  - ARRAY OF UNPACKED CODES
C***     M     - NUMBER OF CODES CONTAINED IN ARRAY CHIA
C***     IY    - ARRAY OF PACKED CODES (N WORDS OF 5 CODES PER WORD)
C***     N     - NUMBER OF WORDS IN ARRAY IY CONTAINING PACKED CODES
C***
      DIMENSION IY(99) 
      CHARACTER*1 CHIA(M),IC(8)
      DATA IC/' ','B','L','N','G','T','H','*'/
      N=(M+4)/5 
      DO 20 I=1,M 
      DO 10 J=1,8
      IF(CHIA(I).EQ.IC(J)) GO TO 20 
      IF(CHIA(I).EQ.CHAR(ICHAR(IC(J))+32)) THEN
      CHIA(I)=IC(J)
      GO TO 20
      ENDIF
   10 CONTINUE 
      CHIA(I)=IC(8) 
   20 CONTINUE 
      N1=5 
      DO 60 I=1,N 
      IY(I)=0 
      IF(I.NE.N) GO TO 30 
      N1=5*(1-N)+M 
   30 DO 50 J=1,N1 
      KX=0 
      DO 40 K=1,8 
      IF(CHIA(5*(I-1)+J).NE.IC(K)) GO TO 40 
      KX=K 
   40 CONTINUE 
      IY(I)=8*IY(I)+KX-1 
   50 CONTINUE 
   60 CONTINUE 
      RETURN 
      END 
      SUBROUTINE JKPTLS(IUNIT,IR,CHRID,LOC,X,CHIA,M) 
C***
C***  THIS ROUTINE PACKS THE QUALIFYING CODES AND WRITES THE ONE
C***  STATPAC RECORD.
C***
      INTEGER*4 LOC 
      DIMENSION LOC(2),X(M),IY(99) 
      CHARACTER*4 CHRID(4) 
      CHARACTER*1 CHIA(M) 
      CALL JKPACK(CHIA,M,IY,N) 
      CALL JKPUT(IUNIT,IR,CHRID,LOC,X,M,IY,N) 
      RETURN 
      END 
      SUBROUTINE JKPUT(IUNIT,IR,CHRID,LOC,X,M,IY,N) 
C***
C***  THIS ROUTINE WRITES ONE STATPAC RECORD WITH THE QUALIFYING
C***  CODES PACKED.
C***
      INTEGER*4 LOC 
      DIMENSION X(M),IY(99),LOC(2) 
      CHARACTER*4 CHRID(4) 
      WRITE(IUNIT)IR,CHRID,(LOC(I),I=1,2),(X(I),I=1,M),(IY(I),I=1,N) 
      RETURN 
      END 
      SUBROUTINE JKUNPK(CHIA,M,IY,N) 
C***
C***  THIS ROUTINE UNPACKS THE QUALIFYING CODES
C***  CONTAINED IN ARRAY IY INTO ARRAY CHIA.
C***  ARGUMENTS THE SAME AS IN SUBROUTINE JKPACK.
C***
      DIMENSION IY(99) 
      CHARACTER*1 CHIA(M),IC(8) 
      DATA IC/' ','B','L','N','G','T','H','*'/
      DO 30 I=1,N 
      N1=5 
      IF(I.NE.N) GO TO 10 
      N1=5*(1-N)+M 
   10 DO 20 J=1,N1 
      KX=MOD(IY(I),8)+1 
      CHIA(5*(I-1)+(N1+1-J))=IC(KX) 
      IY(I)=IY(I)/8 
   20 CONTINUE 
   30 CONTINUE 
      RETURN 
      END 
