$STORAGE:2
      PROGRAM LISTER
C -----------------------------------------------------------------------
C ***  PRINTS A DISK ASCII FILE ONTO THE PRINTER.
C ***  AFTER 55 LINES HAVE BEEN LISTED, A PAGE EJECT OCCURS, AND PRINTING
C ***  IS RESUMED NEAR THE TOP OF THE NEXT PAGE.  IF A TILDA SYMBOL "~"
C ***  IS PRESENT IN COLUMN 1 OF ANY LINE, A PAGE EJECT WILL OCCUR AT
C ***  THIS LINE.  THIS CAN BE USED TO PREVENT TABLES FROM BEING BROKEN
C ***  UP DURING PRINTING.  THE LINE CONTAINING THE TILDA WILL NOT
C ***  BE PRINTED.  A TILDA AT THE END OF ANY LINE OF TEXT WILL ALSO
C ***  EJECT A PAGE, BUT ONLY AFTER THAT PARTICULAR LINE IS PRINTED.
C ***
C ***  MAXIMUM LINE LENGTH MUST NOT EXCEED 132 CHARACTERS.  THE PROGRAM
C ***  HAS OPTIONS TO PRINT IN ONE OF FOUR MODES: COMPRESSED, EXPANDED,
C ***  EMPHASIZED, OR DOUBLE-STRIKE.  THE PROGRAM REQUIRES AN EPSON
C ***  OR IBM COMPATIBLE DOT-MATRIX PRINTER.
C ***
C ***  CODED BY W.D. GRUNDY  JUNE  1987
C ***  COMPILE INSTRUCTIONS FOR MICROSOFT FORTRAN VERSION 4.0
C ***  FL /FPi87 /c lister.for
C ***  link lister /exepack,,nul,c:\lib\statpac4+c:\lib\llibfor7
C ***  NOTE: OBJECT FILES FOR GCLPSP, CKSAFE, CHRKNT, AND KPRESS ARE
C ***  CONTAINED IN LIBRARY STATPAC4.LIB.
C ***
C -----------------------------------------------------------------------
      CHARACTER*1 CMP(4),EXP(4),EMP(4),DBL(4),COLS(132),TILDA,ANSWER
      CHARACTER*1 CMPOFF(4),EXPOFF(4),EMPOFF(4),DBLOFF(4),BLANKS(10),
     1TAIL(33)
      INTEGER ICMP(4),IEXP(4),IEMP(4),IDBL(4)
      INTEGER ICMPOF(4),IEXPOF(4),IEMPOF(4),IDBLOF(4)
      CHARACTER*32 INPUT
      CHARACTER*66 LINE(2)
      LOGICAL FILERR,FLAG,ICMPRS,IEXPND,IEMPH,IDBLE,IMARGN,PAGENO
      EQUIVALENCE (COLS,LINE), (INPUT,TAIL(2))
      DATA TAIL/33*' '/
      DATA
     1ICMP /15,255,0,0/
     2IEXP /27,87,1,255/
     3IEMP /27,69,255,0/
     4IDBL /27,71,255,0/
      DATA
     1ICMPOF /18,255,14,0/
     2IEXPOF /27,87,0,255/
     3IEMPOF /27,70,255,0/
     4IDBLOF /27,72,255,0/
      DATA ICMPRS, IEXPND, IEMPH, IDBLE /4*.FALSE./
      DATA TILDA /'~'/, BLANKS /10*' '/
      CALL GCLPSP(KOUNT,TAIL)
      CALL FNDCUR(IRRR,ICCC,0)
      CALL CHGATR(79,2,IRRR-1,0,0)
      CALL MOVCUR(IRRR,ICCC,0)
      IF(INPUT.NE.' ') GO TO 20
   10 WRITE(*,'(A\)') ' ENTER NAME OF THE ASCII INPUT FILE: '
      READ(*,'(A)') INPUT
   20 CALL CKSAFE(INPUT,2,FILERR)
      IF(FILERR) GO TO 10
      WRITE(*,'(/,'' BE SURE THE DOT-MATRIX PRINTER IS TURNED ON'')')
      OPEN(10,FILE=INPUT,STATUS='OLD')
      OPEN(11,FILE='PRN',STATUS='NEW')
C ---------------------------------------------------------------------
C***  CREATE ASCII PRINTER CONTROL CODES
C ---------------------------------------------------------------------
      DO 30 I=1,4
      CMP(I)=CHAR(ICMP(I))
      EXP(I)=CHAR(IEXP(I))
      EMP(I)=CHAR(IEMP(I))
      DBL(I)=CHAR(IDBL(I))
      CMPOFF(I)=CHAR(ICMPOF(I))
      EXPOFF(I)=CHAR(IEXPOF(I))
      EMPOFF(I)=CHAR(IEMPOF(I))
      DBLOFF(I)=CHAR(IDBLOF(I))
   30 CONTINUE
C ---------------------------------------------------------------------
C***  RESET THE PRINTER TO DEFAULT STATE
C ---------------------------------------------------------------------
      WRITE(11,40) CMPOFF
      WRITE(11,40) EXPOFF
      WRITE(11,40) EMPOFF
      WRITE(11,40) DBLOFF
   40 FORMAT(' ',4A1)
C ---------------------------------------------------------------------
C***  GET USER'S PRINTOUT SPECIFICATIONS
C ---------------------------------------------------------------------
      WRITE(*,'(A\)') ' DO YOU WANT THE PAGES NUMBERED? Y/N: '
      READ(*,'(A)') ANSWER
      PAGENO=ANSWER.EQ.'Y'.OR.ANSWER.EQ.'y'
   50 WRITE(*,'(A\)') ' DO YOU WANT TO SET A LEFT MARGIN? Y/N: '
      READ(*,'(A)') ANSWER
      IMARGN=ANSWER.EQ.'Y'.OR.ANSWER.EQ.'y'
      IF(IMARGN) THEN
      WRITE(*,'(A\)') ' ENTER NUMBER OF SPACES FOR MARGIN (1-10): '
      CALL ERRCHK(1,MARGIN,DUMMY)
      IF(MARGIN.LE.0.OR.MARGIN.GT.10) THEN
      CALL WARN
      WRITE(*,'(A)') ' YOU MUST ENTER A NUMBER FROM 1 TO 10'
      GO TO 50
      ENDIF
      MARGIN=MARGIN-1
      ENDIF
      WRITE(*,'(A\)') ' DO YOU WANT PRINTING IN COMPRESSED MODE? Y/N: '
      READ(*,'(A)') ANSWER
      ICMPRS=ANSWER.EQ.'Y'.OR.ANSWER.EQ.'y'
      IF(.NOT.ICMPRS) THEN
      WRITE(*,'(A\)') ' DO YOU WANT PRINTING IN EXPANDED MODE? Y/N: '
      READ(*,'(A)') ANSWER
      IEXPND=ANSWER.EQ.'Y'.OR.ANSWER.EQ.'y'
      ENDIF
      IF(.NOT.ICMPRS.AND..NOT.IEXPND) THEN
      WRITE(*,'(A\)') ' DO YOU WANT EMPHASIZED PRINTING? Y/N: '
      READ(*,'(A)') ANSWER
      IEMPH=ANSWER.EQ.'Y'.OR.ANSWER.EQ.'y'
      ENDIF
      IF(.NOT.ICMPRS.AND..NOT.IEXPND.AND..NOT.IEMPH) THEN
      WRITE(*,'(A\)') ' DO YOU WANT DOUBLE-STRIKE PRINTING? Y/N: '
      READ(*,'(A)') ANSWER
      IDBLE=ANSWER.EQ.'Y'.OR.ANSWER.EQ.'y'
      ENDIF
C ---------------------------------------------------------------------
C***  SET UP PRINTER WITH USER'S SPECS
C ---------------------------------------------------------------------
      IF(ICMPRS) WRITE(11,40) CMP
      IF(IEXPND) WRITE(11,40) EXP
      IF(IEMPH ) WRITE(11,40) EMP
      IF(IDBLE ) WRITE(11,40) DBL
C***
      WRITE(11,'(''1'')')
      IPAGE=0
C ---------------------------------------------------------------------
C***  NOW LOOP TO PRINT THE FILE
C ---------------------------------------------------------------------
   60 IPRNT = 0
   70 READ(10,'(2A66)',END=80) LINE
      IPRNT=IPRNT+1
      IF(COLS(1).EQ.TILDA) THEN
      CALL PAGE(IPAGE,IPRNT,ICMPRS,IEXPND,PAGENO)
      GO TO 60
      ENDIF
      CALL CHRKNT(COLS,KOUNT,132)
      IF(COLS(KOUNT).EQ.TILDA) THEN
      IF(IMARGN) THEN
      WRITE(11,'('' '',132A1)') (BLANKS(J),J=1,MARGIN),(COLS(I),I=
     11,KOUNT-1)
      ELSE
      WRITE(11,'('' '',132A1)') (COLS(I),I=1,KOUNT-1)
      ENDIF
      CALL PAGE(IPAGE,IPRNT,ICMPRS,IEXPND,PAGENO)
      GO TO 60
      ENDIF
      IF(IMARGN) THEN
      WRITE(11,'('' '',132A1)') (BLANKS(J),J=1,MARGIN),(COLS(I),I=
     11,KOUNT)
      ELSE
      WRITE(11,'('' '',132A1)') (COLS(I),I=1,KOUNT)
      ENDIF
      IF(IPRNT.EQ.55) THEN
      CALL PAGE(IPAGE,IPRNT,ICMPRS,IEXPND,PAGENO)
      GO TO 60
      ENDIF
      GO TO 70
   80 CALL PAGE(IPAGE,IPRNT,ICMPRS,IEXPND,PAGENO)
C ---------------------------------------------------------------------
C***  THROUGH PRINTING; RESET PRINTER TO DEFAULT STATE
C ---------------------------------------------------------------------
      WRITE(11,40) CMPOFF
      WRITE(11,40) EXPOFF
      WRITE(11,40) EMPOFF
      WRITE(11,40) DBLOFF
      STOP 'NORMAL END OF PROGRAM'
      END
      SUBROUTINE PAGE(IPAGE,IPRNT,ICMPRS,IEXPND,PAGENO)
      LOGICAL ICMPRS,IEXPND,PAGENO
      IPAGE=IPAGE+1
      IF(PAGENO) THEN
      DO 10 I=IPRNT+1,57
      WRITE(11,'('' '')')
   10 CONTINUE
      IF(ICMPRS) WRITE(11,'('' '',58X,I3)') IPAGE
      IF(IEXPND) THEN
      WRITE(11,'('' '',18X,I3)') IPAGE
      ELSE
      WRITE(11,'('' '',38X,I3)') IPAGE
      ENDIF
      ENDIF
      WRITE(11,'(''1'')')
      RETURN
      END
