$STORAGE:2
$NOFLOATCALLS
      PROGRAM SS2DCONT
C***  CREATES A CONTOUR MAP OF A KRIGED VARIABLE OR OF THE KRIGING
C***  VARIANCE ON THE PC'S SCREEN.  THE INPUT FILE TO THIS PROGRAM
C***  MUST BE A GRIDDED STATPAC FILE THAT WAS CREATED BY PROGRAM
C***  SS2DGRID.  ON OPTION, A CHARACTER OUTPUT FILE OF GRID POINTS
C***  CAN BE CREATED WHICH IS USABLE AS INPUT TO THE MORE SOPHISTICATED
C***  BASIC CONTOURING PROGRAMS WRITTEN BY J. O. KORK.  THE STATPAC
C***  INPUT FILE MUST HAVE A FILE EXTENSION OF .UGR.  THE OPTIONAL
C***  OUTPUT FILE IS AUTOMATICALLY GIVEN A NAME EXTENSION OF .FCO.
C***  THIS PROGRAM MUST BE LINKED TO TWO PROPRIETARY SUBROUTINES,
C***  QSMODE AND QCNTOUR WHICH ARE AVAILABLE IN LIBRARY GRAFMS2.LIB
C***  PUBLISHED BY MICROCOMPATIBLES IN A FORTRAN GRAPHICS PACKAGE
C***  CALLED GRAFMATIC.
C***
C***  LINKS REQUIRED: ASCIIZ,BYTMOV,CHEKER,CHGCAS,CHRKNT,CKSAFE,CLEAR,
C***  CONCAT,DELAY,DOSREN,DRWBOX,FNDCUR,IOS,MOVCUR,PCHCEN,PCHVAR,
C***  QSMODE,QCNTOUR,RMOVE,SCREAD,SOUND
C***  AT LINK TIME SPECIFY THE LIBRARIES IN THE FOLLOWING MANNER:
C***  C:\COMPILER\GRAFMS2+C:\COMPILER\STATPAC+C:\COMPILER\MENUPGMS+
C***  C:\COMPILER\8087+C:\COMPILER\FORTRAN
C***
C***  NOTE: MISSING GRID VALUES ARE AUTOMATICALLY ASSIGNED A VALUE
C***  OF 100000.  THIS VALUE IS STORED IN VARIABLE XNULL.  THIS
C***  VALUE CAUSES A "WALLING OFF" OF MAP AREAS IN WHICH KRIGING
C***  OF GRID POINTS WAS NOT POSSIBLE IN PROGRAM SS2DGRID.
C***
C***  NOTE: UPON COMPLETION OF THE MAP ON THE SCREEN, IT MAY BE COPIED
C***  TO AN EPSON-COMPATIBLE PRINTER BY PRESSING SIMULTANEOUSLY THE
C***  SHIFT AND PRT SC KEYS.  THE ASPECT RATIO OF THE PRINTER MAP
C***  IS SOMEWHAT DIFFERENT FROM THE ASPECT RATIO OF THE SCREEN, SO
C***  THE PRINTER MAP MAY BE SOMEWHAT DISTORTED.
C***
C***  NOTE: AFTER THE CONTOUR MAP HAS BEEN VIEWED AND/OR COPIED TO THE
C***  PRINTER, PRESS THE RETURN KEY ONCE TO RESUME EXECUTION OF THIS
C***  PROGRAM.
C***
C***  CODED BY W. D. GRUNDY    MAY 1985
C***
      INTEGER*4 LOC,ITIME1,ITIME2
      LOGICAL FILERR,FLAG,WRITEK,WRITEV
      CHARACTER*1 ANS
      CHARACTER*4 EXT10,EXT21
      CHARACTER*8 ID
      CHARACTER*16 NAME
      CHARACTER*32 FILE10,FILE21,FILE14,TEMP
      COMMON /GRID/ XYCOOR(200),VALKRG(10000),IBFLAG(10),CONTS(10)
      COMMON /VAR/ VARKRG(10000)
      COMMON /BUF/ PLTVAL(10000)
      DIMENSION X(4),LOC(2)
      DATA EXT10,EXT21 /'.UGR','.FCO'/
C**********************************************************************
C***  GET STARTING TIME OF RUN
      CALL TICKER(ITIME1)
      KI=10
      KO=21
      KOT=14
      ASPECT=1.32
      XNULL=1.0E+05
      CALL CMDLIN(FILE10,'SS2DCONT',8,FLAG)
      CALL NOTE
      IF(FLAG) GO TO 15
C**********************************************************************
C***  GET NAME OF STATPAC KRIGED GRID INPUT FILE
   10 WRITE(*,'(A\)') ' ENTER ROOT NAME OF STATPAC KRIGED GRID FILE: '
      READ(*,'(A)') FILE10
C***  ATTACH EXTENSION OF .UGR TO THE USER SUPPLIED FILE NAME
   15 CALL CHEKER(FILE10,EXT10,FILERR)
      IF(FILERR) GO TO 10
C***  VERIFY THAT THIS FILE EXISTS
      CALL CKSAFE(FILE10,2,FILERR)
      IF(FILERR) GO TO 10
      OPEN(KI,FILE=FILE10,STATUS='OLD',FORM='UNFORMATTED')
      READ(KI) ID,N,M
      IF(M.NE.4) THEN
      WRITE(*,'(A)') ' INPUT FILE WAS NOT CREATED BY PROGRAM SS2DGRID'
      STOP
      ENDIF
      IKRG=0
      IVAR=0
C**********************************************************************
C***  FOLLOWING USER RESPONSES SHOULD BE THE SAME AS THOSE SUPPLIED
C***  DURING CREATION OF THE STATPAC GRID FILE BY PROGRAM SS2DGRID.
   20 IER=1
      WRITE(*,'(A\)') ' ENTER NUMBER OF GRID POINTS IN N-S DIRECTION: '
      READ(*,'(BN,I3)',ERR=240) NPNS
      IF(NPNS.LE.0) THEN
      CALL SOUND(256,100)
      WRITE(*,30)
   30 FORMAT(' NUMBER OF GRID POINTS MUST BE GREATER THAN ZERO')
      GO TO 20
      ENDIF
   40 JER=1
      WRITE(*,'('' '',''ENTER DISTANCE BETWEEN POINTS IN N-S'',
     1'' DIRECTION: '',\)')
      READ(*,'(BN,F8.0)',ERR=250) YDIS
      IF(YDIS.LE.0.) THEN
      CALL SOUND(256,100)
      WRITE(*,50)
   50 FORMAT(' DISTANCE BETWEEN POINTS MUST BE GREATER THAN 0')
      GO TO 40
      ENDIF
   60 IER=2
      WRITE(*,'(A\)') ' ENTER NUMBER OF GRID POINTS IN E-W DIRECTION: '
      READ(*,'(BN,I3)',ERR=240) NPEW
      IF(NPEW.LE.0) THEN
      CALL SOUND(256,100)
      WRITE(*,30)
      GO TO 60
      ENDIF
      IF(NPNS+NPEW.GT.200) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' '',''THE SUM OF THE NUMBER OF POINTS IN THE N-S '',
     1''DIRECTION AND THE NUMBER OF'',/,'' POINTS IN THE E-W DIRECT'',
     2''ION CANNOT EXCEED 200.  REDO FROM START.'')')
      GO TO 20
      ENDIF
   70 JER=2
      WRITE(*,'('' '',''ENTER DISTANCE BETWEEN POINTS IN E-W'',
     1'' DIRECTION: '',\)')
      READ(*,'(BN,F8.0)',ERR=250) XDIS
      IF(XDIS.LE.0.) THEN
      CALL SOUND(256,100)
      WRITE(*,50)
      GO TO 70
      ENDIF
   80 JER=3
      WRITE(*,'(A\)') ' WHAT IS NORTHING OF SW CORNER OF GRID? '
      READ(*,'(BN,F8.0)',ERR=250) YNO
   90 JER=4
      WRITE(*,'(A\)') ' WHAT IS  EASTING OF SW CORNER OF GRID? '
      READ(*,'(BN,F8.0)',ERR=250) XEA
  100 IER=3
      WRITE(*,'('' '',''DO YOU WANT A MAP OF'',/,10X,''1) THE KRIG'',
     1''ED VALUES,OR'',/,10X,''2) THE KRIGING VARIANCES?'',/,13X,
     2''ANSWER 1 OR 2: '',\)')
      READ(*,'(BN,I1)',ERR=240) IWANT
      IF(IWANT.LT.1.OR.IWANT.GT.2.) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A\)') ' ***ERROR-YOU MUST ANSWER 1 OR 2***'
      GO TO 100
      ENDIF
      IWANT=IWANT+2
      IF(IWANT.EQ.3) IKRG=1
      IF(IWANT.EQ.4) IVAR=1
C***  COMPUTE TOTAL NUMBER OF POSSIBLE GRID POINTS
      ITOT=NPNS*NPEW
      IF(ITOT.GT.10000) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' TOO MANY GRID POINTS.  LIMIT IS 10000'
      STOP
      ENDIF
C**********************************************************************
C***  ALLOW FOR POSSIBLE MISSING GRID POINTS
  110 JER=5
      WRITE(*,'('' '',''THE CURRENT VALUE ASSIGNED TO MISSING GRID '',
     1''POINTS IS '',E8.3,/,'' DO YOU WANT TO CHANGE THIS VALUE? '',
     2''Y/N '',\)') XNULL
      READ(*,'(A)') ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') THEN
  120 WRITE(*,'(A\)') ' ENTER THE NEW VALUE FOR MISSING GRID POINTS: '
      READ(*,*,ERR=250) XNULL
      IF(ABS(XNULL).GT.1.0E+10) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' ABSOLUTE VALUE OF MISSING POINTS CANNOT EXCEED 1.
     10E+10'
      GO TO 120
      ENDIF
      ENDIF
C**********************************************************************
C***  FILL VALKRG AND VARKRG WITH NULLS PRIOR TO READING STATPAC FILE
      DO 130 I=1,ITOT
      VALKRG(I)=XNULL
      VARKRG(I)=XNULL
  130 CONTINUE
C***  COMPUTE COORDINATES
      DO 140 I=1,NPNS
      XYCOOR(I+NPEW)=YNO+FLOAT(I-1)*YDIS
  140 CONTINUE
      DO 150 I=1,NPEW
      XYCOOR(I)=XEA+FLOAT(I-1)*XDIS
  150 CONTINUE
C***  PUT Z-VALUES IN PROPER POSITION IN ARRAY VALKRG
      WRITE(*,'(A)') '          READING STATPAC GRID FILE'
      CALL FNDCUR(IRRR,ICCC,0)
      DO 160 I=1,N
      READ(KI) IROW,NAME,LOC,X
      IF(MOD(I,100).EQ.0) CALL ODOMTR(IRRR,I)
      J=NINT((X(1)-XEA)/XDIS)+1
      IF(J.LE.0.OR.J.GT.NPEW) GO TO 160
      K=NINT((X(2)-YNO)/YDIS)+1
      IF(K.LE.0.OR.K.GT.NPNS) GO TO 160
      IPOS=(K-1)*NPEW+J
      VALKRG(IPOS)=X(3)
      VARKRG(IPOS)=X(4)
  160 CONTINUE
      WRITE(*,'(''+'',I5)') N
C***  GET USER SPECIFICATIONS FOR CONTOUR VALUES AND LABELS
  170 CALL CNTSPX(CONTS,IBFLAG,NUMCON)
      WRITE(*,'('' '',''THE CURRENT GRAPHICS ASPECT RATIO IS '',F4.2,/,
     1'' DO YOU WANT TO CHANGE THIS? Y/N: '',\)') ASPECT
      READ(*,'(A)') ANS
  180 JER=6
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') THEN
      WRITE(*,'(A\)') ' ENTER THE NEW ASPECT RATIO: '
      READ(*,*,ERR=250) ASPECT
      ENDIF
      IF(IWANT.EQ.3) THEN
      CALL RMOVE(VALKRG,PLTVAL,ITOT)
      ELSE
      CALL RMOVE(VARKRG,PLTVAL,ITOT)
      ENDIF
  190 JER=7
      WRITE(*,'('' '',''DO YOU WANT TO SET AN UPPER VARIANCE LIMIT '',
     1''FOR THE CONTOURING? Y/N: '',\)')
      READ(*,'(A)') ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') THEN
      WRITE(*,'(A\)') ' ENTER THE UPPER VARIANCE LIMIT: '
      READ(*,*,ERR=250) VARLMT
      CALL TRIM(VARKRG,PLTVAL,VARLMT,XNULL,ITOT)
      ENDIF
      WRITE(*,'('' '',''DO YOU WANT TO SHADE IN THE AREA OF MISSING '',
     1''GRID POINTS? Y/N: '',\)')
      READ(*,'(A)') ANS
C**********************************************************************
C***  MAKE THE CONTOUR MAP
C***  FOLLOWING CALL PUTS THE SCREEN IN HIGH RESOLUTION BLACK AND
C***  WHITE GRAPHICS MODE (640X200 PIXELS).
      CALL QSMODE(6)
C***  SUBROUTINE QCNTOUR PERFORMS THE SCREEN CONTOURING.
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') THEN
      CALL QCNTOUR(ASPECT,XYCOOR(1),XYCOOR(NPEW+1),PLTVAL,XNULL,0,NPEW,
     1NPNS,1)
      ENDIF
      CALL QCNTOUR(ASPECT,XYCOOR(1),XYCOOR(NPEW+1),PLTVAL,CONTS,IBFLAG,
     1NPEW,NPNS,NUMCON)
C***  ALLOW USER TIME TO VIEW THE CONTOUR PLOT
      READ(*,*)
C***  RESTORE SCREEN TO TEXT MODE
      CALL QSMODE(2)
C**********************************************************************
C***  ASK USER WHAT TO DO NEXT
      WRITE(*,'('' '',''DO YOU WANT TO CHANGE THE CONTOUR SPECIFI'',
     1''CATIONS? Y/N: '',\)')
      READ(*,'(A)') ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') GO TO 170
      IWANT=IWANT+1
      IF(IWANT.EQ.4.AND.IVAR.EQ.0) THEN
      WRITE(*,'('' '',''DO YOU WANT TO CONTOUR THE KRIGING VARIANCES?'',
     1'' Y/N: '',\)')
      READ(*,'(A)') ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') THEN
      IVAR=1
      GO TO 170
      ENDIF
      ENDIF
      IF(IWANT.EQ.5.AND.IKRG.EQ.0) THEN
      IWANT=3
      WRITE(*,'('' '',''DO YOU WANT TO CONTOUR THE KRIGED VALUES? '',
     1''Y/N: '',\)')
      READ(*,'(A)') ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') THEN
      IKRG=1
      GO TO 170
      ENDIF
      ENDIF
C**********************************************************************
C***  NO MORE CONTOURING IS WANTED.  ARE OUTPUT FILES WANTED?
      IF(IKRG.EQ.1) THEN
      WRITE(*,'('' '',''DO YOU WANT A FILE OF KRIGED VALUES FOR'',
     1'' THE BASIC CONTOURING PROGRAM? Y/N: '',\)')
      READ(*,'(A)') ANS
      WRITEK=ANS.EQ.'Y'.OR.ANS.EQ.'y'
      IF(WRITEK) THEN
  200 WRITE(*,'('' '',''GIVE A ROOT NAME FOR THE ASCII KRIGED '',
     1''VALUE OUTPUT FILE: '',\)')
      READ(*,'(A)') FILE21
      TEMP=FILE21
      CALL CHEKER(FILE21,EXT21,FILERR)
      IF(FILERR) GO TO 200
      CALL CKSAFE(FILE21,1,FILERR)
      IF(FILERR) GO TO 200
      OPEN(KO,FILE=FILE21,STATUS='NEW',FORM='FORMATTED')
      ENDIF
      ENDIF
      IF(IVAR.EQ.1) THEN
      WRITE(*,'('' '',''DO YOU WANT A FILE OF KRIGING VARIANCES FOR'',
     1'' THE BASIC PROGRAM? Y/N: '',\)')
      READ(*,'(A)') ANS
      WRITEV=ANS.EQ.'Y'.OR.ANS.EQ.'y'
      IF(WRITEV) THEN
  210 WRITE(*,'(A\)') ' GIVE A ROOT NAME FOR THE VARIANCE FILE: '
      READ(*,'(A)') FILE14
      IF(FILE14.EQ.TEMP) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' YOU CANNOT USE THE SAME FILE NAME'
      GO TO 210
      ENDIF
      CALL CHEKER(FILE14,EXT21,FILERR)
      IF(FILERR) GO TO 210
      CALL CKSAFE(FILE14,1,FILERR)
      IF(FILERR) GO TO 210
      OPEN(KOT,FILE=FILE14,STATUS='NEW',FORM='FORMATTED')
      ENDIF
      ENDIF
      IF(WRITEK.OR.WRITEV) THEN
      WRITE(*,'(A)') '           WRITING CHARACTER GRID FILE(S)'
      CALL FNDCUR(IRRR,ICCC,0)
      DO 220 I=1,ITOT
      IF(WRITEK) WRITE(KO,'(E14.7)') VALKRG(I)
      IF(WRITEV) WRITE(KOT,'(E14.7)') VARKRG(I)
      IF(MOD(I,100).EQ.0) CALL ODOMTR(IRRR,I)
  220 CONTINUE
      WRITE(*,'(''+'',I5)') ITOT
      IF(WRITEK)
     1WRITE(*,'('' '',''THE KRIGED VALUE OUTPUT FILE IS '',A32)')
     2FILE21
      IF(WRITEV)
     1WRITE(*,'('' '',''THE KRIGING VARIANCE OUTPUT FILE IS '',A32)')
     2FILE14
      DO 230 I=1,5
      CALL SOUND(1000,25)
  230 CONTINUE
      ENDIF
C**********************************************************************
C***  FINISHED WITH CURRENT INPUT FILE.  SEE IF ANOTHER IS WANTED.
      IF(WRITEK) CLOSE(KO)
      IF(WRITEV) CLOSE(KOT)
      WRITE(*,'('' '',''DO YOU WANT TO CONTOUR USING A DIFFERENT '',
     1''STATPAC INPUT FILE? Y/N: '',\)')
      READ(*,'(A)') ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') GO TO 10
C**********************************************************************
C***  PROGRAM EXIT ROUTINE
C***  COMPUTE PROGRAM ACTIVE TIME
      CALL TICKER(ITIME2)
      XTIME=FLOAT(ITIME2-ITIME1)/6000.
      WRITE(*,'('' '',''PROGRAM ACTIVE TIME WAS '',F6.2,'' MINUTES'')')
     1XTIME
      STOP 'NORMAL END OF PROGRAM'
C**********************************************************************
C***  ERROR MESSAGES FOR BAD INTERACTIVE DATA INPUT
  240 CALL SOUND(256,100)
      WRITE(*,'(A)')' ***ERROR-INTEGER VALUE WAS EXPECTED-REENTER***'
      GO TO(20,60,100),IER
  250 CALL SOUND(256,100)
      WRITE(*,'(A)')' ***ERROR-REAL VALUE WAS EXPECTED-REENTER***'
      GO TO(40,70,80,90,110,180,190),JER
      END
      SUBROUTINE CNTSPX(CONTS,IBFLAG,NUMCON)
C**********************************************************************
C***  THIS SUBROUTINE INPUTS THE CONTOUR VALUES AND CONTOUR LABEL SPECS
      CHARACTER*1 ANS
      DIMENSION CONTS(10),IBFLAG(10)
      DO 10 I=1,10
      IBFLAG(I)=O
   10 CONTINUE
   20 WRITE(*,'(A\)') ' ENTER NUMBER OF CONTOUR VALUES WANTED.(MAX=10): 
     1'
      READ(*,'(BN,I2)',ERR=30) NUMCON
      GO TO 40
   30 CALL SOUND(256,100)
      WRITE(*,'(A)') ' INTEGER VALUE IS REQUIRED.  REDO'
      GO TO 20
   40 IF(NUMCON.LE.0.OR.NUMCON.GT.10) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' VALUE MUST BE IN RANGE 1-10.  REDO'
      GO TO 20
      ENDIF
      WRITE(*,'(A\)') ' DO YOU WANT EVENLY SPACED CONTOURS? Y/N: '
      READ(*,'(A)') ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') THEN
   50 WRITE(*,'(A\)') ' ENTER STARTING CONTOUR VALUE: '
      READ(*,*,ERR=60) CONTS(1)
      GO TO 80
   60 CALL SOUND(256,100)
      WRITE(*,70)
   70 FORMAT(' REAL VALUE IS REQUIRED. REDO')
      GO TO 50
   80 WRITE(*,'(A\)') ' ENTER CONTOUR INTERVAL TO BE USED: '
      READ(*,*,ERR=90) CNTINT
      GO TO 100
   90 CALL SOUND(256,100)
      WRITE(*,70)
      GO TO 80
  100 IBFLAG(1)=1
      DO 110 I=2,NUMCON
      CONTS(I)=CONTS(1)+FLOAT(I-1)*CNTINT
      IBFLAG(I)=1
  110 CONTINUE
      GO TO 160
      ENDIF
      DO 150 I=1,NUMCON
  120 WRITE(*,'('' '',''ENTER VALUE OF CONTOUR NO. '',I2,'': '',\)') I
      READ(*,*,ERR=130) CONTS(I)
      GO TO 140
  130 CALL SOUND(256,100)
      WRITE(*,70)
      GO TO 120
  140 WRITE(*,'(A\)') ' DO YOU WANT THIS CONTOUR VALUE LABELED? Y/N: '
      READ(*,'(A)') ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') IBFLAG(I)=1
  150 CONTINUE
  160 RETURN
      END
      SUBROUTINE NOTE
C***
C***  THIS SUBROUTINE PRINTS AN ACKNOWLEDGMENT MESSAGE FOR NEWMENU
C***
      CALL CLEAR
      CALL PCHCEN('THIS PROGRAM USES PROPRIETARY SUBROUTINES PUBLISHED B
     1Y:&',1,7,0)
      CALL PCHCEN('Microcompatibles&',2,10,0)
      CALL PCHCEN('11443 Oak Leaf Drive&',2,11,0)
      CALL PCHCEN('Silver Spring, MD&',2,12,0)
      CALL PCHCEN('20901&',2,13,0)
      CALL DRWBOX(9,14,29,50,1,0,1)
      CALL DELAY(500)
      CALL CLEAR
      RETURN
      END
      SUBROUTINE TRIM(VARKRG,PLTVAL,VARLMT,XNULL,ITOT)
C**********************************************************************
C***  CONVERTS PLTVAL TO XNULL IF CORRESPONDING VALUE OF VARKRG EXCEEDS
C***  THE LIMIT VARLMT
      DIMENSION VARKRG(1),PLTVAL(1)
      DO 10 I=1,ITOT
      IF(VARKRG(I).GT.VARLMT.AND.VARKRG(I).NE.XNULL) PLTVAL(I)=XNULL
   10 CONTINUE
      RETURN
      END
