$STORAGE:2
      INTERFACE TO INTEGER*2 FUNCTION SYSTEM [C,ALIAS:'system']
     1        (STRING[REFERENCE])
      CHARACTER*1 STRING
      END
      INTERFACE TO INTEGER*2 FUNCTION SPAWN
     1        [C,VARYING,ALIAS:'spawnlp']
     2        (MODE)
      INTEGER*2 MODE
      END
      PROGRAM SS2DMENU
C***
C***  CODED BY W.D. GRUNDY  MARCH  1985
C***
C***  THIS PROGRAM DISPLAYS THE NAMES OF 29 DIFFERENT PROGRAMS WHICH
C***  ARE USEFUL IN SPATIAL STATISTICS (KRIGING) TOGETHER WITH A
C***  BRIEF DESCRIPTION OF THE FUNCTION OF THESE PROGRAMS.  THE
C***  USER SELECTS THE PROGRAM TO BE RUN BY PRESSING IN ANY DESIRED
C***  SEQUENCE THE UP, DOWN, RIGHT, AND LEFT ARROW KEYS ON THE PC'S
C***  NUMERIC KEY PAD.  PRESSING THE F10 KEY WILL CAUSE THE SELECTED
C***  PROGRAM TO RUN, AND PRESSING THE F8 KEY WILL CAUSE AN EXIT TO DOS.
C***
C***  NOTE: USE OF THIS MENU IS NOT REQUIRED BY ANY OF THE SS2D
C***  SERIES PROGRAMS.  PROGRAMS LOAD MORE RAPIDLY IF THEY ARE
C***  INVOKED DIRECTLY RATHER THAN THROUGH THIS MENU PROGRAM.
C***
C***  NOTE: IF THE PC HAS A COLOR GRAPHICS BOARD, THE COMMAND
C***  MODE BW80 SHOULD BE TYPED PRIOR TO RUNNING THIS MENU PROGRAM.
C***  THIS PROGRAM IS AWKWARD TO USE UNLESS A HARD DISK IS AVAILABLE.
C***  NOTE: ALL SUBROUTINES BUT ABSTR ARE WRITTEN IN 8086 ASSEMBLY.
C***  THIS PROGRAM USES DIRECT WRITES TO VIDEO RAM AND MAY NOT BE
C***  COMPATIBLE WITH NON-IBM COMPUTERS.  THIS PROGRAM, HOWEVER, HAS
C***  BEEN SUCCESSFULLY RUN ON A COMPAQ DESKPRO-2 AND ON A COLUMBIA
C***  1600-4.
C***
C***  LINKS REQUIRED: PCHVAR, CHGATR, CLEAR, CRSOFF, CRSON,
C***  DRWBOX, FSTDSP, KPRESS, MOVCUR, PCHCEN, PCHCON, SCREAD
C***  SPAWNLP (A "C"-LANGUAGE PROGRAM WHOSE OBJECT MODULE IS IN
C***  FILE CEXEC.LIB ON THE MICROSOFT V3.31 FORTRAN COMPILER DISKS.)
C***
C***  AFTER COMPILING SS2DMENU.FOR, LINK BY TYPING:
C***  LINK SS2DMENU /EXEPACK,,NUL,C:\COMPILER\STATPAC+C:\COMPILER\CEXEC+
C***  C\COMPILER\8087+C:\COMPILER\FORTRAN
C***
      INTEGER*2 SPAWN, SYSTEM
      CHARACTER*40 PROGRM
      CHARACTER*60 NAME(6)
      DATA INVIS,NORMAL,INTNSE,IREVRS,NBLINK,INBLNK,IRBLNK
     1/      0  ,  1   ,  2   ,  3   ,  4   ,  5   ,  6   /
      DATA IPAGE /0/, NCHAR /8/
      DATA NAME(1)/'    ADDORDEL    BASTAT      FILTER      GAPMAP      
     1MAPPLT  '/
      DATA NAME(2)/'    NORCHI      PERMUTER    POLYGRET    PUBLST      
     1RANGERET'/
      DATA NAME(3)/'    REGRESS     ROWIDRET    ROWPATCH    SS2DPREP    
     1SS2DVCTL'/
      DATA NAME(4)/'    SS2DGAMH    SS2DXVAL    SS2DBLOK    SS2DGRID    
     1SS2DCONT'/
      DATA NAME(5)/'    SS2DDRES    SS2DOUTL    STATCOR     STPSORT     
     1STRNGRET'/
      DATA NAME(6)/'    TERFIL      TRANSF      UNFILTER    XYPLOT      
     1OTHER   '/
      DATA PROGRM/'                                        '/
      DATA OUTFILE /'BAT2BAT.BAT'/
C**********************************************************************
      JJ=SPAWN(0,LOC('KRIGINFO.COM'C),LOC('KRIGINFO.COM'C),
     1INT4(0))
C***  SET UP THE DISPLAY SCREEN
C***
C***  MAKE CURSOR INVISIBLE
    5 CALL CRSOFF(ICXSAV)
      CALL PCHCEN('PRESS F9 KEY TO DISPLAY THE MENU&',IREVRS,24,IPAGE)
   10 CALL KPRESS(IAH,IAL)
      IF(IAH.NE.67.OR.IAL.NE.0) GO TO 10
      CALL CLEAR
C***  PUT HEADER ON THE SCREEN
      CALL DRWBOX(0,4,20,59,NORMAL,IPAGE,1)
      CALL PCHCEN('LIST OF PROGRAMS FOR TWO-DIMENSIONAL&',NORMAL,1,
     1IPAGE)
      CALL PCHCEN('SPATIAL STATISTICS&',NORMAL,2,IPAGE)
      CALL PCHCEN('(KRIGING)&',NORMAL,3,IPAGE)
      CALL PCHCON('PROGRAM FUNCTION&',NORMAL,23,33,IPAGE)
      IROW=6
C***  PUT LIST OF PROGRAMS ON THE SCREEN
      DO 20 I=1,6
      CALL FSTDSP(IROW,0,NAME(I),60)
      IROW=IROW+2
   20 CONTINUE
C***  PUT INSTRUCTIONS ON THE SCREEN
      CALL DRWBOX(5,16,62,79,NORMAL,IPAGE,1)
      CALL PCHCON('Select   program&',INTNSE,6,63,IPAGE)
      CALL PCHCON('using arrow keys&',INTNSE,7,63,IPAGE)
      CALL PCHCON('on right-keypad.&',INTNSE,8,63,IPAGE)
      CALL PCHCON('Press F10 to run&',INTNSE,9,63,IPAGE)
      CALL PCHCON('or  F8  to quit.&',INTNSE,10,63,IPAGE)
      CALL PCHCON('Read comments in&',NORMAL,11,63,IPAGE)
      CALL PCHCON('program   source&',NORMAL,12,63,IPAGE)
      CALL PCHCON('codes  for  more&',NORMAL,13,63,IPAGE)
      CALL PCHCON('information   on&',NORMAL,14,63,IPAGE)
      CALL PCHCON('their usage.&',NORMAL,15,63,IPAGE)
C***  PUT DESCRIPTION OF FIRST PROGRAM ON THE SCREEN
      CALL DRWBOX(18,22,19,62,INTNSE,IPAGE,1)
      CALL ABSTR(6,4)
      CALL PCHCON('==>&',INTNSE,20,14,IPAGE)
      IROW=6
      ICOL=4
      PROGRM=' '
      CALL SCREAD(PROGRM,NCHAR,IROW,ICOL,IPAGE)
      CALL PCHVAR(PROGRM,INBLNK,8,20,4,IPAGE)
      CALL CHGATR(NCHAR,IREVRS,IROW,ICOL,IPAGE)
C***
C**********************************************************************
C***  USER MAKES SELECTION BY USING NUMERIC KEY PAD ARROW KEYS
C***
   30 CALL KPRESS(IAH,IAL)
      IF(IAH.NE.66.AND.IAH.NE.68.AND.IAH.NE.72.AND.IAH.NE.75.AND.
     1IAH.NE.77.AND.IAH.NE.80) GO TO 30
C***  WAS F10 KEY PRESSED?
      IF(IAH.EQ.68) GO TO 40
C***  WAS F8 KEY PRESSED?  IF YES, PREPARE TO EXIT TO DOS.
      IF(IAH.EQ.66) THEN
C     WRITE(KO,'(''ECHO Exiting FORTRAN - You can delete bat2bat.bat.''
C    1)')
      GO TO 50
      ENDIF
      CALL CHGATR(NCHAR,NORMAL,IROW,ICOL,IPAGE)
C***  WAS CURSOR-UP KEY PRESSED?
      IF(IAH.EQ.72) IROW=IROW-2
C***  WAS CURSOR-DOWN KEY PRESSED?
      IF(IAH.EQ.80) IROW=IROW+2
C***  WAS CURSOR-LEFT KEY PRESSED?
      IF(IAH.EQ.75) ICOL=ICOL-12
C***  WAS CURSOR-RIGHT KEY PRESSED?
      IF(IAH.EQ.77) ICOL=ICOL+12
      IF(IROW.LT.6) IROW=16
      IF(IROW.GT.16) IROW=6
      IF(ICOL.LT.4) ICOL=52
      IF(ICOL.GT.52) ICOL=4
      CALL CHGATR(NCHAR,IREVRS,IROW,ICOL,IPAGE)
      CALL ABSTR(IROW,ICOL)
      PROGRM=' '
      CALL SCREAD(PROGRM,NCHAR,IROW,ICOL,IPAGE)
      CALL PCHVAR(PROGRM,INTNSE,8,20,4,IPAGE)
      GO TO 30
C***
C**********************************************************************
C***  F10 KEY WAS PRESSED.
C***  WRITE OUTPUT FILE BAT2BAT.BAT WITH NAME OF SELECTED PROGRAM
C***
   40 IF(PROGRM.EQ.'OTHER   ') THEN
      CALL CRSON(ICXSAV)
      CALL PCHCON('WHAT IS NAME OF OTHER PROGRAM?  &',NORMAL,24,0,IPAGE)
      READ(*,'(A40)') PROGRM
      ENDIF
      CALL ASCIIZ(PROGRM,40,LENERR)
      CALL CRSON(ICXSAV)
      CALL CLEAR
      JJ = SPAWN(0,LOC(PROGRM),LOC(PROGRM),
     1INT4(0))
      IF(JJ.NE.0) JJ=SYSTEM(PROGRM)
      GO TO 5
   50 CALL CRSON(ICXSAV)
      CALL CLEAR
      IF(IAH.NE.66) THEN
      CALL PCHVAR(PROGRM,NORMAL,40,0,0,IPAGE)
      CALL MOVCUR(1,0,IPAGE)
      ENDIF
      WRITE(*,'('' '',''Exiting FORTRAN....'')')
      END
      SUBROUTINE ABSTR(IROW,ICOL)
      CHARACTER*40 A(3,30)
C***
      DATA A(1,1 )/'APPEND ROWS OR COLUMNS OF ONE STATPAC   '/
      DATA A(2,1 )/'FILE TO THOSE OF ANOTHER STATPAC FILE,  '/
      DATA A(3,1 )/'OR DELETE ROWS OR COLUMNS FROM A FILE.  '/
      DATA A(1,2 )/'COMPUTE BASIC STATISTICS AND OPTIONAL   '/
      DATA A(2,2 )/'HISTOGRAMS FROM STATPAC DATA FILE.  CAN '/
      DATA A(3,2 )/'PERMUTE ROWS AND COLUMNS OF THE FILE.   '/
      DATA A(1,3 )/'CREATE ASCII FILE OF SELECTED OBSERVA-  '/
      DATA A(2,3 )/'TIONS IN A STATPAC FILE.  USEFUL IN ED- '/
      DATA A(3,3 )/'ITING IF USED WITH UNFILTER.            '/
      DATA A(1,4 )/'TEST STATPAC DATA SET FOR MIXED POPULA- '/
      DATA A(2,4 )/'TIONS AND GET MAP ON THE PRINTER.  NO   '/
      DATA A(3,4 )/'ZERO OR QUALIFIED VALUES ALLOWED IN DATA'/
      DATA A(1,5 )/'MAKE CRUDE PRINTER MAP OF STATPAC VARIA-'/
      DATA A(2,5 )/'BLES.  NORTH-SOUTH DIMENSION CANNOT EX- '/
      DATA A(3,5 )/'CEED TWICE THE EAST-WEST MAP DIMENSION. '/
      DATA A(1,6 )/'PERFORM CHI-SQUARE TEST FOR NORMALITY OF'/
      DATA A(2,6 )/'A STATPAC VARIABLE.  ASSUMPTION OF INDE-'/
      DATA A(3,6 )/'PENDENCE IS NOT MET WITH KRIGED VALUES. '/
      DATA A(1,7 )/'REARRANGE (PERMUTE) ROWS OF STATPAC FILE'/
      DATA A(2,7 )/'IN A RANDOM ORDER.  USE FOR SPLIT SAMPLE'/
      DATA A(3,7 )/'OPTION OF SS2DXVAL (CROSS-VALIDATION).  '/
      DATA A(1,8 )/'RETRIEVE STATPAC ROWS CONTAINED WITHIN A'/
      DATA A(2,8 )/'POLYGONAL BOUNDARY.  REQUIRES ASCII FILE'/
      DATA A(3,8 )/'OF NORTHINGS AND EASTINGS OF NODES.     '/
      DATA A(1,9 )/'CREATE FULLY LABELLED ASCII OUTPUT FILE '/
      DATA A(2,9 )/'FROM A STATPAC INPUT FILE.  OUTPUT IN-  '/
      DATA A(3,9 )/'TENDED FOR INCLUSION IN MANUSCRIPTS.    '/
      DATA A(1,10)/'RETRIEVE STATPAC ROWS IN WHICH A SELECT-'/
      DATA A(2,10)/'ED VARIABLE LIES WITHIN LOWER AND UPPER '/
      DATA A(3,10)/'LIMITS SPECIFIED BY THE USER.           '/
      DATA A(1,11)/'PERFORM STEP-FORWARD REGRESSION TO OB-  '/
      DATA A(2,11)/'TAIN DRIFT RESIDUALS.  USEFUL AS AN     '/
      DATA A(3,11)/'EARLY STEP IN UNIVERSAL KRIGING.        '/
      DATA A(1,12)/'RETRIEVE STATPAC ROWS BY EITHER PRIMARY '/
      DATA A(2,12)/'OR SECONDARY ROW-ID.  DESIRED ROW-IDS   '/
      DATA A(3,12)/'MUST BE STORED IN AN ASCII DATA FILE.   '/
      DATA A(1,13)/'EDIT STATPAC VARIABLES, QUALIFIERS, LOC-'/
      DATA A(2,13)/'VALUES, ROW IDS.  REQUIRES GRAPHICS AD- '/
      DATA A(3,13)/'APTER.  IF NO ADAPTER, USE FILTER.      '/
      DATA A(1,14)/'PREPROCESS STATPAC FILE FOR USE IN OTHER'/
      DATA A(2,14)/'SS2D SERIES PROGRAMS.  LOOKS FOR DUPLI- '/
      DATA A(3,14)/'CATE SAMPLE LOCATIONS AND SORTS THE FILE'/
      DATA A(1,15)/'CREATE REQUIRED ASCII CONTROL FILE FOR  '/
      DATA A(2,15)/'PROGRAM SS2DGAMH.  SPECIFY ANGULAR BEAR-'/
      DATA A(3,15)/'INGS AND TOLERANCES, AND DISTANCES.     '/
      DATA A(1,16)/'COMPUTE EXPERIMENTAL VARIOGRAMS.  FIVE  '/
      DATA A(2,16)/'DIRECTIONS MAXIMUM.  REQUIRES ASCII CON-'/
      DATA A(3,16)/'TROL FILE AND PREPROCESSED STATPAC FILE.'/
      DATA A(1,17)/'CROSS-VALIDATE VARIOGRAM/DRIFT MODELS.  '/
      DATA A(2,17)/'REQUIRES STATPAC INPUT FILE AND INTER-  '/
      DATA A(3,17)/'ACTIVE INPUT OF VARIOGRAM/DRIFT MODEL.  '/
      DATA A(1,18)/'ESTIMATE MEAN VALUE OF STATPAC VARIABLE '/
      DATA A(2,18)/'IN A BLOCK OF GROUND OF ANY SHAPE.  RE- '/
      DATA A(3,18)/'QUIRES A PREPROCESSED STATPAC INPUT FILE'/
      DATA A(1,19)/'ESTIMATE VALUE AND ERROR VARIANCE OF A  '/
      DATA A(2,19)/'STATPAC VARIABLE ALONG A GRID OF POINTS.'/
      DATA A(3,19)/'REQUIRES PREPROCESSED STATPAC INPUT FILE'/
      DATA A(1,20)/'MAKE HIGH RESOLUTION CONTOUR MAP OF A   '/
      DATA A(2,20)/'STATPAC VARIABLE.  REQUIRES A STATPAC   '/
      DATA A(3,20)/'INPUT FILE CREATED BY SS2DGRID.         '/
      DATA A(1,21)/'ESTIMATE DRIFT RESIDUALS USING AN ASSUM-'/
      DATA A(2,21)/'ED VARIOGRAM/DRIFT MODEL.  REQUIRES PRE-'/
      DATA A(3,21)/'PROCESSED STATPAC INPUT FILE.           '/
      DATA A(1,22)/'SEARCH FOR OUTLIERS IN STATPAC FILE US- '/
      DATA A(2,22)/'ING KRIGE-MAGRI METHOD.  REQUIRES USER  '/
      DATA A(3,22)/'INPUT OF VARIOGRAM PARAMETERS.          '/
      DATA A(1,23)/'COMPUTE MEAN, STANDARD DEVIATION, AND   '/
      DATA A(2,23)/'RANGE OF VARIABLES IN A STATPAC FILE AND'/
      DATA A(3,23)/'COMPUTE THEIR CORRELATION COEFFICIENTS. '/
      DATA A(1,24)/'SORT STATPAC FILE BY ROW-ID OR BY 1 TO 3'/
      DATA A(2,24)/'SELECTED VARIABLES IN EITHER ASCENDING  '/
      DATA A(3,24)/'OR DESCENDING ORDER.                    '/
      DATA A(1,25)/'RETRIEVE STATPAC ROWS WHOSE ROW-ID CON- '/
      DATA A(2,25)/'TAINS A SUBSTRING OF 1 TO 16 CHARACTERS '/
      DATA A(3,25)/'SPECIFIED BY THE USER.                  '/
      DATA A(1,26)/'CREATE A STATPAC INPUT FILE USING KEY-  '/
      DATA A(2,26)/'BOARD ENTRY.  ALLOWS ENTRY OF LATITUDE- '/
      DATA A(3,26)/'LONGITUDE AND/OR QUALIFYING CODES.      '/
      DATA A(1,27)/'TRANSFORM VALUES OF STATPAC VARIABLES.  '/
      DATA A(2,27)/'ELEVEN DIFFERENT TRANSFORMATIONS AVAIL- '/
      DATA A(3,27)/'ABLE, INCLUDING SQUARING AND SQUARE ROOT'/
      DATA A(1,28)/'CREATE STATPAC FILE FROM ASCII FILE     '/
      DATA A(2,28)/'CREATED BY PROGRAM FILTER.  FILTER-UN-  '/
      DATA A(3,28)/'FILTER CAN BE USED FOR EDITING STP FILES'/
      DATA A(1,29)/'MAKE CRUDE X-Y SCATTER DIAGRAM OF TWO   '/
      DATA A(2,29)/'SELECTED STATPAC VARIABLES.  USEFUL IN  '/
      DATA A(3,29)/'ANALYZING OUTPUT FROM SS2DXVAL.         '/
      DATA A(1,30)/'EXECUTE A PROGRAM NOT CONTAINED ON THIS '/
      DATA A(2,30)/'MENU OR ANY DOS COMMAND AND RETURN TO   '/
      DATA A(3,30)/'THIS MENU UPON COMPLETION OF PROGRAM.   '/
C***
      I=(ICOL-4)/12+1
      J=(IROW-6)/2+1
      K=5*(J-1)+I
      CALL FSTDSP(19,21,A(1,K),40)
      CALL FSTDSP(20,21,A(2,K),40)
      CALL FSTDSP(21,21,A(3,K),40)
      CALL MOVCUR(IROW,ICOL,0)
      RETURN
      END
