$NOFLOATCALLS
$STORAGE:2
      PROGRAM SS2DOUTL
C***  DETECTS OUTLIER ASSAY VALUES USING METHOD OF KRIGE AND MAGRI.
C***  REFERENCE
C***    Krige, Daniel G. and Eduardo J. Magri, 1982, Studies of the
C***      effects of outliers and data transformation on variogram
C***      estimates for a base metal and a gold ore body, Mathematical
C***      Geology, Vol. 14, No. 6, pp 557-564.
C***  OUTLIERS SHOULD HAVE A COMPUTED VALUE FOR HAWKIN'S STATISTIC
C***  WHICH IS .GE. 3.84.
C***  USER MUST SUPPLY VARIOGRAM PARAMETERS TO THIS PROGRAM.  THEY
C***  MIGHT BE OBTAINED BY FIRST RUNNING PROGRAM SS2DGAMH WITH THE
C***  REQUEST FOR A ROBUST ESTIMATE OF THE VARIOGRAM.
C***  THE USER MUST BE AWARE THAT THE PRESENCE OF A PROPORTIONAL
C***  EFFECT WILL CAUSE DIFFICULTIES IN INTERPRETING THE RESULTS
C***  OF THIS PROGRAM.  IT MAY BE NECESSARY TO MAKE A LOGARITHMIC
C***  TRANSFORMATION OF THE DATA PRIOR TO RUNNING SS2DGAMH TO OVERCOME
C***  THESE DIFFICULTIES.
C***  
C***  ADAPTED TO IBM PC BY W. D. GRUNDY    NOVEMBER 1985
C***
C***  LINKS REQUIRED: ASCIIZ, BYTMOV, CBAR, CHEKER, CHGCAS, CHRKNT,
C***                  CKSAFE, CMDLIN, CONCAT, COVAR4, DELAY, DOSREN,
C***                  ERRMST, FNDCUR, FSTDSP, MOVCUR, ODOMTR, PCHCEN,
C***                  PCHVAR, PRECHK, SAVRST, SCREAD, SCROLL, SOUND,
C***                  TICKER, UNPK
C***
C***  AT LINK TIME, LINK WITH STATPAC.LIB, 8087.LIB, AND FORTRAN.LIB
C***
C***  FILE REQUIREMENTS:
C***  INPUT FILE MUST BE A PREPROCESSED STATPAC FILE WITH THE
C***  EXTENSION NAME .UPR
C***  OUTPUT FILE IS AN ASCII FILE WITH EXTENSION NAME .FOU
C***
      CHARACTER*32 UNIT10,UNIT21
      CHARACTER*8 IDSTP,IHOLID
      INTEGER*4 ITIME1,ITIME2
      LOGICAL FLAG
      COMMON IHOLID(1500),XE(1500),YN(1500),GD(1500),KI,N,MAXN,IDSTP
      COMMON NEST,C0,C(5),AVALU(5),ANGLE(5),AFH(5),
     1SILL,ITYPE(5),SLOPE(5),AISI(5),BISI(5),CISI(5),IHOL(151)
C***  GET STARTING TIME OF PROGRAM RUN
      CALL TICKER(ITIME1)
      KI=10
      KO=21
      MAXN=1500
      MAXK=150
      CALL CMDLIN(UNIT10,'OUTLIERS',8,FLAG)
      IF(FLAG) GO TO 20
   10 WRITE(*,'(A\)') ' WHAT IS ROOT NAME OF THE STATPAC INPUT FILE? '
      READ(*,'(A32)') UNIT10
   20 CALL CHEKER(UNIT10,'.UPR',FLAG)
      IF(FLAG) GO TO 10
      CALL CKSAFE(UNIT10,2,FLAG)
      IF(FLAG) GO TO 10
      OPEN(KI,FILE=UNIT10,STATUS='OLD',FORM='UNFORMATTED')
   30 WRITE(*,'(A\)') ' GIVE A ROOT NAME FOR THE ASCII OUTPUT FILE: '
      READ(*,'(A)') UNIT21
      CALL CHEKER(UNIT21,'.FOU',FLAG)
      IF(FLAG) GO TO 30
      CALL CKSAFE(UNIT21,1,FLAG)
      IF(FLAG) GO TO 30
      OPEN(KO,FILE=UNIT21,STATUS='NEW',FORM='FORMATTED')
C***  READ STATPAC INPUT FILE
      CALL READIN
C***  MAKE SURE INPUT FILE WAS PREPROCESSED
      CALL PRECHK(YN,XE,N)
C***  GET VARIOGRAM PARAMETERS
      CALL VARPRM
C***  GET SIZE OF SEARCH CELL
   40 WRITE(*,'(A\)') ' ENTER SIZE OF CELL IN NORTH-DIRECTION: '
      READ(*,'(BN,F6.0)',IOSTAT=IBAD) SIZENS
      IF(IBAD.NE.0) CALL ERRMSG(2,*40)
      IF(SIZENS.LE.0.) THEN
      CALL SOUND(256,100)
      WRITE(*,50)
   50 FORMAT(' ERROR***  SIZE MUST BE GREATER THAN ZERO')
      GO TO 40
      ENDIF
   60 WRITE(*,'(A\)') ' ENTER SIZE OF CELL IN  EAST-DIRECTION: '
      READ(*,'(BN,F6.0)',IOSTAT=IBAD) SIZEEW
      IF(IBAD.NE.0) CALL ERRMSG(2,*60)
      IF(SIZEEW.LE.0) THEN
      CALL SOUND(256,100)
      WRITE(*,50)
      GO TO 60
      ENDIF
      XE2=SIZEEW/2.
      YN2=SIZENS/2.
      CALL HEAD(KO)
      WRITE(KO,'(/,'' SIZE OF SEARCH CELL IN N-S DIRECTION: '',
     1F8.2,/,'' SIZE OF SEARCH CELL IN E-W DIRECTION: '',F8.2)')
     2SIZENS,SIZEEW
C***  GET VARIANCE OF POINT VALUES WITHIN THE BLOCK
      PTVAR=SILL-CBAR(0.0,SIZEEW,0.0,SIZENS)
      WRITE(KO,'('' '',''VARIANCE OF POINTS WITHIN CELL      : '',
     1F8.2)') PTVAR
      WRITE(KO,'(/,'' HOLE NO. N0. PTS  VAL. PT    MEAN    HAWKINS''
     1,/,)')
      WRITE(*,'(''          TESTING FOR OUTLIERS'')')
      MISS=0
      CALL FNDCUR(IRRR,ICCC,0)
      DO 100 I=1,N
      XMIN=XE(I)-XE2
      XMAX=XE(I)+XE2
      YMIN=YN(I)-YN2
      YMAX=YN(I)+YN2
      NS=0
      DO 70 J=1,N
      IF(J.EQ.I) GO TO 70
      IF(XE(J).LT.XMIN.OR.XE(J).GT.XMAX.OR.YN(J).LT.YMIN.OR.
     1YN(J).GT.YMAX) GO TO 70
      NS=NS+1
      IF(NS.GT.151) THEN
      CALL SOUND(256,100)
      WRITE(KO,'(A)') ' MORE THAN 151 POINTS IN SEARCH CELL.'
      STOP
      ENDIF
      IHOL(NS)=J
   70 CONTINUE
      SUM=0.
      DO 80 J=1,NS
      K=IHOL(J)
      SUM=SUM+GD(K)
   80 CONTINUE
      IF(NS.LE.1) THEN
      MISS=MISS+1
      GO TO 90
      ENDIF
      GDMEAN=SUM/FLOAT(NS)
      HWKINS=FLOAT(NS)*((GD(I)-GDMEAN)**2)/(FLOAT(NS+1)*PTVAR)
      WRITE(KO,'('' '',A8,1X,I4,3X,F8.4,2X,F8.4,2X,F8.4)')
     1IHOLID(I),NS,GD(I),GDMEAN,HWKINS
   90 IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
  100 CONTINUE
      WRITE(*,'(''+'',I5)') N
      IF(MISS.NE.0)
     1WRITE(*,'(I6,4X,''DATA POINTS HAD LESS THAN TWO NEIGHBORS'',
     2'' WITHIN THE SEARCH AREA'',/,10X,''AND ARE NOT INCLUDED IN'',
     3'' THE OUTPUT FILE.'')') MISS
      WRITE(*,'(''0'',''THE ASCII OUTPUT FILE IS '',A32)') UNIT21
      STOP 'NORMAL END OF PROGRAM'
      END
      SUBROUTINE READIN
C***
C***  REVISED JULY 1985
C***  THIS SUBROUTINE READS  DATA FROM A STATPAC INPUT FILE
C***  FOR PROGRAM OUTLIERS.
C***  THIS PROGRAM REJECTS QUALIFIED VALUES.
C***
      CHARACTER*8 IVID(100),NAME(2)
      CHARACTER*1 IA(100)
      INTEGER*4 LOC(2)
      CHARACTER*8 IDSTP,IHOLID
      COMMON IHOLID(1500),XE(1500),YN(1500),GD(1500),KI,N,MAXN,IDSTP
      COMMON NEST,C0,C(5),AVALU(5),ANGLE(5),AFH(5),
     1SILL,ITYPE(5),SLOPE(5),AISI(5),BISI(5),CISI(5),IHOL(151)
      DIMENSION Z(100),IPACK(20)
      NHOL=0
      READ(KI) IDSTP,N,M,(IVID(I),I=1,M)
      NPACK=(M+4)/5
      WRITE(*,10) IDSTP
   10 FORMAT(' ',//, 5X,'STATPAC INPUT FILE ID IS: ',A8,
     1' ;  COLUMN ID''S ARE:',/)
      WRITE(*,20) (I,IVID(I),I=1,M)
   20 FORMAT(5(1X,I2,')',A8))
   30 WRITE(*,'(/,5X,''ENTER STATPAC FILE DESCRIPTORS'',/)')
   40 WRITE(*,50)
   50 FORMAT(5X,'WHAT IS COLUMN NUMBER OF THE NORTH COORDINATE? : ',\)
      READ(*,70,IOSTAT=IBAD) NO
      IF(IBAD.NE.0) CALL ERRMSG(1,*40)
      IF(NO.GT.0.AND.NO.LE.M) GO TO 80
      CALL SOUND(256,100)
      WRITE(*,60)
   60 FORMAT(' ','SPECIFIED COLUMN DOES NOT EXIST; REENTER VALUE')
      GO TO 40
   70 FORMAT(BN,I2)
   80 WRITE(*,90)
   90 FORMAT(5X,'WHAT IS COLUMN NUMBER OF THE  EAST COORDINATE? : ',\)
      READ(*,70,IOSTAT=IBAD) IE
      IF(IBAD.NE.0) CALL ERRMSG(1,*80)
      IF(IE.GT.0.AND.IE.LE.M) GO TO 100
      CALL SOUND(256,100)
      WRITE(*,60)
      GO TO 80
  100 WRITE(*,110)
  110 FORMAT(5X,'WHAT IS COLUMN NUMBER OF THE ASSAY VALUE?      : ',\)
      READ(*,70,IOSTAT=IBAD) LD
      IF(IBAD.NE.0) CALL ERRMSG(1,*100)
      IF(LD.GT.0.AND.LD.LE.M) GO TO 120
      CALL SOUND(256,100)
      WRITE(*,60)
      GO TO 100
  120 IF(IE.EQ.NO.OR.IE.EQ.LD.OR.NO.EQ.LD) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' '',''ERROR**  SPECIFIED COLUMNS NOT UNIQUE.  REDO'',
     1'' FROM START'',/)')
      GO TO 40
      ENDIF
      IDSTP=IVID(LD)
      WRITE(*,130)
  130 FORMAT(//,' NOW READING STATPAC INPUT FILE',//)
      DO 160 I=1,N
      READ (KI) IROW,NAME,LOC,(Z(K),K=1,M),(IPACK(K),K=1,NPACK)
      CALL UNPK(IA,M,IPACK)
C***  REJECT QUALIFIED VALUES
  140 IF(IA(LD).NE.' '.OR.IA(NO).NE.' '.OR.IA(IE).NE.' ')
     1GO TO 160
      NHOL=NHOL+1
      IF(NHOL/10*10.EQ.NHOL) WRITE(*,150) NHOL
  150 FORMAT('+',I4)
      IF(NHOL.GT.MAXN)GO TO 200
      IHOLID(NHOL)=NAME(1)
      GD(NHOL)=Z(LD)
      YN(NHOL)=Z(NO)
      XE(NHOL)=Z(IE)
  160 CONTINUE
      WRITE(*,170) NHOL
  170 FORMAT('+',I4,' UNQUALIFIED DATA POINTS HAVE BEEN STORED')
      IREJ=N-NHOL
      IF(IREJ.NE.0) WRITE(*,180) IREJ
  180 FORMAT(' ',I4,' QUALIFIED DATA POINTS HAVE BEEN REJECTED')
      IF(NHOL.GT.1) GO TO 220
      DO 190 I=1,5
      CALL SOUND(256,100)
  190 CONTINUE
  200 WRITE(IOUT,210) NHOL
  210 FORMAT(' INPUT DATA ERROR',3X,I5,' DATA POINTS STORED')
      STOP ' IMPOSSIBLE TO CONTINUE BECAUSE OF DATA PROBLEMS'
  220 N=NHOL
      RETURN
      END

      SUBROUTINE VARPRM
C***
      CHARACTER*8 IDSTP,IHOLID
      COMMON IHOLID(1500),XE(1500),YN(1500),GD(1500),KI,N,MAXN,IDSTP
      COMMON NEST,C0,C(5),AVALU(5),ANGLE(5),AFH(5),
     1SILL,ITYPE(5),SLOPE(5),AISI(5),BISI(5),CISI(5),IHOL(151)
C***  INITIALIZE VARIOGRAM PARAMETERS
      DO 10 I=1,5
      C(I)=0.
      ANGLE(I)=0.
      AFH(I)=1.
      AVALU(I)=0.
      ITYPE(I)=0
      SLOPE(I)=0.
   10 CONTINUE
      C0=0.
      WRITE(*,'(//,5X,''ENTER PARAMETERS OF THE VARIOGRAM(S)'',//)')
   20 WRITE(*,'(5X,''ENTER THE NUGGET VALUE : '',\)')
      READ(*,30,IOSTAT=IBAD) C0
      IF(IBAD.NE.0) CALL ERRMSG(2,*20)
   30 FORMAT(BN,F10.0)
      IF(C0.GE.0) GO TO 40
      CALL SOUND(256,100)
      WRITE(*,'('' NUGGET VALUE MUST NOT BE NEGATIVE'')')
      WRITE(*,60)
      GO TO 20
   40 WRITE(*,'(5X,''HOW MANY OTHER VARIOGRAMS ARE IN THE MODEL ?'',
     1'' (MAX=5) : '',\)')
      READ(*,50,IOSTAT=IBAD) NEST
   50 FORMAT(BN,I2)
      IF(IBAD.NE.0) CALL ERRMSG(1,*40)
      IF(NEST.LT.0.OR.NEST.GT.5) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' ANSWER MUST BE 0,1,2,3,4,OR 5'')')
      GO TO 40
      ENDIF
      IF(C0.EQ.0..AND.NEST.EQ.0) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' THE NUGGET VALUE AND THE NUMBER OF OTHER'',
     1'' VARIOGRAMS CANNOT BOTH'',/,'' BE EQUAL TO ZERO.  '',
     2''REDO OR BREAK.'')')
      WRITE(*,60)
      GO TO 20
      ENDIF
      WRITE(*,60)
   60 FORMAT(//)
C***  IF OTHER VARIOGRAMS ARE WANTED, EXECUTE THE FOLLOWING DO LOOP
      DO 180 I=1,NEST
   70 WRITE(*,'(5X,''IS VARIOGRAM NO. '',I1,'' (1) SPHERICAL, '',
     1''(2) EXPONENTIAL,'',/,5X,''(3) LINEAR, (4) GAUSSIAN, OR '',
     2''(5) CUBIC?'',/,20X,''ANSWER 1, 2, 3, 4, OR 5 : '',\)') I
      READ(*,50,IOSTAT=IBAD) ITYPE(I)
      IF(IBAD.NE.0) CALL ERRMSG(1,*70)
      IF(ITYPE(I).GE.1.AND.ITYPE(I).LE.5) GO TO 80
      CALL SOUND(256,100)
      GO TO  70
   80 WRITE(*,'(5X,''ENTER C-VALUE OF VARIOGRAM NO '',I1,'' : '',
     1\)') I
      READ(*,30,IOSTAT=IBAD) C(I)
      IF(IBAD.NE.0) CALL ERRMSG(2,*80)
      IF(C(I).GT.0.) GO TO 90
      CALL SOUND(256,100)
      WRITE(*,'('' C-VALUE MUST BE GREATER THAN ZERO'')')
      GO TO 80
   90 WRITE(*,'(5X,''ENTER A-VALUE OF VARIOGRAM NO '',I1,'' : '',
     1\)') I
      READ(*,30,IOSTAT=IBAD) AVALU(I)
      IF(IBAD.NE.0) CALL ERRMSG(2,*90)
      IF(AVALU(I).GT.0.) GO TO 100
      CALL SOUND(256,100)
      WRITE(*,'('' A-VALUE MUST BE GREATER THAN ZERO'')')
      GO TO 90
  100 IF(ITYPE(I).NE.3) GO TO 120
      IF(AVALU(I).LT.2.) GO TO 110
      CALL SOUND(256,100)
      WRITE(*,'(5X,''FOR LINEAR VARIOGRAM A-VALUE MUST BE GREATER '',
     1''THAN ZERO AND LESS THAN TWO'')')
      GO TO 90
  110 WRITE(*,'(5X,''ENTER SLOPE OF LINEAR VARIOGRAM NO. '',I1,'' : '',
     1\)') I
      READ(*,30,IOSTAT=IBAD) SLOPE(I)
      IF(IBAD.NE.0) CALL ERRMSG(2,*110)
      IF(SLOPE(I).GT.0.) GO TO 120
      CALL SOUND(256,100)
      WRITE(*,'('' SLOPE OF LINEAR VARIOGRAM MUST BE GREATER THAN '',
     1''ZERO'')')
      GO TO 110
  120 WRITE(*,'(5X,''IS VARIOGRAM NO '',I1,'' (1) ISOTROPIC OR (2) '',
     1''ANISOTROPIC ?'',/,20X,''ANSWER 1 OR 2 : '',\)') I
      READ(*,50,IOSTAT=IBAD) IANS
      IF(IBAD.NE.0) CALL ERRMSG(1,*120)
      IF(IANS.GE.1.AND.IANS.LE.2) GO TO 130
      CALL SOUND(256,100)
      GO TO 120
  130 IF(IANS.EQ.1) GO TO 170
      AFH(I)=0.
  140 WRITE(*,'(5X,''IS ANISOTROPY OF VARIOGRAM NO. '',I1,'' (1) '',
     1''GEOMETRIC OR (2) ZONAL ?'',/,20X,''ANSWER 1 OR 2 : '',\)') I
      READ(*,50,IOSTAT=IBAD) IANS
      IF(IBAD.NE.0) CALL ERRMSG(1,*140)
      IF(IANS.GE.1.AND.IANS.LE.2) GO TO 150
      CALL SOUND(256,100)
      GO TO 140
  150 WRITE(*,'(5X,''ENTER ANISOTROPY ANGLE OF VARIOGRAM NO. '',I1,
     1'' (DEC. DEG) : '',\)') I
      READ(*,30,IOSTAT=IBAD) ANGLE(I)
      IF(IBAD.NE.0) CALL ERRMSG(2,*150)
      IF(IANS.EQ.2) GO TO 170
  160 WRITE(*,'(5X,''ENTER ANISOTROPY FACTOR OF VARIOGRAM NO. '',I1,
     1''  : '',\)') I
      READ(*,30,IOSTAT=IBAD) AFH(I)
      IF(IBAD.NE.0) CALL ERRMSG(2,*160)
      IF(AFH(I).GE.0.) GO TO 170
      CALL SOUND(256,100)
      WRITE(*,'('' ANISOTROPY FACTOR MUST NOT BE NEGATIVE'')')
      GO TO 160
  170 WRITE(*,60)
  180 CONTINUE
C***  COMPUTE SILL VALUE
      SILL=C0
      DO 190 I=1,NEST
      SILL=SILL+C(I)
  190 CONTINUE
C***  COMPUTE ANISOTROPY CORRECTION FACTORS
      DO 200 I=1,NEST
C***  TEMPORARILY CHANGE SIGN OF ANGLE OF ANISOTROPY
      ANGLE(I)=-ANGLE(I)
      SINANG=SIN(ANGLE(I)*1.7453292D-02)
      COSANG=COS(ANGLE(I)*1.7453292D-02)
      AISI(I)=COSANG**2+AFH(I)*SINANG**2
      BISI(I)=SINANG**2+AFH(I)*COSANG**2
      CISI(I)=(1.-AFH(I))*SINANG*COSANG
      ANGLE(I)=-ANGLE(I)
  200 CONTINUE
      RETURN
      END
      FUNCTION CBAR(XMIN,XMAX,YMIN,YMAX)
C***  THIS FUNCTION COMPUTES THE VARIANCE OF A RECTANGULAR
C***  BLOCK, USING THE CAUCHY-GAUSS ALGORITHM. THE SIDES OF
C***  THE RECTANGLE MUST BE PARALLEL TO THE COORDINATE AXES.
C***  THIS FUNCTION IS ADAPTED FROM JOURNEL AND HUIJBREGTS FUNCTION F
C***  SEE MINING GEOSTATISTICS, PP. 106-108
C***  THIS FUNCTION WAS WRITTEN BY W.D. GRUNDY, MARCH 1981
C***  SUBPROGRAM REQUIRED: COVAR
      DIMENSION P(4),W(4),P1(2),H(2)
      DATA P/.0571,.2768,.5836,.86025/
      DATA W/.2710,.4069,.25969,.06235/
      DATA P1/2*0./
      CBAR=0.
      DO 20 I=1,4
      DO 20 J=1,4
      C=0.
      D1=XMAX-XMIN
      D2=YMAX-YMIN
      J1=-1
      J2=-1
      DO 10 IN=1,2
      J1=-J1
      DO 10 IM=1,2
      J2=-J2
      H(1)=J1*P(I)*D1
      H(2)=J2*P(J)*D2
      C=C+COVAR(P1,H)
   10 CONTINUE
      CBAR=CBAR+W(I)*W(J)*0.25*C
   20 CONTINUE
      RETURN
      END
      FUNCTION COVAR(P1,P2)
C***                COVARIANCE FUNCTION
C*** DERIVED FROM THE SUM OF COVARIANCES IN TWO DIMENSIONS
C*** SEE JOURNEL AND HUIJBREGTS FUNCTION COVA, P 382.
C*** THIS SUBPROGRAM WAS WRITTEN BY W.D. GRUNDY, MARCH 1981
      DIMENSION P1(2),P2(2)
      CHARACTER*8 IDSTP,IHOLID
      COMMON IHOLID(1500),XE(1500),YN(1500),GD(1500),KI,N,MAXN,IDSTP
      COMMON NEST,C0,C(5),AVALU(5),ANGLE(5),AFH(5),
     1SILL,ITYPE(5),SLOPE(5),AISI(5),BISI(5),CISI(5),IHOL(151)
      XD=P1(1)-P2(1)
      YD=P1(2)-P2(2)
      TEMP=0.
      IF((ABS(XD)+ABS(YD))-1.E-06) 10,10,20
   10 COVAR=SILL
      GO TO 120
   20 DO 110 I=1,NEST
C***  COMPUTE DISTANCE USING ANISOTROPY CORRECTION ALGORITHM
C***  SEE JOURNEL AND HUIJBREGTS, PP. 179-181
      A=AISI(I)*XD+CISI(I)*YD
      B=CISI(I)*XD+BISI(I)*YD
      H=SQRT(A*A+B*B)
      IF(H.LT.1.E-03.AND.AFH(I).EQ.0.) GO TO 110
      GO TO (30,50,70,80,90),ITYPE(I)
C***  SPHERICAL VARIOGRAM
   30 IF(H-AVALU(I)) 40,40,110
   40 E=H/AVALU(I)
      TEMP=TEMP+C(I)*(1.-1.5*E+0.5*E*E*E)
      GO TO 110
C***  EXPONENTIAL VARIOGRAM
C***  TEST FOR EXPONENTIAL UNDERFLOW
   50 TEST=-H/AVALU(I)
      IF(TEST+38.) 110,110,60
   60 TEMP=TEMP+C(I)*EXP(TEST)
      GO TO 110
C***  LINEAR VARIOGRAM
   70 TEMP=TEMP+C(I)-SLOPE(I)*H**(AVALU(I))
      GO TO 110
C***  GAUSSIAN VARIOGRAM
C***  TEST FOR EXPONENTIAL UNDERFLOW
   80 TEST=-((H/AVALU(I))**2)
      IF(TEST+38.) 110,110,60
C***  CUBIC VARIOGRAM
   90 IF(H-AVALU(I))100,100,110
  100 RR=H/AVALU(I)
      TEMP=TEMP+C(I)*(1.-7.*RR**2+8.75*RR**3
     1-3.5*RR**5+0.75*RR**7)
  110 CONTINUE
      COVAR=TEMP
  120 RETURN
      END
      SUBROUTINE HEAD(IUNIT)
C***  THIS SUBROUTINE WRITES OUT VARIOGRAM PARAMETERS FOR SS2DOUTL
      CHARACTER*8 IDSTP,IHOLID
      COMMON IHOLID(1500),XE(1500),YN(1500),GD(1500),KI,N,MAXN,IDSTP
      COMMON NEST,C0,C(5),AVALU(5),ANGLE(5),AFH(5),
     1SILL,ITYPE(5),SLOPE(5),AISI(5),BISI(5),CISI(5),IHOL(151)
      CHARACTER*4 IVRTYP(5)
      DATA IVRTYP/'SPHR','EXPO','LIN ','GAUS','CUB '/
      IF(NEST.NE.0) GO TO 20
      WRITE(IUNIT,10) C0
   10 FORMAT(//,' NUGGET ONLY MODEL --- NUGGET= ',F10.4)
      GO TO 40
   20 WRITE(IUNIT,30) C0,SILL,NEST,(I,IVRTYP(ITYPE(I)),C(I),ANGLE(I),
     1 AFH(I),AVALU(I),SLOPE(I),I=1,NEST)
   30 FORMAT(29X,'VARIOGRAM PARAMETERS',/,9X,'NUGGET = ',F10.3,5X,'SILL
     1 = ',F10.3,3X,'NO.STRUCTURES = ',I1,/,
     2' VARIOGRAM  C-VALUE    ANGLE     ANISOTROPY  A-VALUE      SLOPE',
     3/,'  NO. TYPE           ANISOTROPY    FACTOR              (IF LINE
     4AR)',/,(I4,2X,A4,1X,G9.3,1X,G9.3,3X,G9.3,2X,G9.3,2X,G9.3))
   40 RETURN
      END
