$NOFLOATCALLS
$STORAGE:2
      PROGRAM SS2DVCTL
C***
C***  THIS PROGRAM CREATES A CONTROL FILE FOR USE BY PROGRAM SS2DGAMH.
C***
C***  REFERENCE: SEE PROGRAM UGAMM IN
C***  Knudsen, H.P., and Kim, Y.C., 1977, A short course on geostatist-
C***      ical ore reserve estimation: College of mines, University of
C***      Arizona, Tucson, Arizona, 202 pages and appendices.
C***
C***                   DESCRIPTION OF CONTROL FILE CREATED
C***
C*** RECORD COL(S) FORMAT  VARIABLE          PURPOSE AND COMMENTS
C***   NO.  USED             NAME
C***
C***   1    1-79   19A4,A3   HEAD    IDENTIFICATION FOR VARIOGRAM RUN.
C***   2     1      I1       LOG     OPTION FOR NATURAL LOG TRANSFORM-
C***                                 ATION OF DATA; 1=YES;0=NO. USUALLY 0.
C***   2     3      I1       IPC     PUNCHOUT OPTION FOR PROGRAM VARPLOT.
C***                                 1=YES;0=NO.
C***   2     5      I1       LL      VARIOGRAM DISPLAY OPTION. 1=MOMENT
C***                                 CENTER;0=GAMMA(H). USUALLY 0.
C***                                 FOR EXPLANATION OF MOMENT CENTER
C***                                 SEE KNUDSEN AND KIM, P119-120.
C***   2     7      I1       ISCAL   AUTOMATIC SCALING OF GRAPH. 1=YES;
C***                                 0=NO. USUALLY 1.
C***   2     9      I1       NDIR    NUMBER OF VARIOGRAM DIRECTIONS SPECI- 
C***                                 FIED. MAXIMUM ALLOWED IS FIVE (5).
C***   2   13-24    F12.3    CLAS    CLASS INTERVAL TO BE USED TO GROUP
C***                                 DISTANCES. IT IS ALSO USED TO LIMIT
C***                                 THE DISTANCE BETWEEN HOLES FOR WHICH
C***                                 THE VARIOGRAM IS TO BE COMPUTED, I.E.,
C***                                 20*CLASS=MAXIMUM DISTANCE(H).
C***   2   24-40    F15.5    TMAX    MAXIMUM VARIOGRAM VALUE ON Y-AXIS OF GRAPH
C***                                 WHEN AUTOMATIC SCALING OPTION IS NOT USED.
C***                                 IF ISCAL=1, THIS VALUE IS NOT USED.
C***   3-1  1-6     F6.2     DANG(1) ANGLE IN DEGREES ALONG WHICH THE VARIO-
C***                                 GRAM IS TO BE CALCULATED:
C***                                 0 = EAST-WEST     45 = NORTHEAST-SOUTHWEST
C***                                 90= NORTH-SOUTH   -45= NORTHWEST-SOUTHEAST
C***   3-1 12-16    F6.2     DSPR(1) ALLOWABLE DEVIATION IN DEGREES.
C***                                 ADD ONLY AS MANY ADDITIONAL ANGLE AND DEV-
C***                                 IATION RECORDS AS NECESSARY TO EQUAL THE 
C***                                 NUMBER OF DIRECTIONS (NDIR) SELECTED.
C***   3-2  1-6     F6.2     DANG(2) ADD IF NDIR.GE.2
C***   3-2 12-16    F6.2     DSPR(2) ADD IF NDIR.GE.2
C***   3-3  1-6     F6.2     DANG(3) ADD IF NDIR.GE.3
C***   3-3 12-16    F6.2     DSPR(3) ADD IF NDIR.GE.3
C***   3-4  1-6     F6.2     DANG(4) ADD IF NDIR.GE.4
C***   3-4 12-16    F6.2     DSPR(4) ADD IF NDIR.GE.4
C***   3-5  1-6     F6.2     DANG(5) ADD IF NDIR.EQ.5
C***   3-5 12-16    F6.2     DSPR(5) ADD IF NDIR.EQ.5
C***   4     1      I1       ISEL    DATA SELECTION OPTION. 1=YES;0=NO.
C***                                 IF YES, THE BOUNDARIES WITHIN WHICH
C***                                 TO SEARCH THE ASSAY DATA MUST BE
C***                                 SPECIFIED ON THIS RECORD AS FOLLOWS:
C***   4    3-14    F12.3    YMIN    MINIMUM NORTH COORDINATE IF ISEL=1
C***                                 OTHER WISE NOT USED.
C***   4   16-27    F12.3    YMAX    MAXIMUM NORTH COORDINATE IF ISEL=1
C***   4   29-40    F12.3    XMIN    MINIMUM EAST-COORDINATE IF ISEL=1
C***   4   42-53    F12.3    XMAX    MAXIMUM EAST COORDINATE IF ISEL=1
C***
C***  LINKS REQUIRED: ASCIIZ, BYTMOV, CHEKER, CHRKNT, CKSAFE,
C***                  CONCAT, SOUND
C***  FILE NAME REQUIREMENTS
C***       THE CHARACTER OUTPUT FILE IS AUTOMATICALLY GIVEN THE
C***       EXTENSION .FVC (Formatted VCtl).
      LOGICAL FLAG
      CHARACTER*1 IANS
      CHARACTER*4 EXT,ID(20)
      CHARACTER*32 UNIT21
      DIMENSION DANG(5),DSPR(5)
      DATA LOG,IPC,LL,ISCAL,NREL,NDIR,CLAS,TMAX/6*0,2*0./
      DATA ISEL,YMIN,YMAX,XMIN,XMAX/0,4*0./
      DATA EXT/'.FVC'/
      KO=21
   10 WRITE(*,'('' '',''ENTER A ROOT NAME FOR THE CONTROL FILE '',
     1''TO BE CREATED: '',\)')
   20 READ(*,'(A32)') UNIT21
      CALL CHEKER(UNIT21,EXT,FLAG)
      IF(FLAG) GO TO 10
C***  CHECK FOR EXISTENCE OF OUTPUT FILE.  IF IT ALREADY EXISTS,
C***  DO NOT ALLOW IT TO BE OVERWRITTEN.  THIS CHECK CANNOT BE
C***  MADE WITH MICROSOFT FORTRAN V3.1X.
      CALL CKSAFE(UNIT21,1,FLAG)
      IF(FLAG) GO TO 10
      OPEN(KO,FILE=UNIT21,STATUS='NEW',FORM='FORMATTED')
      WRITE(*,30)
   30 FORMAT(5X,'ENTER 79 CHARACTER ID FOR VARIOGRAM RUN')
      READ(*,40)ID
   40 FORMAT(19A4,A3)
      WRITE(*,50)
   50 FORMAT(5X,'LOGARITHMIC CONVERSION WANTED? Y OR N: ',\)
      READ(*,60)IANS
   60 FORMAT(A1)
      IF(IANS.EQ.'Y'.OR.IANS.EQ.'y') LOG=1
      WRITE(*,70)
   70 FORMAT(5X,'PUNCH OUT OPTION WANTED? Y OR N: ',\)
      READ(*,60)IANS
      IF(IANS.EQ.'Y'.OR.IANS.EQ.'y') IPC=1
      WRITE(*,80)
   80 FORMAT(5X,'IS MOMENT CENTER DISPLAY OPTION WANTED? Y OR N: '
     1,\)
      READ(*,60)IANS
      IF(IANS.EQ.'Y'.OR.IANS.EQ.'y') LL = 1
      WRITE(*,90)
      ISCAL=1
   90 FORMAT(5X,'BY DEFAULT, SCALING OF THE GRAPH WILL BE ',
     1'AUTOMATIC',/,5X,'DO YOU WANT TO CHANGE THIS? Y OR N: ',\)
      READ(*,60)IANS
      IF(IANS.EQ.'Y'.OR.IANS.EQ.'y') ISCAL=0
      WRITE(*,100)
  100 FORMAT(5X,'IS RELATIVE VARIOGRAM WANTED? Y OR N: ',\)
      READ(*,60)IANS
      IF(IANS.EQ.'Y'.OR.IANS.EQ.'y') NREL=1
      WRITE(*,110)
  110 FORMAT(5X,'NUMBER OF VARIOGRAM DIRECTIONS? MAX = 5 : ',\)
      READ(*,140)NDIR
      WRITE(*,120)
  120 FORMAT(5X,'GIVE CLASS INTERVAL TO GROUP DISTANCES : ',\)
      READ(*,130)CLAS
  130 FORMAT(BN,F10.0)
  140 FORMAT(BN,I1)
      IF(ISCAL.EQ.1) GO TO 160
      WRITE(*,150)
  150 FORMAT(5X,'GIVE MAXIMUM VARIOGRAM VALUE FOR SCALING : ',\)
      READ(*,130)TMAX
  160 DO 190 I=1,NDIR
      WRITE(*,170)I
  170 FORMAT(5X,'ENTER ANGLE (DEC DEG) FOR VARIOGRAM ',I1,
     11X,': ',\)
      READ(*,220)DANG(I)
      WRITE(*,180)I
  180 FORMAT(5X,'ENTER WINDOW (DEC DEG) FOR VARIOGRAM ',I1,
     11X,': ',\)
      READ(*,220)DSPR(I)
  190 CONTINUE
      WRITE(*,200)
  200 FORMAT(5X,'DO YOU WANT TO SELECT COORDINATES? Y OR N: ',\)
      READ(*,60)IANS
      IF(IANS.EQ.'Y'.OR.IANS.EQ.'y') ISEL=1
      IF(ISEL.EQ.0) GO TO 260
      WRITE(*,210)
  210 FORMAT(5X,'ENTER MINIMUM NORTHING : ',\)
      READ(*,220)YMIN
  220 FORMAT(BN,F10.0)
      WRITE(*,230)
  230 FORMAT(5X,'ENTER MAXIMUM NORTHING : ',\)
      READ(*,220)YMAX
      WRITE(*,240)
  240 FORMAT(5X,'ENTER MINIMUM EASTING  : ',\)
      READ(*,220)XMIN
      WRITE(*,250)
  250 FORMAT(5X,'ENTER MAXIMUM EASTING  : ',\)
      READ(*,220)XMAX
  260 WRITE(KO,40)ID
      WRITE(KO,270) LOG,IPC,LL,ISCAL,NREL,NDIR,CLAS,TMAX
  270 FORMAT(6(I1,1X),F12.3,1X,F15.5)
      WRITE(KO,280) (DANG(I),DSPR(I),I=1,NDIR)
  280 FORMAT(F6.2,5X,F6.2)
      WRITE(KO,290)ISEL,YMIN,YMAX,XMIN,XMAX
  290 FORMAT(I1,1X,4(F12.3,1X))
      WRITE(*,'('' THE VARIOGRAM CONTROL FILE HAS BEEN WRITTEN'',/,
     1'' THE CHARACTER OUTPUT FILE IS '',A32)') UNIT21
      STOP 'NORMAL END OF PROGRAM'
      END

