$STORAGE:2

$NOFLOATCALLS
      PROGRAM STP2DAT
C
C***  PRODUCES AN ASCII FILE FROM AN UNFORMATTED STATPAC FILE.
C***  FOUR DIFFERENT TYPES OF ASCII FILES CAN BE CREATED:
C***       1) A ".DAT" FILE FOR INPUT TO GOLDEN SOFTWARE GRAPHICS
C***          PROGRAMS.
C***       2) A ".CHR" FILE FOR INPUT TO A. T. MIESCH'S STATPAC
C***          PROGRAMS WRITTEN IN BASIC (E.G., MAP$);
C***       3) A ".CMN" FILE FOR TELECOMMUNICATIONS WITH THE PRIME,
C***          DATA GENERAL, OR VAX MINICOMPUTERS;
C***       4) A ".DIF" (DATA INTERCHANGE FORMAT) FILE FOR USE AS
C***          INPUT TO THE LOTUS 1-2-3 SPREADSHEET PROGRAM.
C***       5) A ".EPA" FILE FOR INPUT TO GEOSTATISTICAL PROGRAMS
C***          WRITTEN BY THE ENVIRONMENTAL PROTECTION AGENCY;
C***       6) A ".GSP" FILE FOR INPUT TO BASIC PROGRAM GSPOST; OR
C***       7) A ".ALL" FILE FOR INPUT TO BASIC PROGRAM ALLMAP.
C***
C***  ADAPTED FROM PROGRAMS STP2CHR AND STP2CMN WRITTEN BY A. T. MIESCH
C***  AND FROM PROGRAM STP2DIF WRITTEN BY BILL THOEN.
C***  CODED BY W. D. GRUNDY     OCTOBER 1985, MARCH 1987
C***  APRIL 1988
C***
C***  LINKS REQUIRED: ASCIIZ, BYTMOV, CHEKER, CHRKNT, CKSAFE, CLEAR
C***                  CLREOL, CONCAT, CRSOFF, CRSON, DELAY, ERRCHK,
C***                  FNDCUR, FSTDSP, GCLPSP, INT21H, INTR, IOFS,
C***                  ISEG, MATCH, MOVCUR, ODOMTR, PCHCEN, SAVRST,
C***                  SCROLL, SOUND, UNPK.
C***
C
      CHARACTER*32 UNIT10,UNIT11
      CHARACTER*1 TAIL(33)
      CHARACTER*8 ROWID(2),IDS,IVID(100)
      CHARACTER*4 EXT(7)
      CHARACTER*1 IA(100),IANS
      INTEGER*4 LOC(2)
      LOGICAL FLAG
      DIMENSION X(100),IPACK(20),KOLUMN(50)
      EQUIVALENCE(UNIT10,TAIL(2))
      DATA EXT /'.DAT','.CHR','.CMN','.DIF','.EPA','.GSP','.ALL'/,
     1TAIL/33*' '/
      KI=10
      KO=11
      CALL FNDCUR(IRRR,ICCC,0)
      CALL CHGATR(79,2,IRRR-1,0,0)
      CALL DELAY(100)
      CALL CLEAR
C
C***  CHECK IF INPUT FILE NAME WAS TYPED ON THE COMMAND LINE
C
      CALL GCLPSP(KOUNT,TAIL)
      IF(UNIT10.NE.' ') GO TO 20
   10 WRITE(*,'(A\)') ' ENTER NAME OF STATPAC INPUT FILE: '
      READ(*,'(A)') UNIT10
   20 CALL CKSAFE(UNIT10,2,FLAG)
      IF(FLAG) GO TO 10
      OPEN(KI,FILE=UNIT10,FORM='UNFORMATTED',STATUS='OLD')
   30 WRITE(*,'(/,'' DO YOU WANT TO CREATE:'',/,6X,''1) A ".DAT"'',
     1'' FILE FOR GOLDEN SOFTWARE PROGRAMS,'',/,
     26X,''2) A ".CHR" FILE FOR INPUT TO THE BASIC'',
     3'' PROGRAMS,'',/,6X,''3) A ".CMN" FILE FOR TELECOMMUNICAT'',
     4''IONS,'',/,6X,''4) A ".DIF" FILE FOR INPUT TO LOTUS 1-2-3,'',
     5/,6X,''5) A ".EPA" FILE FOR INPUT TO THE EPA PROGRAMS,'',/,
     66X,''6) A ".GSP" FILE FOR INPUT TO THE GSPOST PROGRAM, OR'',/,
     76X,''7) A ".ALL" FILE FOR INPUT TO THE ALLMAP PROGRAM?'',/,
     79X,''ANSWER 1, 2, 3, 4, 5, 6, OR 7: '',\)')
      READ(*,'(A)') IANS
      IF(IANS.LT.'1'.OR.IANS.GT.'7') GO TO 30
      J=ICHAR(IANS)-48
   40 WRITE(*,'(A\)') ' GIVE A ROOT NAME FOR THE ASCII OUTPUT FILE: '
      READ(*,'(A)') UNIT11
      CALL CHEKER(UNIT11,EXT(J),FLAG)
      IF(FLAG) GO TO 40
      CALL CKSAFE(UNIT11,1,FLAG)
      IF(FLAG) GO TO 40
      OPEN(KO,FILE=UNIT11,FORM='FORMATTED',STATUS='UNKNOWN')
      READ(KI) IDS,N,M,(IVID(I),I=1,M)
      NPACK=(M+4)/5
      IF(IANS.EQ.'1')
     1CALL AU(KI,KO,N,M,IDS,IVID,ROWID,LOC,X)
      IF(IANS.EQ.'2')
     1CALL BAS(KI,KO,N,M,NPACK,IPACK,IA,IVID,ROWID,LOC,X)
      IF(IANS.EQ.'3')
     1CALL TELE(KI,KO,N,M,NPACK,IPACK,IA,IVID,ROWID,LOC,X)
      IF(IANS.EQ.'4')
     1CALL DIF(KI,KO,N,M,NPACK,IPACK,IA,IVID,ROWID,LOC,X)
      IF(IANS.EQ.'5')
     1CALL EPA(KI,KO,N,M,IDS,IVID,ROWID,LOC,X,IA)
      IF(IANS.EQ.'6')
     1CALL GSPOST(KI,KO,N,M,IDS,IVID,ROWID,LOC,X)
      IF(IANS.EQ.'7')
     1CALL ALLMAP(KI,KO,N,M,IDS,IVID,ROWID,LOC,X)
      WRITE(*,'(/,'' THE STATPAC INPUT FILE WAS '',A32,/,
     1'' THE ASCII OUTPUT FILE IS '',A32)') UNIT10,UNIT11
      STOP 'NORMAL END OF PROGRAM'
      END
      SUBROUTINE AU(KI,KO,N,M,IDS,IVID,ROWID,LOC,X)
      CHARACTER*8 IDS,IVID(100),ROWID(2)
      CHARACTER*16 FIELD(5)
      CHARACTER*1 FIELD1(80)
      INTEGER*4 LOC(2)
      DIMENSION X(1),KOLUMN(5)
      EQUIVALENCE (FIELD,FIELD1)
      MAXNUM=MIN0(5,M)
      WRITE(*,'(//,5X,''STATPAC INPUT FILE ID IS: '',A8,'' ;   COLUMN
     1IDS ARE:'',/)') IDS
      WRITE(*,'(5(1X,I2,'') '',A8))') (I,IVID(I),I=1,M)
   10 WRITE(*,'(/,'' HOW MANY VARIABLES DO YOU WANT ON THE OUT'',
     1''PUT FILE? (MAX= '',I2,''): '',\)') MAXNUM
      CALL ERRCHK(1,NUMVAR,DUMMY)
      IF(NUMVAR.LE.0.OR.NUMVAR.GT.MAXNUM) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' '',''NEED AN INTEGER FROM 1 TO '',I2)') MAXNUM
      GO TO 10
      ENDIF
      WRITE(*,'(/,'' ENTER COLUMN NUMBERS OF STATPAC VARIABLES IN'',
     1'' THE SEQUENCE YOU WANT'',/,'' THEM TO BE ON THE ASCII'',
     2'' OUTPUT FILE.'')')
      DO 30 I=1,NUMVAR
   20 WRITE(*,'('' ENTER COLUMN NUMBER OF STATPAC VARIABLE FOR '',
     1''FIELD NO.'',I2,'': '',\)') I
      CALL ERRCHK(1,KOLUMN(I),DUMMY)
      IF(KOLUMN(I).LE.0.OR.KOLUMN(I).GT.M) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' NEED AN INTEGER FROM 1 TO '',I3)') M
      GO TO 20
      ENDIF
   30 CONTINUE
      WRITE(*,'(A)') '        ...READING DATA'
      CALL FNDCUR(IRRR,ICCC,0)
      DO 50 I=1,N
      READ(KI) IROW,ROWID,LOC,(X(J),J=1,M)
      DO 40 J=1,NUMVAR
      K=KOLUMN(J)
      WRITE(FIELD(J),'(E14.7,'', '')') X(K)
   40 CONTINUE
      WRITE(KO,'(80A1)') (FIELD1(K),K=1,NUMVAR*16-2)
      IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
   50 CONTINUE
      ENDFILE(KO)
      WRITE(*,'(''+'',I5)') N
      RETURN
      END
      SUBROUTINE BAS(KI,KO,N,M,NPACK,IPACK,IA,IVID,ROWID,LOC,X)
      CHARACTER*8 ROWID(2),IVID(100)
      CHARACTER*1 IA(M)
      INTEGER*4 LOC(2)
      DIMENSION X(M),IPACK(1)
      WRITE(KO,'(I5,'','',I3)') N,M
      WRITE(KO,'(A8)') (IVID(I),I=1,M)
C
      WRITE(*,'(A)') '       ....READING DATA'
      CALL FNDCUR(IRRR,ICCC,0)
      DO 10 I=1,N
      IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
      READ(KI) IROW,ROWID,LOC,(X(J),J=1,M),(IPACK(J),J=1,NPACK)
      CALL UNPK(IA,M,IPACK)
      WRITE(KO,'(I5,'','',A8,'','',A8,'','',I8,
     1'','',I8)') I,ROWID,LOC
      WRITE(KO,'(E15.8,'','',A1)') (X(J),IA(J),J=1,M)
   10 CONTINUE
      WRITE(*,'(''+'',I5)') N
      WRITE(KO,'(A)') CHAR(26)
      RETURN
      END
      SUBROUTINE TELE(KI,KO,N,M,NPACK,IPACK,IA,IVID,ROWID,LOC,X)
      CHARACTER*8 ROWID(2),IVID(100)
      CHARACTER*1 IA(M),IANS
      INTEGER*4 LOC(2)
      DIMENSION X(M),IPACK(1)
      WRITE(KO,'(I5,'','',I3)') N,M
      WRITE(KO,'(4(1X,A8))') (IVID(I),I=1,M)
C
      WRITE(*,'(A)') '       ....READING DATA'
      CALL FNDCUR(IRRR,ICCC,0)
      DO 10 I=1,N
      IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
      READ(KI) IROW,ROWID,LOC,(X(J),J=1,M),(IPACK(J),J=1,NPACK)
      CALL UNPK(IA,M,IPACK)
      WRITE(KO,'(I5,1X,A8,1X,A8,I8,1X,I8)')
     1I,ROWID,LOC
      WRITE(KO,'(4(1X,E15.8,A1))') (X(J),IA(J),J=1,M)
   10 CONTINUE
      WRITE(*,'(''+'',I5)') N
      RETURN
      END
      SUBROUTINE DIF(KI,KO,N,M,NPACK,IPACK,IA,IVID,ROWID,LOC,X)
C
C***  HAS OPTION OF STRIPPING QUALIFYING CODES.  WHEN QUALIFYING CO
C***  ARE STRIPPED, THERE IS NO REPLACEMENT OF THE NUMERIC VALUES.
C***  YOU HAVE ANY NON-BLANK CODES, YOU SHOULD RUN PROGRAM REPLAC F
C***  OR MANUALLY SUBSTITUTE APPROPRIATE ESTIMATES FOR THE QUALIFIE
C***  NUMERIC VALUES.
C***
C***  ALL QUALIFYING CODES ARE CHECKED AND IF CODES L, G, H, OR B
C***  ARE DETECTED AND THE CORRESPONDING NUMERIC VALUE IS ZERO (0.0
C***  THE VALUE OF 0 IS CONVERTED INTO A BLANK CHARACTER (ASCII 32)
C
      CHARACTER*8  ROWID(2),IDS,IVID(100)
      CHARACTER*1 IA(M),IANS
      INTEGER*4 LOC(2)
      LOGICAL QUAL,SECID,LATLON
      DIMENSION X(M),IPACK(1)
      WRITE(*,'(A)') ' DO YOU WANT TO INCLUDE:'
      WRITE(*,'(A\)') '      THE SECONDARY ROW ID? Y/N: '
      READ(*,'(A)') IANS
      SECID=IANS.EQ.'Y'.OR.IANS.EQ.'y'
      WRITE(*,'(A\)') '      THE LAT-LONG VALUES?  Y/N: '
      READ(*,'(A)') IANS
      LATLON=IANS.EQ.'Y'.OR.IANS.EQ.'y'
      WRITE(*,'(A\)') '      THE QUALIFING CODES?  Y/N: '
      READ(*,'(A)')IANS
      QUAL=IANS.EQ.'Y'.OR.IANS.EQ.'y'
C
C***  WRITE HEADER FOR ".DIF" FILE
C
      WRITE(KO,'(''TABLE'',/,''0,1'',/,''""'')')
      WRITE(KO,'(''VECTORS'',/,''0,'',I4,/,''""'')') M+1
      WRITE(KO,'(''TUPLES'',/,''0,'',I4,/,''""'')') N+1
      WRITE(KO,'(''DATA'',/,''0,0'',/,''""'')')
      WRITE(KO,'(''-1,0'',/,''BOT'')')
C
C***  WRITE THE HEADER VARIABLE NAMES
C
      WRITE(KO,'(''1,0'',/,''"SMPL  ID"'')')
      IF(SECID) WRITE(KO,'(''1,0'',/,''"SECND ID"'')')
      IF(LATLON) WRITE(KO,'(''1,0'',/,''"LAT     "'',/,''1,0'',/,
     1''"LONG    "'')')
C
C***  WRITE VARIABLE IDS
C
      DO 10 I=1,M
      WRITE(KO,'(''1,0'',/,''"'',A8,''"'')') IVID(I)
      IF(QUAL) WRITE(KO,'(''1,0'',/,''" "'')')
   10 CONTINUE
C
C***  WRITE A ".DIF" FILE TUPLE TERMINATOR RECORD
C
      WRITE(KO,'(''-1,0'',/,''BOT'')')
C
C***  READ IN STATPAC DATA RECORDS
C
      WRITE(*,'(''      ...READING DATA'')')
      CALL FNDCUR(IRRR,ICOL,0)
      DO 30 I=1,N
      IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
      READ(KI) IROW,ROWID,LOC,(X(J),J=1,M),(IPACK(J),J=1,NPACK)
      CALL UNPK(IA,M,IPACK)
C
C***  WRITE RECORD TO ".DIF" FILE
C
      WRITE(KO,'(''1,0'',/,''"'',A8,''"'')') ROWID(1)
      IF(SECID) WRITE(KO,'(''1,0'',/,''"'',A8,''"'')') ROWID(2)
      IF(LATLON) WRITE(KO,'(''0,'',I8,/,''V'',/,''0,'',I8,/,''V'')')
     1LOC
      DO 20 J=1,M
      IF(IA(J).EQ.'L'.AND.X(J).EQ.0.) THEN
      WRITE(KO,'(''0,'',F16.5,/,'' '')') X(J)
      ELSEIF(IA(J).EQ.'G'.AND.X(J).EQ.0) THEN
      WRITE(KO,'(''0,'',F16.5,/,'' '')') X(J)
      ELSEIF(IA(J).EQ.'H'.AND.X(J).EQ.0) THEN
      WRITE(KO,'(''0,'',F16.5,/,'' '')') X(J)
      ELSEIF(IA(J).EQ.'B'.AND.X(J).EQ.0) THEN
      WRITE(KO,'(''0,'',F16.5,/,'' '')') X(J)
      ELSE
      WRITE(KO,'(''0,'',F16.5,/,''V'')') X(J)
      ENDIF
      IF(QUAL) WRITE(KO,'(''1,0'',/,''"'',A1,''"'')') IA(J)
   20 CONTINUE
C
C***  TERMINATE THE TUPLES ROW
C
      IF(I.LT.N) WRITE(KO,'(''-1,0'',/,''BOT'')')
   30 CONTINUE
C
C***  TERMINATE THE DATA TABLE
C
      WRITE(KO,'(''-1,0'',/,''EOD'')')
      WRITE(*,'(''+'',I5)') N
      END
      SUBROUTINE EPA(KI,KO,N,M,IDS,IVID,ROWID,LOC,X,IA)
      CHARACTER*16 FIELD(100)
      CHARACTER*2 WORD(800)
      CHARACTER*1 IA(M)
      EQUIVALENCE (FIELD,WORD)
      CHARACTER*8 IDS,IVID(100),ROWID(2)
      INTEGER*4 LOC(2)
      DIMENSION IPACK(20)
      DIMENSION X(1),KOLUMN(50)
      WRITE(*,'('' NOTE: QUALIFIED VALUES ARE REPLACED BY '',
     1''THE NUMERIC VALUE 1.E31'')')
      JAXNUM=MIN0(10,M)
      NPACK=(M+4)/5
      WRITE(*,'(//,5X,''STATPAC INPUT FILE ID IS: '',A8,'' ;   COLUMN
     1IDS ARE:'',/)') IDS
      WRITE(*,'(5(1X,I2,'') '',A8))') (I,IVID(I),I=1,M)
   10 WRITE(*,'(/,'' HOW MANY VARIABLES DO YOU WANT ON THE OUT'',
     1''PUT FILE? (MAX= '',I2,''): '',\)') JAXNUM
      CALL ERRCHK(1,NUMVAR,DUMMY)
      IF(NUMVAR.LE.0.OR.NUMVAR.GT.JAXNUM) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' '',''NEED AN INTEGER FROM 1 TO '',I2)') JAXNUM
      GO TO 10
      ENDIF
      WRITE(*,'(/,'' ENTER COLUMN NUMBERS OF STATPAC VARIABLES IN'',
     1'' THE SEQUENCE YOU WANT'',/,'' THEM TO BE ON THE ASCII'',
     2'' OUTPUT FILE.'')')
      DO 30 I=1,NUMVAR
   20 WRITE(*,'('' ENTER COLUMN NUMBER OF STATPAC VARIABLE FOR '',
     1''FIELD NO.'',I2,'': '',\)') I
      CALL ERRCHK(1,KOLUMN(I),DUMMY)
      IF(KOLUMN(I).LE.0.OR.KOLUMN(I).GT.M) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' NEED AN INTEGER FROM 1 TO '',I3)') M
      GO TO 20
      ENDIF
   30 CONTINUE
      WRITE(KO,'(A8)') IDS
      WRITE(KO,'(I2)') NUMVAR
      DO 40 J=1,NUMVAR
      K=KOLUMN(J)
      WRITE(KO,'(A8)') IVID(K)
   40 CONTINUE
      WRITE(*,'(A)') '        ...READING DATA'
      CALL FNDCUR(IRRR,ICCC,0)
      DO 60 I=1,N
      READ(KI) IROW,ROWID,LOC,(X(J),J=1,M),(IPACK(K),K=1,NPACK)
      CALL UNPK(IA,M,IPACK)
      DO 50 J=1,NUMVAR
      K=KOLUMN(J)
      IF(IA(K).NE.' ') X(K)=1.E31
      WRITE(FIELD(J),'(E14.7,'', '')') X(K)
      IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
   50 CONTINUE
      WRITE(KO,'(40A2)') (WORD(K),K=1,NUMVAR*8-1)
      IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
   60 CONTINUE
      WRITE(*,'(''+'',I5)') N
      RETURN
      END
      SUBROUTINE GSPOST(KI,KO,N,M,IDS,IVID,ROWID,LOC,X)
      CHARACTER*8 IDS,IVID(100),ROWID(2)
      CHARACTER*10 FIELD(50), TEMP(1)
      CHARACTER*1 TEMP1(10), IANS
      LOGICAL WEST, NORTH
      INTEGER*4 LOC(2)
      EQUIVALENCE (TEMP,TEMP1)
      DIMENSION X(1),KOLUMN(50)
      MAXNUM=MIN0(50,M)-2
      WRITE(*,'(//,5X,''STATPAC INPUT FILE ID IS: '',A8,'' ;
     1COLUMN IDS ARE:'',/)') IDS
      WRITE(*,'(5(1X,I2,'') '',A8))') (I,IVID(I),I=1,M)
      WRITE(*,'(/,6X,''PROGRAM AUTOMATICALLY INSERTS A ZERO'',
     1'' IN VAR. 3 OF OUTPUT FILE'',/,6X,''FOR A UNIFORM ANGLE'',
     2'' OF POSTING (AT RIGHT).  IF A DIFFERENT ANGLE'',/,
     36X,''IS NEEDED, EITHER CHANGE IDEG IN PROGRAM OR CHANGE'',
     4'' THE ASCII OUTPUT'',/,6X,''FILE IN TEXT EDITOR.  DATA'',
     5'' FORMAT CURRENTLY SET AT F9.3.'')')
      WRITE(*,'(/,6X,''ENTER COLUMN NUMBERS OF STATPAC VARIABLES IN'',
     1'' THE SEQUENCE'',/,6X,''YOU WANT THEM TO BE ON THE ASCII '',
     2''OUTPUT FILE.  PROGRAM'',/,6X,''REQUIRES LAT AND LONG VALU'',
     3''ES TO BE PRESENT IN THE STATPAC FILE.'')')
      CALL LATLON(M,IVID,LAT,LONG)
   10 WRITE(*,'(/,6X,''HOW MANY VARIABLES (DO NOT COUNT LAT, LONG)'',
     1/,6X,''DO YOU WANT ON THE OUTPUT FILE? (MAX= '',I2,''): '',
     2\)') MAXNUM
      CALL ERRCHK(1,NUMVAR,DUMMY)
      IF(NUMVAR.LE.0.OR.NUMVAR.GT.MAXNUM) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' '',''NEED AN INTEGER FROM 1 TO '',I2)') MAXNUM
      GO TO 10
      ENDIF
      DO 30 I=1,NUMVAR
   20 WRITE(*,'(6X,''ENTER COLUMN NUMBER OF STATPAC VARIABLE FOR '',
     1''FIELD NO.'',I2,'': '',\)') I
      CALL ERRCHK(1,KOLUMN(I),DUMMY)
      IF(KOLUMN(I).EQ.LAT.OR.KOLUMN(I).EQ.LONG) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' LAT-LONG ALREADY ACCOUNTED FOR.'')')
      GO TO 20
      ENDIF
      IF(KOLUMN(I).LE.0.OR.KOLUMN(I).GT.M) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' NEED AN INTEGER FROM 1 TO '',I3)') M
      GO TO 20
      ENDIF
   30 CONTINUE
      WRITE(*,'(6X,''ARE THE LOCATIONS IN THE NORTHERN HEMISPHERE'',
     1''? Y/N: '',\)')
      READ(*,'(A)') IANS
      NORTH=IANS.EQ.'Y'.OR.IANS.EQ.'y'
      WRITE(*,'(6X,''ARE THE LOCATIONS IN THE WESTERN HEMISPHERE?'',
     1'' Y/N: '',\)')
      READ(*,'(A)') IANS
      WEST=IANS.EQ.'Y'.OR.IANS.EQ.'y'
      WRITE(*,'(A)') '        ...READING DATA'
      CALL FNDCUR(IRRR,ICCC,0)
      IDEG=0
      DO 80 I=1,N
      READ(KI) IROW,ROWID,LOC,(X(J),J=1,M)
      DO 60 J=1,NUMVAR
      K=KOLUMN(J)
      WRITE(TEMP(1),'(F9.3,'' '')') X(K)
      DO 40 MM=9,7,-1
      IF(TEMP1(MM).NE.'0') GO TO 50
      TEMP1(MM)=' '
   40 CONTINUE
      TEMP1(6)=' '
   50 FIELD(J)=TEMP(1)
   60 CONTINUE
      IF(.NOT.NORTH) X(LAT)=-ABS(X(LAT))
      IF(WEST) X(LONG)=-ABS(X(LONG))
      WRITE(KO,70) ROWID(1),X(LAT),X(LONG),IDEG,(FIELD(K),K=1,
     1NUMVAR)
   70 FORMAT(1X,A8,',',F10.5,1X,F10.5,1X,I3,1X,50A10)
      IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
   80 CONTINUE
      ENDFILE(KO)
      WRITE(*,'(''+'',I5)') N
      RETURN
      END
      SUBROUTINE ALLMAP(KI,KO,N,M,IDS,IVID,ROWID,LOC,X)
      CHARACTER*8 IDS,IVID(100),ROWID(2)
      CHARACTER*16 FIELD(5)
      CHARACTER*1 FIELD1(80)
      LOGICAL ZVCH, WEST, SOUTH, LL
      INTEGER*4 LOC(2)
      DIMENSION X(1),KOLUMN(5)
      EQUIVALENCE (FIELD,FIELD1)
      MAXNUM=MIN0(5,M)
      WRITE(*,'(//,5X,''STATPAC INPUT FILE ID IS: '',A8,'' ;   COLUMN
     1IDS ARE:'',/)') IDS
      WRITE(*,'(5(1X,I2,'') '',A8))') (I,IVID(I),I=1,M)
   10 WRITE(*,'(/,'' DO YOU WANT THE OUTPUT FILE TO CONTAIN:'',/,
     16X,''1) X-COOR., Y-COOR., Z-VALUE;'',/,6X,''2) X-COOR., Y-'',
     2''COOR., PRIMARY ROWID;'',/,6X,''3) LATITUDE, LONGITUDE,'',
     3'' Z-VALUE; OR'',/,6X,''4) LATITUDE, LONGITUDE, PRIMARY '',
     4''ROWID?''/,9X,''ANSWER 1, 2, 3, OR 4: '',\)')
      CALL ERRCHK(1,JANS,DUMMY)
      IF(JANS.LT.0.OR.JANS.GT.4) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' '',''NEED AN INTEGER FROM 1 TO 4.'')')
      GO TO 10
      ENDIF
      LL=JANS.EQ.3.OR.JANS.EQ.4
      IF(.NOT.LL) THEN
   20 WRITE(*,'(/,6X,''ENTER COLUMN NUMBER OF X-COORDINATE: '',\)')
      CALL ERRCHK(1,IXCOL,DUMMY)
      IF(IXCOL.LT.0.OR.IXCOL.GT.M) THEN
      CALL SOUND(256,100)
      WRITE(*,30) M
   30 FORMAT(' NEED A VALUE FROM 1 TO ',I2)
      GO TO 20
      ENDIF
   40 WRITE(*,'(6X,''ENTER COLUMN NUMBER OF Y-COORDINATE: '',\)')
      CALL ERRCHK(1,IYCOL,DUMMY)
      IF(IYCOL.LT.0.OR.IYCOL.GT.M) THEN
      CALL SOUND(256,100)
      WRITE(*,30) M
      GO TO 40
      ENDIF
      ELSE
      CALL LATLON(M,IVID,LAT,LONG)
      IXCOL=LAT
      IYCOL=LONG
   50 WRITE(*,'(/,'' ARE THE LONGITUDES IN'',/,6X,''1) THE WE'',
     1''STERN, OR'',/,6X,''2) THE EASTERN HEMISPHERES?'',/,9X,
     2''ANSWER 1 OR 2: '',\)')
      CALL ERRCHK(1,IANS,DUMMY)
      IF(IANS.LT.1.OR.IANS.GT.2) GO TO 50
      WEST=IANS.EQ.1
   60 WRITE(*,'(/,'' ARE THE LATITUDES IN'',/,6X,''1) THE NOR'',
     1''THERN, OR'',/,6X,''2) THE SOUTHERN HEMISPHERES?'',/,9X,
     2''ANSWER 1 OR OR 2: '',\)')
      CALL ERRCHK(1,IANS,DUMMY)
      IF(IANS.LT.1.OR.IANS.GT.2) GO TO 60
      SOUTH=IANS.EQ.2
      ENDIF
      ZVCH=(JANS.EQ.1.OR.JANS.EQ.3)
      IF(ZVCH) THEN
   70 WRITE(*,'(6X,''ENTER COLUMN NUMBER OF THE Z-VALUE: '',\)')
      CALL ERRCHK(1,IZCOL,DUMMY)
      IF(IZCOL.LT.0.OR.IZCOL.GT.M) THEN
      CALL SOUND(256,100)
      WRITE(*,30) M
      GO TO 70
      ENDIF
      ENDIF
      WRITE(*,'(A)') '        ...READING DATA'
      CALL FNDCUR(IRRR,ICCC,0)
      DO 80 I=1,N
      READ(KI) IROW,ROWID,LOC,(X(J),J=1,M)
      IF(LL) THEN
      IF(SOUTH) X(IXCOL)=-ABS(X(IXCOL))
      IF(WEST)  X(IYCOL)=-ABS(X(IYCOL))
      ENDIF
      IF(ZVCH) THEN
      WRITE(KO,'(E14.7,'','',E14.7,'','',E14.7)') X(IXCOL),X(IYCOL),
     1X(IZCOL)
      ELSE
      WRITE(KO,'(E14.7,'', '',E14.7,'', '',A8)') X(IXCOL),X(IYCOL),
     1ROWID(1)
      ENDIF
      IF(MOD(I,10).EQ.0) CALL ODOMTR(IRRR,I)
   80 CONTINUE
      ENDFILE(KO)
      WRITE(*,'(''+'',I5)') N
      RETURN
      END
      SUBROUTINE LATLON(M,IVID,LAT,LONG)
      CHARACTER*8 IVID(1)
      CHARACTER IANS
      L=8*M
      CALL CHGCAS(IVID,L,1)
      I=MATCH(IVID,L,'LAT',3,' ')-1
      IF(I.LT.0.OR.I/8.NE.(I+5)/8) GO TO 30
      LAT=I/8+1
      I=MATCH(IVID,L,'LONG',4,' ')-1
      IF(I.LT.0.OR.I/8.NE.(I+4)/8) GO TO 30
      LONG=I/8+1
   10 IF(LAT.NE.LONG.AND.LAT.NE.0.AND.LONG.NE.0) THEN
   20 WRITE(*,'(/,6X,''LATITUDE = VARIABLE '',I3,/,6X,
     1''LONGITUDE  = VARIABLE '',I3,/,9X,
     2''IS THIS CORRECT? Y/N: '',\)') LAT,LONG
      READ(*,'(A)') IANS
      IF(IANS.NE.'Y'.AND.IANS.NE.'y'.AND.IANS.NE.'N'.AND.IANS.
     1NE.'n') THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' YOU MUST ANSWER YES OR NO.'
      GO TO 20
      ENDIF
      IF(IANS.EQ.'Y'.OR.IANS.EQ.'y') GO TO 60
      ENDIF
   30 WRITE(*,'(/,6X,''WHICH VARIABLE IS LATITUDE? '',\)')
      CALL ERRCHK(1,LAT,DUMMY)
      IF(LAT.LE.0.OR.LAT.GT.M) GO TO 30
   40 FORMAT(BN,I3)
   50 WRITE(*,'(6X,''WHICH VARIABLE IS LONGITUDE? '',\)')
      CALL ERRCHK(1,LONG,DUMMY)
      IF(LONG.LE.0.OR.LONG.GT.M) GO TO 50
   60 RETURN
      END
