$NOFLOATCALLS
$STORAGE:2
      PROGRAM STPSORT
C***  ADAPTED BY W. D. GRUNDY FROM UNPUBLISHED U.S. ATOMIC ENERGY
C***  COMMISSION COMPUTER PROGRAMS  APRIL 1984
C***
C***  THIS PROGRAM SORTS A STATPAC INPUT FILE BY PRIMARY ROW ID,
C***  BY SECONDARY ROW ID, OR BY ONE, TWO, OR THREE STATPAC VARIABLES.
C***  THE USER MAY SPECIFY WHETHER SORTING IS TO BE IN ASCENDING
C***  OR IN DESCENDING ORDER.  IF A SORT IS REQUESTED ON A STATPAC
C***  VARIABLE, THE USER MAY SPECIFY THAT THE SORTING BE DONE ON THE
C***  ABSOLUTE VALUE OF THE VARIABLE RATHER THAN ITS ACTUAL VALUE.
C***  THE SORTED ROWS ARE WRITTEN ON A STATPAC OUTPUT FILE.
C***  AS CURRENTLY DIMENSIONED, THE PROGRAM WILL HANDLE A FILE OF
C***  NOT MORE THAN 3000 ROWS AND NOT MORE THAN 100 COLUMNS.
C***
C***  LINKS REQUIRED: ASCIIZ, B2SORT, CHRKNT, CKSAFE, CONCAT, DOSREN,
C***                  FSORT, ROSORT, SOUND, TICKER
C***
      INTEGER*4 LOC(2)
      INTEGER*4 ITIME1,ITIME2
      LOGICAL FILERR
      CHARACTER*32 FILE10,FILE11
      CHARACTER*8 TEMP,TEMP1,IHOLID,IDS,IVID(100),ROWID
      CHARACTER*5 MAJOR,MINOR,THIRD
      CHARACTER*4 NAME(4)
      CHARACTER*1 FLAG,ABSV1,ANS
      DIMENSION IPOINT(3000),VAR1(3000),VAR2(3000),VAR3(3000),X(100)
      DIMENSION IPACK(20)
      COMMON /CHAR/ IHOLID(3000)
      EQUIVALENCE (TEMP,NAME(1)),(TEMP1,NAME(3))
      DATA MAJOR,MINOR,THIRD/'MAJOR','MINOR','THIRD'/
      DATA ROWID/'ROW IDS '/
      DATA MAXROW/3000/,MAXCOL/100/
C**********************************************************************
C***
C***  INITIALIZE TIMING OF PROGRAM RUN AND OTHER NECESSARY VARIABLES
C***
      CALL TICKER(ITIME1)
C***  KI IS INPUT UNIT; KO IS OUTPUT UNIT; KS IS SCRATCH UNIT
      KI=10
      KO=11
      KS=13
      IABSV1=0
      IABSV2=0
      IABSV3=0
      IORDR=0
      IORDR1=0
      IORDR2=0
      IRODR3=0
C**********************************************************************
C***
C***  GET NAMES OF INPUT/OUTPUT FILES
C***
   10 WRITE(*,'(A\)')' WHAT IS NAME OF STATPAC INPUT FILE? '
      READ(*,'(A32)') FILE10
      CALL CKSAFE(FILE10,2,FILERR)
      IF(FILERR) GO TO 10
      OPEN(KI,FILE=FILE10,STATUS='OLD',FORM='UNFORMATTED')
      READ(KI) IDS,N,M
      IF(N.GT.MAXROW.OR.M.GT.MAXCOL) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' TOO MANY ROWS OR COLUMNS IN THE INPUT FILE'',/,'' 
     1MAXIMUM ALLOWABLE IS '',I4,'' ROWS AND '',I3,'' COLUMNS'',)') 
     2MAXROW,MAXCOL
      STOP
      ENDIF
      REWIND(KI)
   20 WRITE(*,'(A\)')' GIVE A NAME FOR THE STATPAC OUTPUT FILE: '
      READ(*,'(A32)') FILE11
      CALL CKSAFE(FILE11,1,FILERR)
      IF(FILERR) GO TO 20
      OPEN(KO,FILE=FILE11,STATUS='NEW',FORM='UNFORMATTED')
C***  READ STATPAC HEADER RECORD
      READ(KI) IDS,N,M,(IVID(I),I=1,M)
      NPACK=(M+4)/5
C***  COMPUTE RECORD LENGTH FOR DIRECT ACCESS SCRATCH FILE
      LENREC=24+4*M+2*NPACK
C***  OPEN DIRECT ACCESS SCRATCH FILE
      OPEN(KS,FILE='SCRATCH',ACCESS='DIRECT',STATUS='NEW',
     1RECL=LENREC,FORM='UNFORMATTED')
C**********************************************************************
C***
C***  GET USER'S SPECIFICATIONS FOR THE SORT
C***
      WRITE(*,'(A\)')' DO YOU WANT TO SEE THE COLUMN IDS? Y/N: '
      READ(*,'(A)') ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') THEN
      WRITE(*,30) IDS,N,M
   30 FORMAT(' ',//,5X,'STATPAC INPUT FILE ID IS: ',A8,
     1' N= ',I4,' M= ',I2,/,5X,'COLUMN IDS ARE:')
      WRITE(*,'('' '')')
      WRITE(*,40) (I,IVID(I),I=1,M)
   40 FORMAT(5(1X,I2,')',A8))
      ENDIF
   50 WRITE(*,60) FILE10
   60 FORMAT(//,5X,'DO YOU WANT TO SORT FILE ',A32,/,10X,'1) BY PRI',
     1'MARY ROW ID',/,10X,'2) BY SECONDARY ROW ID',/,10X,'3) BY A ',
     2'SELECTED STATPAC VARIABLE,',/,10X,'4) BY TWO SELECTED STATPAC ',
     3'VARIABLES, OR',/,10X,'5) BY THREE SELECTED STATPAC VARIABLES?',
     4/,13X,'ANSWER 1, 2, 3, 4, OR 5: ',\)
      READ(*,'(A1)') FLAG
      IFLAG=ICHAR(FLAG)-48
      IF(IFLAG.LT.1.OR.IFLAG.GT.5) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' YOU MUST ANSWER 1, 2, 3, 4, OR 5'
      GO TO 50
      ENDIF
      IF(IFLAG.EQ.3) THEN
   70 WRITE(*,'(A\)')'      ENTER COLUMN NUMBER OF SELECTED VARIABLE: '
      READ(*,80,ERR=90) ICOL1
   80 FORMAT(BN,I2)
      GO TO 100
   90 CALL SOUND(256,100)
      WRITE(*,'(A)') ' INTEGER VALUE IS REQUIRED.  REDO.'
      GO TO 70
  100 IF(ICOL1.LT.0.OR.ICOL1.GT.M) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' SPECIFIED COLUMN NUMBER DOES NOT EXIST.  REDO.'
      GO TO 70
      ENDIF
  110 WRITE(*,120) IVID(ICOL1)
  120 FORMAT(5X,'DO YOU WANT TO SORT ',A8,/,
     110X,'1) BY ITS ACTUAL VALUE, OR',/,10X,'2) BY ITS ABSOLUTE VALUE?
     2',/,13X,'ANSWER 1 OR 2: ',\)
      READ(*,'(A1)') ABSV1
      IABSV1=ICHAR(ABSV1)-48
      IF(IABSV1.LT.1.OR.IABSV1.GT.2) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' YOU MUST ANSWER 1 OR 2'
      GO TO 110
      ENDIF
  130 WRITE(*,140) IVID(ICOL1)
  140 FORMAT(5X,'DO YOU WANT TO SORT ',A8,/,10X,'1) IN ASCENDING',
     1' ORDER, OR',/,10X,'2) IN DESCENDING ORDER?',/,13X,'ANSWER',
     2' 1 OR 2: ',\)
      READ(*,80,ERR=150) IORDR1
      GO TO 160
  150 CALL SOUND(256,100)
      WRITE(*,'(A)') ' INTEGER VALUE IS REQUIRED'
      GO TO 130
  160 IF(IORDR1.LT.1.OR.IORDR1.GT.2) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' YOU MUST ANSWER 1 OR 2'
      GO TO 130
      ENDIF
      ENDIF
      IF(IFLAG.GE.4) THEN
      WRITE(*,170) MAJOR
  170 FORMAT(//,5X,'ENTER COLUMN NUMBER OF ',A5,' SORTING',
     1' VARIABLE: ',\)
      READ(*,80) ICOL1
      WRITE(*,120) IVID(ICOL1)
      READ(*,80) IABSV1
      WRITE(*,140) IVID(ICOL1)
      READ(*,80) IORDR1
      WRITE(*,170) MINOR
      READ(*,80) ICOL2
      WRITE(*,120) IVID(ICOL2)
      READ(*,80) IABSV2
      WRITE(*,140) IVID(ICOL2)
      READ(*,80) IORDR2
      ENDIF
      IF(IFLAG.EQ.5) THEN
      WRITE(*,170) THIRD
      READ(*,80) ICOL3
      WRITE(*,120) IVID(ICOL3)
      READ(*,80) IABSV3
      WRITE(*,140) IVID(ICOL3)
      READ(*,80) IORDR3
      ENDIF
      IF(IFLAG.LT.3) THEN
      WRITE(*,140) ROWID
      READ(*,80) IORDR
      ENDIF
C**********************************************************************
C***
C***  FINISHED WITH SORT-SPECIFICATIONS; READ INPUT FILE AND STORE KEYS
C***
      WRITE(*,180)
  180 FORMAT(//,'           READING STATPAC INPUT FILE')
      DO 200 I=1,N
      READ(KI) IROW,NAME,LOC,(X(J),J=1,M),(IPACK(J),J=1,NPACK)
      IF(IER.NE.0) STOP 'UNEXPECTED END OF FILE'
C***  STORE SORTING KEYS AS NEEDED
      IF(IFLAG.EQ.1) IHOLID(I)=TEMP
      IF(IFLAG.EQ.2) IHOLID(I)=TEMP1
      IF(IFLAG.GE.3) VAR1(I)=X(ICOL1)
      IF(IFLAG.GE.4) VAR2(I)=X(ICOL2)
      IF(IFLAG.EQ.5) VAR3(I)=X(ICOL3)
C***  CHECK IF ABSOLUTE VALUE SORTING IS WANTED
      IF(IABSV1.EQ.2) VAR1(I)=ABS(VAR1(I))
      IF(IABSV2.EQ.2) VAR2(I)=ABS(VAR2(I))
      IF(IABSV3.EQ.2) VAR3(I)=ABS(VAR3(I))
C***  CHECK IF DESCENDING SORT IS WANTED
      IF(IORDR1.EQ.2) VAR1(I)=-VAR1(I)
      IF(IORDR2.EQ.2) VAR2(I)=-VAR2(I)
      IF(IORDR3.EQ.2) VAR3(I)=-VAR3(I)
C***  INITIALIZE VALUES IN POINTER ARRAY
      IPOINT(I)=I
C***  WRITE DIRECT ACCESS SCRATCH FILE
      WRITE(KS) NAME,LOC,(X(J),J=1,M),(IPACK(J),J=1,NPACK)
C***  INFORM USER OF PROGRESS OF THE INPUT AND STORING OF DATA
      IF(MOD(I,10).EQ.0) WRITE(*,190) I
  190 FORMAT('+',I4)
  200 CONTINUE
      WRITE(*,190) N
C**********************************************************************
C***
C***  NOW SORT THE ARRAY OF POINTERS
C***
      WRITE(*,210)
  210 FORMAT('           SORTING ARRAY OF POINTERS')
C***  ROSORT SORTS ON A CHARACTER VARIABLE; FSORT ON A REAL VARIABLE
      IF(IFLAG.LE.2) CALL ROSORT(IHOLID,IPOINT,N)
      IF(IFLAG.GE.3) CALL FSORT(VAR1,IPOINT,N)
C***  SORT ON MINOR FIELDS, IF NECESSARY
      IF(IFLAG.GE.5) CALL B2SORT(VAR1,VAR3,IPOINT,N)
      IF(IFLAG.GE.4) CALL B2SORT(VAR1,VAR2,IPOINT,N)
C**********************************************************************
C***
C***  FINISHED WITH SORTING OF POINTERS; WRITE SORTED OUTPUT FILE
C***
      WRITE(*,220)
  220 FORMAT(' ','          WRITING STATPAC OUTPUT FILE')
      WRITE(KO) IDS,N,M,(IVID(I),I=1,M)
      NP1=N+1
      REWIND KS
      DO 230 I=1,N
      K=I
C***  CHECK FOR SORT IN DESCENDING ORDER ON ROW ID
      IF(IORDR.EQ.2) K=NP1-I
      READ(KS,REC=IPOINT(K)) NAME,LOC,(X(J),J=1,M),(IPACK(J),J=1,NPACK)
      WRITE(KO) I,NAME,LOC,(X(J),J=1,M),(IPACK(J),J=1,NPACK)
      IF(MOD(I,10).EQ.0) WRITE(*,190) I
  230 CONTINUE
      WRITE(*,190) N
C*********************************************************************
C***
C***  PRINT MESSAGES TO THE SCREEN AND FINISH
C***
      WRITE(*,240) FILE11,IDS,N,M
  240 FORMAT(' ','THE SORTED STATPAC FILE HAS BEEN WRITTEN',/,
     1' THE OUTPUT FILE IS ',A32,/,
     2' FILEID= ',A8,'   N= ',I4,'   M= ',I2)
C***  GET RID OF SCRATCH FILE
      CLOSE(KS,STATUS='DELETE')
C***  INFORM USER PROGRAM IS FINISHED WITH FIVE BEEPS OF THE SPEAKER.
      DO 250 I=1,5
      CALL SOUND(1000,25)
  250 CONTINUE
C***  COMPUTE AND PRINT RUNNING TIME
      CALL TICKER(ITIME2)
      TIME=FLOAT(ITIME2-ITIME1)/6000.
      WRITE(*,260) TIME
  260 FORMAT(' ','RUN TIME WAS ',F6.2,' MINUTES')
      STOP 'NORMAL END OF PROGRAM'
      END
