$NOFLOATCALLS
$STORAGE:2
      PROGRAM STRNGRET
C***
C***  PROGRAM rowid_subSTRiNG_RETriever
C***  RETRIEVES FROM A STATPAC FILE THOSE ROWS WHOSE 16-CHARACTER
C***  IDENTIFIERS CONTAIN A SUBSTRING SPECIFIED BY THE USER AT
C***  RUN TIME.  SUBSTRING MUST BE FROM 1 TO 16 CHARACTERS LONG.
C***  THE SUBSTRING BEING SOUGHT MAY CONTAIN WILD CARDS WHICH
C***  ARE ENTERED AS CARATS (^).
C***  RETRIEVED ROWS ARE WRITTEN ON A STATPAC OUTPUT FILE.
C***
C***  USER HAS OPTION OF RETRIEVING ONLY THOSE ROWS WHERE THE SUB-
C***  STRING IS FOUND OR ONLY THOSE ROWS WHERE IT IS NOT FOUND.
C***  LINKS REQUIRED: ASCIIZ, BYTMOV, CHRKNT, CKSAFE, CONCAT, DOSREN,
C***  FNDCUR, FSTDSP, MATCH, ODOMTR, PCHVAR, SOUND, TICKER
C***
C***  CODED BY W.D. GRUNDY  JANUARY  1985
C***
      CHARACTER*32 FILE10,FILE11
      CHARACTER*16 NAME,SEARCH,BLANK
      CHARACTER*8 ID,IVID(100)
      CHARACTER*1 CHNAME(16),SUBSTR(16),ANS,WILD
      INTEGER*4 LOC(2),ITIME1,ITIME2
      LOGICAL FLAG,WANT
      DIMENSION X(100), IPACK(20)
      EQUIVALENCE(NAME,CHNAME(1)),(SEARCH,SUBSTR(1))
      DATA WILD /'^'/,BLANK/'xxxxxxxxxxxxxxxx'/
      CALL TICKER(ITIME1)
      KI=10
      KO=11
      KS=13
C***  GET NAMES OF I/O FILES
   10 WRITE(*,'('' '')')
      WRITE(*,'(A\)') ' ENTER NAME OF THE STATPAC INPUT FILE: '
      READ(*,'(A32)') FILE10
      CALL CKSAFE(FILE10,2,FLAG)
      IF(FLAG) GO TO 10
   20 WRITE(*,'(A\)') ' GIVE A NAME FOR THE STATPAC OUTPUT FILE: '
      READ(*,'(A32)') FILE11
      IF(FILE11.EQ.FILE10) THEN
      CALL WARN
      WRITE(*,'(A)') ' STATPAC INPUT FILE CANNOT BE USED FOR OUTPUT'
      GO TO 20
      ENDIF
      CALL CKSAFE(FILE11,1,FLAG)
      IF(FLAG) GO TO 20
      OPEN(KI,FILE=FILE10,STATUS='OLD',FORM='UNFORMATTED')
      READ(KI) ID,N,M
      IF(M.GT.100) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' STATPAC FILE HAS '',I4,'' VARIABLES'',/,
     1'' LIMIT IS 100'')') N
      STOP
      ENDIF
      REWIND(KI)
      OPEN(KO,FILE=FILE11,STATUS='NEW',FORM='UNFORMATTED')
      OPEN(KS,FILE='SCRATCH',STATUS='NEW',FORM='UNFORMATTED')
C***  GET USER'S SPECIFICATIONS FOR RETRIEVAL
   30 WRITE(*,'('' '')')
      WRITE(*,'('' ENTER STARTING CHARACTER POSITION (1-16) '',
     1''IN THE ROWID: '',\)')
      READ(*,*,ERR=40) ISTART
      GO TO 60
   40 CALL SOUND(256,100)
      WRITE(*,50)
   50 FORMAT(' ERROR**  INTEGER VALUE IS REQUIRED.  REDO.')
      GO TO 30
   60 IF(ISTART.LT.1.OR.ISTART.GT.16) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' YOU MUST ENTER A NUMBER FROM 1 TO 16.'
      GO TO 30
      ENDIF
   70 MAXS=16-ISTART+1
      WRITE(*,'('' '',''ENTER THE NUMBER OF CHARACTERS WHICH '',
     1''ARE TO BE SEARCHED (1-'',I2,''): '',\)') MAXS
      READ(*,*,ERR=80) NCH
      GO TO 90
   80 CALL SOUND(256,100)
      WRITE(*,50)
      GO TO 70
   90 IF(NCH.GT.MAXS) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' TOO MANY CHARACTERS SPECIFIED.  REDO OR BREAK.'
      GO TO 70
      ENDIF
      IF(NCH.LT.0) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' VALUE MUST NOT BE NEGATIVE'
      GO TO 70
      ENDIF
  100 MAX=16-ISTART+1
      IF(NCH.EQ.1) THEN
      NSUB=1
      GO TO 130
      ENDIF
      WRITE(*,'('' ENTER NUMBER OF CHARACTERS IN THE SEARCH SUB'',
     1''STRING (1-'',I2,''): '',\)') NCH
      READ(*,*,ERR=110) NSUB
      GO TO 120
  110 CALL SOUND(256,100)
      WRITE(*,50)
      GO TO 100
  120 IF(NSUB.LT.1.OR.NSUB.GT.NCH) THEN
      CALL SOUND(256,100)
      WRITE(*,'('' NUMBER OF CHARACTERS IN SUBSTRING CANNOT BE '',
     1''LESS THAN 1 OR GREATER THAN '',I2)') NCH
      GO TO 100
      ENDIF
  130 WRITE(*,'('' ENTER '',I2,''-CHARACTER SUBSTRING'',/,
     1'' USE A CARAT (^) FOR WILD CARDS'',/,
     2'' FIRST CHARACTER CANNOT BE WILD: '',\)') NSUB
      READ(*,'(A)') SEARCH
      IF(SUBSTR(1).EQ.WILD) THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' ERROR**  FIRST CHARACTER CANNOT BE A (^).  REDO F
     1ROM START.'
      GO TO 30
      ENDIF
      WRITE(*,'(/,'' YOU ENTERED THESE SEARCH SPECIFICATIONS:'',//,
     1'' '','' 0000000001111111'',/,'' '','' 1234567890123456'')')
      WRITE(*,'(21X,'':SUBSTRING SOUGHT AND STARTING POSITION '',
     1''IN ROWID'',/,21X,'':POSITIONS IN ROWID TO BE SEARCHED'')')
      CALL FNDCUR(IR,IC,0)
      CALL PCHVAR(SUBSTR,3,NSUB,IR-1,ISTART,0)
      CALL PCHVAR(BLANK,3,NCH,IR,ISTART,0)
      WRITE(*,'(/,'' '',''ARE THESE OKAY? Y/N: '',\)')
      READ(*,'(A)') ANS
      IF(ANS.EQ.'N'.OR.ANS.EQ.'n') GO TO 30
  140 WRITE(*,'('' DO YOU WANT TO:'',/,6X,''1) '',
     1''RETRIEVE ONLY THOSE ROWS WHERE THE SUBSTRING IS FOUND, '',
     2''OR'',/,6X,''2) ONLY THOSE ROWS WHERE THE SUBSTRING IS NOT '',
     3''FOUND?'',/,9X,''ANSWER 1 OR 2: '',\)')
      READ(*,'(A)') ANS
      IF(ANS.NE.'1'.AND.ANS.NE.'2') THEN
      CALL SOUND(256,100)
      WRITE(*,'('' YOU MUST ANSWER 1 OR 2'')')
      GO TO 140
      ENDIF
      WANT=(ANS.EQ.'1')
C***  BEGIN RETRIEVAL OF DESIRED STATPAC ROWS.
      KOUNTW=0
      READ(KI) ID,N,M,(IVID(I),I=1,M)
      NPACK=(M+4)/5
      WRITE(*,'(''          CURRENT STATPAC ROW IN OUTPUT FILE'')')
      WRITE(*,'(''          CURRENT STATPAC ROW IN INPUT FILE'')')
C***  FIND LOCATION OF CURSOR
      CALL FNDCUR(IR,IC,0)
      DO 150 I=1,N
      CALL ODOMTR(IR,I)
      READ(KI) IROW,NAME,LOC,(X(J),J=1,M),(IPACK(J),J=1,NPACK)
      FLAG=(MATCH(CHNAME(ISTART),NCH,SUBSTR,NSUB,WILD).GT.0)
      IF((FLAG.AND.WANT).OR.(.NOT.FLAG.AND..NOT.WANT)) THEN
      KOUNTW=KOUNTW+1
      CALL ODOMTR(IR-1,KOUNTW)
      WRITE(KS) NAME,LOC,(X(J),J=1,M),(IPACK(J),J=1,NPACK)
      ENDIF
  150 CONTINUE
C***  WRITE STATPAC OUTPUT FILE
      REWIND(KS)
      WRITE(KO) ID,KOUNTW,M,(IVID(I),I=1,M)
      DO 160 I=1,KOUNTW
      READ(KS) NAME,LOC,(X(J),J=1,M),(IPACK(J),J=1,NPACK)
      WRITE(KO) I,NAME,LOC,(X(J),J=1,M),(IPACK(J),J=1,NPACK)
  160 CONTINUE
      WRITE(*,'('' STATPAC OUTPUT FILE '',A32,'' HAS BEEN '',
     1''WRITTEN'',/,'' THE FILE ID IS '',A8,/,'' N= '',I4,5X,
     2''M= '',I3)') FILE11,ID,KOUNTW,M
      DO 170 I=1,5
      CALL SOUND(1000,25)
  170 CONTINUE
      CLOSE(KS,STATUS='DELETE')
      WRITE(*,'(A\)')' DO YOU WANT TO RERUN THIS PROGRAM? Y/N: '
      READ(*,'(A)') ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') THEN
      CLOSE(KI)
      CLOSE(KO)
      GO TO 10
      ENDIF
      CALL TICKER(ITIME2)
      TIME=FLOAT(ITIME2-ITIME1)/6000.
      WRITE(*,'('' '',''PROGRAM ACTIVE TIME WAS '',F7.2,'' MINUTES'')')
     1TIME
      STOP 'NORMAL END OF PROGRAM'
      END
