$STORAGE:2
$LARGE
$NOFLOATCALLS
      PROGRAM UGR2GRD
C -----------------------------------------------------------------------
C ***  CONVERTS A STATPAC rootname.UGR GRID FILE CREATED BY KRIGING
C ***  PROGRAM SS2DGRID INTO A BASIC BINARY rootname.GRD FILE FOR
C ***  USE AS INPUT TO GOLDEN SOFTWARE COMPANY'S TOPO AND SURF
C ***  PROGRAMS.  THESE PARTICULAR GOLDEN SOFTWARE PROGRAMS ARE
C ***  CONTAINED IN THEIR GRAFIT AND SURFER PACKAGES.
C ***
C ***  THE GRID TO BE CONVERTED CANNOT EXCEED 201 N-S POINTS AND
C ***  201 E-W POINTS.
C ***
C ***  NOTE: THE STATPAC INPUT FILE MUST HAVE A COMPLETE X-Y GRID
C ***  IF THE BINARY OUTPUT FILE IS TO BE USED IN THE GRAFIT PACKAGE.
C ***
C ***  LINKS REQUIRED: ASCIIZ, BYTMOV, CHEKER, CHRKNT, CHGCAS, CKSAFE,
C ***                  CMDLIN, CONCAT, FNDCUR, FSTDSP, MOVCUR, ODOMTR,
C ***                  PCHVAR, SCREAD, SOUND, TICKER
C ***
C ***  AT LINK TIME SPECIFY THE LIBRARIES IN THE FOLLOWING MANNER:
C ***  C:\COMPILER\STATPAC+C:\COMPILER\8087+C:\COMPILER\FORTRAN
C ***
C ***  CODED BY W. D. GRUNDY    OCTOBER 1985.  REVISED WDG 7/28/87
C ***
C -----------------------------------------------------------------------
      INTEGER*4 LOC,ITIME1,ITIME2
      LOGICAL FILERR,FLAG,WRITEK,WRITEV,TYPE
      CHARACTER*1 ANS
      CHARACTER*4 EXT10,EXT21,BYTES
      CHARACTER*8 ID
      CHARACTER*16 NAME
      CHARACTER*32 FILE10,FILE21,FILE14,TEMP
      COMMON /VAR/ VARKRG(40401)
      DIMENSION X(4),LOC(2),XYCOOR(402),VALKRG(40401)
      DATA EXT10,EXT21 /'.UGR','.GRD'/
C -----------------------------------------------------------------------
C ***  GET STARTING TIME OF RUN
C -----------------------------------------------------------------------
      CALL TICKER(ITIME1)
      KI=10
      KO=21
      KOT=14
      XNULL=1.701411E+38
      CALL CMDLIN(FILE10,'UGR2GRD',7,FLAG)
      IF(FLAG) GO TO 20
C -----------------------------------------------------------------------
C ***  GET NAME OF STATPAC KRIGED GRID INPUT FILE
C -----------------------------------------------------------------------
   10 WRITE(*,'(A\)') ' ENTER ROOT NAME OF STATPAC KRIGED GRID FILE: '
      READ(*,'(A)') FILE10
C -----------------------------------------------------------------------
C ***  ATTACH EXTENSION OF .UGR TO THE USER SUPPLIED FILE NAME
C -----------------------------------------------------------------------
   20 CALL CHEKER(FILE10,EXT10,FILERR)
      IF(FILERR) GO TO 10
C -----------------------------------------------------------------------
C ***  VERIFY THAT THIS FILE EXISTS
C -----------------------------------------------------------------------
      CALL CKSAFE(FILE10,2,FILERR)
      IF(FILERR) GO TO 10
      OPEN(KI,FILE=FILE10,STATUS='OLD',FORM='UNFORMATTED')
      READ(KI) ID,N,M
      IF(M.NE.4)THEN
      WRITE(*,'(A)') ' INPUT FILE WAS NOT CREATED BY PROGRAM SS2DGRID'
      STOP
      ENDIF
      IKRG=0
C -----------------------------------------------------------------------
C ***  FOLLOWING USER RESPONSES SHOULD BE THE SAME AS THOSE SUPPLIED
C ***  DURING CREATION OF THE STATPAC GRID FILE BY PROGRAM SS2DGRID.
C -----------------------------------------------------------------------
   30 WRITE(*,'('' '',''WILL THE BINARY OUTPUT FILE BE USED IN:'',/,
     11X,''     1) THE GRAFIT PACKAGE, OR'',/,
     21X,''     2) THE SURFER PACKAGE?'',/,
     31X,''        ANSWER 1 OR 2: '',\)')
      READ(*,'(A)') ANS
      IF(ANS.LT.'1'.OR.ANS.GT.'2')THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' YOU MUST ANSWER 1 OR 2'
      GO TO 30
      ENDIF
      TYPE=ANS.EQ.'1'
      IF(TYPE)THEN
      BYTES='DSPM'
      ELSE
      BYTES='DSBB'
      ENDIF
   40 IER=1
      WRITE(*,'(A\)') ' ENTER NUMBER OF GRID POINTS IN N-S DIRECTION: '
      READ(*,'(BN,I3)',ERR=220) NPNS
      IF(NPNS.LE.0.OR.NPNS.GT.201)THEN
      CALL SOUND(256,100)
      WRITE(*,50)
   50 FORMAT(' NUMBER OF GRID POINTS MUST BE GREATER THAN ZERO',/,
     1' AND NO GREATER THAN 201')
      GO TO 40
      ENDIF
   60 JER=1
      WRITE(*,'('' '',''ENTER DISTANCE BETWEEN POINTS IN N-S'',
     1'' DIRECTION: '',\)')
      READ(*,'(BN,F8.0)',ERR=230) YDIS
      IF(YDIS.LE.0.)THEN
      CALL SOUND(256,100)
      WRITE(*,70)
   70 FORMAT(' DISTANCE BETWEEN POINTS MUST BE GREATER THAN 0')
      GO TO 60
      ENDIF
   80 IER=2
      WRITE(*,'(A\)') ' ENTER NUMBER OF GRID POINTS IN E-W DIRECTION: '
      READ(*,'(BN,I3)',ERR=220) NPEW
      IF(NPEW.LE.0.OR.NPEW.GT.201)THEN
      CALL SOUND(256,100)
      WRITE(*,50)
      GO TO 80
      ENDIF
      ITOT=NPNS*NPEW
      IF(TYPE)THEN
      IF(N.LT.ITOT)THEN
      CALL SOUND(256,100)
      WRITE(*,'('' '',''THE SPECIFIED GRID HAS MISSING DATA POINTS'',/,
     1''REDO FROM START'')')
      GO TO 40
      ENDIF
      ENDIF
   90 JER=2
      WRITE(*,'('' '',''ENTER DISTANCE BETWEEN POINTS IN E-W'',
     1'' DIRECTION: '',\)')
      READ(*,'(BN,F8.0)',ERR=230) XDIS
      IF(XDIS.LE.0.)THEN
      CALL SOUND(256,100)
      WRITE(*,70)
      GO TO 90
      ENDIF
  100 JER=3
      WRITE(*,'(A\)') ' WHAT IS NORTHING OF SW CORNER OF GRID? '
      READ(*,'(BN,F8.0)',ERR=230) YNO
  110 JER=4
      WRITE(*,'(A\)') ' WHAT IS  EASTING OF SW CORNER OF GRID? '
      READ(*,'(BN,F8.0)',ERR=230) XEA
C -----------------------------------------------------------------------
C ***  COMPUTE AND TRANSFORM MINIMUM AND MAXIMUM X AND Y VALUES
C -----------------------------------------------------------------------
      YMAX=YNO+YDIS*FLOAT(NPNS-1)
      XMAX=XEA+XDIS*FLOAT(NPEW-1)
      YMIN=YNO
      XMIN=XEA
C -----------------------------------------------------------------------
C ***  FILL VALKRG AND VARKRG WITH NULLS PRIOR TO READING STATPAC FILE
C -----------------------------------------------------------------------
      DO 120 I=1,ITOT
      VALKRG(I)=XNULL
      VARKRG(I)=XNULL
  120 CONTINUE
C -----------------------------------------------------------------------
C ***  COMPUTE COORDINATES
C -----------------------------------------------------------------------
      DO 130 I=1,NPNS
      XYCOOR(I+NPEW)=YNO+FLOAT(I-1)*YDIS
  130 CONTINUE
      DO 140 I=1,NPEW
      XYCOOR(I)=XEA+FLOAT(I-1)*XDIS
  140 CONTINUE
C -----------------------------------------------------------------------
C ***  PUT Z-VALUES IN PROPER POSITION IN ARRAY VALKRG
C -----------------------------------------------------------------------
      WRITE(*,'(A)') '          READING STATPAC GRID FILE'
      CALL FNDCUR(IRRR,ICCC,0)
      DO 150 I=1,N
      READ(KI) IROW,NAME,LOC,X
      IF(MOD(I,100).EQ.0) CALL ODOMTR(IRRR,I)
      J=NINT((X(1)-XEA)/XDIS)+1
      IF(J.LE.0.OR.J.GT.NPEW) GO TO 150
      K=NINT((X(2)-YNO)/YDIS)+1
      IF(K.LE.0.OR.K.GT.NPNS) GO TO 150
      IPOS=(K-1)*NPEW+J
      VALKRG(IPOS)=X(3)
      VARKRG(IPOS)=X(4)
  150 CONTINUE
      WRITE(*,'(''+'',I5)') N
C -----------------------------------------------------------------------
C ***  MAKE ANOTHER CHECK FOR MISSING GRID POINTS
C -----------------------------------------------------------------------
      IF(TYPE)THEN
      DO 160 I=1,ITOT
      IF(VALKRG(I).EQ.XNULL) STOP 'DATA SET HAS MISSING GRID POINTS'
  160 CONTINUE
      ENDIF
C -----------------------------------------------------------------------
C ***  FIND OUT WHICH OUTPUT FILES ARE WANTED.
C -----------------------------------------------------------------------
      WRITE(*,'('' '',''DO YOU WANT A FILE OF KRIGED VALUES FOR'',
     1'' THE TOPO CONTOURING PROGRAM? Y/N: '',\)')
      READ(*,'(A)') ANS
      WRITEK=ANS.EQ.'Y'.OR.ANS.EQ.'y'
      IF(WRITEK)THEN
  170 WRITE(*,'(A\)') ' GIVE A NAME FOR THE KRIGED VALUE OUTPUT FILE: '
      READ(*,'(A)') FILE21
      IF(FILE21.EQ.FILE10)THEN
      CALL WARN
      WRITE(*,'(A)') ' STATPAC INPUT FILE CANNOT BE USED FOR OUTPUT'
      GO TO 170
      ENDIF
      TEMP=FILE21
      CALL CHEKER(FILE21,EXT21,FILERR)
      IF(FILERR) GO TO 170
      CALL CKSAFE(FILE21,1,FILERR)
      IF(FILERR) GO TO 170
      OPEN(KO,FILE=FILE21,STATUS='NEW',FORM='BINARY')
      ENDIF
      WRITE(*,'('' '',''DO YOU WANT A FILE OF KRIGING VARIANCES FOR'',
     1'' THE TOPO PROGRAM? Y/N: '',\)')
      READ(*,'(A)') ANS
      WRITEV=ANS.EQ.'Y'.OR.ANS.EQ.'y'
      IF(WRITEV)THEN
  180 WRITE(*,'(A\)') ' GIVE A NAME FOR THE KRIGING VARIANCE FILE: '
      READ(*,'(A)') FILE14
      IF(FILE14.EQ.FILE10)THEN
      CALL WARN
      WRITE(*,'(A)') ' STATPAC INPUT FILE CANNOT BE USED FOR OUTPUT'
      GO TO 180
      ENDIF
      IF(FILE14.EQ.TEMP)THEN
      CALL SOUND(256,100)
      WRITE(*,'(A)') ' YOU CANNOT USE THE SAME FILE NAME'
      GO TO 180
      ENDIF
      CALL CHEKER(FILE14,EXT21,FILERR)
      IF(FILERR) GO TO 180
      CALL CKSAFE(FILE14,1,FILERR)
      IF(FILERR) GO TO 180
      OPEN(KOT,FILE=FILE14,STATUS='NEW',FORM='BINARY')
      ENDIF
C -----------------------------------------------------------------------
C ***  FIND MININUM AND MAXIMUM KRIGED VALUE AND VARIANCE
C -----------------------------------------------------------------------
      VAMIN=100000.
      VVMIN=100000.
      VAMAX=-100000.
      VVMAX=-100000.
      DO 190 I=1,ITOT
      IF(WRITEK.AND.VALKRG(I).LT.VAMIN) VAMIN=VALKRG(I)
      IF(WRITEV.AND.VARKRG(I).LT.VVMIN) VVMIN=VARKRG(I)
      IF(WRITEK.AND.VALKRG(I).GT.VAMAX) VAMAX=VALKRG(I)
      IF(WRITEV.AND.VARKRG(I).GT.VVMAX) VVMAX=VARKRG(I)
  190 CONTINUE
      WRITE(*,'(A)') '           WRITING CHARACTER GRID FILE(S)'
C -----------------------------------------------------------------------
C ***  WRITE HEADER(S) FOR BINARY OUTPUT FILE(S)
C -----------------------------------------------------------------------
      IF(TYPE)THEN
      IF(WRITEK) WRITE(KO) BYTES,NPEW,NPNS,XMIN,XMAX,YMIN,YMAX,
     1VAMIN,VAMAX
      IF(WRITEV) WRITE(KOT) BYTES,NPEW,NPNS,XMIN,XMAX,YMIN,YMAX,
     1VVMIN,VVMAX
      ELSE
      IF(WRITEK) WRITE(KO) BYTES,NPEW,NPNS,DBLE(XMIN),DBLE(XMAX),
     1DBLE(YMIN),DBLE(YMAX),DBLE(VAMIN),DBLE(VAMAX)
      IF(WRITEV) WRITE(KOT) BYTES,NPEW,NPNS,DBLE(XMIN),DBLE(XMAX),
     1DBLE(YMIN),DBLE(YMAX),DBLE(VVMIN),DBLE(VVMAX)
      ENDIF
      CALL FNDCUR(IRRR,ICCC,0)
      DO 200 I=1,ITOT
      IF(WRITEK)THEN
      VALM=VALKRG(I)
      WRITE(KO) VALM
      ENDIF
      IF(WRITEV)THEN
      VARM=VARKRG(I)
      WRITE(KOT) VARM
      ENDIF
      IF(MOD(I,100).EQ.0) CALL ODOMTR(IRRR,I)
  200 CONTINUE
      WRITE(*,'(''+'',I5)') ITOT
      IF(WRITEK)
     1WRITE(*,'('' '',''THE KRIGED VALUE OUTPUT FILE IS '',A32)')
     2FILE21
      IF(WRITEV)
     1WRITE(*,'('' '',''THE KRIGING VARIANCE OUTPUT FILE IS '',A32)')
     2FILE14
      DO 210 I=1,5
      CALL SOUND(1000,25)
  210 CONTINUE
C -----------------------------------------------------------------------
C ***  FINISHED WITH CURRENT INPUT FILE.  SEE IF ANOTHER IS WANTED.
C -----------------------------------------------------------------------
      IF(WRITEK) CLOSE(KO)
      IF(WRITEV) CLOSE(KOT)
      WRITE(*,'('' '',''DO YOU WANT TO CONTOUR USING A DIFFERENT '',
     1''STATPAC INPUT FILE? Y/N: '',\)')
      READ(*,'(A)') ANS
      IF(ANS.EQ.'Y'.OR.ANS.EQ.'y') GO TO 10
C -----------------------------------------------------------------------
C ***  PROGRAM EXIT ROUTINE
C ***  COMPUTE PROGRAM ACTIVE TIME
C -----------------------------------------------------------------------
      CALL TICKER(ITIME2)
      XTIME=FLOAT(ITIME2-ITIME1)/6000.
      WRITE(*,'('' '',''PROGRAM ACTIVE TIME WAS '',F6.2,'' MINUTES'')')
     1XTIME
      STOP 'NORMAL END OF PROGRAM'
C -----------------------------------------------------------------------
C ***  ERROR MESSAGES FOR BAD INTERACTIVE DATA INPUT
C -----------------------------------------------------------------------
  220 CALL SOUND(256,100)
      WRITE(*,'(A)')' ***ERROR-INTEGER VALUE WAS EXPECTED-REENTER***'
      GO TO(40,80),IER
  230 CALL SOUND(256,100)
      WRITE(*,'(A)')' ***ERROR-REAL VALUE WAS EXPECTED-REENTER***'
      GO TO(60,90,100,110),JER
      END
