TITLE          SUBROUTINE UNPK(CHIA,M,IY)
;              THIS SUBROUTINE UNPK  S THE QUALIFYING CODES
;              CONTAINED IN ARRAY IY INTO ARRAY CHIA.
;              THIS SUBROUTINE IS CALLED BY SUBROUTINE JKGTLS
;
;CODED BY W. D. GRUNDY  JULY 1985
;
FRAME          STRUC
SAVESI         DW         ?
SAVEDI         DW         ?
SAVEDS         DW         ?            ;SAVE AREA FOR DS REGISTER
SAVEBP         DW         ?            ;SAVE AREA FOR CALLER'S BP
SAVERET        DD         ?            ;SAVE AREA FOR CALLER'S RETURN
C              DD         ?            ;POINTER TO IY
B              DD         ?            ;POINTER TO M
A              DD         ?            ;POINTER TO CHIA
FRAME          ENDS
;
_DATA          SEGMENT    'DATA'
_DATA          ENDS
;
UNPK_TEXT      SEGMENT    'CODE'
DGROUP         GROUP      _DATA
               ASSUME     CS:UNPK_TEXT,DS:DGROUP,SS:DGROUP
               PUBLIC     UNPK  
;
UNPK           PROC       FAR
               PUSH       BP           ;SAVE CALLER'S BP
               PUSH       DS           ;SAVE DS REGISTER
               PUSH       DI
               PUSH       SI
               MOV        BP,SP
               LDS        BX,[BP]+B    ;GET ADDRESS OF M
               MOV        AX,[BX]
               MOV        DX,AX        ;SAVE M FOR LATER USE
               MOV        BL,05H       ;IS M EVENLY DIVISIBLE BY 5?
               DIV        BL
               CMP        AH,0         ;NON-ZERO REMAINDER?
               JE         LAST_OKAY    ;YES, NO SPECIAL TREATMENT NEEDED
;
;FOLLOWING SECTION OF CODE POSITIONS BITS IN LAST IY SO THAT THEY
;CAN BE PROCESSED IN LOOP BEGINNING AT WORD_UNPK
;
               MOV        CH,AL        ;CH CONTAINS ONE LESS THAN THE
                                       ;NUMBER OF WORDS IN ARRAY IY
               MOV        AL,AH
               NEG        AL
               ADD        AL,BL
               MOV        BL,3
               MUL        BL           ;NOTE: AH NOW CONTAINS ZERO
               MOV        CL,AL        ;COUNTER FOR ROTATION
               ADD        CH,CH
               MOV        AL,CH
               LDS        BX,[BP]+C    ;GET ADDRESS OF IY
               ADD        BX,AX        ;OFFSET OF LAST IY [i.e., IY(N)]
               MOV        AX,[BX]      ;LAST IY IS NOW IN AX
               ROL        AX,CL        ;MAKE LAST IY CONSISTENT WITH
               MOV        [BX],AX      ;WITH OTHER IY'S.
;END OF SPECIAL TREATMENT OF LAST IY 
;
LAST_OKAY:
               MOV        BX,OFFSET CHAR_TABLE
               LES        DI,[BP]+A    ;GET ADDRESS OF CHIA ARRAY
               LDS        SI,[BP]+C    ;GET ADDRESS OF IY ARRAY
;
;PREPARE TO LOOP
               MOV        CL,3         ;COUNTER FOR ROTATING AX
               DEC        SI
               DEC        SI
               DEC        DI
               ADD        DX,DI        ;COMPUTE OFFSET OF LAST CHIA
WORD_UNPK:     INC        SI           ;UPDATE ADDRESS OF IY
               INC        SI
               MOV        AX,[SI]
               ROL        AX,1         ;MOVE LEADING 0 OUT OF THE WAY
               MOV        CH,5
CONVT:         INC        DI           ;UPDATE ADDRESS OF CHIA
               CMP        DI,DX        ;FINISHED WITH UNPACKING?
               JA         EXIT         ;YES, EXIT.
               ROL        AX,CL
               PUSH       AX           ;PREPARATION FOR XLAT
               AND        AL,07H       ;MASK OFF BITS 3-7 OF AL
               XLAT       CS:CHAR_TABLE;GET CHARACTER FOR 3-BIT CODE
                                       ;AND RETURN IT TO THE CALLER
               MOV        BYTE PTR ES:[DI],AL
               POP        AX
               DEC        CH           ;TEST FOR LAST CODE IN IY
               JNZ        CONVT        ;UNPACK NEXT CHARACTER
               JMP SHORT  WORD_UNPK    ;GET ANOTHER IY TO UNPACK
EXIT:          POP        SI
               POP        DI
               POP        DS
               POP        BP
               RET        12
UNPK           ENDP
;
CHAR_TABLE     DB         ' BLNGTH*'   ;TABLE OF CHARACTERS FOR XLAT
UNPK_TEXT      ENDS
               END
