$STORAGE:2
       SUBROUTINE VARMAX2(MAXF,MAXT,NV,T)
C     MODIFIED FROM J. E. KLOVAN, UNIV. OF CALGARY
C     VARIMAX MATRIX ROTATION
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION COM(800)
      DIMENSION VAR(10),CUM(10), T(10,10)
      COMMON/X111/ F(800,10)
C
C     MAXT = NO. OF SAMPLES, NV = NO. OF VARIABLES,MAXF = NO.OF FACTORS
C     ------------------------------------------------------------------
C
  100 FORMAT(2I4)
  110 FORMAT(4X 10F7.4 )
      DO 140 I=1,MAXF
      DO 140 J=1,MAXF
      IF(I-J) 130,120,130
  120 T(I,J)= 1.0
      GO  TO 140
  130 T(I,J) = 0.0
  140 CONTINUE
      EPS = 0.06993
  150 DO 170 N = 1, MAXT
      COM(N)=0.0
      DO 160 M = 1, MAXF
  160 COM(N) = COM(N) + F(N,M) * F(N,M)
      COM(N) = DSQRT (COM(N)  )
      DO 170 M = 1, MAXF
  170 F(N,M) = F(N,M)/COM(N)
      L = MAXF - 1
  180 NOROT = 0
      DO 380 M = 1, L
      K = M + 1
      DO 380 MONE = K, MAXF
      A = 0.0
      B = 0.0
      C = 0.0
      D = 0.0
      DO 190 N = 1, MAXT
      U = F(N,M)**2  -F(N,MONE) **2
      V = F(N,M) * F(N,MONE)* 2.
      A = A + U
      B = B + V
      C=C+U**2-V**2
  190 D = D + U * V * 2.0
      R = MAXT
      QNUM = D - 2.0 * A * B / R
      QDEN = C - (A ** 2 - B ** 2) / R
      IF(DABS(QNUM) + DABS(QDEN)) 340,340,200
  200 IF(DABS(QNUM) - DABS(QDEN)) 210,280,250
  210 R = DABS(QNUM/QDEN)
      IF(R - EPS) 230,220,220
  220 CS4TH = DCOS(DATAN(R))
      SN4TH = DSIN(DATAN(R))
      GO TO 290
  230 IF(QDEN) 240,340,340
  240 SNPHI = .70710678
      CSPHI = SNPHI
      GO TO 350
  250 R = DABS(QDEN/QNUM)
      IF(R - EPS) 270,260,260
  260 SN4TH = 1.0/ DSQRT(1.0 + R ** 2)
      CS4TH = SN4TH * R
      GO TO 290
  270 CS4TH = 0.0
      SN4TH = 1.0
      GO TO 290
  280 CS4TH = .70710678
      SN4TH = CS4TH
  290 R = DSQRT((1.0 + CS4TH) * 0.5)
      CSTH = DSQRT((1.0 + R) * 0.5)
      SNTH = SN4TH/(4.0 * CSTH * R)
      IF(QDEN) 300,310,310
  300 CSPHI =.70710678*(CSTH+SNTH)
      SNPHI =.70710678*(CSTH-SNTH)
      GO TO 320
  310 CSPHI = CSTH
      SNPHI = SNTH
  320 IF(QNUM) 330,350,350
  330 SNPHI = - SNPHI
      GO TO 350
  340 NOROT = NOROT + 1
      GO TO 380
  350 DO 370 N=1,MAXT
      R = F(N,M) * CSPHI + F(N,MONE) * SNPHI
      F(N,MONE) = F(N,MONE) * CSPHI - F(N,M) * SNPHI
       F(N,M)= R
      IF(N-MAXF) 360,360,370
  360 TP = T(N,M)
      T(N,M)= TP * CSPHI + T(N,MONE) * SNPHI
      T(N,MONE) = -TP * SNPHI + T(N,MONE) * CSPHI
  370 CONTINUE
  380 CONTINUE
      IF(NOROT -(MAXF * L)/2) 180,390,180
  390 DO 410 N = 1, MAXT
      DO 400 M = 1, MAXF
  400 F(N,M) = F(N,M) * COM(N)
  410 COM(N) = COM(N) ** 2
C     -----------------------------------------
C     MAKE THE COLUMN SUMS OF THE VARIMAX FACTORS POSITIVE
C     -----------------------------------------
      DO 450 M = 1,MAXF
      SUMV = 0.
      DO 420 N = 1,MAXT
  420 SUMV= SUMV + F(N,M)
      IF(SUMV.GE.0.0) GO TO 450
      DO 430 N = 1,MAXF
  430 T(N,M) =-T(N,M)
      DO 440 N = 1,MAXT
  440 F(N,M) =-F(N,M)
  450 CONTINUE
  460 RETURN
      END
