TITLE   SUBROUTINE WDPEEK(SSEG,SOFF,DEST,KOUNT) {STANDS FOR WorD PEEK}
;COPIES A STRING OF WORDS FROM RAM INTO A FORTRAN VARIABLE OR ARRAY.
;KOUNT IS THE NUMBER OF WORDS TO BE COPIED.  IN DETERMINING A VALUE OF
;KOUNT, REMEMBER THAT AN INTEGER*2 VARIABLE IS ONE WORD, AN INTEGER*4
;VARIABLE IS TWO WORDS, AND A REAL VARIABLE IS ALSO TWO WORDS.  ONE
;BYTE, HOWEVER, IS ONLY 1/2 A WORD, SO THIS SUBPROGRAM CAN HANDLE ONLY
;AN EVEN NUMBER OF BYTES.
;THE USER SPECIFIES THE RAM ADDRESS BY SEGMENT AND STARTING OFFSET.
;THE WORDS ARE COPIED IN A FORWARD DIRECTION.
;
;      CODED BY W. D. GRUNDY    JULY   1986
;
;      FORTRAN USAGE
;      CHARACTER*1 BYTES
;      REAL*4 ARRAY
;      INTEGER*2 IARRAY
;      INTEGER*4 SSEG, SOFF
;      DIMENSION BYTES(NB),ARRAY(NR),IARRAY(NI)
;      ...........
;      ...........
;      SSEG=#C000    {SEGMENT ADDRESS FOR SOURCE - HEX RADIX ALLOWED}
;      SOFF=#E000    {STARTING OFFSET ADDRESS FOR SOURCE}
;      CALL WDPEEK(SSEG,SOFF,BYTES,NB/2)
;      {AS ALTERNATIVES:}
;      CALL WDPEEK(SSEG,SOFF,ARRAY,NR*2)
;      CALL WDPEEK(SSEG,SOFF,IARRAY,NI)
;
FRAME      STRUC
SAVESI     DW         ?
SAVEDI     DW         ?
SAVEDS     DW         ?
SAVEBP     DW         ?
SAVERET    DD         ?
D          DD         ?             ;POINTER TO KOUNT
C          DD         ?             ;POINTER TO DESTINATION
B          DD         ?             ;POINTER TO SOURCE OFFSET ADDRESS
A          DD         ?             ;POINTER TO SOURCE SEGMENT ADDRESS
FRAME      ENDS
;
_DATA      SEGMENT    'DATA'
_DATA      ENDS
;
WDPE_TEXT  SEGMENT    'CODE'
DGROUP     GROUP      _DATA
           ASSUME     CS:WDPE_TEXT,DS:DGROUP,SS:DGROUP
           PUBLIC     WDPEEK
WDPEEK     PROC       FAR
           PUSH       BP            ;SAVE CALLER'S BP
           PUSH       DS            ;SAVE CALLER'S DS
           PUSH       DI
           PUSH       SI
           MOV        BP,SP         ;POINT TO FORTRAN ARGUMENTS
           LES        BX,[BP]+D     ;GET ADDRESS OF KOUNT AND STORE
           MOV        CX,ES:[BX]    ;KOUNT IN CX
           LES        BX,[BP]+A     ;GET SEGMENT
           MOV        DS,ES:[BX]
           LES        BX,[BP]+B     ;GET OFFSET
           MOV        SI,ES:[BX]
           LES        DI,[BP]+C     ;GET DESTINATION ADDRESS
           CLD                      ;MOVE IS TO BE FORWARD
           REP MOVSW                ;PERFORM THE MOVE
           POP        SI
           POP        DI
           POP        DS            ;RESTORE CALLER'S DS
           POP        BP            ;RESTORE CALLER'S BP
           RET        16            ;FAR RETURN; RELEASE 16 BYTES
WDPEEK     ENDP
WDPE_TEXT  ENDS
           END
