TITLE  SUBROUTINE WDPOKE(SOURCE,DSEG,DOFF,KOUNT) {STANDS FOR WorD POKE}
;COPIES A STRING OF WORDS FROM A FORTRAN VARIABLE OR ARRAY INTO RAM.
;KOUNT IS THE NUMBER OF WORDS TO BE MOVED.  IN DETERMINING A VALUE OF
;KOUNT, REMEMBER THAT AN INTEGER*2 VARIABLE IS ONE WORD, AN INTEGER*4
;VARIABLE IS TWO WORDS, AND A REAL VARIABLE IS ALSO TWO WORDS.  ONE
;BYTE, HOWEVER, IS ONLY 1/2 A WORD, SO THIS SUBPROGRAM CAN HANDLE ONLY
;AN EVEN NUMBER OF BYTES.
;THE USER SPECIFIES THE RAM ADDRESS BY SEGMENT AND STARTING OFFSET.
;THE WORDS ARE COPIED IN A FORWARD DIRECTION.
;
;      CODED BY W. D. GRUNDY    JULY    1986
;
;      FORTRAN USAGE
;      CHARACTER*1 BYTES
;      REAL*4 ARRAY
;      INTEGER*2 IARRAY
;      INTEGER*4 DSEG, DOFF
;      DIMENSION BYTES(NB),ARRAY(NR),IARRAY(NI)
;      ...........
;      ...........
;      DSEG=#C000  {SEGMENT ADDRESS FOR DESTINATION; HEX RADIX ALLOWED}
;      DOFF=#E000  {STARTING OFFSET ADDRESS FOR DESTINATION}
;      CALL WDPOKE(BYTES,DSEG,DOFF,NB/2)
;      {AS ALTERNATIVES:}
;      CALL WDPOKE(ARRAY,DSEG,DOFF,NR*2)
;      CALL WDPOKE(IARRAY,DSEG,DOFF,NI)
;
FRAME      STRUC
SAVESI     DW         ?
SAVEDI     DW         ?
SAVEDS     DW         ?
SAVEBP     DW         ?
SAVERET    DD         ?
D          DD         ?             ;POINTER TO KOUNT
C          DD         ?             ;POINTER TO DESTINATION OFFSET
B          DD         ?             ;POINTER TO DESTINATION SEGMENT
A          DD         ?             ;POINTER TO SOURCE
FRAME      ENDS
;
_DATA      SEGMENT    'DATA'
_DATA      ENDS
;
WDPO_TEXT  SEGMENT    'CODE'
DGROUP     GROUP      _DATA
           ASSUME     CS:WDPO_TEXT,DS:DGROUP,SS:DGROUP
           PUBLIC     WDPOKE
WDPOKE     PROC       FAR
           PUSH       BP            ;SAVE CALLER'S BP
           PUSH       DS            ;SAVE CALLER'S DS
           PUSH       DI
           PUSH       SI
           MOV        BP,SP         ;POINT TO FORTRAN ARGUMENTS
           LES        BX,[BP]+D     ;GET ADDRESS OF KOUNT AND STORE
           MOV        CX,ES:[BX]    ;KOUNT IN CX
           LDS        BX,[BP]+B     ;GET SEGMENT
           MOV        ES,DS:[BX]
           LDS        BX,[BP]+C     ;GET OFFSET
           MOV        DI,DS:[BX]
           LDS        SI,[BP]+A     ;GET SOURCE ADDRESS
           CLD                      ;MOVE IS TO BE FORWARD
           REP MOVSW                ;PERFORM THE MOVE
           POP        SI
           POP        DI
           POP        DS            ;RESTORE CALLER'S DS
           POP        BP            ;RESTORE CALLER'S BP
           RET        16            ;FAR RETURN; RELEASE 16 BYTES
WDPOKE     ENDP
WDPO_TEXT  ENDS
           END
