$STORAGE:2
      PROGRAM DATA2STP
C ---------------------------------------------------------------------
C***  PROGRAM CREATES AN UNFORMATTED USGS  STATPAC DATA FILE FROM AN
C***  ASCII INPUT FILE.  THE FORMAT OF THE ASCII INPUT FILE IS SPECI-
C***  FIED BY THE USER AT RUN TIME.  (THE USER MUST BE FAMILIAR WITH
C***  FORTRAN LANGUAGE FORMATTED INPUT-OUTPUT COMMANDS).
C***
C***  EACH RECORD OF THE ASCII FILE MUST CONTAIN:
C***       1) AN ALPHAMERIC IDENTIFIER CONSISTING OF ONE TO
C***          SIXTEEN PRINTABLE CHARACTERS (E.G. DIGITS, ALPHA-
C***          BETIC CHARACTERS, SPECIAL CHARACTERS);
C***       2) AT LEAST ONE AND NO MORE THAN 100 STATPAC VARIABLES.
C***
C***  AS OPTIONS, EACH ASCII RECORD MAY ALSO CONTAIN:
C***       1) SINGLE CHARACTER STATPAC QUALIFIER CODES (E.G.
C***          B,L,N,G,T,H,*, AND BLANK (ASCII 32 CODE);
C***       2) LATITUDE AND LONGITUDE MEASURES EXPRESSED IN INTEGER
C***          DEGREES, MINUTES, SECONDS.  THE VALUES MUST BE SPECIFIED
C***          AS DDDMMSS WITH NO INTERVENING SPACES.  FOR EXAMPLE,
C***          A LATITUDE OF 30 DEGREES, 14 MINUTES, 27 SECONDS MUST
C***          BE PRESENT ON THE FILE AS 301427. (WITHOUT THE DECIMAL
C***          POINT)
C***
C***  THE USER SHOULD REMEMBER THAT THE ALPHAMERIC IDENTIFIERS AND
C***  INTEGER LATITUDE-LONGITUDE VALUES ARE NOT CONSIDERED TO BE
C***  STATPAC VARIABLES.
C***
C***  THE INFORMATION FIELDS (IDENTFIERS, LAT-LONG, AND STATPAC
C***  VARIABLES AND QUALIFIERS) MUST EXIST IN CONSISTENT LOCATIONS
C***  FROM RECORD TO RECORD (THE SAME "CARD" COLUMNS FROM RECORD
C***  TO RECORD).
C***
C***  SUBPROGRAMS REQUIRED: ASCIIZ, BYTMOV, CHEKER, CHRKNT, CKSAFE,
C***  CLEAR, CLREOL, CONCAT, CRSOFF, CRSON, DELAY, ERRCHK, FNDCUR,
C***  FSTDSP, INT21H, INTR, IOFS, IREGHI, IREGLO, ISEG, MOVCUR,
C***  ODOMTR, PACK, PCHCEN, PCHVAR, SAVRST, SCROLL, SOUND, TICKER
C***
C***  PROGRAM REQUIRES THE MICROSOFT VERSION 4.0 FORTRAN COMPILER.
C***  COMPILE AS FOLLOWS:
C***  FL /FPi87 /c data2stp.for
C***  LINK DATA2STP /EXEPACK,,NUL,C:\LIB\STATPAC4+C:\LIB\LLIBFOR7
C***  (STATPAC4.LIB IS A LIBRARY CONTAINING OBJECT MODULES OF THE
C***  SUBPROGRAMS LISTED ABOVE.  THE SUBPROGRAMS WERE COMPILED WITH
C***  THE MICROSOFT VERSION 4.O FORTRAN COMPILER OR ASSEMBLED WITH
C***  THE MICROSOFT VERSION 3.0 MACROASSEMBLER.)
C***  CODED BY W. D. GRUNDY      MAY  1987
C ---------------------------------------------------------------------
      CHARACTER*80 IFRMT
      CHARACTER*32 INFILE,OUTFIL
      CHARACTER*16 ROWID
      CHARACTER*8 VARIDS(100),ID
      CHARACTER*1 IA(100),IANS
      INTEGER*4 LOC(2)
      LOGICAL FILERR,QCODE,LLCODE
      DIMENSION IPACK(20),X(100)
      DATA IA /100*' '/,LOC /2*0/
C ---------------------------------------------------------------------
C***  GET DESCRIPTION OF WHAT IS ON THE FILE
C ---------------------------------------------------------------------
      CALL CLEAR
      WRITE(*,'('' '',''DOES THE DATA FILE CONTAIN INTEGER LAT-LONG '',
     1''VALUES? Y/N: '',\)')
      READ(*,'(A)') IANS
      LLCODE=IANS.EQ.'Y'.OR.IANS.EQ.'y'
      WRITE(*,'('' '',''DOES THE DATA FILE CONTAIN QUALIFIED VALUES? ''
     1,''Y/N: '',\)')
      READ(*,'(A)') IANS
      QCODE=IANS.EQ.'Y'.OR.IANS.EQ.'y'
   10 WRITE(*,'('' '',''HOW MANY ROWS OF DATA ARE IN THE INPUT FILE? ''
     1,\)')
      CALL ERRCHK(1,NROWS,DUMMY)
   20 WRITE(*,'('' '',''HOW MANY VARIABLES WILL BE IN EACH ROW? '',
     1''(MAX=100): '',\)')
      CALL ERRCHK(1,NVAR,DUMMY)
         IF(NVAR.LE.0.OR.NVAR.GT.100) THEN
         CALL SOUND(256,100)
         WRITE(*,'(A)') ' NUMBER OF VARIABLES MUST BE GE.1.AND.LE.100'
         GO TO 20
         ENDIF
      NPACK=(NVAR+4)/5
      WRITE(*,'('' '',''ENTER '',I3,'' VARIABLE IDS - FOLLOW EACH '',
     1''WITH A CARRIAGE RETURN'')') NVAR
         DO 30 I=1,NVAR
         READ(*,'(A)') VARIDS(I)
   30    CONTINUE
C ---------------------------------------------------------------------
C***  GET NAMES OF INPUT AND OUTPUT FILES
C ---------------------------------------------------------------------
      KI=20
      KO=11
   40 WRITE(*,'(A\)') ' ENTER NAME OF ASCII INPUT FILE: '
      READ(*,'(A)') INFILE
      CALL CKSAFE(INFILE,2,FILERR)
      IF(FILERR) GO TO 40
      OPEN(KI,FILE=INFILE)
   50 WRITE(*,'('' GIVE A ROOT NAME FOR THE STATPAC OUTPUT FILE: '',
     1\)')
      READ(*,'(A)') OUTFIL
      CALL CHEKER(OUTFIL,'.STP',FILERR)
      IF(FILERR) GO TO 50
      CALL CKSAFE(OUTFIL,1,FILERR)
      IF(FILERR) GO TO 50
      OPEN(KO,FILE=OUTFIL,STATUS='UNKNOWN',FORM='UNFORMATTED')
C ---------------------------------------------------------------------
C***  USER ENTERS FORMAT DIRECTLY FROM THE KEYBOARD
C ---------------------------------------------------------------------
   60 WRITE(*,'('' '',''ENTER THE FORMAT BELOW WITH 80 CHARACTERS '',
     1''OR LESS.'',/,'' REMEMBER THE FORMAT MUST START WITH A LEFT'',
     2'' PARENTHESIS'',/,'' AND END WITH A RIGHT PARENTHESIS.'')')
      READ(*,'(A)') IFRMT
C ---------------------------------------------------------------------
C***  LET USER TAKE A LOOK AT THE FORMAT THAT WAS CREATED
C ---------------------------------------------------------------------
   70 WRITE(*,'(/,'' THE FOLLOWING FORMAT WILL BE USED:'')')
      WRITE(*,'('' '',A80)') IFRMT
      WRITE(*,'('' DO YOU WANT TO CHANGE THIS? Y/N: '',\)')
      READ(*,'(A)') IANS
      IF(IANS.EQ.'Y'.OR.IANS.EQ.'y') GO TO 60
C ---------------------------------------------------------------------
C***  NOW READ THE INPUT FILE AND WRITE STATPAC OUTPUT FILE
C ---------------------------------------------------------------------
      WRITE(KO) ID,NROWS,NVAR,(VARIDS(I),I=1,NVAR)
      WRITE(*,'(A)') '       ...READING DATA'
      CALL FNDCUR(IRRR,ICCC,0)
         DO 80 II=1,NROWS
            IF(LLCODE.AND.QCODE) THEN
            READ(KI,IFRMT,ERR=90) ROWID,LOC,(X(I),IA(I),I=1,NVAR)
            ELSE IF(LLCODE) THEN
            READ(KI,IFRMT,ERR=90) ROWID,LOC,(X(I),I=1,NVAR)
            ELSE IF(QCODE) THEN
            READ(KI,IFRMT,ERR=90) ROWID,(X(I),IA(I),I=1,NVAR)
            ELSE
            READ(KI,IFRMT,ERR=90) ROWID,(X(I),I=1,NVAR)
            END IF
         IF(MOD(II,10).EQ.0) CALL ODOMTR(IRRR,II)
         CALL PACK(IA,NVAR,IPACK,NPACK)
C ---------------------------------------------------------------------
C***  THE OUTPUT FILE IS WRITTEN HERE
C ---------------------------------------------------------------------
         WRITE(KO) II,ROWID,LOC,(X(I),I=1,NVAR),(IPACK(I),I=1,NPACK)
   80    CONTINUE
      WRITE(*,'(''+'',I5)') NROWS
      WRITE(*,'('' THE STATPAC OUTPUT FILE IS '',A32)') OUTFIL
      WRITE(*,'('' N= '',I4,'', M= '',I2)') NROWS,NVAR
      STOP 'NORMAL END OF PROGRAM'
   90 CALL SOUND(256,100)
C ---------------------------------------------------------------------
C***  IF A RECORD CAN'T BE CORRECTLY READ, DISPLAY THE NUMBER.
C ---------------------------------------------------------------------
      WRITE(*,'('' FATAL ERROR IN READING RECORD NUMBER '',I4)') II
      END
